(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    441853,      13253]*)
(*NotebookOutlinePosition[    442546,      13277]*)
(*  CellTagsIndexPosition[    442502,      13273]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[TextData[StyleBox["Biophysics 101, Fall 2002\nProblem Set 1, part 3", \
"DisplayFormula"]], "Text",
  TextAlignment->Right,
  TextJustification->0],

Cell["Warm-up Notebook", "Subtitle",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[StyleBox["warmup_answers", "Title",
  FontFamily->"Garamond",
  FontWeight->"Bold",
  FontColor->RGBColor[1, 0.501961, 0.752941]]], "Subtitle",
  Evaluatable->False,
  TextAlignment->Center,
  TextJustification->0,
  FormatType->TextForm],

Cell[TextData[{
  "This notebook is for beginners that have done the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " tutorial. Most of it is no harder than a coloring book  It starts with \
cell manipulation and formatting, and it works its way up to discrete \
recursive functions that operate on ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " tables and arrays. Many of us are new to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ", so ",
  StyleBox["if you discover anything useful, please include them in your \
finished notebook.",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["1:  Saving notebooks", "Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell["\<\
Your first challenge is to save a copy of this notebook, and you get to name \
it after you.  On the menu bar at the top of the screen its \"File-> Save \
As.... \". If your name is Jack Flapjack then name it Jack_Flapjack.nb. If \
your name is not Jack Flapjack then name it after your own name instead. Put \
your answers in your self-named copy and turn it in to your TF. \
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["2: Inserting and deleting ", "Subsection"],
  StyleBox["Mathematica", "Subsection",
    FontSlant->"Italic"],
  StyleBox[" cells", "Subsection"]
}], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell["\<\
If you click in the thin horizontal space between cells, a thin black line \
appears. Hit the enter key, and voila, a new cell. Insert a cell between the \
second and third cells in this notebook, and type your name in it. If you are \
feeling stylish, format your name text with the many options available under \
the format menu. On the menu, check out \"Format->Show Toolbar\" Though short \
on features, the formatting toolbar may be worth it's screen real estate. To \
delete a cell, click to highlight it's blue bracket on the right, and press \
the delete key. To copy/paste a cell - highlight the blue bracket of the cell \
you want to copy, <right-click>->copy,then  make the thin horizontal black \
line appear where you want it to go, and <right-click>->paste.\
\>", "Text",
  TextAlignment->Left,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["3: ", "Subsection"],
  StyleBox["Mathematica", "Subsection",
    FontSlant->"Italic"],
  StyleBox[" cell types", "Subsection"]
}], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "Notice the subtle differences in the cell bracket shapes. They tell you \
what type of cell it is. This type, with the double line at the top, means \
its a non-evaluatable text cell. If you press <shift-enter> while the cursor \
is in this type of cell, ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " will beep at you.",
  StyleBox[" \n",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox["(2 pts)",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  StyleBox[" ",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox["Try it on the cell below. Now to make it evaluatable, highlight \
the cell bracket, and then its \"Cell->Cell Properties->Cell Evaluatable\"",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[CellGroupData[{

Cell[TextData[StyleBox["2+2", "Subsubsection"]], "Text",
  Evaluatable->True,
  TextAlignment->Center,
  TextJustification->0],

Cell[BoxData[
    \(4\)], "Output"]
}, Open  ]],

Cell["\<\
The default cell type, for example the one you just typed your name in,  is \
called \"Input Form\", and its cell bracket has a small triangle at the top. \
Change the property of the cell containing your name to non-evaluatable, and \
convert its display type to Text thru the menu via \"Cell->Display \
As->Text\".\
\>", "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[CellGroupData[{

Cell["\<\
This is an input type cell in text display mode. If you press <shift-enter> \
in this cell, you will see what this sentence means to the Mathematica kernel \
(not much).
\
\>", "Input",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(input\)\" is similar to \
existing symbol \"\!\(Input\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(cell\)\" is similar to \
existing symbol \"\!\(Cell\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(text\)\" is similar to \
existing symbol \"\!\(Text\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \(\(:\)\(\ \)\) 
      "Further output of \!\(General :: \"spell1\"\) will be suppressed \
during this calculation."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(enter\)\" is similar to \
existing symbols \!\({Center, Enter}\)."\)], "Message"],

Cell["\<\
Syntax::sntxf: \"cell in text display mode. If you press <shift-enter> in \
this cell\"
     cannot be followed by \", you will see what this sentence means to \
<<11>>tica kernel
       (not much).\".\
\>", "Message"]
}, Open  ]],

Cell[BoxData[
    FormBox[
      StyleBox[\(This\ is\ a\ traditional\ form\ cell . \ \ It\ has\ the\ \
coolest\ bracket\ shape, \ 
        but\ it' s\ a\ relic\ of\ old\ Mathematica\ versions\ that' 
          s\ \ still\ \ compatable\ with\ version\ \ \(\(4.2\)\(.\)\)\),
        "Text"], TraditionalForm]], "Input"]
}, Open  ]],

Cell[TextData[StyleBox["4: Cell grouping", "Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell["\<\
Notice how most of these cells are nested, but the two cells in this section \
are not. To group them, first go on the menu to \"Cell->Cell Grouping\" and \
make sure \"Manual Grouping\" is checked. Then select both brackets by \
dragging the mouse along the right margin, and its \"Cell->Cell \
Grouping->Group Cells\". Double click on the outermost bracket to make the \
nest expand and collapse.\
\>", "Text"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["5: Named lists", "Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "In the next cell there are some named lists and a name based list \
operation. ",
  StyleBox["(2 pts)",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  "  ",
  StyleBox["Evaluate the expressions by placing the cursor to the right of \
the last line, and <shift-enter>.  To get the total oil consumption for all \
five years, replace the \"*\" with a \".\" and evaluate again.",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(census\  = \ {7, \ 12, \ 11, \ 17, \ 28}\), "\[IndentingNewLine]", 
    \(perCapitaOil\  = \ {300, \ 445, \ 425, \ 625, \ 
        850}\), "\[IndentingNewLine]", 
    \(census\  . \ perCapitaOil\)}], "Input"],

Cell[BoxData[
    \({7, 12, 11, 17, 28}\)], "Output"],

Cell[BoxData[
    \({300, 445, 425, 625, 850}\)], "Output"],

Cell[BoxData[
    \(46540\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["6: Calculated lists using the Table method", \
"Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "The first example creates a length b array of a. ",
  StyleBox["Evaluate the expression",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  "."
}], "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[{
    \(a = 3\), "\[IndentingNewLine]", 
    \(b = 4\), "\[IndentingNewLine]", 
    \(Table[a, \ {b}]\)}], "Input"],

Cell[BoxData[
    \(3\)], "Output"],

Cell[BoxData[
    \(4\)], "Output"],

Cell[BoxData[
    \({3, 3, 3, 3}\)], "Output"]
}, Open  ]],

Cell["Evaluate these expressions.", "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Prime[5]\), "\[IndentingNewLine]", 
    \(Table[Prime[n], \ {n, \ 1, \ 10}]\), "\[IndentingNewLine]", 
    \(Random[Real, \ {0, 1}]\)}], "Input"],

Cell[BoxData[
    \(11\)], "Output"],

Cell[BoxData[
    \({2, 3, 5, 7, 11, 13, 17, 19, 23, 29}\)], "Output"],

Cell[BoxData[
    \(0.94127986139163`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(Table[
      Random[Real, \ {1, \ 50}], \ {20}]\)\)\)], "Input"],

Cell[BoxData[
    \({14.556840234489927`, 33.078928353359785`, 10.156443695978671`, 
      39.59380185009969`, 46.6495343533104`, 38.52922586331066`, 
      13.07540143960344`, 17.229586972539`, 43.04399743824508`, 
      37.02509447266429`, 17.845463372599585`, 19.076441212256032`, 
      4.1217915629010635`, 44.92846297637551`, 25.88415998048764`, 
      8.492839502008037`, 4.723503541876793`, 30.606596936008366`, 
      11.198791359134926`, 22.87579907055333`}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  StyleBox["(2 pts) ",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  StyleBox["Now insert a cell below this one that creates a list of 20 random \
numbers. Choose your own range (in the above case the range is between 0 and \
1), and your number type choices are (Integer, Real, or Complex).",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell["\<\
Evaluate these different ways to count to ten.\
\>", "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[{
    \(Table[x, \ {x, \ 10}]\), "\[IndentingNewLine]", 
    \(Table[x, \ {x, \ 1, \ 10}]\), "\[IndentingNewLine]", 
    \(Table[x/2, \ {x, 2, 20, 2}]\), "\[IndentingNewLine]", 
    \(Range[10]\)}], "Input"],

Cell[TextData[StyleBox["Inset a formula in a cell at the bottom of this group \
that counts backwards from ten.",
  FontWeight->"Bold",
  FontColor->RGBColor[0, 0, 1]]], "Text",
  TextAlignment->Left,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Table[x, \ {x, \ 10, \ 1, \ \(-1\)}]\)], "Input"],

Cell[BoxData[
    \({10, 9, 8, 7, 6, 5, 4, 3, 2, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox[" 7: List generation using functions with the Array \
method", "Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "This example introduces functions and arrays. Notice the underscore (x_) \
after the variable definition in the function. Arg 1 in the Array \
specification is the creation method that takes an integer, arg 2 is the \
array length, arg 3 is the starting point. ",
  StyleBox["(2 pts)",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  " ",
  StyleBox["Evaluate these expressions. ",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[{\(f[x_]\  := \ x^2;\), "\[IndentingNewLine]", \(qT = \ 
      Array[f, \ 20, \ \(-12\)]\), "\[IndentingNewLine]", 
  "qT", "\[IndentingNewLine]", \(ListPlot[qT];\), "\[IndentingNewLine]", 
    RowBox[{"ListPlot", "[", 
      RowBox[{"qT", ",", " ", 
        RowBox[{
          StyleBox["PlotJoined",
            "MR"], " ", "\[Rule]", " ", 
          StyleBox["True",
            "MR"]}]}], "]"}]}], "Input"],

Cell[BoxData[
    \({144, 121, 100, 81, 64, 49, 36, 25, 16, 9, 4, 1, 0, 1, 4, 9, 16, 25, 
      36, 49}\)], "Output"],

Cell[BoxData[
    \({144, 121, 100, 81, 64, 49, 36, 25, 16, 9, 4, 1, 0, 1, 4, 9, 16, 25, 
      36, 49}\)], "Output"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.047619 0.0147151 0.00408753 [
[.2619 .00222 -3 -9 ]
[.2619 .00222 3 0 ]
[.5 .00222 -6 -9 ]
[.5 .00222 6 0 ]
[.7381 .00222 -6 -9 ]
[.7381 .00222 6 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.01131 .09647 -12 -4.5 ]
[.01131 .09647 0 4.5 ]
[.01131 .17822 -12 -4.5 ]
[.01131 .17822 0 4.5 ]
[.01131 .25997 -12 -4.5 ]
[.01131 .25997 0 4.5 ]
[.01131 .34172 -12 -4.5 ]
[.01131 .34172 0 4.5 ]
[.01131 .42347 -18 -4.5 ]
[.01131 .42347 0 4.5 ]
[.01131 .50522 -18 -4.5 ]
[.01131 .50522 0 4.5 ]
[.01131 .58697 -18 -4.5 ]
[.01131 .58697 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(5)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(10)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(15)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(20)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .09647 m
.03006 .09647 L
s
[(20)] .01131 .09647 1 0 Mshowa
.02381 .17822 m
.03006 .17822 L
s
[(40)] .01131 .17822 1 0 Mshowa
.02381 .25997 m
.03006 .25997 L
s
[(60)] .01131 .25997 1 0 Mshowa
.02381 .34172 m
.03006 .34172 L
s
[(80)] .01131 .34172 1 0 Mshowa
.02381 .42347 m
.03006 .42347 L
s
[(100)] .01131 .42347 1 0 Mshowa
.02381 .50522 m
.03006 .50522 L
s
[(120)] .01131 .50522 1 0 Mshowa
.02381 .58697 m
.03006 .58697 L
s
[(140)] .01131 .58697 1 0 Mshowa
.125 Mabswid
.02381 .03515 m
.02756 .03515 L
s
.02381 .05559 m
.02756 .05559 L
s
.02381 .07603 m
.02756 .07603 L
s
.02381 .1169 m
.02756 .1169 L
s
.02381 .13734 m
.02756 .13734 L
s
.02381 .15778 m
.02756 .15778 L
s
.02381 .19865 m
.02756 .19865 L
s
.02381 .21909 m
.02756 .21909 L
s
.02381 .23953 m
.02756 .23953 L
s
.02381 .2804 m
.02756 .2804 L
s
.02381 .30084 m
.02756 .30084 L
s
.02381 .32128 m
.02756 .32128 L
s
.02381 .36215 m
.02756 .36215 L
s
.02381 .38259 m
.02756 .38259 L
s
.02381 .40303 m
.02756 .40303 L
s
.02381 .44391 m
.02756 .44391 L
s
.02381 .46434 m
.02756 .46434 L
s
.02381 .48478 m
.02756 .48478 L
s
.02381 .52566 m
.02756 .52566 L
s
.02381 .54609 m
.02756 .54609 L
s
.02381 .56653 m
.02756 .56653 L
s
.02381 .60741 m
.02756 .60741 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.07143 .60332 Mdot
.11905 .50931 Mdot
.16667 .42347 Mdot
.21429 .3458 Mdot
.2619 .27632 Mdot
.30952 .215 Mdot
.35714 .16187 Mdot
.40476 .1169 Mdot
.45238 .08012 Mdot
.5 .0515 Mdot
.54762 .03107 Mdot
.59524 .0188 Mdot
.64286 .01472 Mdot
.69048 .0188 Mdot
.7381 .03107 Mdot
.78571 .0515 Mdot
.83333 .08012 Mdot
.88095 .1169 Mdot
.92857 .16187 Mdot
.97619 .215 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00E@3oool2000003X0oooo1@0000020?ooo`800000>03oool500000080oooo0P00000h0?oo
o`@000000`3oool2000000@0oooo001D0?ooo`040000003oool0oooo000003/0oooo00D000000?oo
o`3oool0oooo000000020?ooo`030000003oool0oooo03L0oooo00D000000?ooo`3oool0oooo0000
00020?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool00`3oool010000000oooo0?oo
o`0000030?ooo`00E`3oool00`000000oooo0?ooo`0i0?ooo`050000003oool0oooo0?ooo`000000
0P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
=P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo001E0?ooo`800000
?03oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0=`3oool00`000000
oooo0?ooo`020?ooo`800000>P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?oo
o`3oool00@3oool005D0oooo00<000000?ooo`3oool0>`3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
03L0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`00E@3oool3
000003X0oooo0P0000040?ooo`800000>@3oool2000000@0oooo0`00000h0?ooo`800000103oool2
000000@0oooo003o0?ooob40oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo
00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E
0?ooo`030000003oool0oooo0?l0oooo2@3oool000h0ooooo`00000C000000005@3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool01@3oool001D0oooo
00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01L0oooo
00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo03h0oooo
00<000000?ooo`3oool01@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool0
0`000000oooo0?ooo`2;0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0AP3oool0
01D0oooo00<000000?ooo`3oool0R`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo
04H0oooo000E0?ooo`800000o`3oool:0?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo
000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3oool9
0?ooo`005@3oool00`000000oooo0?ooo`1n0?ooo`030000003oool0oooo04/0oooo00<000000?oo
o`3oool0>@3oool001D0oooo0P00001o0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3o
ool0>@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?oo
o`3o0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?oo
o`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`800000
o`3oool:0?ooo`005@3oool00`000000oooo0?ooo`1a0?ooo`030000003oool0oooo06D0oooo00<0
00000?ooo`3oool0;03oool001D0oooo00<000000?ooo`3oool0L@3oool00`000000oooo0?ooo`1U
0?ooo`030000003oool0oooo02`0oooo00070?ooo`@000000`3oool2000000D0oooo00<000000?oo
o`3oool0o`3oool90?ooo`001`3oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo0000
00@0oooo00<000000?ooo`3oool0o`3oool90?ooo`00203oool00`000000oooo0?ooo`020?ooo`04
0000003oool0oooo000000@0oooo0`00003o0?ooo`T0oooo00090?ooo`050000003oool0oooo0?oo
o`0000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0?l0oooo2@3oool000L0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0
oooo0?l0oooo2@3oool000P0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`3o0?oo
o`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0
o`3oool90?ooo`005@3oool2000006D0oooo00<000000?ooo`3oool0O`3oool00`000000oooo0?oo
o`0O0?ooo`005@3oool00`000000oooo0?ooo`1T0?ooo`030000003oool0oooo07l0oooo00<00000
0?ooo`3oool07`3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`000000
oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<0
00000?ooo`3oool0o`3oool90?ooo`005@3oool200000?l0oooo2P3oool001D0oooo00<000000?oo
o`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000
003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool2
00000?l0oooo2P3oool001D0oooo00<000000?ooo`3oool0E`3oool00`000000oooo0?ooo`2I0?oo
o`030000003oool0oooo0180oooo000E0?ooo`030000003oool0oooo05L0oooo00<000000?ooo`3o
ool0V@3oool00`000000oooo0?ooo`0B0?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo
00090?ooo`<000000P3oool2000000D0oooo00<000000?ooo`3oool0o`3oool90?ooo`002P3oool0
10000000oooo0?ooo`0000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0o`3o
ool90?ooo`001`3oool5000000050?ooo`000000oooo0?ooo`000000103oool300000?l0oooo2@3o
ool000L0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000
003oool0oooo0?l0oooo2@3oool000P0oooo00<000000?ooo`0000000P3oool010000000oooo0?oo
o`0000040?ooo`030000003oool0oooo0?l0oooo2@3oool000T0oooo0P0000030?ooo`8000001@3o
ool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool0
01D0oooo0P00003o0?ooo`X0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo
00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E
0?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool0/P3oool00`000000oooo0?ooo`06
0?ooo`005@3oool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo0;80oooo00<000000?oo
o`3oool01P3oool001D0oooo0P00003o0?ooo`X0oooo000E0?ooo`030000003oool0oooo0?l0oooo
2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o
0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo0P00003o0?ooo`X0
oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3o
ool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo00070?ooo`<00000103oool20000
00D0oooo00<000000?ooo`3oool0o`3oool90?ooo`001`3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0o`3oool90?ooo`001`3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo0`00003o0?ooo`T0oooo0007
0?ooo`<000000`3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0?l0oooo2@3o
ool000P0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000040?ooo`030000003o
ool0oooo0?l0oooo2@3oool000P0oooo0`0000030?ooo`8000001@3oool00`000000oooo0?ooo`3o
0?ooo`T0oooo000E0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0b03oool001D0
oooo0P00000n0?ooo`030000003oool0oooo0<P0oooo000E0?ooo`030000003oool0oooo0?l0oooo
2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o
0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3o
ool0o`3oool90?ooo`005@3oool200000?l0oooo2P3oool001D0oooo00<000000?ooo`3oool0o`3o
ool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000003oool0oooo
0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`000000oooo
0?ooo`3o0?ooo`T0oooo000E0?ooo`800000o`3oool:0?ooo`005@3oool00`000000oooo0?ooo`3o
0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool000P0oooo0P0000040?ooo`80
00001@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo00070?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`3o0?ooo`T0oooo00070?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool300000?l0oooo2@3oool0
00P0oooo0P0000030?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0<03oool0
0`000000oooo0?ooo`3E0?ooo`001`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`3E0?ooo`00203oool2
000000@0oooo0P0000050?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?oo
o`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`800000
o`3oool:0?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000003oool0
oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`000000
oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`800000o`3oool:0?ooo`005@3oool00`000000oooo0?oo
o`3o0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?oo
o`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000
003oool0oooo0?l0oooo2@3oool001D0oooo0P00003o0?ooo`X0oooo000E0?ooo`030000003oool0
oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`0000<0oooo00000000
00000`0000020?ooo`800000103oool2000000D0oooo00<000000?ooo`3oool0o`3oool90?ooo`00
0`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo0?l0oooo2@3oool000<0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00P3oool3
000002<0oooo00<000000?ooo`3oool0hP3oool000<0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`0S0?ooo`030000003oool0oooo0>80oooo00030?ooo`050000003oool0oooo0?ooo`0000000P3o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0
o`3oool90?ooo`000P3oool2000000@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?oo
o`3o0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?oo
o`3oool0o`3oool90?ooo`005@3oool200000?l0oooo2P3oool001D0oooo00<000000?ooo`3oool0
o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000003oool0
oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool200000?l0
oooo2P3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?oo
o`3o0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?oo
o`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`800000
o`3oool:0?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000003oool0
oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`0000<0oooo00000000
00000`0000000`3oool0000000000002000000<0oooo0P0000050?ooo`030000003oool0oooo0?l0
oooo2@3oool000<0oooo00D000000?ooo`3oool0oooo000000050?ooo`040000003oool0oooo0000
00@0oooo00<000000?ooo`3oool0o`3oool90?ooo`000`3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo0080oooo00@000000?ooo`3oool00000103oool3000001H0oooo00<000000?oo
o`3oool0k`3oool000<0oooo00<000000?ooo`3oool00`3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo
0>l0oooo00030?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`000002
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0o`3oool90?ooo`000P3oool20000
00@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`03
0000003oool0oooo0?l0oooo2@3oool001D0oooo0P00003o0?ooo`X0oooo000E0?ooo`030000003o
ool0oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`00
0000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo
00<000000?ooo`3oool0o`3oool90?ooo`005@3oool200000?l0oooo2P3oool001D0oooo00<00000
0?ooo`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`03
0000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3o
ool200000?l0oooo2P3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`00
0000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool000030?oo
o`000000000000<000000`3oool300000080oooo0P0000050?ooo`030000003oool0oooo0?l0oooo
2@3oool000<0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000020?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool0o`3oool90?ooo`000`3oool010000000oooo0?oo
o`3oool5000000050?ooo`000000oooo0?ooo`000000103oool300000?l0oooo2@3oool000<0oooo
00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`3o0?ooo`T0oooo00030?ooo`030000003oool0oooo0080
oooo00<000000?ooo`0000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo
0?l0oooo2@3oool00080oooo0P0000050?ooo`8000000`3oool2000000D0oooo00<000000?ooo`3o
ool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0?`0oooo
000E0?ooo`8000002P3oool00`000000oooo0?ooo`3l0?ooo`005@3oool00`000000oooo0?ooo`3o
0?ooo`T0oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo00<000000?ooo`3o
ool0o`3oool90?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.65192, -11.3255, \
0.0771848, 0.89919}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.047619 0.0147151 0.00408753 [
[.2619 .00222 -3 -9 ]
[.2619 .00222 3 0 ]
[.5 .00222 -6 -9 ]
[.5 .00222 6 0 ]
[.7381 .00222 -6 -9 ]
[.7381 .00222 6 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.01131 .09647 -12 -4.5 ]
[.01131 .09647 0 4.5 ]
[.01131 .17822 -12 -4.5 ]
[.01131 .17822 0 4.5 ]
[.01131 .25997 -12 -4.5 ]
[.01131 .25997 0 4.5 ]
[.01131 .34172 -12 -4.5 ]
[.01131 .34172 0 4.5 ]
[.01131 .42347 -18 -4.5 ]
[.01131 .42347 0 4.5 ]
[.01131 .50522 -18 -4.5 ]
[.01131 .50522 0 4.5 ]
[.01131 .58697 -18 -4.5 ]
[.01131 .58697 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .01472 m
.2619 .02097 L
s
[(5)] .2619 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(10)] .5 .00222 0 1 Mshowa
.7381 .01472 m
.7381 .02097 L
s
[(15)] .7381 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(20)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.07143 .01472 m
.07143 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.16667 .01472 m
.16667 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.35714 .01472 m
.35714 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.45238 .01472 m
.45238 .01847 L
s
.54762 .01472 m
.54762 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.64286 .01472 m
.64286 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.83333 .01472 m
.83333 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.92857 .01472 m
.92857 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .09647 m
.03006 .09647 L
s
[(20)] .01131 .09647 1 0 Mshowa
.02381 .17822 m
.03006 .17822 L
s
[(40)] .01131 .17822 1 0 Mshowa
.02381 .25997 m
.03006 .25997 L
s
[(60)] .01131 .25997 1 0 Mshowa
.02381 .34172 m
.03006 .34172 L
s
[(80)] .01131 .34172 1 0 Mshowa
.02381 .42347 m
.03006 .42347 L
s
[(100)] .01131 .42347 1 0 Mshowa
.02381 .50522 m
.03006 .50522 L
s
[(120)] .01131 .50522 1 0 Mshowa
.02381 .58697 m
.03006 .58697 L
s
[(140)] .01131 .58697 1 0 Mshowa
.125 Mabswid
.02381 .03515 m
.02756 .03515 L
s
.02381 .05559 m
.02756 .05559 L
s
.02381 .07603 m
.02756 .07603 L
s
.02381 .1169 m
.02756 .1169 L
s
.02381 .13734 m
.02756 .13734 L
s
.02381 .15778 m
.02756 .15778 L
s
.02381 .19865 m
.02756 .19865 L
s
.02381 .21909 m
.02756 .21909 L
s
.02381 .23953 m
.02756 .23953 L
s
.02381 .2804 m
.02756 .2804 L
s
.02381 .30084 m
.02756 .30084 L
s
.02381 .32128 m
.02756 .32128 L
s
.02381 .36215 m
.02756 .36215 L
s
.02381 .38259 m
.02756 .38259 L
s
.02381 .40303 m
.02756 .40303 L
s
.02381 .44391 m
.02756 .44391 L
s
.02381 .46434 m
.02756 .46434 L
s
.02381 .48478 m
.02756 .48478 L
s
.02381 .52566 m
.02756 .52566 L
s
.02381 .54609 m
.02756 .54609 L
s
.02381 .56653 m
.02756 .56653 L
s
.02381 .60741 m
.02756 .60741 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.07143 .60332 m
.11905 .50931 L
.16667 .42347 L
.21429 .3458 L
.2619 .27632 L
.30952 .215 L
.35714 .16187 L
.40476 .1169 L
.45238 .08012 L
.5 .0515 L
.54762 .03107 L
.59524 .0188 L
.64286 .01472 L
.69048 .0188 L
.7381 .03107 L
.78571 .0515 L
.83333 .08012 L
.88095 .1169 L
.92857 .16187 L
.97619 .215 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00E@3oool2000003X0oooo1@0000020?ooo`800000>03oool500000080oooo0P00000h0?oo
o`@000000`3oool2000000@0oooo001D0?ooo`040000003oool0oooo000003/0oooo00D000000?oo
o`3oool0oooo000000020?ooo`030000003oool0oooo03L0oooo00D000000?ooo`3oool0oooo0000
00020?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool00`3oool010000000oooo0?oo
o`0000030?ooo`00E`3oool00`000000oooo0?ooo`0i0?ooo`050000003oool0oooo0?ooo`000000
0P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
=P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0oooo001E0?ooo`800000
?03oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0=`3oool00`000000
oooo0?ooo`020?ooo`800000>P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?oo
o`3oool00@3oool005D0oooo00<000000?ooo`3oool0>`3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
03L0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`00E@3oool3
000003X0oooo0P0000040?ooo`800000>@3oool2000000@0oooo0`00000h0?ooo`800000103oool2
000000@0oooo003o0?ooob40oooo000E0?ooo`030000003oool0oooo0?l0oooo2@3oool001D0oooo
00<000000?ooo`3oool0o`3oool90?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E
0?ooo`030000003oool0oooo0?l0oooo2@3oool000h0ooooo`00000C000000005@3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool8000000H0
oooo00<000000?ooo`3oool0103oool8000000/0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00D0oooo000E0?ooo`030000003oool0oooo03h0oooo
00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0C0?ooo`<000007@3oool3000000P0oooo
00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`050?ooo`005@3oool00`000000oooo0?oo
o`2@0?ooo`@000008`3oool4000004d0oooo000E0?ooo`030000003oool0oooo08d0oooo0`00000[
0?ooo`<00000BP3oool001D0oooo00<000000?ooo`3oool0RP3oool300000340oooo0`0000170?oo
o`005@3oool2000008T0oooo0P00000g0?ooo`800000A@3oool001D0oooo00<000000?ooo`3oool0
Q@3oool3000003/0oooo0`0000120?ooo`005@3oool00`000000oooo0?ooo`220?ooo`<00000@@3o
ool3000003l0oooo000E0?ooo`030000003oool0oooo0800oooo0P0000170?ooo`800000?@3oool0
01D0oooo00<000000?ooo`3oool0OP3oool2000004/0oooo0P00000k0?ooo`005@3oool2000007d0
oooo0P00001?0?ooo`800000>@3oool001D0oooo00<000000?ooo`3oool0N`3oool00`000000oooo
0?ooo`1A0?ooo`800000=`3oool001D0oooo00<000000?ooo`3oool0N@3oool2000005H0oooo00<0
00000?ooo`3oool0=03oool001D0oooo00<000000?ooo`3oool0N03oool00`000000oooo0?ooo`1G
0?ooo`800000=03oool001D0oooo00<000000?ooo`3oool0MP3oool2000005`0oooo00<000000?oo
o`3oool0<@3oool001D0oooo00<000000?ooo`3oool0M@3oool00`000000oooo0?ooo`1M0?ooo`80
0000<@3oool001D0oooo0P00001d0?ooo`800000HP3oool2000002l0oooo000E0?ooo`030000003o
ool0oooo0780oooo00<000000?ooo`3oool0I03oool00`000000oooo0?ooo`0/0?ooo`005@3oool0
0`000000oooo0?ooo`1a0?ooo`030000003oool0oooo06H0oooo00<000000?ooo`3oool0:`3oool0
00L0oooo100000030?ooo`8000001@3oool00`000000oooo0?ooo`1_0?ooo`800000JP3oool20000
02/0oooo00070?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool00000103oool00`00
0000oooo0?ooo`1^0?ooo`030000003oool0oooo06`0oooo00<000000?ooo`3oool0:03oool000P0
oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000040?ooo`<00000K@3oool00`00
0000oooo0?ooo`1^0?ooo`030000003oool0oooo02L0oooo00090?ooo`050000003oool0oooo0?oo
o`0000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo06/0oooo0P00001b0?oo
o`8000009`3oool000L0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000004
0?ooo`030000003oool0oooo06X0oooo00<000000?ooo`3oool0M03oool00`000000oooo0?ooo`0T
0?ooo`00203oool2000000@0oooo0P0000050?ooo`030000003oool0oooo06T0oooo00<000000?oo
o`3oool0MP3oool00`000000oooo0?ooo`0S0?ooo`005@3oool00`000000oooo0?ooo`1W0?ooo`80
0000NP3oool2000002<0oooo000E0?ooo`030000003oool0oooo06H0oooo00<000000?ooo`3oool0
O03oool00`000000oooo0?ooo`0P0?ooo`005@3oool2000006H0oooo00<000000?ooo`3oool0OP3o
ool00`000000oooo0?ooo`0O0?ooo`005@3oool00`000000oooo0?ooo`1T0?ooo`030000003oool0
oooo0800oooo00<000000?ooo`3oool07P3oool001D0oooo00<000000?ooo`3oool0H`3oool00`00
0000oooo0?ooo`220?ooo`030000003oool0oooo01d0oooo000E0?ooo`030000003oool0oooo0680
oooo00<000000?ooo`3oool0Q03oool00`000000oooo0?ooo`0L0?ooo`005@3oool00`000000oooo
0?ooo`1Q0?ooo`030000003oool0oooo08H0oooo00<000000?ooo`3oool06`3oool001D0oooo00<0
00000?ooo`3oool0H03oool00`000000oooo0?ooo`280?ooo`030000003oool0oooo01X0oooo000E
0?ooo`800000G`3oool2000008`0oooo0P00000J0?ooo`005@3oool00`000000oooo0?ooo`1M0?oo
o`030000003oool0oooo08h0oooo00<000000?ooo`3oool05`3oool001D0oooo00<000000?ooo`3o
ool0G03oool00`000000oooo0?ooo`2@0?ooo`030000003oool0oooo01H0oooo000E0?ooo`030000
003oool0oooo05/0oooo00<000000?ooo`3oool0TP3oool00`000000oooo0?ooo`0E0?ooo`005@3o
ool00`000000oooo0?ooo`1J0?ooo`030000003oool0oooo09@0oooo00<000000?ooo`3oool0503o
ool001D0oooo0P00001J0?ooo`030000003oool0oooo09H0oooo00<000000?ooo`3oool04`3oool0
01D0oooo00<000000?ooo`3oool0F03oool00`000000oooo0?ooo`2H0?ooo`030000003oool0oooo
0180oooo000E0?ooo`030000003oool0oooo05L0oooo00<000000?ooo`3oool0VP3oool00`000000
oooo0?ooo`0A0?ooo`005@3oool00`000000oooo0?ooo`1F0?ooo`030000003oool0oooo09`0oooo
00<000000?ooo`3oool0403oool000T0oooo0`0000020?ooo`8000001@3oool00`000000oooo0?oo
o`1E0?ooo`030000003oool0oooo09h0oooo00<000000?ooo`3oool03`3oool000X0oooo00@00000
0?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo05D0oooo00<0
00000?ooo`3oool0WP3oool00`000000oooo0?ooo`0?0?ooo`001`3oool5000000050?ooo`000000
oooo0?ooo`000000103oool3000005@0oooo00<000000?ooo`3oool0X03oool00`000000oooo0?oo
o`0>0?ooo`001`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo
00<000000?ooo`3oool0D`3oool00`000000oooo0?ooo`2R0?ooo`030000003oool0oooo00d0oooo
00080?ooo`030000003oool000000080oooo00@000000?ooo`3oool00000103oool00`000000oooo
0?ooo`1B0?ooo`030000003oool0oooo0:@0oooo00<000000?ooo`3oool0303oool000T0oooo0P00
00030?ooo`8000001@3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo0:H0oooo00<0
00000?ooo`3oool02`3oool001D0oooo00<000000?ooo`3oool0D03oool00`000000oooo0?ooo`2X
0?ooo`030000003oool0oooo00X0oooo000E0?ooo`800000D03oool00`000000oooo0?ooo`2Z0?oo
o`030000003oool0oooo00T0oooo000E0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3o
ool0[03oool00`000000oooo0?ooo`080?ooo`005@3oool00`000000oooo0?ooo`1>0?ooo`030000
003oool0oooo0:`0oooo00<000000?ooo`3oool0203oool001D0oooo00<000000?ooo`3oool0C@3o
ool00`000000oooo0?ooo`2^0?ooo`030000003oool0oooo00L0oooo000E0?ooo`030000003oool0
oooo04`0oooo00<000000?ooo`3oool0/03oool00`000000oooo0?ooo`060?ooo`005@3oool00`00
0000oooo0?ooo`1;0?ooo`030000003oool0oooo0;80oooo00<000000?ooo`3oool01@3oool001D0
oooo0P00001;0?ooo`030000003oool0oooo0;/0oooo000E0?ooo`030000003oool0oooo04T0oooo
00<000000?ooo`3oool0_03oool001D0oooo00<000000?ooo`3oool0B@3oool00`000000oooo0?oo
o`2l0?ooo`005@3oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo0;d0oooo000E0?oo
o`030000003oool0oooo04L0oooo00<000000?ooo`3oool0_P3oool001D0oooo0P0000170?ooo`03
0000003oool0oooo0;l0oooo000E0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0
`03oool001D0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`310?ooo`005@3oool0
0`000000oooo0?ooo`140?ooo`030000003oool0oooo0<40oooo00070?ooo`<00000103oool20000
00D0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`320?ooo`001`3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0@P3oool0
0`000000oooo0?ooo`330?ooo`001`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo000000@0oooo0`0000110?ooo`030000003oool0oooo0<@0oooo00070?ooo`<000000`3oool0
10000000oooo0?ooo`0000040?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0a@3o
ool000P0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000040?ooo`030000003o
ool0oooo0400oooo00<000000?ooo`3oool0a@3oool000P0oooo0`0000030?ooo`8000001@3oool0
0`000000oooo0?ooo`0o0?ooo`030000003oool0oooo0<H0oooo000E0?ooo`030000003oool0oooo
03h0oooo00<000000?ooo`3oool0a`3oool001D0oooo0P00000n0?ooo`030000003oool0oooo0<P0
oooo000E0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0b03oool001D0oooo00<0
00000?ooo`3oool0?03oool00`000000oooo0?ooo`390?ooo`005@3oool00`000000oooo0?ooo`0k
0?ooo`030000003oool0oooo0<X0oooo000E0?ooo`030000003oool0oooo03/0oooo00<000000?oo
o`3oool0bP3oool001D0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`3;0?ooo`00
5@3oool2000003X0oooo00<000000?ooo`3oool0c03oool001D0oooo00<000000?ooo`3oool0>@3o
ool00`000000oooo0?ooo`3<0?ooo`005@3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0
oooo0<d0oooo000E0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0cP3oool001D0
oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`3?0?ooo`005@3oool00`000000oooo
0?ooo`0f0?ooo`030000003oool0oooo0<l0oooo000E0?ooo`800000=P3oool00`000000oooo0?oo
o`3@0?ooo`005@3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo0=40oooo000E0?oo
o`030000003oool0oooo03@0oooo00<000000?ooo`3oool0d@3oool000P0oooo0P0000040?ooo`80
00001@3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo0=80oooo00070?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0b0?oo
o`030000003oool0oooo0=<0oooo00070?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool00000103oool300000380oooo00<000000?ooo`3oool0d`3oool000P0oooo0P0000030?oo
o`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`3D
0?ooo`001`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<0
00000?ooo`3oool0<03oool00`000000oooo0?ooo`3E0?ooo`00203oool2000000@0oooo0P000005
0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0e@3oool001D0oooo00<000000?oo
o`3oool0;`3oool00`000000oooo0?ooo`3F0?ooo`005@3oool00`000000oooo0?ooo`0_0?ooo`03
0000003oool0oooo0=H0oooo000E0?ooo`800000;`3oool00`000000oooo0?ooo`3G0?ooo`005@3o
ool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo0=P0oooo000E0?ooo`030000003oool0
oooo02d0oooo00<000000?ooo`3oool0f03oool001D0oooo00<000000?ooo`3oool0;03oool00`00
0000oooo0?ooo`3I0?ooo`005@3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo0=X0
oooo000E0?ooo`800000;03oool00`000000oooo0?ooo`3J0?ooo`005@3oool00`000000oooo0?oo
o`0Z0?ooo`030000003oool0oooo0=/0oooo000E0?ooo`030000003oool0oooo02X0oooo00<00000
0?ooo`3oool0f`3oool001D0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`3L0?oo
o`005@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo0=d0oooo000E0?ooo`030000
003oool0oooo02P0oooo00<000000?ooo`3oool0g@3oool001D0oooo0P00000X0?ooo`030000003o
ool0oooo0=h0oooo000E0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0g`3oool0
01D0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`3O0?ooo`0000<0oooo00000000
00000`0000020?ooo`800000103oool2000000D0oooo00<000000?ooo`3oool09@3oool00`000000
oooo0?ooo`3P0?ooo`000`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo02D0oooo00<000000?oo
o`3oool0h03oool000<0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo
00000080oooo00<000000?ooo`3oool00P3oool3000002@0oooo00<000000?ooo`3oool0h@3oool0
00<0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo0>80oooo0003
0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`3R0?ooo`000P3o
ool2000000@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`0R0?ooo`030000003o
ool0oooo0><0oooo000E0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0h`3oool0
01D0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`3T0?ooo`005@3oool200000280
oooo00<000000?ooo`3oool0i03oool001D0oooo00<000000?ooo`3oool0803oool00`000000oooo
0?ooo`3U0?ooo`005@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0>D0oooo000E
0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0iP3oool001D0oooo00<000000?oo
o`3oool07`3oool00`000000oooo0?ooo`3V0?ooo`005@3oool2000001l0oooo00<000000?ooo`3o
ool0i`3oool001D0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`3X0?ooo`005@3o
ool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0>P0oooo000E0?ooo`030000003oool0
oooo01`0oooo00<000000?ooo`3oool0j@3oool001D0oooo00<000000?ooo`3oool0703oool00`00
0000oooo0?ooo`3Y0?ooo`005@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0>X0
oooo000E0?ooo`800000703oool00`000000oooo0?ooo`3Z0?ooo`005@3oool00`000000oooo0?oo
o`0J0?ooo`030000003oool0oooo0>/0oooo000E0?ooo`030000003oool0oooo01X0oooo00<00000
0?ooo`3oool0j`3oool001D0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`3/0?oo
o`0000<0oooo0000000000000`0000000`3oool0000000000002000000<0oooo0P0000050?ooo`03
0000003oool0oooo01T0oooo00<000000?ooo`3oool0k03oool000<0oooo00D000000?ooo`3oool0
oooo000000050?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0603oool00`00
0000oooo0?ooo`3]0?ooo`000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080
oooo00@000000?ooo`3oool00000103oool3000001P0oooo00<000000?ooo`3oool0k@3oool000<0
oooo00<000000?ooo`3oool00`3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo0>h0oooo00030?ooo`05
0000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`3_0?ooo`000P3oool20000
00@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo
0>l0oooo000E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0l03oool001D0oooo
0P00000F0?ooo`030000003oool0oooo0?00oooo000E0?ooo`030000003oool0oooo01@0oooo00<0
00000?ooo`3oool0l@3oool001D0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`3a
0?ooo`005@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0?80oooo000E0?ooo`03
0000003oool0oooo01<0oooo00<000000?ooo`3oool0lP3oool001D0oooo00<000000?ooo`3oool0
4P3oool00`000000oooo0?ooo`3c0?ooo`005@3oool2000001<0oooo00<000000?ooo`3oool0l`3o
ool001D0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`3d0?ooo`005@3oool00`00
0000oooo0?ooo`0A0?ooo`030000003oool0oooo0?@0oooo000E0?ooo`030000003oool0oooo0100
oooo00<000000?ooo`3oool0m@3oool001D0oooo00<000000?ooo`3oool0403oool00`000000oooo
0?ooo`3e0?ooo`005@3oool200000100oooo00<000000?ooo`3oool0mP3oool001D0oooo00<00000
0?ooo`3oool03`3oool00`000000oooo0?ooo`3f0?ooo`005@3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo0?L0oooo000E0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3o
ool0m`3oool000030?ooo`000000000000<000000`3oool300000080oooo0P0000050?ooo`030000
003oool0oooo00d0oooo00<000000?ooo`3oool0n03oool000<0oooo00<000000?ooo`3oool0103o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0
3@3oool00`000000oooo0?ooo`3h0?ooo`000`3oool010000000oooo0?ooo`3oool5000000050?oo
o`000000oooo0?ooo`000000103oool3000000`0oooo00<000000?ooo`3oool0n@3oool000<0oooo
00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0?T0oooo00030?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`0000000P3oool010000000oooo0?ooo`0000040?oo
o`030000003oool0oooo00/0oooo00<000000?ooo`3oool0nP3oool00080oooo0P0000050?ooo`80
00000`3oool2000000D0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`3j0?ooo`00
5@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0?/0oooo000E0?ooo`800000o`3o
ool:0?ooo`005@3oool00`000000oooo0?ooo`3o0?ooo`T0oooo000E0?ooo`030000003oool0oooo
0?l0oooo2@3oool001D0oooo00<000000?ooo`3oool0o`3oool90?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.65192, -11.3255, \
0.0771848, 0.89919}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[TextData[{
  StyleBox["Note 1) ",
    FontWeight->"Bold",
    FontColor->RGBColor[0.682353, 0.32549, 0.317647]],
  StyleBox["Notice how the arrays are printed out when you evaluate the cell. \
This can be annoying when you want to look at a complicated graph but don't \
want to see all of it's underlying points printed out. Put a \";\" at the end \
of the expressions that you don't want to display the results of.\n\nNote 2) \
It's considered good ",
    FontWeight->"Bold",
    FontColor->RGBColor[0.682353, 0.32549, 0.317647],
    FontVariations->{"CompatibilityType"->0}],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic",
    FontColor->RGBColor[0.682353, 0.32549, 0.317647],
    FontVariations->{"CompatibilityType"->0}],
  StyleBox[" practice to begin your custom variable names with a lower case \
letter, which will prevent name collisions with the ",
    FontWeight->"Bold",
    FontColor->RGBColor[0.682353, 0.32549, 0.317647],
    FontVariations->{"CompatibilityType"->0}],
  StyleBox["Mathematicas ",
    FontWeight->"Bold",
    FontSlant->"Italic",
    FontColor->RGBColor[0.682353, 0.32549, 0.317647],
    FontVariations->{"CompatibilityType"->0}],
  StyleBox["names, all of which begin with uppercase letters.\n\nNote 3) \
Don't forget to put the colon in front of the equals sign \":=\" when you \
define a function. This can be very frustrating, because leaving it off won't \
cause an error. So if your function is giving you unexpected results, don't \
forget to re-read this note!",
    FontWeight->"Bold",
    FontColor->RGBColor[0.682353, 0.32549, 0.317647],
    FontVariations->{"CompatibilityType"->0}]
}], "Text",
  TextAlignment->Left,
  TextJustification->0]
}, Open  ]],

Cell[TextData[StyleBox["8: Using lists to graph a built in function", \
"Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[CellGroupData[{

Cell[TextData[{
  "You can compose your own custom functions with ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " built in functions. Remember N from the tutorial? -",
  StyleBox[" evaluate these expressions.",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(k\  = \ 3;\)\), "\[IndentingNewLine]", 
    \(\(f[x_]\  = k*Tanh[x];\)\), "\[IndentingNewLine]", 
    \(\(f[3];\)\), "\[IndentingNewLine]", 
    \(N[f[3]]\)}], "Input"],

Cell[BoxData[
    \(2.9851642610601914`\)], "Output"]
}, Open  ]],

Cell[TextData[{
  StyleBox["(2 pts) ",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  StyleBox["Make a plot of Tanh[x], with the y values between -0.9 and 0.9. \
Bonus: Make it exactly between -0.9 and 0.9 (hint: look in Help->Master \
Index->Built-in Functions->Mathematical Functions).",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0]
}, Open  ]],

Cell[TextData[{
  StyleBox["Its possible to do this using functions with plot or using a \
lists with listplot.  In order to get the y range exactly between -0.9 and \
0.9, use the ArcTanh function.",
    FontColor->RGBColor[1, 0.501961, 1]],
  "\n"
}], "Input",
  Evaluatable->False,
  FormatType->TextForm],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Plot[\ 
      Tanh[x], \ {x, \ ArcTanh[\(-0.9\)], \ 
        ArcTanh[0.9]}\ ]\), "\[IndentingNewLine]", 
    \(\(numPoints\  = \ 50;\)\), "\[IndentingNewLine]", 
    \(stepSize\  = \ \((ArcTanh[0.9]\  - ArcTanh[\(-0.9\)])\)/
        numPoints\), "\[IndentingNewLine]", 
    \(\(dataPoints\  = \ 
        Table[Tanh[ArcTanh[\(-0.9\)] + \ x*stepSize], \ {x, \ 1\ , \ 
            numPoints\  - \ 1}];\)\), "\[IndentingNewLine]", 
    \(ListPlot[dataPoints, \ PlotJoined \[Rule] True]\)}], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.323451 0.309017 0.327002 [
[.01482 .29652 -12 -9 ]
[.01482 .29652 12 0 ]
[.17655 .29652 -6 -9 ]
[.17655 .29652 6 0 ]
[.33827 .29652 -12 -9 ]
[.33827 .29652 12 0 ]
[.66173 .29652 -9 -9 ]
[.66173 .29652 9 0 ]
[.82345 .29652 -3 -9 ]
[.82345 .29652 3 0 ]
[.98518 .29652 -9 -9 ]
[.98518 .29652 9 0 ]
[.4875 .06377 -30 -4.5 ]
[.4875 .06377 0 4.5 ]
[.4875 .14552 -24 -4.5 ]
[.4875 .14552 0 4.5 ]
[.4875 .22727 -30 -4.5 ]
[.4875 .22727 0 4.5 ]
[.4875 .39077 -24 -4.5 ]
[.4875 .39077 0 4.5 ]
[.4875 .47252 -18 -4.5 ]
[.4875 .47252 0 4.5 ]
[.4875 .55427 -24 -4.5 ]
[.4875 .55427 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.01482 .30902 m
.01482 .31527 L
s
[(-1.5)] .01482 .29652 0 1 Mshowa
.17655 .30902 m
.17655 .31527 L
s
[(-1)] .17655 .29652 0 1 Mshowa
.33827 .30902 m
.33827 .31527 L
s
[(-0.5)] .33827 .29652 0 1 Mshowa
.66173 .30902 m
.66173 .31527 L
s
[(0.5)] .66173 .29652 0 1 Mshowa
.82345 .30902 m
.82345 .31527 L
s
[(1)] .82345 .29652 0 1 Mshowa
.98518 .30902 m
.98518 .31527 L
s
[(1.5)] .98518 .29652 0 1 Mshowa
.125 Mabswid
.04717 .30902 m
.04717 .31277 L
s
.07951 .30902 m
.07951 .31277 L
s
.11186 .30902 m
.11186 .31277 L
s
.1442 .30902 m
.1442 .31277 L
s
.20889 .30902 m
.20889 .31277 L
s
.24124 .30902 m
.24124 .31277 L
s
.27358 .30902 m
.27358 .31277 L
s
.30593 .30902 m
.30593 .31277 L
s
.37062 .30902 m
.37062 .31277 L
s
.40296 .30902 m
.40296 .31277 L
s
.43531 .30902 m
.43531 .31277 L
s
.46765 .30902 m
.46765 .31277 L
s
.53235 .30902 m
.53235 .31277 L
s
.56469 .30902 m
.56469 .31277 L
s
.59704 .30902 m
.59704 .31277 L
s
.62938 .30902 m
.62938 .31277 L
s
.69407 .30902 m
.69407 .31277 L
s
.72642 .30902 m
.72642 .31277 L
s
.75876 .30902 m
.75876 .31277 L
s
.79111 .30902 m
.79111 .31277 L
s
.8558 .30902 m
.8558 .31277 L
s
.88814 .30902 m
.88814 .31277 L
s
.92049 .30902 m
.92049 .31277 L
s
.95283 .30902 m
.95283 .31277 L
s
.25 Mabswid
0 .30902 m
1 .30902 L
s
.5 .06377 m
.50625 .06377 L
s
[(-0.75)] .4875 .06377 1 0 Mshowa
.5 .14552 m
.50625 .14552 L
s
[(-0.5)] .4875 .14552 1 0 Mshowa
.5 .22727 m
.50625 .22727 L
s
[(-0.25)] .4875 .22727 1 0 Mshowa
.5 .39077 m
.50625 .39077 L
s
[(0.25)] .4875 .39077 1 0 Mshowa
.5 .47252 m
.50625 .47252 L
s
[(0.5)] .4875 .47252 1 0 Mshowa
.5 .55427 m
.50625 .55427 L
s
[(0.75)] .4875 .55427 1 0 Mshowa
.125 Mabswid
.5 .08012 m
.50375 .08012 L
s
.5 .09647 m
.50375 .09647 L
s
.5 .11282 m
.50375 .11282 L
s
.5 .12917 m
.50375 .12917 L
s
.5 .16187 m
.50375 .16187 L
s
.5 .17822 m
.50375 .17822 L
s
.5 .19457 m
.50375 .19457 L
s
.5 .21092 m
.50375 .21092 L
s
.5 .24362 m
.50375 .24362 L
s
.5 .25997 m
.50375 .25997 L
s
.5 .27632 m
.50375 .27632 L
s
.5 .29267 m
.50375 .29267 L
s
.5 .32537 m
.50375 .32537 L
s
.5 .34172 m
.50375 .34172 L
s
.5 .35807 m
.50375 .35807 L
s
.5 .37442 m
.50375 .37442 L
s
.5 .40712 m
.50375 .40712 L
s
.5 .42347 m
.50375 .42347 L
s
.5 .43982 m
.50375 .43982 L
s
.5 .45617 m
.50375 .45617 L
s
.5 .48887 m
.50375 .48887 L
s
.5 .50522 m
.50375 .50522 L
s
.5 .52157 m
.50375 .52157 L
s
.5 .53792 m
.50375 .53792 L
s
.5 .04742 m
.50375 .04742 L
s
.5 .03107 m
.50375 .03107 L
s
.5 .01472 m
.50375 .01472 L
s
.5 .57062 m
.50375 .57062 L
s
.5 .58697 m
.50375 .58697 L
s
.5 .60332 m
.50375 .60332 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01472 m
.06244 .02299 L
.10458 .03421 L
.14415 .04723 L
.18221 .06241 L
.22272 .0818 L
.26171 .10394 L
.30316 .13141 L
.34309 .16175 L
.3815 .1943 L
.42237 .232 L
.46172 .27049 L
.49955 .30856 L
.53984 .34909 L
.57861 .38696 L
.61984 .42491 L
.65954 .45839 L
.69774 .48725 L
.73838 .51415 L
.77751 .53635 L
.81909 .55619 L
.85916 .57199 L
.89771 .5845 L
.93871 .59532 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{42, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00T@3oool00`000000oooo0?ooo`2<0?ooo`00T@3o
ool00`000000oooo0?ooo`2<0?ooo`00T@3oool00`000000oooo0?ooo`2<0?ooo`00T@3oool00`00
0000oooo0?ooo`2<0?ooo`003P3oool200000840oooo0P00002=0?ooo`00403oool4000007d0oooo
00<000000?ooo`3oool0S03oool001@0oooo1000001i0?ooo`030000003oool0oooo08`0oooo000H
0?ooo`<00000MP3oool00`000000oooo0?ooo`2<0?ooo`006`3oool400000780oooo00<000000?oo
o`3oool0S03oool001l0oooo1000001^0?ooo`800000S@3oool002<0oooo0`00001[0?ooo`030000
003oool0oooo08`0oooo000V0?ooo`@00000I`3oool00`000000oooo0?ooo`2<0?ooo`00:P3oool4
000006<0oooo00<000000?ooo`3oool0S03oool002h0oooo0`00001P0?ooo`800000S@3oool00340
oooo0P00001N0?ooo`030000003oool0oooo08`0oooo000c0?ooo`<00000F`3oool00`000000oooo
0?ooo`2<0?ooo`00=P3oool2000003l0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?oo
o`020?ooo`8000001P3oool00`000000oooo0?ooo`2<0?ooo`00>03oool2000003`0oooo00@00000
0?ooo`3oool000002P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`2<0?ooo`00>P3oool2000003X0oooo00@000000?ooo`3oool00000
2P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo0P00002=0?ooo`00?03o
ool200000380oooo100000020?ooo`040000003oool0oooo000000/0oooo00@000000?ooo`3oool0
oooo0P0000060?ooo`030000003oool0oooo08`0oooo000n0?ooo`800000=P3oool010000000oooo
0?ooo`0000080?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`2<0?ooo`00@03oool2000003D0oooo0P0000090?ooo`@000000`3oool3000000D0
oooo00<000000?ooo`3oool0S03oool00480oooo0P00001=0?ooo`800000S@3oool004@0oooo00<0
00000?ooo`3oool0BP3oool00`000000oooo0?ooo`2<0?ooo`00A@3oool2000004X0oooo00<00000
0?ooo`3oool0S03oool004L0oooo0P0000180?ooo`030000003oool0oooo08`0oooo00190?ooo`80
0000AP3oool00`000000oooo0?ooo`2<0?ooo`00B`3oool2000004@0oooo0P00002=0?ooo`00C@3o
ool200000480oooo00<000000?ooo`3oool0S03oool004l0oooo00<000000?ooo`3oool0?`3oool0
0`000000oooo0?ooo`2<0?ooo`00D03oool2000003l0oooo00<000000?ooo`3oool0S03oool00580
oooo0P00000m0?ooo`800000S@3oool005@0oooo00<000000?ooo`3oool0>P3oool00`000000oooo
0?ooo`2<0?ooo`00E@3oool2000003X0oooo00<000000?ooo`3oool0S03oool005L0oooo0P00000h
0?ooo`030000003oool0oooo08`0oooo001I0?ooo`800000=P3oool00`000000oooo0?ooo`2<0?oo
o`00F`3oool00`000000oooo0?ooo`0c0?ooo`800000S@3oool005`0oooo00<000000?ooo`3oool0
<P3oool00`000000oooo0?ooo`2<0?ooo`00G@3oool00`000000oooo0?ooo`0M0?ooo`800000103o
ool2000000@0oooo0P0000060?ooo`030000003oool0oooo08`0oooo001N0?ooo`030000003oool0
oooo01/0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000050?ooo`030000
003oool0oooo08`0oooo001O0?ooo`030000003oool0oooo01X0oooo00@000000?ooo`3oool00000
2`3oool00`000000oooo0?ooo`030?ooo`800000S@3oool00600oooo0P00000D0?ooo`@000000P3o
ool010000000oooo0?ooo`0000090?ooo`8000001P3oool00`000000oooo0?ooo`2<0?ooo`00HP3o
ool00`000000oooo0?ooo`0G0?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`2<0?ooo`00H`3oool00`000000oooo0?ooo`0G0?ooo`8000002P3o
ool3000000D0oooo00<000000?ooo`3oool0S03oool006@0oooo00<000000?ooo`3oool0:P3oool0
0`000000oooo0?ooo`2<0?ooo`00I@3oool00`000000oooo0?ooo`0Y0?ooo`800000S@3oool006H0
oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`2<0?ooo`00I`3oool2000002P0oooo
00<000000?ooo`3oool0S03oool006T0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?oo
o`2<0?ooo`00JP3oool00`000000oooo0?ooo`0T0?ooo`800000S@3oool006/0oooo00<000000?oo
o`3oool08`3oool00`000000oooo0?ooo`2<0?ooo`00K03oool00`000000oooo0?ooo`0R0?ooo`03
0000003oool0oooo08`0oooo001]0?ooo`8000008P3oool00`000000oooo0?ooo`2<0?ooo`00K`3o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo08`0oooo001`0?ooo`030000003oool0
oooo01h0oooo0P00002=0?ooo`00L@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo
08`0oooo001b0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0S03oool007<0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2<0?ooo`00M03oool00`000000oooo0?oo
o`0J0?ooo`800000S@3oool007D0oooo0P00000J0?ooo`030000003oool0oooo08`0oooo001g0?oo
o`030000003oool0oooo01L0oooo00<000000?ooo`3oool0S03oool007L0oooo0P0000040?ooo`80
00000`3oool4000000<0oooo0P0000060?ooo`030000003oool0oooo08`0oooo001f0?ooo`040000
003oool0oooo000000P0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`0000050?oo
o`030000003oool0oooo08`0oooo001f0?ooo`030000003oool0oooo00800000203oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00<0oooo0P00002=0?ooo`00L03oool400000080oooo
00H000000?ooo`3oool000000?ooo`0000080?ooo`030000003oool0oooo0080oooo0P0000060?oo
o`030000003oool0oooo08`0oooo001f0?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool00`3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0S03oool007L0oooo0P0000040?ooo`030000003oool0oooo00<0oooo0P0000040?oo
o`<000001@3oool00`000000oooo0?ooo`2<0?ooo`00OP3oool00`000000oooo0?ooo`0@0?ooo`80
0000S@3oool007l0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`2<0?ooo`00P03o
ool2000000l0oooo00<000000?ooo`3oool0S03oool00880oooo00<000000?ooo`3oool0303oool0
0`000000oooo0?ooo`2<0?ooo`00P`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo
08`0oooo00240?ooo`030000003oool0oooo00X0oooo0P00002=0?ooo`00Q@3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo08`0oooo00070?ooo`D000000P3oool2000000@0oooo0P00
000S0?ooo`D000008P3oool2000000@0oooo0P0000040?ooo`800000603oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo0280oooo0P0000040?ooo`800000103oool2000002<0oooo1@00
000R0?ooo`D000000P3oool2000000@0oooo0P0000030?ooo`002@3oool00`000000oooo0?ooo`07
0?ooo`040000003oool0oooo000002@0oooo00<000000?ooo`3oool08@3oool010000000oooo0?oo
o`0000080?ooo`040000003oool0oooo000001P0oooo00<000000?ooo`3oool01`3oool00`000000
oooo0?ooo`0Q0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000903oool0
0`000000oooo0?ooo`0T0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000P3o
ool000T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0
oooo0240oooo00@000000?ooo`3oool000002`3oool00`000000oooo0?ooo`0G0?ooo`030000003o
ool0oooo00H0oooo0P00000R0?ooo`040000003oool0oooo000000/0oooo00<000000?ooo`3oool0
8P3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo00X0oooo0@0000010?ooo`40oooo
00000`3oool0000000000002000000@0oooo00<000000?ooo`3oool0203oool2000001d0oooo1000
00040?ooo`030000003oool0oooo01/0oooo100000020?ooo`040000003oool0oooo000000T0oooo
0P00000K0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool08@3oool010000000oooo
0?ooo`0000090?ooo`8000009@3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo00P0
oooo0P0000030?ooo`002@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo02@0oooo
00<000000?ooo`3oool08@3oool010000000oooo0?ooo`0000090?ooo`030000003oool0oooo01/0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0Q0?ooo`040000003oool0oooo0000
00T0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo
00P0oooo00<000000?ooo`3oool00P3oool000P0oooo0P00000:0?ooo`<000008`3oool2000002@0
oooo0P00000:0?ooo`<00000703oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0280
oooo0P00000:0?ooo`<000008`3oool2000002D0oooo0P00000:0?ooo`<000000P3oool008/0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`2<0?ooo`00S03oool00`000000oooo0?oo
o`020?ooo`800000S@3oool008d0oooo00D000000?ooo`3oool0oooo0000002>0?ooo`00SP3oool0
10000000oooo0?ooo`00002>0?ooo`00S`3oool00`000000oooo0000002>0?ooo`001`3ooooo0000
01D000001@3oool000`0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01`3oool000`0oooo00<000000?ooo`3oool0
:@3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo02X0oooo0P00000Z0?ooo`030000
003oool0oooo02T0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`070?ooo`00T@3o
ool00`000000oooo0000002<0?ooo`00T@3oool010000000oooo0?ooo`00002;0?ooo`00T@3oool2
00000080oooo00<000000?ooo`3oool0R03oool00940oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`270?ooo`00T@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo08H0
oooo002A0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0Q@3oool00940oooo0P00
00060?ooo`030000003oool0oooo08@0oooo002A0?ooo`030000003oool0oooo00H0oooo00<00000
0?ooo`3oool0P`3oool00940oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`220?oo
o`00T@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0840oooo002A0?ooo`800000
2P3oool00`000000oooo0?ooo`200?ooo`00T@3oool00`000000oooo0?ooo`0:0?ooo`030000003o
ool0oooo07l0oooo002A0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0OP3oool0
0940oooo00<000000?ooo`3oool0303oool2000007h0oooo002A0?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool0N`3oool00940oooo0P00000@0?ooo`030000003oool0oooo07X0oooo
002A0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0N@3oool007L0oooo0P000004
0?ooo`8000000`3oool4000000<0oooo0P0000060?ooo`030000003oool0oooo0140oooo00<00000
0?ooo`3oool0N03oool007H0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`03
0?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?oo
o`1g0?ooo`00MP3oool010000000oooo0?ooo`0000090?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool00`3oool2000001@0oooo00<000000?ooo`3oool0MP3oool007H0oooo00@00000
0?ooo`3oool000002P3oool00`000000oooo0?ooo`020?ooo`8000001P3oool00`000000oooo0?oo
o`0D0?ooo`030000003oool0oooo07D0oooo001f0?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool000000`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool0M03oool007L0oooo0P00000:0?ooo`800000103oool3000000D0oooo00<0
00000?ooo`3oool05P3oool00`000000oooo0?ooo`1c0?ooo`00T@3oool00`000000oooo0?ooo`0G
0?ooo`030000003oool0oooo0780oooo002A0?ooo`8000006@3oool00`000000oooo0?ooo`1a0?oo
o`00T@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0700oooo002A0?ooo`030000
003oool0oooo01X0oooo00<000000?ooo`3oool0K`3oool00940oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`1^0?ooo`00T@3oool2000001d0oooo00<000000?ooo`3oool0K@3oool0
0940oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`1/0?ooo`00T@3oool00`000000
oooo0?ooo`0N0?ooo`030000003oool0oooo06/0oooo002A0?ooo`030000003oool0oooo01l0oooo
0P00001[0?ooo`00T@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo06P0oooo002A
0?ooo`8000008`3oool00`000000oooo0?ooo`1W0?ooo`00T@3oool00`000000oooo0?ooo`0S0?oo
o`030000003oool0oooo06H0oooo002A0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3o
ool0I@3oool00940oooo00<000000?ooo`3oool09@3oool2000006D0oooo002A0?ooo`800000:03o
ool00`000000oooo0?ooo`1R0?ooo`00T@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0
oooo0640oooo002A0?ooo`030000003oool0oooo02T0oooo0P00001Q0?ooo`00O@3oool2000000@0
oooo0P0000040?ooo`8000001P3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo05h0
oooo001l0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000001@3oool00`00
0000oooo0?ooo`0/0?ooo`030000003oool0oooo05d0oooo001l0?ooo`040000003oool0oooo0000
00/0oooo00<000000?ooo`3oool00`3oool2000002h0oooo0P00001M0?ooo`00O03oool010000000
oooo0?ooo`0000090?ooo`8000001P3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo
05X0oooo001l0?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`0`0?ooo`030000003oool0oooo05T0oooo001m0?ooo`8000002P3oool3000000D0
oooo00<000000?ooo`3oool0<@3oool2000005T0oooo002A0?ooo`800000=03oool00`000000oooo
0?ooo`1F0?ooo`00T@3oool00`000000oooo0?ooo`0d0?ooo`800000EP3oool00940oooo00<00000
0?ooo`3oool0=P3oool00`000000oooo0?ooo`1C0?ooo`00T@3oool00`000000oooo0?ooo`0g0?oo
o`800000D`3oool00940oooo00<000000?ooo`3oool0>@3oool200000540oooo002A0?ooo`800000
?03oool00`000000oooo0?ooo`1>0?ooo`00T@3oool00`000000oooo0?ooo`0l0?ooo`800000CP3o
ool00940oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`1;0?ooo`00T@3oool00`00
0000oooo0?ooo`0o0?ooo`800000B`3oool00940oooo0P0000120?ooo`800000B@3oool00940oooo
00<000000?ooo`3oool0@`3oool2000004L0oooo002A0?ooo`030000003oool0oooo04D0oooo0P00
00150?ooo`00T@3oool00`000000oooo0?ooo`170?ooo`800000@`3oool00940oooo00<000000?oo
o`3oool0B@3oool00`000000oooo0?ooo`100?ooo`00T@3oool2000004/0oooo0P0000100?ooo`00
T@3oool00`000000oooo0?ooo`1<0?ooo`800000?P3oool007L0oooo0P0000040?ooo`8000001@3o
ool00`000000oooo0?ooo`020?ooo`8000001P3oool00`000000oooo0?ooo`1>0?ooo`800000?03o
ool007H0oooo00@000000?ooo`3oool000002P3oool01@000000oooo0?ooo`3oool000000080oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`1@0?ooo`800000>P3oool007H0oooo00@0
00000?ooo`3oool000002P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo
0P00001C0?ooo`800000>03oool007H0oooo00@000000?ooo`3oool000002`3oool010000000oooo
0?ooo`3oool2000000H0oooo00<000000?ooo`3oool0E03oool2000003H0oooo001f0?ooo`040000
003oool0oooo000000P0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo05H0oooo0`00000c0?ooo`00M`3oool2000000T0oooo100000030?ooo`<0
00001@3oool00`000000oooo0?ooo`1I0?ooo`800000<@3oool00940oooo00<000000?ooo`3oool0
F`3oool3000002h0oooo002A0?ooo`800000G`3oool3000002/0oooo002A0?ooo`030000003oool0
oooo0640oooo0`00000X0?ooo`00T@3oool00`000000oooo0?ooo`1T0?ooo`8000009P3oool00940
oooo00<000000?ooo`3oool0IP3oool3000002<0oooo002A0?ooo`800000JP3oool300000200oooo
002A0?ooo`030000003oool0oooo06`0oooo1000000L0?ooo`00T@3oool00`000000oooo0?ooo`1`
0?ooo`@00000603oool00940oooo00<000000?ooo`3oool0M03oool4000001@0oooo002A0?ooo`03
0000003oool0oooo07P0oooo1@00000?0?ooo`00T@3oool2000007h0oooo0`00000<0?ooo`00T@3o
ool00`000000oooo0?ooo`2<0?ooo`00T@3oool00`000000oooo0?ooo`2<0?ooo`00T@3oool00`00
0000oooo0?ooo`2<0?ooo`00T@3oool00`000000oooo0?ooo`2<0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.63537, -0.986956, \
0.0112784, 0.0111559}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[BoxData[
    \(0.05888877958332881`\)], "Output"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0194363 0.309017 0.331347 [
[.21817 .29652 -6 -9 ]
[.21817 .29652 6 0 ]
[.41254 .29652 -6 -9 ]
[.41254 .29652 6 0 ]
[.6069 .29652 -6 -9 ]
[.6069 .29652 6 0 ]
[.80126 .29652 -6 -9 ]
[.80126 .29652 6 0 ]
[.99563 .29652 -6 -9 ]
[.99563 .29652 6 0 ]
[.01131 .06051 -30 -4.5 ]
[.01131 .06051 0 4.5 ]
[.01131 .14334 -24 -4.5 ]
[.01131 .14334 0 4.5 ]
[.01131 .22618 -30 -4.5 ]
[.01131 .22618 0 4.5 ]
[.01131 .39185 -24 -4.5 ]
[.01131 .39185 0 4.5 ]
[.01131 .47469 -18 -4.5 ]
[.01131 .47469 0 4.5 ]
[.01131 .55753 -24 -4.5 ]
[.01131 .55753 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21817 .30902 m
.21817 .31527 L
s
[(10)] .21817 .29652 0 1 Mshowa
.41254 .30902 m
.41254 .31527 L
s
[(20)] .41254 .29652 0 1 Mshowa
.6069 .30902 m
.6069 .31527 L
s
[(30)] .6069 .29652 0 1 Mshowa
.80126 .30902 m
.80126 .31527 L
s
[(40)] .80126 .29652 0 1 Mshowa
.99563 .30902 m
.99563 .31527 L
s
[(50)] .99563 .29652 0 1 Mshowa
.125 Mabswid
.06268 .30902 m
.06268 .31277 L
s
.10155 .30902 m
.10155 .31277 L
s
.14043 .30902 m
.14043 .31277 L
s
.1793 .30902 m
.1793 .31277 L
s
.25705 .30902 m
.25705 .31277 L
s
.29592 .30902 m
.29592 .31277 L
s
.33479 .30902 m
.33479 .31277 L
s
.37366 .30902 m
.37366 .31277 L
s
.45141 .30902 m
.45141 .31277 L
s
.49028 .30902 m
.49028 .31277 L
s
.52915 .30902 m
.52915 .31277 L
s
.56803 .30902 m
.56803 .31277 L
s
.64577 .30902 m
.64577 .31277 L
s
.68465 .30902 m
.68465 .31277 L
s
.72352 .30902 m
.72352 .31277 L
s
.76239 .30902 m
.76239 .31277 L
s
.84014 .30902 m
.84014 .31277 L
s
.87901 .30902 m
.87901 .31277 L
s
.91788 .30902 m
.91788 .31277 L
s
.95675 .30902 m
.95675 .31277 L
s
.25 Mabswid
0 .30902 m
1 .30902 L
s
.02381 .06051 m
.03006 .06051 L
s
[(-0.75)] .01131 .06051 1 0 Mshowa
.02381 .14334 m
.03006 .14334 L
s
[(-0.5)] .01131 .14334 1 0 Mshowa
.02381 .22618 m
.03006 .22618 L
s
[(-0.25)] .01131 .22618 1 0 Mshowa
.02381 .39185 m
.03006 .39185 L
s
[(0.25)] .01131 .39185 1 0 Mshowa
.02381 .47469 m
.03006 .47469 L
s
[(0.5)] .01131 .47469 1 0 Mshowa
.02381 .55753 m
.03006 .55753 L
s
[(0.75)] .01131 .55753 1 0 Mshowa
.125 Mabswid
.02381 .07707 m
.02756 .07707 L
s
.02381 .09364 m
.02756 .09364 L
s
.02381 .11021 m
.02756 .11021 L
s
.02381 .12678 m
.02756 .12678 L
s
.02381 .15991 m
.02756 .15991 L
s
.02381 .17648 m
.02756 .17648 L
s
.02381 .19305 m
.02756 .19305 L
s
.02381 .20961 m
.02756 .20961 L
s
.02381 .24275 m
.02756 .24275 L
s
.02381 .25931 m
.02756 .25931 L
s
.02381 .27588 m
.02756 .27588 L
s
.02381 .29245 m
.02756 .29245 L
s
.02381 .32558 m
.02756 .32558 L
s
.02381 .34215 m
.02756 .34215 L
s
.02381 .35872 m
.02756 .35872 L
s
.02381 .37529 m
.02756 .37529 L
s
.02381 .40842 m
.02756 .40842 L
s
.02381 .42499 m
.02756 .42499 L
s
.02381 .44156 m
.02756 .44156 L
s
.02381 .45812 m
.02756 .45812 L
s
.02381 .49126 m
.02756 .49126 L
s
.02381 .50783 m
.02756 .50783 L
s
.02381 .52439 m
.02756 .52439 L
s
.02381 .54096 m
.02756 .54096 L
s
.02381 .04394 m
.02756 .04394 L
s
.02381 .02737 m
.02756 .02737 L
s
.02381 .0108 m
.02756 .0108 L
s
.02381 .57409 m
.02756 .57409 L
s
.02381 .59066 m
.02756 .59066 L
s
.02381 .60723 m
.02756 .60723 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.04325 .01472 m
.06268 .01906 L
.08212 .02387 L
.10155 .02919 L
.12099 .03508 L
.14043 .04156 L
.15986 .04869 L
.1793 .05651 L
.19874 .06507 L
.21817 .0744 L
.23761 .08454 L
.25705 .09552 L
.27648 .10737 L
.29592 .12009 L
.31535 .1337 L
.33479 .14819 L
.35423 .16352 L
.37366 .17967 L
.3931 .19658 L
.41254 .21418 L
.43197 .23238 L
.45141 .25108 L
.47085 .27017 L
.49028 .28953 L
.50972 .30902 L
.52915 .32851 L
.54859 .34786 L
.56803 .36695 L
.58746 .38566 L
.6069 .40385 L
.62634 .42145 L
.64577 .43836 L
.66521 .45451 L
.68465 .46985 L
.70408 .48433 L
.72352 .49794 L
.74295 .51067 L
.76239 .52252 L
.78183 .5335 L
.80126 .54364 L
.8207 .55297 L
.84014 .56152 L
.85957 .56934 L
.87901 .57647 L
.89845 .58296 L
.91788 .58884 L
.93732 .59417 L
.95675 .59898 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`008@3oool00`000000oooo0?oo
o`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?oo
o`008@3oool200000?d0oooo000Q0?ooo`030000003oool0oooo0080oooo0`00003g0?ooo`008@3o
ool00`000000oooo0?ooo`050?ooo`D00000lP3oool00240oooo00<000000?ooo`3oool02P3oool4
00000>h0oooo000Q0?ooo`8000003`3oool200000>`0oooo000Q0?ooo`030000003oool0oooo0100
oooo0`00003Y0?ooo`008@3oool00`000000oooo0?ooo`0C0?ooo`@00000i@3oool00240oooo00<0
00000?ooo`3oool05`3oool200000><0oooo000Q0?ooo`8000006P3oool300000>00oooo000Q0?oo
o`030000003oool0oooo01`0oooo0P00003N0?ooo`008@3oool00`000000oooo0?ooo`0N0?ooo`<0
0000f`3oool000P0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`800000
1@3oool00`000000oooo0?ooo`0Q0?ooo`800000f@3oool000L0oooo00@000000?ooo`3oool00000
2P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`0S0?ooo`<00000eP3oool000L0oooo00@000000?ooo`3oool000002P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo0080oooo0P00000W0?ooo`800000e03oool000030?oo
o`0000000000008000000P3oool010000000oooo0?ooo`00000;0?ooo`040000003oool0oooo0?oo
o`8000001@3oool00`000000oooo0?ooo`0X0?ooo`<00000d@3oool000L0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool0:`3oool200000<l0oooo00080?ooo`8000002@3oool4000000<0oooo0`0000040?oo
o`030000003oool0oooo02d0oooo0P00003=0?ooo`008@3oool200000300oooo0P00003;0?ooo`00
8@3oool00`000000oooo0?ooo`0a0?ooo`800000b@3oool00240oooo00<000000?ooo`3oool0<`3o
ool00`000000oooo0?ooo`360?ooo`008@3oool00`000000oooo0?ooo`0d0?ooo`800000aP3oool0
0240oooo0P00000g0?ooo`800000a03oool00240oooo00<000000?ooo`3oool0>03oool00`000000
oooo0?ooo`310?ooo`008@3oool00`000000oooo0?ooo`0i0?ooo`800000`@3oool00240oooo00<0
00000?ooo`3oool0>`3oool200000;l0oooo000Q0?ooo`800000?P3oool00`000000oooo0?ooo`2l
0?ooo`008@3oool00`000000oooo0?ooo`0n0?ooo`800000_03oool00240oooo00<000000?ooo`3o
ool0@03oool200000;X0oooo000Q0?ooo`030000003oool0oooo0480oooo00<000000?ooo`3oool0
]`3oool00240oooo00<000000?ooo`3oool0@`3oool200000;L0oooo000Q0?ooo`800000AP3oool2
00000;D0oooo000Q0?ooo`030000003oool0oooo04L0oooo00<000000?ooo`3oool0/P3oool000h0
oooo0P0000040?ooo`800000103oool2000000D0oooo00<000000?ooo`3oool0B03oool00`000000
oooo0?ooo`2a0?ooo`003@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
00@0oooo00<000000?ooo`3oool0B@3oool200000;40oooo000=0?ooo`040000003oool0oooo0000
00/0oooo00<000000?ooo`3oool00P3oool2000004`0oooo00<000000?ooo`3oool0[P3oool000L0
oooo100000020?ooo`040000003oool0oooo000000T0oooo0P0000050?ooo`030000003oool0oooo
04`0oooo00<000000?ooo`3oool0[@3oool000d0oooo00@000000?ooo`3oool000002@3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo04d0oooo00<000000?ooo`3oool0[03oool000h0
oooo0P00000:0?ooo`<00000103oool00`000000oooo0?ooo`1>0?ooo`800000[03oool00240oooo
0P00001A0?ooo`030000003oool0oooo0:T0oooo000Q0?ooo`030000003oool0oooo0540oooo00<0
00000?ooo`3oool0Z03oool00240oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`2W
0?ooo`008@3oool00`000000oooo0?ooo`1C0?ooo`800000Y`3oool00240oooo0P00001F0?ooo`03
0000003oool0oooo0:@0oooo000Q0?ooo`030000003oool0oooo05H0oooo00<000000?ooo`3oool0
X`3oool00240oooo00<000000?ooo`3oool0E`3oool00`000000oooo0?ooo`2R0?ooo`008@3oool0
0`000000oooo0?ooo`1H0?ooo`800000XP3oool00240oooo0P00001K0?ooo`030000003oool0oooo
09l0oooo000Q0?ooo`030000003oool0oooo05/0oooo00<000000?ooo`3oool0WP3oool00240oooo
00<000000?ooo`3oool0G03oool00`000000oooo0?ooo`2M0?ooo`008@3oool00`000000oooo0?oo
o`1M0?ooo`030000003oool0oooo09`0oooo000Q0?ooo`030000003oool0oooo05h0oooo00<00000
0?ooo`3oool0V`3oool00240oooo0P00001P0?ooo`030000003oool0oooo09X0oooo000Q0?ooo`03
0000003oool0oooo0600oooo00<000000?ooo`3oool0V@3oool000P0oooo0P0000040?ooo`800000
0`3oool4000000<0oooo0P0000050?ooo`030000003oool0oooo0640oooo00<000000?ooo`3oool0
V03oool000L0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`030?ooo`040000
003oool0oooo000000@0oooo00<000000?ooo`3oool0HP3oool2000009P0oooo00070?ooo`040000
003oool0oooo000000T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`020?ooo`80
0000I@3oool00`000000oooo0?ooo`2E0?ooo`0000<0oooo0000000000000P0000020?ooo`040000
003oool0oooo000000X0oooo00<000000?ooo`3oool00P3oool2000000D0oooo00<000000?ooo`3o
ool0I@3oool00`000000oooo0?ooo`2D0?ooo`001`3oool010000000oooo0?ooo`0000080?ooo`04
0000003oool0oooo000000<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1V0?oo
o`030000003oool0oooo09<0oooo00080?ooo`8000002P3oool2000000@0oooo0`0000040?ooo`03
0000003oool0oooo06L0oooo00<000000?ooo`3oool0TP3oool00240oooo0P00001Y0?ooo`030000
003oool0oooo0940oooo000Q0?ooo`030000003oool0oooo06T0oooo00<000000?ooo`3oool0T03o
ool00240oooo00<000000?ooo`3oool0JP3oool00`000000oooo0?ooo`2?0?ooo`008@3oool00`00
0000oooo0?ooo`1[0?ooo`030000003oool0oooo08h0oooo000Q0?ooo`800000K@3oool00`000000
oooo0?ooo`2=0?ooo`008@3oool00`000000oooo0?ooo`1]0?ooo`030000003oool0oooo08`0oooo
000Q0?ooo`030000003oool0oooo02T0oooo1@0000020?ooo`800000:@3oool4000000<0oooo0P00
000:0?ooo`030000003oool0oooo01`0oooo0P0000040?ooo`800000:`3oool300000080oooo0P00
000Z0?ooo`800000103oool2000000<0oooo000Q0?ooo`030000003oool0oooo02/0oooo00D00000
0?ooo`3oool0oooo000000020?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool00`3o
ool010000000oooo0?ooo`00000:0?ooo`030000003oool0oooo01X0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000[0?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool09P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo
000Q0?ooo`030000003oool0oooo02/0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000
003oool0oooo02L0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00000;0?ooo`03
0000003oool0oooo01/0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo
02H0oooo1@0000001@3oool000000?ooo`3oool0000002/0oooo00@000000?ooo`3oool000000P3o
ool100000040oooo0@3oool00240oooo0P00000/0?ooo`050000003oool0oooo0?ooo`0000000P3o
ool00`000000oooo0?ooo`0X0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo01/0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`0V0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000:@3oool2
000000<0oooo00@000000?ooo`3oool000000P3oool00240oooo00<000000?ooo`3oool0:`3oool0
1@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool09P3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo000000d0oooo00<000000?ooo`3oool05`3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000002T0oooo00<000000?ooo`0000000P3oool0
10000000oooo0?ooo`00000Y0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000
0P3oool00240oooo00<000000?ooo`3oool0:P3oool2000000@0oooo0P00000Z0?ooo`800000103o
ool2000000l0oooo00<000000?ooo`3oool05`3oool2000000@0oooo0P00000[0?ooo`8000000`3o
ool2000002X0oooo0`0000030?ooo`8000000`3oool00240oooo00<000000?ooo`3oool0M03oool0
0`000000oooo0?ooo`250?ooo`008@3oool2000007H0oooo00<000000?ooo`3oool0Q03oool00240
oooo00<000000?ooo`3oool0MP3oool00`000000oooo0?ooo`230?ooo`008@3oool00`000000oooo
0?ooo`1g0?ooo`030000003oool0oooo0880oooo000Q0?ooo`030000003oool0oooo07P0oooo00<0
00000?ooo`3oool0P@3oool001/0ooooo`000001000000D0oooo000Q0?ooo`030000003oool0oooo
00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
00<0oooo00D000000?ooo`3oool0oooo000000080?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`040?ooo`008@3oool00`000000oooo0?ooo`0^0?oo
o`030000003oool0oooo02l0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0C0?oo
o`030000003oool0oooo02l0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`040?oo
o`008@3oool00`000000oooo0?ooo`1l0?ooo`030000003oool0oooo07d0oooo000Q0?ooo`800000
OP3oool00`000000oooo0?ooo`1l0?ooo`008@3oool00`000000oooo0?ooo`1n0?ooo`030000003o
ool0oooo07/0oooo000Q0?ooo`030000003oool0oooo07l0oooo00<000000?ooo`3oool0NP3oool0
0240oooo00<000000?ooo`3oool0P03oool00`000000oooo0?ooo`1i0?ooo`008@3oool200000880
oooo00<000000?ooo`3oool0N03oool00240oooo00<000000?ooo`3oool0PP3oool00`000000oooo
0?ooo`1g0?ooo`008@3oool00`000000oooo0?ooo`230?ooo`030000003oool0oooo07H0oooo000Q
0?ooo`030000003oool0oooo08@0oooo00<000000?ooo`3oool0M@3oool00240oooo00<000000?oo
o`3oool0Q@3oool00`000000oooo0?ooo`1d0?ooo`008@3oool2000008H0oooo00<000000?ooo`3o
ool0M03oool00240oooo00<000000?ooo`3oool0QP3oool00`000000oooo0?ooo`1c0?ooo`008@3o
ool00`000000oooo0?ooo`270?ooo`030000003oool0oooo0780oooo000Q0?ooo`030000003oool0
oooo08P0oooo00<000000?ooo`3oool0L@3oool00240oooo0P00002:0?ooo`030000003oool0oooo
0700oooo000Q0?ooo`030000003oool0oooo08X0oooo00<000000?ooo`3oool0K`3oool000P0oooo
0P0000040?ooo`8000000`3oool4000000<0oooo0P0000050?ooo`030000003oool0oooo08/0oooo
00<000000?ooo`3oool0KP3oool000L0oooo00@000000?ooo`3oool00000203oool00`000000oooo
0?ooo`030?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0S03oool00`000000
oooo0?ooo`1]0?ooo`001`3oool010000000oooo0?ooo`0000090?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool00P3oool2000008h0oooo00<000000?ooo`3oool0K03oool000L0oooo
00@000000?ooo`3oool000002P3oool00`000000oooo0?ooo`020?ooo`8000001@3oool00`000000
oooo0?ooo`2>0?ooo`800000K03oool000L0oooo00@000000?ooo`3oool00000203oool010000000
oooo0?ooo`0000030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T03oool00`00
0000oooo0?ooo`1Y0?ooo`00203oool2000000X0oooo0P0000040?ooo`<00000103oool00`000000
oooo0?ooo`2A0?ooo`030000003oool0oooo06P0oooo000Q0?ooo`800000T`3oool00`000000oooo
0?ooo`1W0?ooo`008@3oool00`000000oooo0?ooo`2C0?ooo`030000003oool0oooo06H0oooo000Q
0?ooo`030000003oool0oooo09@0oooo00<000000?ooo`3oool0I@3oool00240oooo00<000000?oo
o`3oool0U@3oool00`000000oooo0?ooo`1T0?ooo`008@3oool00`000000oooo0?ooo`2F0?ooo`03
0000003oool0oooo06<0oooo000Q0?ooo`800000V03oool00`000000oooo0?ooo`1R0?ooo`008@3o
ool00`000000oooo0?ooo`2H0?ooo`800000HP3oool00240oooo00<000000?ooo`3oool0VP3oool0
0`000000oooo0?ooo`1O0?ooo`008@3oool00`000000oooo0?ooo`2K0?ooo`030000003oool0oooo
05h0oooo000Q0?ooo`800000W@3oool00`000000oooo0?ooo`1M0?ooo`008@3oool00`000000oooo
0?ooo`2M0?ooo`800000G@3oool00240oooo00<000000?ooo`3oool0W`3oool00`000000oooo0?oo
o`1J0?ooo`008@3oool00`000000oooo0?ooo`2P0?ooo`030000003oool0oooo05T0oooo000Q0?oo
o`800000XP3oool00`000000oooo0?ooo`1H0?ooo`008@3oool00`000000oooo0?ooo`2R0?ooo`80
0000F03oool000h0oooo0P0000040?ooo`800000103oool2000000D0oooo00<000000?ooo`3oool0
Y03oool00`000000oooo0?ooo`1E0?ooo`003@3oool010000000oooo0?ooo`0000080?ooo`040000
003oool0oooo000000@0oooo00<000000?ooo`3oool0Y@3oool00`000000oooo0?ooo`1D0?ooo`00
3@3oool010000000oooo0?ooo`00000;0?ooo`030000003oool0oooo0080oooo0P00002W0?ooo`03
0000003oool0oooo05<0oooo000=0?ooo`040000003oool0oooo000000T0oooo0P0000050?ooo`03
0000003oool0oooo0:L0oooo0P00001C0?ooo`003@3oool010000000oooo0?ooo`0000090?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0Z@3oool00`000000oooo0?ooo`1@0?ooo`00
3P3oool2000000X0oooo0`0000040?ooo`030000003oool0oooo0:X0oooo00<000000?ooo`3oool0
C`3oool00240oooo00<000000?ooo`3oool0Z`3oool2000004l0oooo000Q0?ooo`800000[P3oool2
000004d0oooo000Q0?ooo`030000003oool0oooo0:l0oooo00<000000?ooo`3oool0BP3oool00240
oooo00<000000?ooo`3oool0/03oool2000004X0oooo000Q0?ooo`030000003oool0oooo0;80oooo
0P0000180?ooo`008@3oool200000;D0oooo00<000000?ooo`3oool0A@3oool00240oooo00<00000
0?ooo`3oool0]@3oool2000004D0oooo000Q0?ooo`030000003oool0oooo0;L0oooo0P0000130?oo
o`008@3oool00`000000oooo0?ooo`2i0?ooo`030000003oool0oooo0400oooo000Q0?ooo`800000
^`3oool200000400oooo000Q0?ooo`030000003oool0oooo0;`0oooo0P00000n0?ooo`008@3oool0
0`000000oooo0?ooo`2n0?ooo`030000003oool0oooo03/0oooo000Q0?ooo`030000003oool0oooo
0;l0oooo0P00000k0?ooo`008@3oool200000<80oooo0P00000i0?ooo`008@3oool00`000000oooo
0?ooo`330?ooo`800000=`3oool000P0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?oo
o`020?ooo`8000001@3oool00`000000oooo0?ooo`350?ooo`800000=@3oool000L0oooo00@00000
0?ooo`3oool000002P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`370?ooo`<00000<P3oool000L0oooo00@000000?ooo`3oool00000
2P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo0P00003;0?ooo`800000
<03oool000L0oooo00@000000?ooo`3oool000002`3oool010000000oooo0?ooo`3oool2000000D0
oooo00<000000?ooo`3oool0c03oool3000002d0oooo00070?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
0<l0oooo0P00000[0?ooo`00203oool2000000T0oooo100000030?ooo`<00000103oool00`000000
oooo0?ooo`3A0?ooo`<00000:03oool00240oooo00<000000?ooo`3oool0e03oool2000002H0oooo
000Q0?ooo`800000e`3oool3000002<0oooo000Q0?ooo`030000003oool0oooo0=T0oooo0P00000Q
0?ooo`008@3oool00`000000oooo0?ooo`3K0?ooo`@000007@3oool00240oooo00<000000?ooo`3o
ool0g`3oool4000001T0oooo000Q0?ooo`800000i03oool2000001L0oooo000Q0?ooo`030000003o
ool0oooo0>D0oooo1000000C0?ooo`008@3oool00`000000oooo0?ooo`3Y0?ooo`D000003P3oool0
0240oooo00<000000?ooo`3oool0kP3oool3000000/0oooo000Q0?ooo`800000o@3oool00240oooo
00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<00000
0?ooo`3oool0o03oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3o
ool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3o
ool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-6.69641, -1.04707, \
0.201768, 0.0118354}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["9: The Table method", "Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "Similar to the Array method, these two have a lot of overlapping \
functionality. ",
  StyleBox["Evaluate ",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  "and notice we didn't have to redefine f, because this variable has \
notebook level scope. ",
  StyleBox["(2 pts)",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  " ",
  StyleBox["Create a second list populated with decimal approximations of f.",
    
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(myTableGeneratedList\  = 
        Table[f[x], \ {x, 2, 20, 2}];\)\), "\[IndentingNewLine]", 
    \(myTableGeneratedList\)}], "Input"],

Cell[BoxData[
    \({3\ Tanh[2], 3\ Tanh[4], 3\ Tanh[6], 3\ Tanh[8], 3\ Tanh[10], 
      3\ Tanh[12], 3\ Tanh[14], 3\ Tanh[16], 3\ Tanh[18], 
      3\ Tanh[20]}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(myList\  = \ 
        Table[N[f[x]], \ {x, \ 2, \ 20, \ 2}];\)\), "\[IndentingNewLine]", 
    \(myList\), "\[IndentingNewLine]", 
    \(\)}], "Input"],

Cell[BoxData[
    \({2.8920827402274507`, 2.9979878992172013`, 2.9999631349523868`, 
      2.9999993247890275`, 2.9999999876330783`, 2.999999999773492`, 
      2.9999999999958513`, 2.999999999999924`, 2.9999999999999987`, 
      3.`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["10: Recursive functions", "Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "Recursive functions take whole numbers as inputs,  while their output \
variables can be as simple as true/false, whole numbers, or as complicated as \
you can imagine. A recursive function, rF, is made out of a regular function, \
f, and a seed value, s. s is usually the same type of thing as the output of \
f. \nrF(0) = s\nrF(1) = f(s)\nrF(2) = f(f(s)), or generally speaking, rF(n) = \
f(rF(n-1)).\n",
  StyleBox["(2 pts)",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  " ",
  StyleBox["In the cell below is the definition of a ",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  StyleBox["Mathematica",
    FontWeight->"Bold",
    FontSlant->"Italic",
    FontColor->RGBColor[0, 0, 1]],
  StyleBox[" function that doubles at every step. Insert some expressions \
that evaluate it at a few more steps.  What is the function \"f\" in this \
case?",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(rF[t_] := \ \(rF[t]\  = \ rF[t - 1]*2\);\)\), "\[IndentingNewLine]", 
    \(\(rF[0]\  = \ 7;\)\), "\[IndentingNewLine]", 
    \(rF[3]\)}], "Input"],

Cell[BoxData[
    \(56\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(rF[4]\[IndentingNewLine]
    rF[5]\[IndentingNewLine]
    rF[6]\)\)\)], "Input"],

Cell[BoxData[
    \(112\)], "Output"],

Cell[BoxData[
    \(224\)], "Output"],

Cell[BoxData[
    \(448\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "\n",
  StyleBox["In this case, f(x) = 2x.",
    Evaluatable->False,
    FontColor->RGBColor[1, 0.501961, 1]]
}], "Input",
  FormatType->TextForm],

Cell[CellGroupData[{

Cell[TextData[StyleBox["11: Modeling population growth", "Subsection"]], \
"Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "Recursive functions are perfect for modeling systems that change in a step \
by step way at regular time points. Dynamic systems such as populations of \
organisms don't change their numbers on a fixed schedule, but recursive \
functions can be a good rough model, since the population at year n has a big \
influence on the population at year n+1.  ",
  StyleBox["(2 pts)",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]],
  " ",
  StyleBox["Use the methods in steps 6-9 to create a graph of F defined \
above. Can you think of a real biological system that F is a good model for?",
    
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"ListPlot", "[", 
        RowBox[{\(Table[rF[t], \ {t, \ 0, 10}]\), ",", 
          StyleBox[" ",
            FontWeight->"Plain"], 
          RowBox[{
            StyleBox["PlotJoined",
              "MR",
              FontWeight->"Plain"], 
            StyleBox[" ",
              FontWeight->"Plain"], 
            StyleBox["\[Rule]",
              FontWeight->"Plain"], 
            StyleBox[" ",
              FontWeight->"Plain"], 
            StyleBox["True",
              "MR",
              FontWeight->"Plain"]}]}], 
        StyleBox["]",
          FontWeight->"Plain"]}], "\[IndentingNewLine]"}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0714286 0.0952381 0.0141397 8.21958e-005 [
[.30952 .00164 -3 -9 ]
[.30952 .00164 3 0 ]
[.5 .00164 -3 -9 ]
[.5 .00164 3 0 ]
[.69048 .00164 -3 -9 ]
[.69048 .00164 3 0 ]
[.88095 .00164 -6 -9 ]
[.88095 .00164 6 0 ]
[.10655 .09634 -24 -4.5 ]
[.10655 .09634 0 4.5 ]
[.10655 .17853 -24 -4.5 ]
[.10655 .17853 0 4.5 ]
[.10655 .26073 -24 -4.5 ]
[.10655 .26073 0 4.5 ]
[.10655 .34292 -24 -4.5 ]
[.10655 .34292 0 4.5 ]
[.10655 .42512 -24 -4.5 ]
[.10655 .42512 0 4.5 ]
[.10655 .50731 -24 -4.5 ]
[.10655 .50731 0 4.5 ]
[.10655 .58951 -24 -4.5 ]
[.10655 .58951 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.30952 .01414 m
.30952 .02039 L
s
[(4)] .30952 .00164 0 1 Mshowa
.5 .01414 m
.5 .02039 L
s
[(6)] .5 .00164 0 1 Mshowa
.69048 .01414 m
.69048 .02039 L
s
[(8)] .69048 .00164 0 1 Mshowa
.88095 .01414 m
.88095 .02039 L
s
[(10)] .88095 .00164 0 1 Mshowa
.125 Mabswid
.16667 .01414 m
.16667 .01789 L
s
.21429 .01414 m
.21429 .01789 L
s
.2619 .01414 m
.2619 .01789 L
s
.35714 .01414 m
.35714 .01789 L
s
.40476 .01414 m
.40476 .01789 L
s
.45238 .01414 m
.45238 .01789 L
s
.54762 .01414 m
.54762 .01789 L
s
.59524 .01414 m
.59524 .01789 L
s
.64286 .01414 m
.64286 .01789 L
s
.7381 .01414 m
.7381 .01789 L
s
.78571 .01414 m
.78571 .01789 L
s
.83333 .01414 m
.83333 .01789 L
s
.07143 .01414 m
.07143 .01789 L
s
.02381 .01414 m
.02381 .01789 L
s
.92857 .01414 m
.92857 .01789 L
s
.97619 .01414 m
.97619 .01789 L
s
.25 Mabswid
0 .01414 m
1 .01414 L
s
.11905 .09634 m
.1253 .09634 L
s
[(1000)] .10655 .09634 1 0 Mshowa
.11905 .17853 m
.1253 .17853 L
s
[(2000)] .10655 .17853 1 0 Mshowa
.11905 .26073 m
.1253 .26073 L
s
[(3000)] .10655 .26073 1 0 Mshowa
.11905 .34292 m
.1253 .34292 L
s
[(4000)] .10655 .34292 1 0 Mshowa
.11905 .42512 m
.1253 .42512 L
s
[(5000)] .10655 .42512 1 0 Mshowa
.11905 .50731 m
.1253 .50731 L
s
[(6000)] .10655 .50731 1 0 Mshowa
.11905 .58951 m
.1253 .58951 L
s
[(7000)] .10655 .58951 1 0 Mshowa
.125 Mabswid
.11905 .03058 m
.1228 .03058 L
s
.11905 .04702 m
.1228 .04702 L
s
.11905 .06346 m
.1228 .06346 L
s
.11905 .0799 m
.1228 .0799 L
s
.11905 .11277 m
.1228 .11277 L
s
.11905 .12921 m
.1228 .12921 L
s
.11905 .14565 m
.1228 .14565 L
s
.11905 .16209 m
.1228 .16209 L
s
.11905 .19497 m
.1228 .19497 L
s
.11905 .21141 m
.1228 .21141 L
s
.11905 .22785 m
.1228 .22785 L
s
.11905 .24429 m
.1228 .24429 L
s
.11905 .27717 m
.1228 .27717 L
s
.11905 .29361 m
.1228 .29361 L
s
.11905 .31004 m
.1228 .31004 L
s
.11905 .32648 m
.1228 .32648 L
s
.11905 .35936 m
.1228 .35936 L
s
.11905 .3758 m
.1228 .3758 L
s
.11905 .39224 m
.1228 .39224 L
s
.11905 .40868 m
.1228 .40868 L
s
.11905 .44156 m
.1228 .44156 L
s
.11905 .458 m
.1228 .458 L
s
.11905 .47444 m
.1228 .47444 L
s
.11905 .49088 m
.1228 .49088 L
s
.11905 .52375 m
.1228 .52375 L
s
.11905 .54019 m
.1228 .54019 L
s
.11905 .55663 m
.1228 .55663 L
s
.11905 .57307 m
.1228 .57307 L
s
.11905 .60595 m
.1228 .60595 L
s
.25 Mabswid
.11905 0 m
.11905 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01472 m
.11905 .01529 L
.21429 .01644 L
.30952 .01874 L
.40476 .02335 L
.5 .03255 L
.59524 .05096 L
.69048 .08779 L
.78571 .16143 L
.88095 .30873 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00F`3oool3000002l0oooo0`00000b0?ooo`800000;P3oool500000080oooo0P00000U0?oo
o`00G03oool00`000000oooo0?ooo`0^0?ooo`040000003oool0oooo00000300oooo00@000000?oo
o`3oool00000;`3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool08P3o
ool005T0oooo1@00000_0?ooo`040000003oool0oooo00000300oooo00@000000?ooo`3oool00000
;`3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool08P3oool005T0oooo
00@000000?ooo`3oool00000<03oool300000380oooo0P00000`0?ooo`050000003oool0oooo0?oo
o`0000000P3oool00`000000oooo0?ooo`0R0?ooo`00FP3oool00`000000oooo0000000a0?ooo`03
0000003oool0oooo0300oooo00@000000?ooo`3oool00000;`3oool01@000000oooo0?ooo`3oool0
00000080oooo00<000000?ooo`3oool08P3oool005/0oooo0P00000a0?ooo`<00000<@3oool20000
02l0oooo0P0000040?ooo`8000009@3oool00?l0oooo8@3oool002L0oooo00<000000?ooo`3oool0
mP3oool002L0oooo00<000000?ooo`3oool0mP3oool002L0oooo00<000000?ooo`3oool0mP3oool0
02L0oooo00<000000?ooo`3oool0mP3oool000L0ooooo`00000B000000P0oooo000=0?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooocD00000
303oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`0<0?ooo`009`3oool00`000000oooo0?ooo`0a0?ooo`030000003o
ool0oooo00X0oooo4P00000E0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0<@3o
ool00`000000oooo0?ooo`0V0?ooo`009`3oool00`000000oooo0?ooo`1@0?ooo`P00000WP3oool0
02L0oooo0P00001I0?ooo`T00000U@3oool002L0oooo00<000000?ooo`3oool0H@3oool7000008h0
oooo000W0?ooo`030000003oool0oooo06P0oooo1@0000290?ooo`009`3oool00`000000oooo0?oo
o`1]0?ooo`D00000Q03oool002L0oooo00<000000?ooo`3oool0LP3oool6000007h0oooo000W0?oo
o`800000N@3oool5000007T0oooo000W0?ooo`030000003oool0oooo07d0oooo1000001e0?ooo`00
9`3oool00`000000oooo0?ooo`210?ooo`800000L`3oool002L0oooo00<000000?ooo`3oool0P`3o
ool300000700oooo000W0?ooo`800000Q`3oool3000006d0oooo000W0?ooo`030000003oool0oooo
08T0oooo0P00001[0?ooo`009`3oool00`000000oooo0?ooo`2;0?ooo`<00000J03oool002L0oooo
00<000000?ooo`3oool0SP3oool2000006H0oooo000W0?ooo`030000003oool0oooo0900oooo0`00
001S0?ooo`009`3oool2000009@0oooo0`00001P0?ooo`009`3oool00`000000oooo0?ooo`2F0?oo
o`800000GP3oool000d0oooo1@0000020?ooo`800000103oool2000000@0oooo0P0000050?ooo`03
0000003oool0oooo09P0oooo0P00001L0?ooo`003`3oool01@000000oooo0?ooo`3oool000000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0VP3oool00`000000oooo0?ooo`1I0?ooo`003`3oool01@00
0000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo0080oooo0`00002K0?ooo`800000F@3oool000l0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo09d0oooo00<000000?oo
o`3oool0EP3oool000l0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo09h0oooo00<000000?ooo`3oool0E@3oool000h0oooo0P0000040?ooo`800000103oool2
000000@0oooo0P0000050?ooo`030000003oool0oooo09l0oooo0P00001E0?ooo`009`3oool00`00
0000oooo0?ooo`2Q0?ooo`030000003oool0oooo0580oooo000W0?ooo`800000X`3oool00`000000
oooo0?ooo`1A0?ooo`009`3oool00`000000oooo0?ooo`2S0?ooo`800000D@3oool002L0oooo00<0
00000?ooo`3oool0Y@3oool00`000000oooo0?ooo`1>0?ooo`009`3oool00`000000oooo0?ooo`2V
0?ooo`030000003oool0oooo04d0oooo000W0?ooo`800000Z03oool00`000000oooo0?ooo`1<0?oo
o`009`3oool00`000000oooo0?ooo`2X0?ooo`800000C03oool002L0oooo00<000000?ooo`3oool0
ZP3oool00`000000oooo0?ooo`190?ooo`009`3oool00`000000oooo0?ooo`2[0?ooo`030000003o
ool0oooo04P0oooo000W0?ooo`030000003oool0oooo0:`0oooo0P0000180?ooo`009`3oool20000
0:l0oooo00<000000?ooo`3oool0A@3oool002L0oooo00<000000?ooo`3oool0[`3oool00`000000
oooo0?ooo`140?ooo`009`3oool00`000000oooo0?ooo`2`0?ooo`800000A03oool002L0oooo00<0
00000?ooo`3oool0/P3oool00`000000oooo0?ooo`110?ooo`009`3oool200000;@0oooo00<00000
0?ooo`3oool0@03oool002L0oooo00<000000?ooo`3oool0]03oool00`000000oooo0?ooo`0o0?oo
o`009`3oool00`000000oooo0?ooo`2d0?ooo`030000003oool0oooo03l0oooo000=0?ooo`@00000
0`3oool2000000@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`2e0?ooo`030000
003oool0oooo03h0oooo000=0?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?oo
o`3oool0]P3oool00`000000oooo0?ooo`0m0?ooo`003P3oool00`000000oooo0?ooo`020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
00040?ooo`<00000]P3oool00`000000oooo0?ooo`0m0?ooo`003`3oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0]`3oool00`000000oooo0?ooo`0l0?ooo`00
3@3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0;P0oooo00<0
00000?ooo`3oool0>`3oool000h0oooo0P0000040?ooo`800000103oool2000000@0oooo0P000005
0?ooo`030000003oool0oooo0;P0oooo00<000000?ooo`3oool0>`3oool002L0oooo0P00002j0?oo
o`030000003oool0oooo03X0oooo000W0?ooo`030000003oool0oooo0;T0oooo00<000000?ooo`3o
ool0>P3oool002L0oooo00<000000?ooo`3oool0^P3oool00`000000oooo0?ooo`0i0?ooo`009`3o
ool00`000000oooo0?ooo`2k0?ooo`030000003oool0oooo03P0oooo000W0?ooo`030000003oool0
oooo0;/0oooo00<000000?ooo`3oool0>03oool002L0oooo0P00002m0?ooo`030000003oool0oooo
03L0oooo000W0?ooo`030000003oool0oooo0;d0oooo00<000000?ooo`3oool0=P3oool002L0oooo
00<000000?ooo`3oool0_@3oool00`000000oooo0?ooo`0f0?ooo`009`3oool00`000000oooo0?oo
o`2n0?ooo`030000003oool0oooo03D0oooo000W0?ooo`800000`03oool00`000000oooo0?ooo`0d
0?ooo`009`3oool00`000000oooo0?ooo`2o0?ooo`030000003oool0oooo03@0oooo000W0?ooo`03
0000003oool0oooo0<00oooo00<000000?ooo`3oool0<`3oool002L0oooo00<000000?ooo`3oool0
`@3oool00`000000oooo0?ooo`0b0?ooo`009`3oool00`000000oooo0?ooo`310?ooo`030000003o
ool0oooo0380oooo000W0?ooo`800000``3oool00`000000oooo0?ooo`0a0?ooo`009`3oool00`00
0000oooo0?ooo`330?ooo`030000003oool0oooo0300oooo000>0?ooo`800000103oool2000000@0
oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`330?ooo`030000003oool0oooo0300
oooo000=0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0a03o
ool00`000000oooo0?ooo`0_0?ooo`003`3oool01@000000oooo0?ooo`3oool000000080oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0080
oooo0`0000350?ooo`030000003oool0oooo02h0oooo000@0?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0a@3oool00`000000oooo0?ooo`0^0?ooo`003@3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0<H0oooo00<000000?ooo`3o
ool0;@3oool000h0oooo0P0000040?ooo`800000103oool2000000@0oooo0P0000050?ooo`030000
003oool0oooo0<H0oooo00<000000?ooo`3oool0;@3oool002L0oooo00<000000?ooo`3oool0a`3o
ool00`000000oooo0?ooo`0/0?ooo`009`3oool200000<T0oooo00<000000?ooo`3oool0:`3oool0
02L0oooo00<000000?ooo`3oool0b03oool00`000000oooo0?ooo`0[0?ooo`009`3oool00`000000
oooo0?ooo`390?ooo`030000003oool0oooo02X0oooo000W0?ooo`030000003oool0oooo0<X0oooo
00<000000?ooo`3oool0:@3oool002L0oooo0P00003;0?ooo`030000003oool0oooo02T0oooo000W
0?ooo`030000003oool0oooo0</0oooo00<000000?ooo`3oool0:03oool002L0oooo00<000000?oo
o`3oool0c03oool00`000000oooo0?ooo`0W0?ooo`009`3oool00`000000oooo0?ooo`3<0?ooo`03
0000003oool0oooo02L0oooo000W0?ooo`030000003oool0oooo0<d0oooo00<000000?ooo`3oool0
9P3oool002L0oooo0P00003>0?ooo`030000003oool0oooo02H0oooo000W0?ooo`030000003oool0
oooo0<h0oooo00<000000?ooo`3oool09@3oool002L0oooo00<000000?ooo`3oool0cP3oool00`00
0000oooo0?ooo`0U0?ooo`009`3oool00`000000oooo0?ooo`3>0?ooo`030000003oool0oooo02D0
oooo000W0?ooo`800000d03oool00`000000oooo0?ooo`0T0?ooo`009`3oool00`000000oooo0?oo
o`3?0?ooo`030000003oool0oooo02@0oooo000W0?ooo`030000003oool0oooo0<l0oooo00<00000
0?ooo`3oool0903oool000l0oooo0`0000020?ooo`800000103oool2000000@0oooo0P0000050?oo
o`030000003oool0oooo0=00oooo00<000000?ooo`3oool08`3oool00100oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`3@0?ooo`030000003oool0oooo02<0oooo000=
0?ooo`D0000000D0oooo0000003oool0oooo000000020?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool00000103oool300000=00oooo00<000000?ooo`3oool08`3oool000d0oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`3A0?ooo`030000003o
ool0oooo0280oooo000>0?ooo`030000003oool000000080oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3o
ool0d@3oool00`000000oooo0?ooo`0R0?ooo`003`3oool2000000<0oooo0P0000040?ooo`800000
103oool2000000D0oooo00<000000?ooo`3oool0d@3oool00`000000oooo0?ooo`0R0?ooo`009`3o
ool200000=<0oooo00<000000?ooo`3oool08@3oool002L0oooo00<000000?ooo`3oool0dP3oool0
0`000000oooo0?ooo`0Q0?ooo`009`3oool00`000000oooo0?ooo`3B0?ooo`030000003oool0oooo
0240oooo000W0?ooo`030000003oool0oooo0=<0oooo00<000000?ooo`3oool0803oool002L0oooo
00<000000?ooo`3oool0d`3oool00`000000oooo0?ooo`0P0?ooo`009`3oool200000=@0oooo00<0
00000?ooo`3oool0803oool002L0oooo00<000000?ooo`3oool0d`3oool00`000000oooo0?ooo`0P
0?ooo`009`3oool00`000000oooo0?ooo`3D0?ooo`030000003oool0oooo01l0oooo000W0?ooo`03
0000003oool0oooo0=@0oooo00<000000?ooo`3oool07`3oool002L0oooo0P00003E0?ooo`030000
003oool0oooo01l0oooo000W0?ooo`030000003oool0oooo0=D0oooo00<000000?ooo`3oool07P3o
ool002L0oooo00<000000?ooo`3oool0e@3oool00`000000oooo0?ooo`0N0?ooo`009`3oool00`00
0000oooo0?ooo`3E0?ooo`030000003oool0oooo01h0oooo000W0?ooo`800000e`3oool00`000000
oooo0?ooo`0M0?ooo`009`3oool00`000000oooo0?ooo`3F0?ooo`030000003oool0oooo01d0oooo
000W0?ooo`030000003oool0oooo0=H0oooo00<000000?ooo`3oool07@3oool000h0oooo0P000004
0?ooo`800000103oool2000000@0oooo0P0000050?ooo`030000003oool0oooo0=L0oooo00<00000
0?ooo`3oool0703oool000d0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000
oooo0?ooo`3G0?ooo`030000003oool0oooo01`0oooo000@0?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0
oooo0080oooo0`00003G0?ooo`030000003oool0oooo01`0oooo000>0?ooo`8000000`3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
103oool00`000000oooo0?ooo`3H0?ooo`030000003oool0oooo01/0oooo000>0?ooo`030000003o
ool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000000@0oooo00<000000?ooo`3oool0f03oool00`000000oooo0?ooo`0K0?oo
o`003P3oool3000000<0oooo0P0000040?ooo`800000103oool2000000D0oooo00<000000?ooo`3o
ool0f03oool00`000000oooo0?ooo`0K0?ooo`009`3oool200000=X0oooo00<000000?ooo`3oool0
6P3oool002L0oooo00<000000?ooo`3oool0f@3oool00`000000oooo0?ooo`0J0?ooo`009`3oool0
0`000000oooo0?ooo`3I0?ooo`030000003oool0oooo01X0oooo000W0?ooo`030000003oool0oooo
0=X0oooo00<000000?ooo`3oool06@3oool002L0oooo00<000000?ooo`3oool0fP3oool00`000000
oooo0?ooo`0I0?ooo`009`3oool200000=/0oooo00<000000?ooo`3oool06@3oool002L0oooo00<0
00000?ooo`3oool0f`3oool00`000000oooo0?ooo`0H0?ooo`009`3oool00`000000oooo0?ooo`3K
0?ooo`030000003oool0oooo01P0oooo000W0?ooo`030000003oool0oooo0=/0oooo00<000000?oo
o`3oool0603oool002L0oooo0P00003M0?ooo`030000003oool0oooo01L0oooo000W0?ooo`030000
003oool0oooo0=`0oooo00<000000?ooo`3oool05`3oool002L0oooo00<000000?ooo`3oool0g03o
ool00`000000oooo0?ooo`0G0?ooo`009`3oool00`000000oooo0?ooo`3M0?ooo`030000003oool0
oooo01H0oooo000W0?ooo`030000003oool0oooo0=d0oooo00<000000?ooo`3oool05P3oool002L0
oooo0P00003N0?ooo`030000003oool0oooo01H0oooo000W0?ooo`030000003oool0oooo0=h0oooo
00<000000?ooo`3oool05@3oool000d0oooo0`0000040?ooo`800000103oool2000000@0oooo0P00
00050?ooo`030000003oool0oooo0=h0oooo00<000000?ooo`3oool05@3oool000d0oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`3N0?ooo`030000003oool0oooo
01D0oooo000=0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo0`00003O0?ooo`030000
003oool0oooo01@0oooo000=0?ooo`<000000`3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`3O0?oo
o`030000003oool0oooo01@0oooo000>0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<0
00000?ooo`3oool0g`3oool00`000000oooo0?ooo`0D0?ooo`003P3oool3000000<0oooo0P000004
0?ooo`800000103oool2000000D0oooo00<000000?ooo`3oool0h03oool00`000000oooo0?ooo`0C
0?ooo`009`3oool00`000000oooo0?ooo`3P0?ooo`030000003oool0oooo01<0oooo000W0?ooo`80
0000h@3oool00`000000oooo0?ooo`0C0?ooo`009`3oool00`000000oooo0?ooo`3P0?ooo`030000
003oool0oooo01<0oooo000W0?ooo`030000003oool0oooo0>40oooo00<000000?ooo`3oool04P3o
ool002L0oooo00<000000?ooo`3oool0h@3oool00`000000oooo0?ooo`0B0?ooo`009`3oool20000
0>80oooo00<000000?ooo`3oool04P3oool002L0oooo00<000000?ooo`3oool0hP3oool00`000000
oooo0?ooo`0A0?ooo`009`3oool00`000000oooo0?ooo`3R0?ooo`030000003oool0oooo0140oooo
000W0?ooo`030000003oool0oooo0>80oooo00<000000?ooo`3oool04@3oool002L0oooo00<00000
0?ooo`3oool0h`3oool00`000000oooo0?ooo`0@0?ooo`009`3oool200000>@0oooo00<000000?oo
o`3oool0403oool002L0oooo00<000000?ooo`3oool0h`3oool00`000000oooo0?ooo`0@0?ooo`00
9`3oool00`000000oooo0?ooo`3T0?ooo`030000003oool0oooo00l0oooo000W0?ooo`030000003o
ool0oooo0>@0oooo00<000000?ooo`3oool03`3oool002L0oooo0P00003U0?ooo`030000003oool0
oooo00l0oooo000W0?ooo`030000003oool0oooo0>D0oooo00<000000?ooo`3oool03P3oool002L0
oooo00<000000?ooo`3oool0i@3oool00`000000oooo0?ooo`0>0?ooo`003`3oool00`000000oooo
0?ooo`020?ooo`800000103oool2000000@0oooo0P0000050?ooo`030000003oool0oooo0>D0oooo
00<000000?ooo`3oool03P3oool000l0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo0>H0oooo00<000000?ooo`3oool03@3oool000l0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`020?ooo`<00000iP3oool00`000000oooo0?ooo`0=0?ooo`00403oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0>H0oooo00<000000?ooo`3o
ool03@3oool000d0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?oo
o`3W0?ooo`030000003oool0oooo00`0oooo000=0?ooo`@000000`3oool2000000@0oooo0P000004
0?ooo`8000001@3oool00`000000oooo0?ooo`3W0?ooo`030000003oool0oooo00`0oooo000W0?oo
o`800000m`3oool002L0oooo00<000000?ooo`3oool0mP3oool002L0oooo00<000000?ooo`3oool0
mP3oool002L0oooo00<000000?ooo`3oool0mP3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {0.46964, -553.998, \
0.0385391, 44.6542}}],

Cell[TextData[{
  "\n",
  StyleBox["This population chart models pools of organisims with no \
predators and insignificant resource constraints, like bacterial cultures in \
\"mid log phase\", and people until recently.  ",
    Evaluatable->False,
    FontColor->RGBColor[1, 0.501961, 1]]
}], "Input",
  FormatType->TextForm],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[TextData[StyleBox["12: A more complex model", "Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "The logistic model is presented below. It is considered to be the simplest \
dynamical system that exhibits chaotic behavior. It is implemented here with \
three parameters: r, k, and g. Set these three numbers to different values, \
evaluate, and observe how the graph changes. In ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " it is necessary to clear a function before you change the parameters that \
are part of it's definition, which explains the first command: Clear[pop]. \
Note: use values for r, 0 < r < 4, or you will get overflow errors. Also, \
when setting r to a whole number, such as 2, put a decimal point after the \
number: write \"r = 2.\" instead of \"r=2\" . The latter will cause ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " to hang.  ",
  StyleBox["\n(12 pts) Match the four  parameters to the following \
definitions:\n1) The population at time zero.\n2) The number of generations.\n\
3) The capacity of the enviroment to sustain the population.\n4) The \
fertility of the organisims.\nCreate three copies of this cell. In one cell \
choose parameters that produce a graph that shows unchecked exponential \
growth, similar to the graph you created in (11). \nIn the second cell, set \
parameters that produce a graph that shows periodic behavior (i.e. the \
population changes from generation to generation in a regular way.\nIn the \
thrid cell, set parameters that result in chaotic behavior. Which parameter \
controls the chaotic/non-chaotic behavior of the system? ",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text"],

Cell[TextData[{
  StyleBox["r - A measure of the fecundity of the population.\nk - The \
carrying capacity of the enviroment: (1-pop[t]/k) becomes negative when the \
population exceeds k.\ng - The number of generations plotted.\ns - The \
population at time 0.\n\n",
    FontColor->RGBColor[1, 0.501961, 1]],
  StyleBox["The parameters below show unrestrained population growth.   A \
large carrying capacity was chosen, and saturation was avoided by choosing \
small enough k, g, and s.",
    Evaluatable->False,
    FontColor->RGBColor[1, 0.501961, 1]],
  "\n"
}], "Input",
  Evaluatable->False,
  FormatType->TextForm],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(Clear\ [pop]\n
    \(r\  = \ 1.2;\)\n
    \(k\  = \ 10000;\)\n
    \(g\  = \ 30;\)\n
    \(s\  = \ 2;\)\n
    \(pop[t_]\  := \ \(pop[t]\  = \ 
          r\ pop[t - 1] \((1 - \ pop[t - 1]/k)\)\);\)\n
    \(pop[0]\  = \ 5;\)\n
    \(dt\  = Table[pop[x], \ {x, 0, g, 1}];\)\n
    ListPlot[dt, \ PlotJoined\  \[Rule] True, \ 
      PlotRange \[Rule] {0, \ k/16}]\)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.030722 -1.6263e-018 0.000988854 [
[.17742 -0.0125 -3 -9 ]
[.17742 -0.0125 3 0 ]
[.33103 -0.0125 -6 -9 ]
[.33103 -0.0125 6 0 ]
[.48464 -0.0125 -6 -9 ]
[.48464 -0.0125 6 0 ]
[.63825 -0.0125 -6 -9 ]
[.63825 -0.0125 6 0 ]
[.79186 -0.0125 -6 -9 ]
[.79186 -0.0125 6 0 ]
[.94547 -0.0125 -6 -9 ]
[.94547 -0.0125 6 0 ]
[.01131 .09889 -18 -4.5 ]
[.01131 .09889 0 4.5 ]
[.01131 .19777 -18 -4.5 ]
[.01131 .19777 0 4.5 ]
[.01131 .29666 -18 -4.5 ]
[.01131 .29666 0 4.5 ]
[.01131 .39554 -18 -4.5 ]
[.01131 .39554 0 4.5 ]
[.01131 .49443 -18 -4.5 ]
[.01131 .49443 0 4.5 ]
[.01131 .59331 -18 -4.5 ]
[.01131 .59331 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.17742 0 m
.17742 .00625 L
s
[(5)] .17742 -0.0125 0 1 Mshowa
.33103 0 m
.33103 .00625 L
s
[(10)] .33103 -0.0125 0 1 Mshowa
.48464 0 m
.48464 .00625 L
s
[(15)] .48464 -0.0125 0 1 Mshowa
.63825 0 m
.63825 .00625 L
s
[(20)] .63825 -0.0125 0 1 Mshowa
.79186 0 m
.79186 .00625 L
s
[(25)] .79186 -0.0125 0 1 Mshowa
.94547 0 m
.94547 .00625 L
s
[(30)] .94547 -0.0125 0 1 Mshowa
.125 Mabswid
.05453 0 m
.05453 .00375 L
s
.08525 0 m
.08525 .00375 L
s
.11598 0 m
.11598 .00375 L
s
.1467 0 m
.1467 .00375 L
s
.20814 0 m
.20814 .00375 L
s
.23886 0 m
.23886 .00375 L
s
.26959 0 m
.26959 .00375 L
s
.30031 0 m
.30031 .00375 L
s
.36175 0 m
.36175 .00375 L
s
.39247 0 m
.39247 .00375 L
s
.4232 0 m
.4232 .00375 L
s
.45392 0 m
.45392 .00375 L
s
.51536 0 m
.51536 .00375 L
s
.54608 0 m
.54608 .00375 L
s
.5768 0 m
.5768 .00375 L
s
.60753 0 m
.60753 .00375 L
s
.66897 0 m
.66897 .00375 L
s
.69969 0 m
.69969 .00375 L
s
.73041 0 m
.73041 .00375 L
s
.76114 0 m
.76114 .00375 L
s
.82258 0 m
.82258 .00375 L
s
.8533 0 m
.8533 .00375 L
s
.88402 0 m
.88402 .00375 L
s
.91475 0 m
.91475 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.02381 .09889 m
.03006 .09889 L
s
[(100)] .01131 .09889 1 0 Mshowa
.02381 .19777 m
.03006 .19777 L
s
[(200)] .01131 .19777 1 0 Mshowa
.02381 .29666 m
.03006 .29666 L
s
[(300)] .01131 .29666 1 0 Mshowa
.02381 .39554 m
.03006 .39554 L
s
[(400)] .01131 .39554 1 0 Mshowa
.02381 .49443 m
.03006 .49443 L
s
[(500)] .01131 .49443 1 0 Mshowa
.02381 .59331 m
.03006 .59331 L
s
[(600)] .01131 .59331 1 0 Mshowa
.125 Mabswid
.02381 .01978 m
.02756 .01978 L
s
.02381 .03955 m
.02756 .03955 L
s
.02381 .05933 m
.02756 .05933 L
s
.02381 .07911 m
.02756 .07911 L
s
.02381 .11866 m
.02756 .11866 L
s
.02381 .13844 m
.02756 .13844 L
s
.02381 .15822 m
.02756 .15822 L
s
.02381 .17799 m
.02756 .17799 L
s
.02381 .21755 m
.02756 .21755 L
s
.02381 .23733 m
.02756 .23733 L
s
.02381 .2571 m
.02756 .2571 L
s
.02381 .27688 m
.02756 .27688 L
s
.02381 .31643 m
.02756 .31643 L
s
.02381 .33621 m
.02756 .33621 L
s
.02381 .35599 m
.02756 .35599 L
s
.02381 .37576 m
.02756 .37576 L
s
.02381 .41532 m
.02756 .41532 L
s
.02381 .4351 m
.02756 .4351 L
s
.02381 .45487 m
.02756 .45487 L
s
.02381 .47465 m
.02756 .47465 L
s
.02381 .5142 m
.02756 .5142 L
s
.02381 .53398 m
.02756 .53398 L
s
.02381 .55376 m
.02756 .55376 L
s
.02381 .57354 m
.02756 .57354 L
s
.02381 .61309 m
.02756 .61309 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.05453 .00494 m
.08525 .00593 L
.11598 .00711 L
.1467 .00853 L
.17742 .01022 L
.20814 .01226 L
.23886 .01469 L
.26959 .0176 L
.30031 .02109 L
.33103 .02525 L
.36175 .03022 L
.39247 .03615 L
.4232 .04323 L
.45392 .05164 L
.48464 .06165 L
.51536 .07352 L
.54608 .08757 L
.5768 .10415 L
.60753 .12366 L
.63825 .14654 L
.66897 .17324 L
.69969 .20425 L
.73041 .24004 L
.76114 .28105 L
.79186 .32767 L
.82258 .38018 L
.8533 .43868 L
.88402 .50306 L
.91475 .57296 L
s
.91475 .57296 m
.93327 .61803 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00@03oool200000280oooo1@0000020?ooo`800000803oool500000080oooo0P00000P0?oo
o`@000000`3oool200000200oooo100000030?ooo`8000008@3oool2000000@0oooo0P00000?0?oo
o`00?`3oool010000000oooo0?ooo`00000S0?ooo`050000003oool0oooo0?ooo`0000000P3oool0
0`000000oooo0?ooo`0O0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?oo
o`0M0?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool000007`3oool00`000000oooo
0?ooo`030?ooo`040000003oool0oooo000001l0oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`00000>0?ooo`00@P3oool00`000000oooo0?ooo`0Q0?ooo`050000003oool0oooo
0?ooo`0000000P3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool07P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000200oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`0O0?ooo`050000003oool0oooo0?ooo`000000
0P3oool00`000000oooo0?ooo`0<0?ooo`00@03oool2000002@0oooo00D000000?ooo`3oool0oooo
000000020?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool00P3oool200000280oooo
00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3o
ool00P3oool2000002<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0<0?oo
o`00@03oool00`000000oooo0?ooo`0S0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool07`3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo000001l0oooo00@000000?ooo`3oool00000
0`3oool00`000000oooo0?ooo`0O0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000003P3oool00400oooo0`00000R0?ooo`800000103oool200000240oooo0P0000040?ooo`<0
0000803oool2000000@0oooo0P00000Q0?ooo`800000103oool300000200oooo0P0000040?ooo`80
00003`3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0
oooo8@3oool00140ooooo`00000=000000<0oooo000H0?ooo`030000003oool0oooo00D0oooo3000
00040?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0203oool001P0oooo00<00000
0?ooo`3oool04@3ooolA000000@0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0V
0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0V
0?ooo`030000003oool0oooo0100oooo000H0?ooo`030000003oool0oooo0280oooo4000003C0?oo
o`00603oool00`000000oooo0?ooo`0b0?ooo`P00000b`3oool001P0oooo0P00000k0?ooo`P00000
``3oool001P0oooo00<000000?ooo`3oool0@P3oool800000;/0oooo000H0?ooo`030000003oool0
oooo04X0oooo2@00002b0?ooo`00603oool00`000000oooo0?ooo`1C0?ooo`H00000[03oool001P0
oooo00<000000?ooo`3oool0F@3oool400000:P0oooo000H0?ooo`800000GP3oool600000:80oooo
000H0?ooo`030000003oool0oooo06<0oooo1P00002L0?ooo`00603oool00`000000oooo0?ooo`1Y
0?ooo`800000VP3oool001P0oooo00<000000?ooo`3oool0J`3oool3000009L0oooo000H0?ooo`03
0000003oool0oooo06h0oooo0`00002D0?ooo`00603oool00`000000oooo0?ooo`1a0?ooo`@00000
T03oool001P0oooo0P00001f0?ooo`@00000S03oool001P0oooo00<000000?ooo`3oool0N@3oool3
000008T0oooo000H0?ooo`030000003oool0oooo07`0oooo0`0000260?ooo`00603oool00`000000
oooo0?ooo`1o0?ooo`800000Q03oool001P0oooo00<000000?ooo`3oool0P@3oool200000880oooo
000H0?ooo`800000Q03oool200000800oooo000H0?ooo`030000003oool0oooo08D0oooo0P00001n
0?ooo`00603oool00`000000oooo0?ooo`270?ooo`800000O03oool000<0oooo1@0000020?ooo`80
0000103oool2000000H0oooo00<000000?ooo`3oool0R@3oool2000007X0oooo00050?ooo`050000
003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0R`3oool00`000000oooo0?ooo`1g0?ooo`001@3oool01@000000
oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`03
0?ooo`800000S@3oool2000007L0oooo00050?ooo`050000003oool0oooo0?ooo`0000000P3oool0
10000000oooo0?ooo`0000020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0SP3o
ool2000007D0oooo00050?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0T03oool00`000000oooo
0?ooo`1b0?ooo`00103oool2000000@0oooo0P0000040?ooo`8000001P3oool00`000000oooo0?oo
o`2A0?ooo`800000LP3oool001P0oooo00<000000?ooo`3oool0T`3oool00`000000oooo0?ooo`1_
0?ooo`00603oool2000009D0oooo0P00001_0?ooo`00603oool00`000000oooo0?ooo`2F0?ooo`80
0000K@3oool001P0oooo00<000000?ooo`3oool0V03oool00`000000oooo0?ooo`1Z0?ooo`00603o
ool00`000000oooo0?ooo`2I0?ooo`030000003oool0oooo06T0oooo000H0?ooo`030000003oool0
oooo09X0oooo0P00001Y0?ooo`00603oool00`000000oooo0?ooo`2L0?ooo`030000003oool0oooo
06H0oooo000H0?ooo`800000WP3oool00`000000oooo0?ooo`1U0?ooo`00603oool00`000000oooo
0?ooo`2N0?ooo`800000I@3oool001P0oooo00<000000?ooo`3oool0X03oool00`000000oooo0?oo
o`1R0?ooo`00603oool00`000000oooo0?ooo`2Q0?ooo`030000003oool0oooo0640oooo000H0?oo
o`030000003oool0oooo0:80oooo00<000000?ooo`3oool0H03oool001P0oooo0P00002T0?ooo`03
0000003oool0oooo05l0oooo000H0?ooo`030000003oool0oooo0:@0oooo0P00001O0?ooo`00603o
ool00`000000oooo0?ooo`2V0?ooo`030000003oool0oooo05`0oooo000H0?ooo`030000003oool0
oooo0:L0oooo00<000000?ooo`3oool0F`3oool001P0oooo00<000000?ooo`3oool0Z03oool00`00
0000oooo0?ooo`1J0?ooo`00603oool200000:X0oooo00<000000?ooo`3oool0F@3oool001P0oooo
00<000000?ooo`3oool0ZP3oool00`000000oooo0?ooo`1H0?ooo`00603oool00`000000oooo0?oo
o`2[0?ooo`030000003oool0oooo05L0oooo000H0?ooo`030000003oool0oooo0:`0oooo0P00001G
0?ooo`000`3oool4000000<0oooo0P0000040?ooo`8000001P3oool00`000000oooo0?ooo`2^0?oo
o`030000003oool0oooo05@0oooo00030?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo0:l0oooo00<00000
0?ooo`3oool0D`3oool000@0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo000000D0oooo0P00002a0?ooo`030000003oool0oooo0580oooo0005
0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0/@3oool00`000000oooo0?ooo`1A0?ooo`000`3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000001@3oool00`000000oooo0?ooo`2b0?ooo`030000003oool0oooo0500oooo00040?ooo`80
0000103oool2000000@0oooo0P0000060?ooo`030000003oool0oooo0;<0oooo00<000000?ooo`3o
ool0C`3oool001P0oooo00<000000?ooo`3oool0/`3oool00`000000oooo0?ooo`1?0?ooo`00603o
ool200000;D0oooo00<000000?ooo`3oool0CP3oool001P0oooo00<000000?ooo`3oool0]@3oool0
0`000000oooo0?ooo`1=0?ooo`00603oool00`000000oooo0?ooo`2f0?ooo`030000003oool0oooo
04`0oooo000H0?ooo`030000003oool0oooo0;L0oooo00<000000?ooo`3oool0B`3oool001P0oooo
00<000000?ooo`3oool0]`3oool00`000000oooo0?ooo`1;0?ooo`00603oool200000;T0oooo00<0
00000?ooo`3oool0BP3oool001P0oooo00<000000?ooo`3oool0^@3oool00`000000oooo0?ooo`19
0?ooo`00603oool00`000000oooo0?ooo`2j0?ooo`030000003oool0oooo04P0oooo000H0?ooo`03
0000003oool0oooo0;X0oooo00<000000?ooo`3oool0B03oool001P0oooo00<000000?ooo`3oool0
^`3oool00`000000oooo0?ooo`170?ooo`00603oool200000;d0oooo00<000000?ooo`3oool0AP3o
ool001P0oooo00<000000?ooo`3oool0_@3oool00`000000oooo0?ooo`150?ooo`00603oool00`00
0000oooo0?ooo`2m0?ooo`030000003oool0oooo04D0oooo000H0?ooo`030000003oool0oooo0;h0
oooo00<000000?ooo`3oool0A03oool001P0oooo00<000000?ooo`3oool0_`3oool00`000000oooo
0?ooo`130?ooo`00603oool00`000000oooo0?ooo`300?ooo`030000003oool0oooo0480oooo000H
0?ooo`800000`@3oool00`000000oooo0?ooo`120?ooo`00603oool00`000000oooo0?ooo`310?oo
o`030000003oool0oooo0440oooo000H0?ooo`030000003oool0oooo0<80oooo00<000000?ooo`3o
ool0@03oool000@0oooo0P0000040?ooo`800000103oool2000000H0oooo00<000000?ooo`3oool0
`P3oool00`000000oooo0?ooo`100?ooo`000`3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`330?oo
o`030000003oool0oooo03l0oooo00050?ooo`050000003oool0oooo0?ooo`0000000P3oool01000
0000oooo0?ooo`0000020?ooo`030000003oool0oooo00<0oooo0P0000350?ooo`030000003oool0
oooo03h0oooo00060?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0<@0oooo00<000000?ooo`3oool0?P3o
ool000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000000D0oooo00<000000?ooo`3oool0a@3oool00`000000oooo0?ooo`0m0?ooo`00
103oool2000000@0oooo0P0000040?ooo`8000001P3oool00`000000oooo0?ooo`360?ooo`030000
003oool0oooo03`0oooo000H0?ooo`030000003oool0oooo0<H0oooo00<000000?ooo`3oool0?03o
ool001P0oooo0P0000380?ooo`030000003oool0oooo03/0oooo000H0?ooo`030000003oool0oooo
0<P0oooo00<000000?ooo`3oool0>P3oool001P0oooo00<000000?ooo`3oool0b03oool00`000000
oooo0?ooo`0j0?ooo`00603oool00`000000oooo0?ooo`390?ooo`030000003oool0oooo03T0oooo
000H0?ooo`030000003oool0oooo0<X0oooo00<000000?ooo`3oool0>03oool001P0oooo0P00003;
0?ooo`030000003oool0oooo03P0oooo000H0?ooo`030000003oool0oooo0</0oooo00<000000?oo
o`3oool0=`3oool001P0oooo00<000000?ooo`3oool0b`3oool00`000000oooo0?ooo`0g0?ooo`00
603oool00`000000oooo0?ooo`3<0?ooo`030000003oool0oooo03H0oooo000H0?ooo`030000003o
ool0oooo0<`0oooo00<000000?ooo`3oool0=P3oool001P0oooo00<000000?ooo`3oool0c@3oool0
0`000000oooo0?ooo`0e0?ooo`00603oool200000<l0oooo00<000000?ooo`3oool0=03oool001P0
oooo00<000000?ooo`3oool0cP3oool00`000000oooo0?ooo`0d0?ooo`00603oool00`000000oooo
0?ooo`3?0?ooo`030000003oool0oooo03<0oooo000H0?ooo`030000003oool0oooo0<l0oooo00<0
00000?ooo`3oool0<`3oool001P0oooo00<000000?ooo`3oool0d03oool00`000000oooo0?ooo`0b
0?ooo`00603oool200000=40oooo00<000000?ooo`3oool0<P3oool001P0oooo00<000000?ooo`3o
ool0d@3oool00`000000oooo0?ooo`0a0?ooo`00603oool00`000000oooo0?ooo`3B0?ooo`030000
003oool0oooo0300oooo00050?ooo`<000000P3oool2000000@0oooo0P0000060?ooo`030000003o
ool0oooo0=80oooo00<000000?ooo`3oool0<03oool000H0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
d`3oool00`000000oooo0?ooo`0_0?ooo`000`3oool5000000050?ooo`000000oooo0?ooo`000000
0P3oool010000000oooo0?ooo`0000050?ooo`800000e03oool00`000000oooo0?ooo`0_0?ooo`00
0`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000001@3oool00`000000oooo0?ooo`3D0?ooo`030000003oool0oooo02h0oooo00040?oo
o`030000003oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
00050?ooo`030000003oool0oooo0=@0oooo00<000000?ooo`3oool0;P3oool000D0oooo0P000003
0?ooo`800000103oool2000000H0oooo00<000000?ooo`3oool0e@3oool00`000000oooo0?ooo`0]
0?ooo`00603oool00`000000oooo0?ooo`3E0?ooo`030000003oool0oooo02d0oooo000H0?ooo`03
0000003oool0oooo0=H0oooo00<000000?ooo`3oool0;03oool001P0oooo0P00003H0?ooo`030000
003oool0oooo02/0oooo000H0?ooo`030000003oool0oooo0=L0oooo00<000000?ooo`3oool0:`3o
ool001P0oooo00<000000?ooo`3oool0f03oool00`000000oooo0?ooo`0Z0?ooo`00603oool00`00
0000oooo0?ooo`3H0?ooo`030000003oool0oooo02X0oooo000H0?ooo`030000003oool0oooo0=T0
oooo00<000000?ooo`3oool0:@3oool001P0oooo0P00003J0?ooo`030000003oool0oooo02T0oooo
000H0?ooo`030000003oool0oooo0=X0oooo00<000000?ooo`3oool0:03oool001P0oooo00<00000
0?ooo`3oool0fP3oool00`000000oooo0?ooo`0X0?ooo`00603oool00`000000oooo0?ooo`3K0?oo
o`030000003oool0oooo02L0oooo000H0?ooo`030000003oool0oooo0=/0oooo00<000000?ooo`3o
ool09`3oool001P0oooo0P00003M0?ooo`030000003oool0oooo02H0oooo000H0?ooo`030000003o
ool0oooo0=`0oooo00<000000?ooo`3oool09P3oool001P0oooo00<000000?ooo`3oool0g@3oool0
0`000000oooo0?ooo`0U0?ooo`00603oool00`000000oooo0?ooo`3M0?ooo`030000003oool0oooo
02D0oooo000H0?ooo`030000003oool0oooo0=h0oooo00<000000?ooo`3oool0903oool001P0oooo
0P00003O0?ooo`030000003oool0oooo02@0oooo000H0?ooo`030000003oool0oooo0=l0oooo00<0
00000?ooo`3oool08`3oool001P0oooo00<000000?ooo`3oool0g`3oool00`000000oooo0?ooo`0S
0?ooo`00603oool00`000000oooo0?ooo`3P0?ooo`030000003oool0oooo0280oooo00040?ooo`80
0000103oool2000000@0oooo0P0000060?ooo`030000003oool0oooo0>00oooo00<000000?ooo`3o
ool08P3oool000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0h@3oool00`000000oooo0?ooo`0Q
0?ooo`001P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool00`3oool200000>80oooo00<000000?ooo`3oool08@3oool000@0oooo0P000003
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000001@3oool00`000000oooo
0?ooo`3R0?ooo`030000003oool0oooo0200oooo00040?ooo`030000003oool0oooo0080oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo0>80
oooo00<000000?ooo`3oool0803oool000@0oooo0`0000030?ooo`800000103oool2000000H0oooo
00<000000?ooo`3oool0hP3oool00`000000oooo0?ooo`0P0?ooo`00603oool00`000000oooo0?oo
o`3S0?ooo`030000003oool0oooo01l0oooo000H0?ooo`800000i03oool00`000000oooo0?ooo`0O
0?ooo`00603oool00`000000oooo0?ooo`3T0?ooo`030000003oool0oooo01h0oooo000H0?ooo`03
0000003oool0oooo0>@0oooo00<000000?ooo`3oool07P3oool001P0oooo00<000000?ooo`3oool0
i@3oool00`000000oooo0?ooo`0M0?ooo`00603oool00`000000oooo0?ooo`3U0?ooo`030000003o
ool0oooo01d0oooo000H0?ooo`800000i`3oool00`000000oooo0?ooo`0L0?ooo`00603oool00`00
0000oooo0?ooo`3V0?ooo`030000003oool0oooo01`0oooo000H0?ooo`030000003oool0oooo0>H0
oooo00<000000?ooo`3oool0703oool001P0oooo00<000000?ooo`3oool0i`3oool00`000000oooo
0?ooo`0K0?ooo`00603oool00`000000oooo0?ooo`3W0?ooo`030000003oool0oooo01/0oooo000H
0?ooo`800000j@3oool00`000000oooo0?ooo`0J0?ooo`00603oool00`000000oooo0?ooo`3X0?oo
o`030000003oool0oooo01X0oooo000H0?ooo`030000003oool0oooo0>T0oooo00<000000?ooo`3o
ool06@3oool001P0oooo00<000000?ooo`3oool0j@3oool00`000000oooo0?ooo`0I0?ooo`00603o
ool00`000000oooo0?ooo`3Z0?ooo`030000003oool0oooo01P0oooo000H0?ooo`030000003oool0
oooo0>X0oooo00<000000?ooo`3oool0603oool001P0oooo0P00003[0?ooo`030000003oool0oooo
01P0oooo000H0?ooo`030000003oool0oooo0>/0oooo00<000000?ooo`3oool05`3oool001P0oooo
00<000000?ooo`3oool0j`3oool00`000000oooo0?ooo`0G0?ooo`000`3oool3000000@0oooo0P00
00040?ooo`8000001P3oool00`000000oooo0?ooo`3/0?ooo`030000003oool0oooo01H0oooo0003
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000050?ooo`030000003oool0oooo0>`0oooo00<000000?ooo`3oool05P3oool000<0oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
000000D0oooo0P00003]0?ooo`030000003oool0oooo01H0oooo00030?ooo`<000000`3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0k@3o
ool00`000000oooo0?ooo`0E0?ooo`00103oool00`000000oooo0?ooo`020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`3]0?ooo`030000
003oool0oooo01D0oooo00040?ooo`<000000`3oool2000000@0oooo0P0000060?ooo`030000003o
ool0oooo0>h0oooo00<000000?ooo`3oool0503oool001P0oooo00<000000?ooo`3oool0kP3oool0
0`000000oooo0?ooo`0D0?ooo`00603oool200000?00oooo00<000000?ooo`3oool04`3oool001P0
oooo00<000000?ooo`3oool0k`3oool00`000000oooo0?ooo`0C0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-2.95324, -46.8163, \
0.122212, 3.79691}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[TextData[StyleBox["The parameters below show a period 4 cycle. \
Substituting in r = 3.4 will show a period two,  and r = 3.562 will show a \
period 8 cycle.  These cycles show up better by selecting large g and by \
setting PlotJoined->False. Starting with s near k eliminates pre-convergence \
noise as well.",
  FontColor->RGBColor[1, 0.501961, 1]]], "Input",
  Evaluatable->False,
  FormatType->TextForm],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(Clear\ [pop]\n
    \(r\  = \ 3.51;\)\n
    \(k\  = \ 1000;\)\n
    \(g\  = \ 1000;\)\n
    \(s\  = \ 1000;\)\n
    \(pop[t_]\  := \ \(pop[t]\  = \ 
          r\ pop[t - 1] \((1 - \ pop[t - 1]/k)\)\);\)\n
    \(pop[0]\  = \ 5;\)\n
    \(dt\  = Table[pop[x], \ {x, 0, g, 1}];\)\n
    ListPlot[dt, \ PlotJoined\  \[Rule] False, \ 
      PlotRange \[Rule] {k/4, \ k}]\)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00095143 -0.206011 0.000824045 [
[.2141 .0287 -9 -9 ]
[.2141 .0287 9 0 ]
[.40438 .0287 -9 -9 ]
[.40438 .0287 9 0 ]
[.59467 .0287 -9 -9 ]
[.59467 .0287 9 0 ]
[.78495 .0287 -9 -9 ]
[.78495 .0287 9 0 ]
[.97524 .0287 -12 -9 ]
[.97524 .0287 12 0 ]
[.01131 .12361 -18 -4.5 ]
[.01131 .12361 0 4.5 ]
[.01131 .20601 -18 -4.5 ]
[.01131 .20601 0 4.5 ]
[.01131 .28842 -18 -4.5 ]
[.01131 .28842 0 4.5 ]
[.01131 .37082 -18 -4.5 ]
[.01131 .37082 0 4.5 ]
[.01131 .45322 -18 -4.5 ]
[.01131 .45322 0 4.5 ]
[.01131 .53563 -18 -4.5 ]
[.01131 .53563 0 4.5 ]
[.01131 .61803 -24 -4.5 ]
[.01131 .61803 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2141 .0412 m
.2141 .04745 L
s
[(200)] .2141 .0287 0 1 Mshowa
.40438 .0412 m
.40438 .04745 L
s
[(400)] .40438 .0287 0 1 Mshowa
.59467 .0412 m
.59467 .04745 L
s
[(600)] .59467 .0287 0 1 Mshowa
.78495 .0412 m
.78495 .04745 L
s
[(800)] .78495 .0287 0 1 Mshowa
.97524 .0412 m
.97524 .04745 L
s
[(1000)] .97524 .0287 0 1 Mshowa
.125 Mabswid
.07138 .0412 m
.07138 .04495 L
s
.11895 .0412 m
.11895 .04495 L
s
.16652 .0412 m
.16652 .04495 L
s
.26167 .0412 m
.26167 .04495 L
s
.30924 .0412 m
.30924 .04495 L
s
.35681 .0412 m
.35681 .04495 L
s
.45195 .0412 m
.45195 .04495 L
s
.49952 .0412 m
.49952 .04495 L
s
.5471 .0412 m
.5471 .04495 L
s
.64224 .0412 m
.64224 .04495 L
s
.68981 .0412 m
.68981 .04495 L
s
.73738 .0412 m
.73738 .04495 L
s
.83252 .0412 m
.83252 .04495 L
s
.8801 .0412 m
.8801 .04495 L
s
.92767 .0412 m
.92767 .04495 L
s
.25 Mabswid
0 .0412 m
1 .0412 L
s
.02381 .12361 m
.03006 .12361 L
s
[(400)] .01131 .12361 1 0 Mshowa
.02381 .20601 m
.03006 .20601 L
s
[(500)] .01131 .20601 1 0 Mshowa
.02381 .28842 m
.03006 .28842 L
s
[(600)] .01131 .28842 1 0 Mshowa
.02381 .37082 m
.03006 .37082 L
s
[(700)] .01131 .37082 1 0 Mshowa
.02381 .45322 m
.03006 .45322 L
s
[(800)] .01131 .45322 1 0 Mshowa
.02381 .53563 m
.03006 .53563 L
s
[(900)] .01131 .53563 1 0 Mshowa
.02381 .61803 m
.03006 .61803 L
s
[(1000)] .01131 .61803 1 0 Mshowa
.125 Mabswid
.02381 .05768 m
.02756 .05768 L
s
.02381 .07416 m
.02756 .07416 L
s
.02381 .09064 m
.02756 .09064 L
s
.02381 .10713 m
.02756 .10713 L
s
.02381 .14009 m
.02756 .14009 L
s
.02381 .15657 m
.02756 .15657 L
s
.02381 .17305 m
.02756 .17305 L
s
.02381 .18953 m
.02756 .18953 L
s
.02381 .22249 m
.02756 .22249 L
s
.02381 .23897 m
.02756 .23897 L
s
.02381 .25545 m
.02756 .25545 L
s
.02381 .27193 m
.02756 .27193 L
s
.02381 .3049 m
.02756 .3049 L
s
.02381 .32138 m
.02756 .32138 L
s
.02381 .33786 m
.02756 .33786 L
s
.02381 .35434 m
.02756 .35434 L
s
.02381 .3873 m
.02756 .3873 L
s
.02381 .40378 m
.02756 .40378 L
s
.02381 .42026 m
.02756 .42026 L
s
.02381 .43674 m
.02756 .43674 L
s
.02381 .46971 m
.02756 .46971 L
s
.02381 .48619 m
.02756 .48619 L
s
.02381 .50267 m
.02756 .50267 L
s
.02381 .51915 m
.02756 .51915 L
s
.02381 .55211 m
.02756 .55211 L
s
.02381 .56859 m
.02756 .56859 L
s
.02381 .58507 m
.02756 .58507 L
s
.02381 .60155 m
.02756 .60155 L
s
.02381 .02472 m
.02756 .02472 L
s
.02381 .00824 m
.02756 .00824 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02857 .25442 Mdot
.02952 .5071 Mdot
.03047 .13094 Mdot
.03142 .49308 Mdot
.03237 .16607 Mdot
.03332 .51029 Mdot
.03428 .12271 Mdot
.03523 .48753 Mdot
.03618 .1795 Mdot
.03713 .5141 Mdot
.03808 .1128 Mdot
.03903 .48008 Mdot
.03998 .19715 Mdot
.04094 .51675 Mdot
.04189 .10579 Mdot
.04284 .4743 Mdot
.04379 .21049 Mdot
.04474 .517 Mdot
.04569 .10513 Mdot
.04664 .47374 Mdot
.0476 .21178 Mdot
.04855 .51695 Mdot
.0495 .10528 Mdot
.05045 .47387 Mdot
.0514 .21148 Mdot
.05235 .51696 Mdot
.0533 .10524 Mdot
.05426 .47384 Mdot
.05521 .21156 Mdot
.05616 .51696 Mdot
.05711 .10525 Mdot
.05806 .47384 Mdot
.05901 .21154 Mdot
.05996 .51696 Mdot
.06092 .10525 Mdot
.06187 .47384 Mdot
.06282 .21154 Mdot
.06377 .51696 Mdot
.06472 .10525 Mdot
.06567 .47384 Mdot
.06662 .21154 Mdot
.06758 .51696 Mdot
.06853 .10525 Mdot
.06948 .47384 Mdot
.07043 .21154 Mdot
.07138 .51696 Mdot
.07233 .10525 Mdot
.07328 .47384 Mdot
.07424 .21154 Mdot
.07519 .51696 Mdot
.07614 .10525 Mdot
.07709 .47384 Mdot
.07804 .21154 Mdot
.07899 .51696 Mdot
.07994 .10525 Mdot
.0809 .47384 Mdot
.08185 .21154 Mdot
.0828 .51696 Mdot
.08375 .10525 Mdot
.0847 .47384 Mdot
.08565 .21154 Mdot
.0866 .51696 Mdot
.08756 .10525 Mdot
.08851 .47384 Mdot
.08946 .21154 Mdot
.09041 .51696 Mdot
.09136 .10525 Mdot
.09231 .47384 Mdot
.09326 .21154 Mdot
.09422 .51696 Mdot
.09517 .10525 Mdot
.09612 .47384 Mdot
.09707 .21154 Mdot
.09802 .51696 Mdot
.09897 .10525 Mdot
.09992 .47384 Mdot
.10088 .21154 Mdot
.10183 .51696 Mdot
.10278 .10525 Mdot
.10373 .47384 Mdot
.10468 .21154 Mdot
.10563 .51696 Mdot
.10658 .10525 Mdot
.10754 .47384 Mdot
.10849 .21154 Mdot
.10944 .51696 Mdot
.11039 .10525 Mdot
.11134 .47384 Mdot
.11229 .21154 Mdot
.11324 .51696 Mdot
.1142 .10525 Mdot
.11515 .47384 Mdot
.1161 .21154 Mdot
.11705 .51696 Mdot
.118 .10525 Mdot
.11895 .47384 Mdot
.1199 .21154 Mdot
.12086 .51696 Mdot
.12181 .10525 Mdot
.12276 .47384 Mdot
.12371 .21154 Mdot
.12466 .51696 Mdot
.12561 .10525 Mdot
.12656 .47384 Mdot
.12752 .21154 Mdot
.12847 .51696 Mdot
.12942 .10525 Mdot
.13037 .47384 Mdot
.13132 .21154 Mdot
.13227 .51696 Mdot
.13322 .10525 Mdot
.13418 .47384 Mdot
.13513 .21154 Mdot
.13608 .51696 Mdot
.13703 .10525 Mdot
.13798 .47384 Mdot
.13893 .21154 Mdot
.13988 .51696 Mdot
.14084 .10525 Mdot
.14179 .47384 Mdot
.14274 .21154 Mdot
.14369 .51696 Mdot
.14464 .10525 Mdot
.14559 .47384 Mdot
.14654 .21154 Mdot
.1475 .51696 Mdot
.14845 .10525 Mdot
.1494 .47384 Mdot
.15035 .21154 Mdot
.1513 .51696 Mdot
.15225 .10525 Mdot
.1532 .47384 Mdot
.15416 .21154 Mdot
.15511 .51696 Mdot
.15606 .10525 Mdot
.15701 .47384 Mdot
.15796 .21154 Mdot
.15891 .51696 Mdot
.15986 .10525 Mdot
.16082 .47384 Mdot
.16177 .21154 Mdot
.16272 .51696 Mdot
.16367 .10525 Mdot
.16462 .47384 Mdot
.16557 .21154 Mdot
.16652 .51696 Mdot
.16748 .10525 Mdot
.16843 .47384 Mdot
.16938 .21154 Mdot
.17033 .51696 Mdot
.17128 .10525 Mdot
.17223 .47384 Mdot
.17318 .21154 Mdot
.17414 .51696 Mdot
.17509 .10525 Mdot
.17604 .47384 Mdot
.17699 .21154 Mdot
.17794 .51696 Mdot
.17889 .10525 Mdot
.17984 .47384 Mdot
.1808 .21154 Mdot
.18175 .51696 Mdot
.1827 .10525 Mdot
.18365 .47384 Mdot
.1846 .21154 Mdot
.18555 .51696 Mdot
.1865 .10525 Mdot
.18746 .47384 Mdot
.18841 .21154 Mdot
.18936 .51696 Mdot
.19031 .10525 Mdot
.19126 .47384 Mdot
.19221 .21154 Mdot
.19316 .51696 Mdot
.19412 .10525 Mdot
.19507 .47384 Mdot
.19602 .21154 Mdot
.19697 .51696 Mdot
.19792 .10525 Mdot
.19887 .47384 Mdot
.19982 .21154 Mdot
.20078 .51696 Mdot
.20173 .10525 Mdot
.20268 .47384 Mdot
.20363 .21154 Mdot
.20458 .51696 Mdot
.20553 .10525 Mdot
.20648 .47384 Mdot
.20744 .21154 Mdot
.20839 .51696 Mdot
.20934 .10525 Mdot
.21029 .47384 Mdot
.21124 .21154 Mdot
.21219 .51696 Mdot
.21314 .10525 Mdot
.2141 .47384 Mdot
.21505 .21154 Mdot
.216 .51696 Mdot
.21695 .10525 Mdot
.2179 .47384 Mdot
.21885 .21154 Mdot
.2198 .51696 Mdot
.22076 .10525 Mdot
.22171 .47384 Mdot
.22266 .21154 Mdot
.22361 .51696 Mdot
.22456 .10525 Mdot
.22551 .47384 Mdot
.22646 .21154 Mdot
.22742 .51696 Mdot
.22837 .10525 Mdot
.22932 .47384 Mdot
.23027 .21154 Mdot
.23122 .51696 Mdot
.23217 .10525 Mdot
.23312 .47384 Mdot
.23408 .21154 Mdot
.23503 .51696 Mdot
.23598 .10525 Mdot
.23693 .47384 Mdot
.23788 .21154 Mdot
.23883 .51696 Mdot
.23978 .10525 Mdot
.24074 .47384 Mdot
.24169 .21154 Mdot
.24264 .51696 Mdot
.24359 .10525 Mdot
.24454 .47384 Mdot
.24549 .21154 Mdot
.24644 .51696 Mdot
.2474 .10525 Mdot
.24835 .47384 Mdot
.2493 .21154 Mdot
.25025 .51696 Mdot
.2512 .10525 Mdot
.25215 .47384 Mdot
.2531 .21154 Mdot
.25406 .51696 Mdot
.25501 .10525 Mdot
.25596 .47384 Mdot
.25691 .21154 Mdot
.25786 .51696 Mdot
.25881 .10525 Mdot
.25976 .47384 Mdot
.26072 .21154 Mdot
.26167 .51696 Mdot
.26262 .10525 Mdot
.26357 .47384 Mdot
.26452 .21154 Mdot
.26547 .51696 Mdot
.26642 .10525 Mdot
.26738 .47384 Mdot
.26833 .21154 Mdot
.26928 .51696 Mdot
.27023 .10525 Mdot
.27118 .47384 Mdot
.27213 .21154 Mdot
.27308 .51696 Mdot
.27404 .10525 Mdot
.27499 .47384 Mdot
.27594 .21154 Mdot
.27689 .51696 Mdot
.27784 .10525 Mdot
.27879 .47384 Mdot
.27974 .21154 Mdot
.2807 .51696 Mdot
.28165 .10525 Mdot
.2826 .47384 Mdot
.28355 .21154 Mdot
.2845 .51696 Mdot
.28545 .10525 Mdot
.2864 .47384 Mdot
.28736 .21154 Mdot
.28831 .51696 Mdot
.28926 .10525 Mdot
.29021 .47384 Mdot
.29116 .21154 Mdot
.29211 .51696 Mdot
.29306 .10525 Mdot
.29402 .47384 Mdot
.29497 .21154 Mdot
.29592 .51696 Mdot
.29687 .10525 Mdot
.29782 .47384 Mdot
.29877 .21154 Mdot
.29972 .51696 Mdot
.30068 .10525 Mdot
.30163 .47384 Mdot
.30258 .21154 Mdot
.30353 .51696 Mdot
.30448 .10525 Mdot
.30543 .47384 Mdot
.30638 .21154 Mdot
.30734 .51696 Mdot
.30829 .10525 Mdot
.30924 .47384 Mdot
.31019 .21154 Mdot
.31114 .51696 Mdot
.31209 .10525 Mdot
.31304 .47384 Mdot
.314 .21154 Mdot
.31495 .51696 Mdot
.3159 .10525 Mdot
.31685 .47384 Mdot
.3178 .21154 Mdot
.31875 .51696 Mdot
.3197 .10525 Mdot
.32066 .47384 Mdot
.32161 .21154 Mdot
.32256 .51696 Mdot
.32351 .10525 Mdot
.32446 .47384 Mdot
.32541 .21154 Mdot
.32636 .51696 Mdot
.32732 .10525 Mdot
.32827 .47384 Mdot
.32922 .21154 Mdot
.33017 .51696 Mdot
.33112 .10525 Mdot
.33207 .47384 Mdot
.33302 .21154 Mdot
.33398 .51696 Mdot
.33493 .10525 Mdot
.33588 .47384 Mdot
.33683 .21154 Mdot
.33778 .51696 Mdot
.33873 .10525 Mdot
.33968 .47384 Mdot
.34064 .21154 Mdot
.34159 .51696 Mdot
.34254 .10525 Mdot
.34349 .47384 Mdot
.34444 .21154 Mdot
.34539 .51696 Mdot
.34634 .10525 Mdot
.3473 .47384 Mdot
.34825 .21154 Mdot
.3492 .51696 Mdot
.35015 .10525 Mdot
.3511 .47384 Mdot
.35205 .21154 Mdot
.353 .51696 Mdot
.35396 .10525 Mdot
.35491 .47384 Mdot
.35586 .21154 Mdot
.35681 .51696 Mdot
.35776 .10525 Mdot
.35871 .47384 Mdot
.35966 .21154 Mdot
.36062 .51696 Mdot
.36157 .10525 Mdot
.36252 .47384 Mdot
.36347 .21154 Mdot
.36442 .51696 Mdot
.36537 .10525 Mdot
.36632 .47384 Mdot
.36728 .21154 Mdot
.36823 .51696 Mdot
.36918 .10525 Mdot
.37013 .47384 Mdot
.37108 .21154 Mdot
.37203 .51696 Mdot
.37298 .10525 Mdot
.37394 .47384 Mdot
.37489 .21154 Mdot
.37584 .51696 Mdot
.37679 .10525 Mdot
.37774 .47384 Mdot
.37869 .21154 Mdot
.37964 .51696 Mdot
.3806 .10525 Mdot
.38155 .47384 Mdot
.3825 .21154 Mdot
.38345 .51696 Mdot
.3844 .10525 Mdot
.38535 .47384 Mdot
.3863 .21154 Mdot
.38726 .51696 Mdot
.38821 .10525 Mdot
.38916 .47384 Mdot
.39011 .21154 Mdot
.39106 .51696 Mdot
.39201 .10525 Mdot
.39296 .47384 Mdot
.39392 .21154 Mdot
.39487 .51696 Mdot
.39582 .10525 Mdot
.39677 .47384 Mdot
.39772 .21154 Mdot
.39867 .51696 Mdot
.39962 .10525 Mdot
.40058 .47384 Mdot
.40153 .21154 Mdot
.40248 .51696 Mdot
.40343 .10525 Mdot
.40438 .47384 Mdot
.40533 .21154 Mdot
.40628 .51696 Mdot
.40724 .10525 Mdot
.40819 .47384 Mdot
.40914 .21154 Mdot
.41009 .51696 Mdot
.41104 .10525 Mdot
.41199 .47384 Mdot
.41294 .21154 Mdot
.4139 .51696 Mdot
.41485 .10525 Mdot
.4158 .47384 Mdot
.41675 .21154 Mdot
.4177 .51696 Mdot
.41865 .10525 Mdot
.4196 .47384 Mdot
.42056 .21154 Mdot
.42151 .51696 Mdot
.42246 .10525 Mdot
.42341 .47384 Mdot
.42436 .21154 Mdot
.42531 .51696 Mdot
.42626 .10525 Mdot
.42722 .47384 Mdot
.42817 .21154 Mdot
.42912 .51696 Mdot
.43007 .10525 Mdot
.43102 .47384 Mdot
.43197 .21154 Mdot
.43292 .51696 Mdot
.43388 .10525 Mdot
.43483 .47384 Mdot
.43578 .21154 Mdot
.43673 .51696 Mdot
.43768 .10525 Mdot
.43863 .47384 Mdot
.43958 .21154 Mdot
.44054 .51696 Mdot
.44149 .10525 Mdot
.44244 .47384 Mdot
.44339 .21154 Mdot
.44434 .51696 Mdot
.44529 .10525 Mdot
.44624 .47384 Mdot
.4472 .21154 Mdot
.44815 .51696 Mdot
.4491 .10525 Mdot
.45005 .47384 Mdot
.451 .21154 Mdot
.45195 .51696 Mdot
.4529 .10525 Mdot
.45386 .47384 Mdot
.45481 .21154 Mdot
.45576 .51696 Mdot
.45671 .10525 Mdot
.45766 .47384 Mdot
.45861 .21154 Mdot
.45956 .51696 Mdot
.46052 .10525 Mdot
.46147 .47384 Mdot
.46242 .21154 Mdot
.46337 .51696 Mdot
.46432 .10525 Mdot
.46527 .47384 Mdot
.46622 .21154 Mdot
.46718 .51696 Mdot
.46813 .10525 Mdot
.46908 .47384 Mdot
.47003 .21154 Mdot
.47098 .51696 Mdot
.47193 .10525 Mdot
.47288 .47384 Mdot
.47384 .21154 Mdot
.47479 .51696 Mdot
.47574 .10525 Mdot
.47669 .47384 Mdot
.47764 .21154 Mdot
.47859 .51696 Mdot
.47954 .10525 Mdot
.4805 .47384 Mdot
.48145 .21154 Mdot
.4824 .51696 Mdot
.48335 .10525 Mdot
.4843 .47384 Mdot
.48525 .21154 Mdot
.4862 .51696 Mdot
.48716 .10525 Mdot
.48811 .47384 Mdot
.48906 .21154 Mdot
.49001 .51696 Mdot
.49096 .10525 Mdot
.49191 .47384 Mdot
.49286 .21154 Mdot
.49382 .51696 Mdot
.49477 .10525 Mdot
.49572 .47384 Mdot
.49667 .21154 Mdot
.49762 .51696 Mdot
.49857 .10525 Mdot
.49952 .47384 Mdot
.50048 .21154 Mdot
.50143 .51696 Mdot
.50238 .10525 Mdot
.50333 .47384 Mdot
.50428 .21154 Mdot
.50523 .51696 Mdot
.50618 .10525 Mdot
.50714 .47384 Mdot
.50809 .21154 Mdot
.50904 .51696 Mdot
.50999 .10525 Mdot
.51094 .47384 Mdot
.51189 .21154 Mdot
.51284 .51696 Mdot
.5138 .10525 Mdot
.51475 .47384 Mdot
.5157 .21154 Mdot
.51665 .51696 Mdot
.5176 .10525 Mdot
.51855 .47384 Mdot
.5195 .21154 Mdot
.52046 .51696 Mdot
.52141 .10525 Mdot
.52236 .47384 Mdot
.52331 .21154 Mdot
.52426 .51696 Mdot
.52521 .10525 Mdot
.52616 .47384 Mdot
.52712 .21154 Mdot
.52807 .51696 Mdot
.52902 .10525 Mdot
.52997 .47384 Mdot
.53092 .21154 Mdot
.53187 .51696 Mdot
.53282 .10525 Mdot
.53378 .47384 Mdot
.53473 .21154 Mdot
.53568 .51696 Mdot
.53663 .10525 Mdot
.53758 .47384 Mdot
.53853 .21154 Mdot
.53948 .51696 Mdot
.54044 .10525 Mdot
.54139 .47384 Mdot
.54234 .21154 Mdot
.54329 .51696 Mdot
.54424 .10525 Mdot
.54519 .47384 Mdot
.54614 .21154 Mdot
.5471 .51696 Mdot
.54805 .10525 Mdot
.549 .47384 Mdot
.54995 .21154 Mdot
.5509 .51696 Mdot
.55185 .10525 Mdot
.5528 .47384 Mdot
.55376 .21154 Mdot
.55471 .51696 Mdot
.55566 .10525 Mdot
.55661 .47384 Mdot
.55756 .21154 Mdot
.55851 .51696 Mdot
.55946 .10525 Mdot
.56042 .47384 Mdot
.56137 .21154 Mdot
.56232 .51696 Mdot
.56327 .10525 Mdot
.56422 .47384 Mdot
.56517 .21154 Mdot
.56612 .51696 Mdot
.56708 .10525 Mdot
.56803 .47384 Mdot
.56898 .21154 Mdot
.56993 .51696 Mdot
.57088 .10525 Mdot
.57183 .47384 Mdot
.57278 .21154 Mdot
.57374 .51696 Mdot
.57469 .10525 Mdot
.57564 .47384 Mdot
.57659 .21154 Mdot
.57754 .51696 Mdot
.57849 .10525 Mdot
.57944 .47384 Mdot
.5804 .21154 Mdot
.58135 .51696 Mdot
.5823 .10525 Mdot
.58325 .47384 Mdot
.5842 .21154 Mdot
.58515 .51696 Mdot
.5861 .10525 Mdot
.58706 .47384 Mdot
.58801 .21154 Mdot
.58896 .51696 Mdot
.58991 .10525 Mdot
.59086 .47384 Mdot
.59181 .21154 Mdot
.59276 .51696 Mdot
.59372 .10525 Mdot
.59467 .47384 Mdot
.59562 .21154 Mdot
.59657 .51696 Mdot
.59752 .10525 Mdot
.59847 .47384 Mdot
.59942 .21154 Mdot
.60038 .51696 Mdot
.60133 .10525 Mdot
.60228 .47384 Mdot
.60323 .21154 Mdot
.60418 .51696 Mdot
.60513 .10525 Mdot
.60608 .47384 Mdot
.60704 .21154 Mdot
.60799 .51696 Mdot
.60894 .10525 Mdot
.60989 .47384 Mdot
.61084 .21154 Mdot
.61179 .51696 Mdot
.61274 .10525 Mdot
.6137 .47384 Mdot
.61465 .21154 Mdot
.6156 .51696 Mdot
.61655 .10525 Mdot
.6175 .47384 Mdot
.61845 .21154 Mdot
.6194 .51696 Mdot
.62036 .10525 Mdot
.62131 .47384 Mdot
.62226 .21154 Mdot
.62321 .51696 Mdot
.62416 .10525 Mdot
.62511 .47384 Mdot
.62606 .21154 Mdot
.62702 .51696 Mdot
.62797 .10525 Mdot
.62892 .47384 Mdot
.62987 .21154 Mdot
.63082 .51696 Mdot
.63177 .10525 Mdot
.63272 .47384 Mdot
.63368 .21154 Mdot
.63463 .51696 Mdot
.63558 .10525 Mdot
.63653 .47384 Mdot
.63748 .21154 Mdot
.63843 .51696 Mdot
.63938 .10525 Mdot
.64034 .47384 Mdot
.64129 .21154 Mdot
.64224 .51696 Mdot
.64319 .10525 Mdot
.64414 .47384 Mdot
.64509 .21154 Mdot
.64604 .51696 Mdot
.647 .10525 Mdot
.64795 .47384 Mdot
.6489 .21154 Mdot
.64985 .51696 Mdot
.6508 .10525 Mdot
.65175 .47384 Mdot
.6527 .21154 Mdot
.65366 .51696 Mdot
.65461 .10525 Mdot
.65556 .47384 Mdot
.65651 .21154 Mdot
.65746 .51696 Mdot
.65841 .10525 Mdot
.65936 .47384 Mdot
.66032 .21154 Mdot
.66127 .51696 Mdot
.66222 .10525 Mdot
.66317 .47384 Mdot
.66412 .21154 Mdot
.66507 .51696 Mdot
.66602 .10525 Mdot
.66698 .47384 Mdot
.66793 .21154 Mdot
.66888 .51696 Mdot
.66983 .10525 Mdot
.67078 .47384 Mdot
.67173 .21154 Mdot
.67268 .51696 Mdot
.67364 .10525 Mdot
.67459 .47384 Mdot
.67554 .21154 Mdot
.67649 .51696 Mdot
.67744 .10525 Mdot
.67839 .47384 Mdot
.67934 .21154 Mdot
.6803 .51696 Mdot
.68125 .10525 Mdot
.6822 .47384 Mdot
.68315 .21154 Mdot
.6841 .51696 Mdot
.68505 .10525 Mdot
.686 .47384 Mdot
.68696 .21154 Mdot
.68791 .51696 Mdot
.68886 .10525 Mdot
.68981 .47384 Mdot
.69076 .21154 Mdot
.69171 .51696 Mdot
.69266 .10525 Mdot
.69362 .47384 Mdot
.69457 .21154 Mdot
.69552 .51696 Mdot
.69647 .10525 Mdot
.69742 .47384 Mdot
.69837 .21154 Mdot
.69932 .51696 Mdot
.70028 .10525 Mdot
.70123 .47384 Mdot
.70218 .21154 Mdot
.70313 .51696 Mdot
.70408 .10525 Mdot
.70503 .47384 Mdot
.70598 .21154 Mdot
.70694 .51696 Mdot
.70789 .10525 Mdot
.70884 .47384 Mdot
.70979 .21154 Mdot
.71074 .51696 Mdot
.71169 .10525 Mdot
.71264 .47384 Mdot
.7136 .21154 Mdot
.71455 .51696 Mdot
.7155 .10525 Mdot
.71645 .47384 Mdot
.7174 .21154 Mdot
.71835 .51696 Mdot
.7193 .10525 Mdot
.72026 .47384 Mdot
.72121 .21154 Mdot
.72216 .51696 Mdot
.72311 .10525 Mdot
.72406 .47384 Mdot
.72501 .21154 Mdot
.72596 .51696 Mdot
.72692 .10525 Mdot
.72787 .47384 Mdot
.72882 .21154 Mdot
.72977 .51696 Mdot
.73072 .10525 Mdot
.73167 .47384 Mdot
.73262 .21154 Mdot
.73358 .51696 Mdot
.73453 .10525 Mdot
.73548 .47384 Mdot
.73643 .21154 Mdot
.73738 .51696 Mdot
.73833 .10525 Mdot
.73928 .47384 Mdot
.74024 .21154 Mdot
.74119 .51696 Mdot
.74214 .10525 Mdot
.74309 .47384 Mdot
.74404 .21154 Mdot
.74499 .51696 Mdot
.74594 .10525 Mdot
.7469 .47384 Mdot
.74785 .21154 Mdot
.7488 .51696 Mdot
.74975 .10525 Mdot
.7507 .47384 Mdot
.75165 .21154 Mdot
.7526 .51696 Mdot
.75356 .10525 Mdot
.75451 .47384 Mdot
.75546 .21154 Mdot
.75641 .51696 Mdot
.75736 .10525 Mdot
.75831 .47384 Mdot
.75926 .21154 Mdot
.76022 .51696 Mdot
.76117 .10525 Mdot
.76212 .47384 Mdot
.76307 .21154 Mdot
.76402 .51696 Mdot
.76497 .10525 Mdot
.76592 .47384 Mdot
.76688 .21154 Mdot
.76783 .51696 Mdot
.76878 .10525 Mdot
.76973 .47384 Mdot
.77068 .21154 Mdot
.77163 .51696 Mdot
.77258 .10525 Mdot
.77354 .47384 Mdot
.77449 .21154 Mdot
.77544 .51696 Mdot
.77639 .10525 Mdot
.77734 .47384 Mdot
.77829 .21154 Mdot
.77924 .51696 Mdot
.7802 .10525 Mdot
.78115 .47384 Mdot
.7821 .21154 Mdot
.78305 .51696 Mdot
.784 .10525 Mdot
.78495 .47384 Mdot
.7859 .21154 Mdot
.78686 .51696 Mdot
.78781 .10525 Mdot
.78876 .47384 Mdot
.78971 .21154 Mdot
.79066 .51696 Mdot
.79161 .10525 Mdot
.79256 .47384 Mdot
.79352 .21154 Mdot
.79447 .51696 Mdot
.79542 .10525 Mdot
.79637 .47384 Mdot
.79732 .21154 Mdot
.79827 .51696 Mdot
.79922 .10525 Mdot
.80018 .47384 Mdot
.80113 .21154 Mdot
.80208 .51696 Mdot
.80303 .10525 Mdot
.80398 .47384 Mdot
.80493 .21154 Mdot
.80588 .51696 Mdot
.80684 .10525 Mdot
.80779 .47384 Mdot
.80874 .21154 Mdot
.80969 .51696 Mdot
.81064 .10525 Mdot
.81159 .47384 Mdot
.81254 .21154 Mdot
.8135 .51696 Mdot
.81445 .10525 Mdot
.8154 .47384 Mdot
.81635 .21154 Mdot
.8173 .51696 Mdot
.81825 .10525 Mdot
.8192 .47384 Mdot
.82016 .21154 Mdot
.82111 .51696 Mdot
.82206 .10525 Mdot
.82301 .47384 Mdot
.82396 .21154 Mdot
.82491 .51696 Mdot
.82586 .10525 Mdot
.82682 .47384 Mdot
.82777 .21154 Mdot
.82872 .51696 Mdot
.82967 .10525 Mdot
.83062 .47384 Mdot
.83157 .21154 Mdot
.83252 .51696 Mdot
.83348 .10525 Mdot
.83443 .47384 Mdot
.83538 .21154 Mdot
.83633 .51696 Mdot
.83728 .10525 Mdot
.83823 .47384 Mdot
.83918 .21154 Mdot
.84014 .51696 Mdot
.84109 .10525 Mdot
.84204 .47384 Mdot
.84299 .21154 Mdot
.84394 .51696 Mdot
.84489 .10525 Mdot
.84584 .47384 Mdot
.8468 .21154 Mdot
.84775 .51696 Mdot
.8487 .10525 Mdot
.84965 .47384 Mdot
.8506 .21154 Mdot
.85155 .51696 Mdot
.8525 .10525 Mdot
.85346 .47384 Mdot
.85441 .21154 Mdot
.85536 .51696 Mdot
.85631 .10525 Mdot
.85726 .47384 Mdot
.85821 .21154 Mdot
.85916 .51696 Mdot
.86012 .10525 Mdot
.86107 .47384 Mdot
.86202 .21154 Mdot
.86297 .51696 Mdot
.86392 .10525 Mdot
.86487 .47384 Mdot
.86582 .21154 Mdot
.86678 .51696 Mdot
.86773 .10525 Mdot
.86868 .47384 Mdot
.86963 .21154 Mdot
.87058 .51696 Mdot
.87153 .10525 Mdot
.87248 .47384 Mdot
.87344 .21154 Mdot
.87439 .51696 Mdot
.87534 .10525 Mdot
.87629 .47384 Mdot
.87724 .21154 Mdot
.87819 .51696 Mdot
.87914 .10525 Mdot
.8801 .47384 Mdot
.88105 .21154 Mdot
.882 .51696 Mdot
.88295 .10525 Mdot
.8839 .47384 Mdot
.88485 .21154 Mdot
.8858 .51696 Mdot
.88676 .10525 Mdot
.88771 .47384 Mdot
.88866 .21154 Mdot
.88961 .51696 Mdot
.89056 .10525 Mdot
.89151 .47384 Mdot
.89246 .21154 Mdot
.89342 .51696 Mdot
.89437 .10525 Mdot
.89532 .47384 Mdot
.89627 .21154 Mdot
.89722 .51696 Mdot
.89817 .10525 Mdot
.89912 .47384 Mdot
.90008 .21154 Mdot
.90103 .51696 Mdot
.90198 .10525 Mdot
.90293 .47384 Mdot
.90388 .21154 Mdot
.90483 .51696 Mdot
.90578 .10525 Mdot
.90674 .47384 Mdot
.90769 .21154 Mdot
.90864 .51696 Mdot
.90959 .10525 Mdot
.91054 .47384 Mdot
.91149 .21154 Mdot
.91244 .51696 Mdot
.9134 .10525 Mdot
.91435 .47384 Mdot
.9153 .21154 Mdot
.91625 .51696 Mdot
.9172 .10525 Mdot
.91815 .47384 Mdot
.9191 .21154 Mdot
.92006 .51696 Mdot
.92101 .10525 Mdot
.92196 .47384 Mdot
.92291 .21154 Mdot
.92386 .51696 Mdot
.92481 .10525 Mdot
.92576 .47384 Mdot
.92672 .21154 Mdot
.92767 .51696 Mdot
.92862 .10525 Mdot
.92957 .47384 Mdot
.93052 .21154 Mdot
.93147 .51696 Mdot
.93242 .10525 Mdot
.93338 .47384 Mdot
.93433 .21154 Mdot
.93528 .51696 Mdot
.93623 .10525 Mdot
.93718 .47384 Mdot
.93813 .21154 Mdot
.93908 .51696 Mdot
.94004 .10525 Mdot
.94099 .47384 Mdot
.94194 .21154 Mdot
.94289 .51696 Mdot
.94384 .10525 Mdot
.94479 .47384 Mdot
.94574 .21154 Mdot
.9467 .51696 Mdot
.94765 .10525 Mdot
.9486 .47384 Mdot
.94955 .21154 Mdot
.9505 .51696 Mdot
.95145 .10525 Mdot
.9524 .47384 Mdot
.95336 .21154 Mdot
.95431 .51696 Mdot
.95526 .10525 Mdot
.95621 .47384 Mdot
.95716 .21154 Mdot
.95811 .51696 Mdot
.95906 .10525 Mdot
.96002 .47384 Mdot
.96097 .21154 Mdot
.96192 .51696 Mdot
.96287 .10525 Mdot
.96382 .47384 Mdot
.96477 .21154 Mdot
.96572 .51696 Mdot
.96668 .10525 Mdot
.96763 .47384 Mdot
.96858 .21154 Mdot
.96953 .51696 Mdot
.97048 .10525 Mdot
.97143 .47384 Mdot
.97238 .21154 Mdot
.97334 .51696 Mdot
.97429 .10525 Mdot
.97524 .47384 Mdot
.97619 .21154 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{287, 177.313},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004O0000/B000`400?l00000o`00003oo`3ooolP
0?ooo`00o`3ooolP0?ooo`00o`3ooolP0?ooo`00o`3ooolP0?ooo`00o`3ooolP0?ooo`00o`3ooolP
0?ooo`00A03oool4000000<0oooo0P0000040?ooo`800000903oool300000080oooo0P0000040?oo
o`8000008`3oool3000000@0oooo0P0000040?ooo`8000008`3oool2000000@0oooo0P0000040?oo
o`800000803oool500000080oooo0P0000040?ooo`800000103oool2000000<0oooo000K0?ooo`03
0000003oool0oooo02H0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo000002@0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo0200oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo00000240oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000240oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool100000040oooo0@3oool001/0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`02
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000008@3oool5000000050?oo
o`000000oooo0?ooo`0000000P3oool010000000oooo0?ooo`00000R0?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000Q0?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000Q
0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo00000080oooo0@0000010?ooo`40oooo000K0?ooo`800000:@3oool01@000000oooo
0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0O0?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000R0?ooo`<000000`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
0280oooo0P0000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000008@3o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`0000020?ooo`4000000@3oool10?ooo`006`3oool00`000000oooo0?ooo`0V0?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
000R0?ooo`030000003oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`00000S0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`00000Q0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`00000Q0?ooo`050000003oool0oooo0?ooo`0000000P3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo0@0000010?ooo`40oooo000K
0?ooo`030000003oool0oooo02L0oooo0P0000040?ooo`800000103oool2000002@0oooo0P000003
0?ooo`800000103oool2000002@0oooo0`0000030?ooo`800000103oool2000002<0oooo0P000004
0?ooo`800000103oool200000240oooo0P0000040?ooo`800000103oool2000000@0oooo0P000003
0?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`800000o`3oool30?ooo`00
6`3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`030000003oool0oooo0?l0oooo0P3o
ool001/0oooo00<000000?ooo`3oool0o`3oool20?ooo`005@3ooooo000000D000001P3oool001/0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00X0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00X0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00X0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00X0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00X0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00X0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0
oooo000K0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0;P3oool00`000000oooo
0?ooo`0_0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0;`3oool00`000000oooo
0?ooo`0:0?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`030000003oool0
oooo0?l0oooo0P3oool001/0oooo0P00003o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0
oooo0P3oool001/0oooo00<000000?ooo`3oool0o`3oool20?ooo`006`3oool00`000000oooo0?oo
o`3o0?ooo`80oooo000K0?ooo`800000o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?oo
o`80oooo000K0?ooo`030000003oool0oooo0?l0oooo0P3oool001/0oooo00<000000?ooo`3oool0
o`3oool20?ooo`006`3oool200000?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool2
0?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool0o03oool001/0oooo00@000000?ooo`3oool0ooool`00000=0?ooo`00
6`3oool2000000040?ooo`00000000000?oooo4000003@3oool001/0oooo00@000000?ooo`3oool0
0000o`3oool10?ooo`002@3oool300000080oooo0P0000040?ooo`8000001@3oool00`000000oooo
0?ooo`3o0?ooo`80oooo000:0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool00`000000oooo0?ooo`020?ooo`030000003oool000000?l0oooo0P3oool000L0oooo
1@0000001@3oool000000?ooo`3oool000000080oooo00@000000?ooo`3oool00000103oool30000
0?l0oooo0P3oool000L0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo000000@0oooo0P00003o0?ooo`<0oooo00080?ooo`030000003oool0
00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`800000
o`3oool30?ooo`002@3oool2000000<0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?oo
o`3o0?ooo`80oooo000K0?ooo`800000o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?oo
o`80oooo000K0?ooo`030000003oool0oooo0?l0oooo0P3oool001/0oooo00<000000?ooo`3oool0
o`3oool20?ooo`006`3oool200000?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool2
0?ooo`006`3oool200000?l0oooo0`3oool001/0oooo0P00003o0?ooo`<0oooo000K0?ooo`030000
003oool0oooo0?l0oooo0P3oool001/0oooo0P00003o0?ooo`<0oooo000K0?ooo`030000003oool0
00000?l0oooo0P3oool001/0oooo00<000000?ooo`000000o`3oool20?ooo`006`3oool00`000000
oooo0?ooo`3o0?ooo`80oooo000K0?ooo`800000o`3oool30?ooo`006`3oool010000000oooo0?oo
o`00003o0?ooo`40oooo00080?ooo`800000103oool2000000@0oooo0P0000050?ooo`040000003o
ool0oooo00000?l0oooo0@3oool000L0oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0o`3oool20?oo
o`002P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool00P3oool200000?l0oooo0`3oool000P0oooo0P0000030?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool00000103oool010000000oooo0?ooo`3ooooc000000d0oooo
00080?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000040?ooo`040000003oool0oooo0?oooo<000003@3oool000P0oooo0`0000030?ooo`80
0000103oool2000000D0oooo00<000000?ooo`3oool0o`3oool20?ooo`006`3oool200000?l0oooo
0`3oool001/0oooo00<000000?ooo`3oool0o`3oool20?ooo`006`3oool00`000000oooo0?ooo`3o
0?ooo`80oooo000K0?ooo`030000003oool0oooo0?l0oooo0P3oool001/0oooo00<000000?ooo`3o
ool0o`3oool20?ooo`006`3oool200000?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3o
ool20?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`030000003oool0oooo
0?l0oooo0P3oool001/0oooo0P00003o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo
0P3oool001/0oooo00<000000?ooo`3oool0o`3oool20?ooo`006`3oool00`000000oooo0?ooo`3o
0?ooo`80oooo000K0?ooo`800000o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80
oooo000K0?ooo`030000003oool0oooo0?l0oooo0P3oool000L0oooo0`0000040?ooo`800000103o
ool2000000D0oooo00<000000?ooo`3oool0o`3oool20?ooo`001`3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000
oooo0?ooo`3o0?ooo`80oooo00070?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000040?ooo`800000o`3oool30?ooo`001`3oool30000
00<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003o
ool0oooo0?l0oooo0P3oool000P0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0o`3oool20?ooo`00203o
ool3000000<0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K
0?ooo`800000o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`03
0000003oool0oooo0?l0oooo0P3oool001/0oooo00<000000?ooo`3oool0o`3oool20?ooo`006`3o
ool200000?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool20?ooo`006`3oool00`00
0000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`030000003oool0oooo0?l0oooo0P3oool001/0oooo
0P00003o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0P3oool001/0oooo00<00000
0?ooo`3oool0o`3oool20?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`03
0000003oool0oooo0?l0oooo0P3oool001/0oooo0P00003o0?ooo`<0oooo000K0?ooo`030000003o
ool0oooo0?l0oooo0P3oool000T0oooo00<000000?ooo`3oool00P3oool2000000@0oooo0P000005
0?ooo`030000003oool0oooo0?l0oooo0P3oool000T0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`3o0?ooo`80oooo00090?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo0080oooo0P00003o0?ooo`<0oooo000:0?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo0?l0oooo0P3oool000L0oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0o`3oool2
0?ooo`001`3oool4000000<0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`3o0?oo
o`80oooo000K0?ooo`800000o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo
000K0?ooo`030000003oool0oooo0?l0oooo0P3oool001/0oooo00<000000?ooo`3oool0o`3oool2
0?ooo`006`3oool200000?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool20?ooo`00
6`3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`030000003oool0oooo0?l0oooo0P3o
ool001/0oooo00<000000?ooo`3oool0o`3oool20?ooo`006`3oool200000?l0oooo0`3oool001/0
oooo00<000000?ooo`3oool0o`3oool20?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo
000K0?ooo`030000003oool0oooo0?l0oooo0P3oool001/0oooo0P00003o0?ooo`<0oooo000K0?oo
o`030000003oool0oooo0?l0oooo0P3oool000P0oooo0P0000040?ooo`800000103oool2000000D0
oooo00<000000?ooo`3oool0o`3oool20?ooo`001`3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`3o
0?ooo`80oooo00070?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000040?ooo`800000o`3oool30?ooo`00203oool2000000<0oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0?l0
oooo0P3oool000L0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0o`3oool20?ooo`00203oool20000
00@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`03
0000003oool0oooo0?l0oooo0P3oool001/0oooo0P0000020?oooo<000003@3oool001/0oooo00@0
00000?ooo`3oool0ooool`00000=0?ooo`006`3oool010000000oooo0?ooo`00003o0?ooo`40oooo
000K0?ooo`040000003oool0oooo00000?l0oooo0@3oool001/0oooo0`00003o0?ooo`80oooo000K
0?ooo`<00000o`3oool20?ooo`006`3oool200000?l0oooo0`3oool001/0oooo00<000000?ooo`3o
ool0o`3oool20?ooo`006`3oool200000?l0oooo0`3oool001/0oooo0P00003o0?ooo`<0oooo000K
0?ooo`<00000o`3oool20?ooo`006`3oool00`000000oooo0000003d000000d0oooo000K0?ooo`80
000000<0oooo000000000000lP00000=0?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo
000K0?ooo`030000003oool0oooo0?l0oooo0P3oool000L0oooo0`0000040?ooo`800000103oool2
000000D0oooo00<000000?ooo`3oool0o`3oool20?ooo`002@3oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo0?l0oooo0P3oool000P0oooo0`0000020?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool00000103oool200000?l0oooo0`3oool000L0oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?oo
o`3oool0o`3oool20?ooo`001`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`3o0?ooo`80oooo0008
0?ooo`<000000`3oool2000000@0oooo0P0000050?ooo`030000003oool0oooo0?l0oooo0P3oool0
01/0oooo0P00003o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0P3oool001/0oooo
00<000000?ooo`3oool0o`3oool20?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K
0?ooo`800000o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`03
0000003oool0oooo0?l0oooo0P3oool001/0oooo00<000000?ooo`3oool0o`3oool20?ooo`006`3o
ool200000?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool20?ooo`006`3oool00`00
0000oooo0?ooo`3o0?ooo`80oooo000K0?ooo`030000003oool0oooo0?l0oooo0P3oool001/0oooo
00<000000?ooo`3oool0o`3oool20?ooo`006`3oool200000?l0oooo0`3oool001/0oooo00<00000
0?ooo`3oool0o`3oool20?ooo`0000<0oooo0000000000000`0000020?ooo`800000103oool20000
00@0oooo0P0000050?ooo`030000003oool0oooo0?l0oooo0P3oool000<0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0?l0oooo0P3oool000<0oooo00D00000
0?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool00`000000oooo0?ooo`020?ooo`800000o`3oool30?ooo`000`3oool01@000000oooo
0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000002
0?ooo`030000003oool0oooo0?l0oooo1`3oool000<0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo
0?ooo`3o0?ooo`L0oooo00020?ooo`800000103oool2000000@0oooo0P0000040?ooo`800000o`3o
ool:0?ooo`00o`3ooolP0?ooo`00o`3ooolP0?ooo`00o`3ooolP0?ooo`00o`3ooolP0?ooo`00o`3o
oolP0?ooo`00o`3ooolP0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 286}, {176.313, 0}} -> {-110.405, 219.395, 4.05259, \
4.67906}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[TextData[{
  StyleBox["Its r values just under four show chaos. There are actually a few \
values that have limit cycles that are not powers of two. If you pick an r \
value close enough to one of them, you can easily see them.",
    FontColor->RGBColor[1, 0.501961, 1]],
  "\n"
}], "Input",
  Evaluatable->False,
  FormatType->TextForm],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(Clear\ [pop]\n
    \(r\  = \ 3.97;\)\n
    \(k\  = \ 1000;\)\n
    \(g\  = \ 1000;\)\n
    \(s\  = \ 1000;\)\n
    \(pop[t_]\  := \ \(pop[t]\  = \ 
          r\ pop[t - 1] \((1 - \ pop[t - 1]/k)\)\);\)\n
    \(pop[0]\  = \ 5;\)\n
    \(dt\  = Table[pop[x], \ {x, 0, g, 1}];\)\n
    ListPlot[dt, \ PlotJoined\  \[Rule] False, \ 
      PlotRange \[Rule] {0, \ 3  k/2}]\)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00095143 -1.6263e-018 0.000412023 [
[.2141 -0.0125 -9 -9 ]
[.2141 -0.0125 9 0 ]
[.40438 -0.0125 -9 -9 ]
[.40438 -0.0125 9 0 ]
[.59467 -0.0125 -9 -9 ]
[.59467 -0.0125 9 0 ]
[.78495 -0.0125 -9 -9 ]
[.78495 -0.0125 9 0 ]
[.97524 -0.0125 -12 -9 ]
[.97524 -0.0125 12 0 ]
[.01131 .0824 -18 -4.5 ]
[.01131 .0824 0 4.5 ]
[.01131 .16481 -18 -4.5 ]
[.01131 .16481 0 4.5 ]
[.01131 .24721 -18 -4.5 ]
[.01131 .24721 0 4.5 ]
[.01131 .32962 -18 -4.5 ]
[.01131 .32962 0 4.5 ]
[.01131 .41202 -24 -4.5 ]
[.01131 .41202 0 4.5 ]
[.01131 .49443 -24 -4.5 ]
[.01131 .49443 0 4.5 ]
[.01131 .57683 -24 -4.5 ]
[.01131 .57683 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2141 0 m
.2141 .00625 L
s
[(200)] .2141 -0.0125 0 1 Mshowa
.40438 0 m
.40438 .00625 L
s
[(400)] .40438 -0.0125 0 1 Mshowa
.59467 0 m
.59467 .00625 L
s
[(600)] .59467 -0.0125 0 1 Mshowa
.78495 0 m
.78495 .00625 L
s
[(800)] .78495 -0.0125 0 1 Mshowa
.97524 0 m
.97524 .00625 L
s
[(1000)] .97524 -0.0125 0 1 Mshowa
.125 Mabswid
.07138 0 m
.07138 .00375 L
s
.11895 0 m
.11895 .00375 L
s
.16652 0 m
.16652 .00375 L
s
.26167 0 m
.26167 .00375 L
s
.30924 0 m
.30924 .00375 L
s
.35681 0 m
.35681 .00375 L
s
.45195 0 m
.45195 .00375 L
s
.49952 0 m
.49952 .00375 L
s
.5471 0 m
.5471 .00375 L
s
.64224 0 m
.64224 .00375 L
s
.68981 0 m
.68981 .00375 L
s
.73738 0 m
.73738 .00375 L
s
.83252 0 m
.83252 .00375 L
s
.8801 0 m
.8801 .00375 L
s
.92767 0 m
.92767 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.02381 .0824 m
.03006 .0824 L
s
[(200)] .01131 .0824 1 0 Mshowa
.02381 .16481 m
.03006 .16481 L
s
[(400)] .01131 .16481 1 0 Mshowa
.02381 .24721 m
.03006 .24721 L
s
[(600)] .01131 .24721 1 0 Mshowa
.02381 .32962 m
.03006 .32962 L
s
[(800)] .01131 .32962 1 0 Mshowa
.02381 .41202 m
.03006 .41202 L
s
[(1000)] .01131 .41202 1 0 Mshowa
.02381 .49443 m
.03006 .49443 L
s
[(1200)] .01131 .49443 1 0 Mshowa
.02381 .57683 m
.03006 .57683 L
s
[(1400)] .01131 .57683 1 0 Mshowa
.125 Mabswid
.02381 .0206 m
.02756 .0206 L
s
.02381 .0412 m
.02756 .0412 L
s
.02381 .0618 m
.02756 .0618 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .12361 m
.02756 .12361 L
s
.02381 .14421 m
.02756 .14421 L
s
.02381 .18541 m
.02756 .18541 L
s
.02381 .20601 m
.02756 .20601 L
s
.02381 .22661 m
.02756 .22661 L
s
.02381 .26781 m
.02756 .26781 L
s
.02381 .28842 m
.02756 .28842 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .35022 m
.02756 .35022 L
s
.02381 .37082 m
.02756 .37082 L
s
.02381 .39142 m
.02756 .39142 L
s
.02381 .43262 m
.02756 .43262 L
s
.02381 .45322 m
.02756 .45322 L
s
.02381 .47383 m
.02756 .47383 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .53563 m
.02756 .53563 L
s
.02381 .55623 m
.02756 .55623 L
s
.02381 .59743 m
.02756 .59743 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02476 .00206 Mdot
.02571 .00814 Mdot
.02666 .03167 Mdot
.02762 .11606 Mdot
.02857 .33097 Mdot
.02952 .25847 Mdot
.03047 .38242 Mdot
.03142 .10909 Mdot
.03237 .31843 Mdot
.03332 .28716 Mdot
.03428 .34548 Mdot
.03523 .22151 Mdot
.03618 .40662 Mdot
.03713 .02118 Mdot
.03808 .07976 Mdot
.03903 .25535 Mdot
.03998 .38548 Mdot
.04094 .09859 Mdot
.04189 .29775 Mdot
.04284 .32784 Mdot
.04379 .26592 Mdot
.04474 .37435 Mdot
.04569 .1359 Mdot
.04664 .36156 Mdot
.0476 .17579 Mdot
.04855 .40013 Mdot
.0495 .04584 Mdot
.05045 .16173 Mdot
.0514 .39004 Mdot
.05235 .08261 Mdot
.0533 .26221 Mdot
.05426 .3785 Mdot
.05521 .12224 Mdot
.05616 .34132 Mdot
.05711 .23252 Mdot
.05806 .40216 Mdot
.05901 .03822 Mdot
.05996 .13766 Mdot
.06092 .36391 Mdot
.06187 .1687 Mdot
.06282 .39552 Mdot
.06377 .0629 Mdot
.06472 .2116 Mdot
.06567 .40863 Mdot
.06662 .01335 Mdot
.06758 .05129 Mdot
.06853 .17828 Mdot
.06948 .40152 Mdot
.07043 .04063 Mdot
.07138 .14539 Mdot
.07233 .37352 Mdot
.07328 .13857 Mdot
.07424 .36511 Mdot
.07519 .16504 Mdot
.07614 .39276 Mdot
.07709 .0729 Mdot
.07804 .23822 Mdot
.07899 .39894 Mdot
.07994 .0503 Mdot
.0809 .1753 Mdot
.08185 .39985 Mdot
.0828 .04691 Mdot
.08375 .16503 Mdot
.0847 .39275 Mdot
.08565 .07293 Mdot
.0866 .23827 Mdot
.08756 .3989 Mdot
.08851 .05042 Mdot
.08946 .17568 Mdot
.09041 .40007 Mdot
.09136 .04609 Mdot
.09231 .1625 Mdot
.09326 .39069 Mdot
.09422 .08029 Mdot
.09517 .25665 Mdot
.09612 .38423 Mdot
.09707 .1029 Mdot
.09802 .30648 Mdot
.09897 .31167 Mdot
.09992 .30137 Mdot
.10088 .32132 Mdot
.10183 .28082 Mdot
.10278 .355 Mdot
.10373 .19504 Mdot
.10468 .40777 Mdot
.10563 .0167 Mdot
.10658 .06361 Mdot
.10754 .21353 Mdot
.10849 .40839 Mdot
.10944 .0143 Mdot
.11039 .05481 Mdot
.11134 .18866 Mdot
.11229 .40603 Mdot
.11324 .02344 Mdot
.1142 .08775 Mdot
.11515 .27418 Mdot
.1161 .36416 Mdot
.11705 .16794 Mdot
.118 .39496 Mdot
.11895 .06492 Mdot
.1199 .21713 Mdot
.12086 .40774 Mdot
.12181 .01682 Mdot
.12276 .06404 Mdot
.12371 .21473 Mdot
.12466 .4082 Mdot
.12561 .01504 Mdot
.12656 .05752 Mdot
.12752 .19648 Mdot
.12847 .40806 Mdot
.12942 .01559 Mdot
.13037 .05956 Mdot
.13132 .20228 Mdot
.13227 .4088 Mdot
.13322 .0127 Mdot
.13418 .04887 Mdot
.13513 .171 Mdot
.13608 .39712 Mdot
.13703 .05701 Mdot
.13798 .19502 Mdot
.13893 .40777 Mdot
.13988 .01672 Mdot
.14084 .06367 Mdot
.14179 .2137 Mdot
.14274 .40836 Mdot
.14369 .0144 Mdot
.14464 .05518 Mdot
.14559 .18972 Mdot
.14654 .40638 Mdot
.1475 .02211 Mdot
.14845 .08307 Mdot
.1494 .2633 Mdot
.15035 .37731 Mdot
.1513 .12621 Mdot
.15225 .34758 Mdot
.1532 .21583 Mdot
.15416 .408 Mdot
.15511 .0158 Mdot
.15606 .06031 Mdot
.15701 .20438 Mdot
.15796 .40891 Mdot
.15891 .01228 Mdot
.15986 .04728 Mdot
.16082 .16617 Mdot
.16177 .39364 Mdot
.16272 .06972 Mdot
.16367 .22995 Mdot
.16462 .40341 Mdot
.16557 .03347 Mdot
.16652 .12209 Mdot
.16748 .34108 Mdot
.16843 .23316 Mdot
.16938 .40183 Mdot
.17033 .03945 Mdot
.17128 .14164 Mdot
.17223 .369 Mdot
.17318 .15296 Mdot
.17414 .38181 Mdot
.17509 .11114 Mdot
.17604 .32221 Mdot
.17699 .27883 Mdot
.17794 .35784 Mdot
.17889 .1868 Mdot
.17984 .40538 Mdot
.1808 .02595 Mdot
.18175 .09655 Mdot
.1827 .29348 Mdot
.18365 .33522 Mdot
.1846 .24807 Mdot
.18555 .39189 Mdot
.1865 .07603 Mdot
.18746 .24614 Mdot
.18841 .39341 Mdot
.18936 .07054 Mdot
.19031 .23209 Mdot
.19126 .40238 Mdot
.19221 .0374 Mdot
.19316 .13498 Mdot
.19412 .36032 Mdot
.19507 .17949 Mdot
.19602 .40216 Mdot
.19697 .03823 Mdot
.19792 .1377 Mdot
.19887 .36396 Mdot
.19982 .16854 Mdot
.20078 .3954 Mdot
.20173 .06332 Mdot
.20268 .21274 Mdot
.20363 .4085 Mdot
.20458 .01388 Mdot
.20553 .05325 Mdot
.20648 .18407 Mdot
.20744 .40429 Mdot
.20839 .03011 Mdot
.20934 .11079 Mdot
.21029 .32157 Mdot
.21124 .28026 Mdot
.21219 .35581 Mdot
.21314 .19272 Mdot
.2141 .40723 Mdot
.21505 .0188 Mdot
.216 .07124 Mdot
.21695 .23391 Mdot
.2179 .40143 Mdot
.21885 .04097 Mdot
.2198 .14646 Mdot
.22076 .37476 Mdot
.22171 .13454 Mdot
.22266 .35971 Mdot
.22361 .18131 Mdot
.22456 .40305 Mdot
.22551 .03484 Mdot
.22646 .12661 Mdot
.22742 .34818 Mdot
.22837 .21418 Mdot
.22932 .40829 Mdot
.23027 .01468 Mdot
.23122 .05622 Mdot
.23217 .19274 Mdot
.23312 .40723 Mdot
.23408 .01879 Mdot
.23503 .07119 Mdot
.23598 .23378 Mdot
.23693 .4015 Mdot
.23788 .0407 Mdot
.23883 .14563 Mdot
.23978 .3738 Mdot
.24074 .13767 Mdot
.24169 .36393 Mdot
.24264 .16864 Mdot
.24359 .39548 Mdot
.24454 .06306 Mdot
.24549 .21202 Mdot
.24644 .40858 Mdot
.2474 .01353 Mdot
.24835 .05197 Mdot
.2493 .18029 Mdot
.25025 .40256 Mdot
.2512 .03671 Mdot
.25215 .13275 Mdot
.2531 .35722 Mdot
.25406 .18862 Mdot
.25501 .40602 Mdot
.25596 .02349 Mdot
.25691 .08794 Mdot
.25786 .27462 Mdot
.25881 .36358 Mdot
.25976 .1697 Mdot
.26072 .39623 Mdot
.26167 .06031 Mdot
.26262 .20438 Mdot
.26357 .40891 Mdot
.26452 .01228 Mdot
.26547 .04729 Mdot
.26642 .16618 Mdot
.26738 .39364 Mdot
.26833 .06971 Mdot
.26928 .22992 Mdot
.27023 .40342 Mdot
.27118 .03342 Mdot
.27213 .12192 Mdot
.27308 .34079 Mdot
.27404 .2339 Mdot
.27499 .40144 Mdot
.27594 .04093 Mdot
.27689 .14636 Mdot
.27784 .37464 Mdot
.27879 .13494 Mdot
.27974 .36026 Mdot
.2807 .17968 Mdot
.28165 .40225 Mdot
.2826 .03786 Mdot
.28355 .1365 Mdot
.2845 .36238 Mdot
.28545 .17333 Mdot
.2864 .39864 Mdot
.28736 .0514 Mdot
.28831 .1786 Mdot
.28926 .40169 Mdot
.29021 .03999 Mdot
.29116 .14335 Mdot
.29211 .3711 Mdot
.29306 .14632 Mdot
.29402 .37461 Mdot
.29497 .13506 Mdot
.29592 .36042 Mdot
.29687 .1792 Mdot
.29782 .402 Mdot
.29877 .03881 Mdot
.29972 .13955 Mdot
.30068 .36637 Mdot
.30163 .16116 Mdot
.30258 .38955 Mdot
.30353 .08436 Mdot
.30448 .26634 Mdot
.30543 .37386 Mdot
.30638 .13748 Mdot
.30734 .36368 Mdot
.30829 .16941 Mdot
.30924 .39603 Mdot
.31019 .06103 Mdot
.31114 .20641 Mdot
.31209 .40893 Mdot
.31304 .01218 Mdot
.314 .04693 Mdot
.31495 .1651 Mdot
.3159 .39281 Mdot
.31685 .07273 Mdot
.3178 .23778 Mdot
.31875 .39921 Mdot
.3197 .0493 Mdot
.32066 .17229 Mdot
.32161 .39798 Mdot
.32256 .05385 Mdot
.32351 .18586 Mdot
.32446 .40502 Mdot
.32541 .02733 Mdot
.32636 .10131 Mdot
.32732 .3033 Mdot
.32827 .31773 Mdot
.32922 .28868 Mdot
.33017 .34308 Mdot
.33112 .22791 Mdot
.33207 .40431 Mdot
.33302 .03004 Mdot
.33398 .11055 Mdot
.33493 .32113 Mdot
.33588 .28125 Mdot
.33683 .35439 Mdot
.33778 .1968 Mdot
.33873 .40812 Mdot
.33968 .01536 Mdot
.34064 .05872 Mdot
.34159 .19989 Mdot
.34254 .40857 Mdot
.34349 .01359 Mdot
.34444 .05216 Mdot
.34539 .18086 Mdot
.34634 .40284 Mdot
.3473 .03566 Mdot
.34825 .12932 Mdot
.3492 .35226 Mdot
.35015 .20285 Mdot
.3511 .40884 Mdot
.35205 .01255 Mdot
.353 .04831 Mdot
.35396 .16931 Mdot
.35491 .39595 Mdot
.35586 .06132 Mdot
.35681 .2072 Mdot
.35776 .40892 Mdot
.35871 .01223 Mdot
.35966 .04711 Mdot
.36062 .16564 Mdot
.36157 .39323 Mdot
.36252 .07121 Mdot
.36347 .23385 Mdot
.36442 .40147 Mdot
.36537 .04084 Mdot
.36632 .14606 Mdot
.36728 .37431 Mdot
.36823 .13603 Mdot
.36918 .36174 Mdot
.37013 .17525 Mdot
.37108 .39981 Mdot
.37203 .04704 Mdot
.37298 .16542 Mdot
.37394 .39306 Mdot
.37489 .07182 Mdot
.37584 .23544 Mdot
.37679 .40059 Mdot
.37774 .04413 Mdot
.37869 .15643 Mdot
.37964 .38525 Mdot
.3806 .09939 Mdot
.38155 .29939 Mdot
.3825 .32491 Mdot
.38345 .27271 Mdot
.3844 .36607 Mdot
.38535 .16208 Mdot
.3863 .39034 Mdot
.38726 .08156 Mdot
.38821 .2597 Mdot
.38916 .38116 Mdot
.39011 .11336 Mdot
.39106 .32622 Mdot
.39201 .2697 Mdot
.39296 .36984 Mdot
.39392 .15031 Mdot
.39487 .37904 Mdot
.39582 .12047 Mdot
.39677 .33844 Mdot
.39772 .23997 Mdot
.39867 .39782 Mdot
.39962 .05443 Mdot
.40058 .18753 Mdot
.40153 .40564 Mdot
.40248 .02494 Mdot
.40343 .09303 Mdot
.40438 .28593 Mdot
.40533 .34739 Mdot
.40628 .21635 Mdot
.40724 .4079 Mdot
.40819 .0162 Mdot
.40914 .06177 Mdot
.41009 .20846 Mdot
.41104 .40887 Mdot
.41199 .0124 Mdot
.41294 .04775 Mdot
.4139 .16761 Mdot
.41485 .39472 Mdot
.4158 .0658 Mdot
.41675 .21951 Mdot
.4177 .40718 Mdot
.41865 .01901 Mdot
.4196 .07199 Mdot
.42056 .23586 Mdot
.42151 .40035 Mdot
.42246 .04504 Mdot
.42341 .15925 Mdot
.42436 .38787 Mdot
.42531 .09027 Mdot
.42626 .27986 Mdot
.42722 .35638 Mdot
.42817 .19108 Mdot
.42912 .40678 Mdot
.43007 .02054 Mdot
.43102 .07747 Mdot
.43197 .24972 Mdot
.43292 .39052 Mdot
.43388 .08091 Mdot
.43483 .25812 Mdot
.43578 .38277 Mdot
.43673 .1079 Mdot
.43768 .31619 Mdot
.43863 .29197 Mdot
.43958 .33774 Mdot
.44054 .24173 Mdot
.44149 .39664 Mdot
.44244 .0588 Mdot
.44339 .20013 Mdot
.44434 .4086 Mdot
.44529 .01348 Mdot
.44624 .05176 Mdot
.4472 .17967 Mdot
.44815 .40225 Mdot
.4491 .03789 Mdot
.45005 .13659 Mdot
.451 .36249 Mdot
.45195 .173 Mdot
.4529 .39843 Mdot
.45386 .05218 Mdot
.45481 .18091 Mdot
.45576 .40286 Mdot
.45671 .03556 Mdot
.45766 .129 Mdot
.45861 .35179 Mdot
.45956 .20417 Mdot
.46052 .4089 Mdot
.46147 .0123 Mdot
.46242 .04739 Mdot
.46337 .16649 Mdot
.46432 .39389 Mdot
.46527 .06884 Mdot
.46622 .22762 Mdot
.46718 .40443 Mdot
.46813 .02958 Mdot
.46908 .109 Mdot
.47003 .31825 Mdot
.47098 .28754 Mdot
.47193 .34488 Mdot
.47288 .22311 Mdot
.47384 .40612 Mdot
.47479 .02311 Mdot
.47574 .08662 Mdot
.47669 .27158 Mdot
.47764 .36751 Mdot
.47859 .15762 Mdot
.47954 .38637 Mdot
.4805 .09551 Mdot
.48145 .29128 Mdot
.4824 .33888 Mdot
.48335 .23884 Mdot
.4843 .39855 Mdot
.48525 .05174 Mdot
.4862 .1796 Mdot
.48716 .40221 Mdot
.48811 .03802 Mdot
.48906 .13702 Mdot
.49001 .36307 Mdot
.49096 .17125 Mdot
.49191 .39729 Mdot
.49286 .0564 Mdot
.49382 .19327 Mdot
.49477 .40737 Mdot
.49572 .01827 Mdot
.49667 .0693 Mdot
.49762 .22886 Mdot
.49857 .4039 Mdot
.49952 .0316 Mdot
.50048 .11583 Mdot
.50143 .33058 Mdot
.50238 .25942 Mdot
.50333 .38145 Mdot
.50428 .11237 Mdot
.50523 .32445 Mdot
.50618 .27378 Mdot
.50714 .36468 Mdot
.50809 .16636 Mdot
.50904 .39378 Mdot
.50999 .06921 Mdot
.51094 .22862 Mdot
.51189 .40401 Mdot
.51284 .03121 Mdot
.5138 .11451 Mdot
.51475 .32825 Mdot
.5157 .26495 Mdot
.51665 .37546 Mdot
.5176 .13227 Mdot
.51855 .35654 Mdot
.5195 .1906 Mdot
.52046 .40664 Mdot
.52141 .02108 Mdot
.52236 .0794 Mdot
.52331 .25448 Mdot
.52426 .3863 Mdot
.52521 .09574 Mdot
.52616 .29177 Mdot
.52712 .33806 Mdot
.52807 .24091 Mdot
.52902 .39719 Mdot
.52997 .05675 Mdot
.53092 .19426 Mdot
.53187 .4076 Mdot
.53282 .01736 Mdot
.53378 .06601 Mdot
.53473 .22007 Mdot
.53568 .40703 Mdot
.53663 .01959 Mdot
.53758 .07406 Mdot
.53853 .24118 Mdot
.53948 .39702 Mdot
.54044 .05741 Mdot
.54139 .19616 Mdot
.54234 .408 Mdot
.54329 .01583 Mdot
.54424 .06042 Mdot
.54519 .20468 Mdot
.54614 .40892 Mdot
.5471 .01224 Mdot
.54805 .04716 Mdot
.549 .16579 Mdot
.54995 .39335 Mdot
.5509 .07078 Mdot
.55185 .23273 Mdot
.5528 .40205 Mdot
.55376 .03862 Mdot
.55471 .13894 Mdot
.55566 .36558 Mdot
.55661 .16358 Mdot
.55756 .39158 Mdot
.55851 .07712 Mdot
.55946 .24885 Mdot
.56042 .39125 Mdot
.56137 .0783 Mdot
.56232 .25179 Mdot
.56327 .38874 Mdot
.56422 .0872 Mdot
.56517 .27292 Mdot
.56612 .3658 Mdot
.56708 .16293 Mdot
.56803 .39105 Mdot
.56898 .07904 Mdot
.56993 .25358 Mdot
.57088 .38713 Mdot
.57183 .09286 Mdot
.57278 .28557 Mdot
.57374 .34794 Mdot
.57469 .21484 Mdot
.57564 .40818 Mdot
.57659 .0151 Mdot
.57754 .05777 Mdot
.57849 .19718 Mdot
.57944 .40818 Mdot
.5804 .01511 Mdot
.58135 .05779 Mdot
.5823 .19724 Mdot
.58325 .40819 Mdot
.5842 .01507 Mdot
.58515 .05764 Mdot
.5861 .19681 Mdot
.58706 .40812 Mdot
.58801 .01536 Mdot
.58896 .05872 Mdot
.58991 .19988 Mdot
.59086 .40857 Mdot
.59181 .01359 Mdot
.59276 .05217 Mdot
.59372 .1809 Mdot
.59467 .40286 Mdot
.59562 .03558 Mdot
.59657 .12905 Mdot
.59752 .35186 Mdot
.59847 .20397 Mdot
.59942 .40889 Mdot
.60038 .01233 Mdot
.60133 .0475 Mdot
.60228 .16683 Mdot
.60323 .39414 Mdot
.60418 .06792 Mdot
.60513 .22519 Mdot
.60608 .40539 Mdot
.60704 .02592 Mdot
.60799 .09642 Mdot
.60894 .2932 Mdot
.60989 .33568 Mdot
.61084 .24692 Mdot
.61179 .39281 Mdot
.61274 .07273 Mdot
.6137 .23778 Mdot
.61465 .39921 Mdot
.6156 .0493 Mdot
.61655 .17229 Mdot
.6175 .39797 Mdot
.61845 .05387 Mdot
.6194 .1859 Mdot
.62036 .40504 Mdot
.62131 .02727 Mdot
.62226 .10109 Mdot
.62321 .30285 Mdot
.62416 .31857 Mdot
.62511 .28687 Mdot
.62606 .34594 Mdot
.62702 .22027 Mdot
.62797 .40697 Mdot
.62892 .0198 Mdot
.62987 .07484 Mdot
.63082 .24315 Mdot
.63177 .39564 Mdot
.63272 .06244 Mdot
.63368 .21032 Mdot
.63463 .40875 Mdot
.63558 .01287 Mdot
.63653 .04952 Mdot
.63748 .17295 Mdot
.63843 .3984 Mdot
.63938 .05229 Mdot
.64034 .18123 Mdot
.64129 .40302 Mdot
.64224 .03497 Mdot
.64319 .12706 Mdot
.64414 .34887 Mdot
.64509 .21228 Mdot
.64604 .40855 Mdot
.647 .01365 Mdot
.64795 .05241 Mdot
.6489 .18161 Mdot
.64985 .4032 Mdot
.6508 .03429 Mdot
.65175 .1248 Mdot
.6527 .34539 Mdot
.65366 .22175 Mdot
.65461 .40655 Mdot
.65556 .02145 Mdot
.65651 .08072 Mdot
.65746 .25768 Mdot
.65841 .38321 Mdot
.65936 .10639 Mdot
.66032 .31331 Mdot
.66127 .29801 Mdot
.66222 .32739 Mdot
.66317 .26699 Mdot
.66412 .37311 Mdot
.66507 .1399 Mdot
.66602 .36682 Mdot
.66698 .15975 Mdot
.66793 .38832 Mdot
.66888 .0887 Mdot
.66983 .27633 Mdot
.67078 .36129 Mdot
.67173 .17662 Mdot
.67268 .40061 Mdot
.67364 .04407 Mdot
.67459 .15623 Mdot
.67554 .38506 Mdot
.67649 .10004 Mdot
.67744 .30073 Mdot
.67839 .32248 Mdot
.67934 .27823 Mdot
.6803 .35868 Mdot
.68125 .18436 Mdot
.6822 .40441 Mdot
.68315 .02965 Mdot
.6841 .10923 Mdot
.68505 .31868 Mdot
.686 .28663 Mdot
.68696 .34631 Mdot
.68791 .21926 Mdot
.68886 .40724 Mdot
.68981 .01876 Mdot
.69076 .07109 Mdot
.69171 .23353 Mdot
.69266 .40163 Mdot
.69362 .04021 Mdot
.69457 .14404 Mdot
.69552 .37193 Mdot
.69647 .14369 Mdot
.69742 .37151 Mdot
.69837 .14503 Mdot
.69932 .3731 Mdot
.70028 .13991 Mdot
.70123 .36683 Mdot
.70218 .15972 Mdot
.70313 .38829 Mdot
.70408 .0888 Mdot
.70503 .27655 Mdot
.70598 .36099 Mdot
.70694 .17752 Mdot
.70789 .40111 Mdot
.70884 .04217 Mdot
.70979 .15029 Mdot
.71074 .37902 Mdot
.71169 .12054 Mdot
.71264 .33854 Mdot
.7136 .23969 Mdot
.71455 .398 Mdot
.7155 .05377 Mdot
.71645 .18561 Mdot
.7174 .40492 Mdot
.71835 .0277 Mdot
.7193 .10258 Mdot
.72026 .30584 Mdot
.72121 .3129 Mdot
.72216 .29884 Mdot
.72311 .3259 Mdot
.72406 .27045 Mdot
.72501 .36892 Mdot
.72596 .15321 Mdot
.72692 .38207 Mdot
.72787 .11026 Mdot
.72882 .32059 Mdot
.72977 .28244 Mdot
.73072 .35265 Mdot
.73167 .20175 Mdot
.73262 .40876 Mdot
.73358 .01286 Mdot
.73453 .04947 Mdot
.73548 .1728 Mdot
.73643 .39831 Mdot
.73738 .05264 Mdot
.73833 .18229 Mdot
.73928 .40351 Mdot
.74024 .03309 Mdot
.74119 .12081 Mdot
.74214 .33899 Mdot
.74309 .23855 Mdot
.74404 .39873 Mdot
.74499 .05107 Mdot
.74594 .17763 Mdot
.7469 .40117 Mdot
.74785 .04195 Mdot
.7488 .14959 Mdot
.74975 .37826 Mdot
.7507 .12304 Mdot
.75165 .34261 Mdot
.7526 .22916 Mdot
.75356 .40377 Mdot
.75451 .0321 Mdot
.75546 .11752 Mdot
.75641 .33348 Mdot
.75736 .25238 Mdot
.75831 .38821 Mdot
.75926 .08906 Mdot
.76022 .27715 Mdot
.76117 .36017 Mdot
.76212 .17994 Mdot
.76307 .40238 Mdot
.76402 .03738 Mdot
.76497 .13494 Mdot
.76592 .36027 Mdot
.76688 .17965 Mdot
.76783 .40224 Mdot
.76878 .03792 Mdot
.76973 .13669 Mdot
.77068 .36263 Mdot
.77163 .17259 Mdot
.77258 .39817 Mdot
.77354 .05316 Mdot
.77449 .18381 Mdot
.77544 .40418 Mdot
.77639 .03053 Mdot
.77734 .11224 Mdot
.77829 .32421 Mdot
.77924 .27433 Mdot
.7802 .36396 Mdot
.78115 .16854 Mdot
.7821 .3954 Mdot
.78305 .06332 Mdot
.784 .21275 Mdot
.78495 .4085 Mdot
.7859 .01388 Mdot
.78686 .05326 Mdot
.78781 .18412 Mdot
.78876 .40432 Mdot
.78971 .03002 Mdot
.79066 .11051 Mdot
.79161 .32105 Mdot
.79256 .28142 Mdot
.79352 .35414 Mdot
.79447 .19752 Mdot
.79542 .40824 Mdot
.79637 .01489 Mdot
.79732 .05698 Mdot
.79827 .19491 Mdot
.79922 .40775 Mdot
.80018 .0168 Mdot
.80113 .06399 Mdot
.80208 .21458 Mdot
.80303 .40822 Mdot
.80398 .01494 Mdot
.80493 .05716 Mdot
.80588 .19545 Mdot
.80684 .40786 Mdot
.80779 .01637 Mdot
.80874 .0624 Mdot
.80969 .21021 Mdot
.81064 .40876 Mdot
.81159 .01284 Mdot
.81254 .04938 Mdot
.8135 .17255 Mdot
.81445 .39814 Mdot
.8154 .05325 Mdot
.81635 .18409 Mdot
.8173 .4043 Mdot
.81825 .03008 Mdot
.8192 .1107 Mdot
.82016 .32141 Mdot
.82111 .28063 Mdot
.82206 .35529 Mdot
.82301 .19423 Mdot
.82396 .40759 Mdot
.82491 .01739 Mdot
.82586 .06612 Mdot
.82682 .22038 Mdot
.82777 .40694 Mdot
.82872 .01991 Mdot
.82967 .07523 Mdot
.83062 .24414 Mdot
.83157 .39493 Mdot
.83252 .06505 Mdot
.83348 .21748 Mdot
.83443 .40767 Mdot
.83538 .01712 Mdot
.83633 .06513 Mdot
.83728 .21769 Mdot
.83823 .40762 Mdot
.83918 .0173 Mdot
.84014 .0658 Mdot
.84109 .21952 Mdot
.84204 .40717 Mdot
.84299 .01902 Mdot
.84394 .07202 Mdot
.84489 .23594 Mdot
.84584 .4003 Mdot
.8468 .04521 Mdot
.84775 .15979 Mdot
.8487 .38835 Mdot
.84965 .08859 Mdot
.8506 .27609 Mdot
.85155 .36162 Mdot
.8525 .17563 Mdot
.85346 .40004 Mdot
.85441 .04619 Mdot
.85536 .16281 Mdot
.85631 .39095 Mdot
.85726 .07938 Mdot
.85821 .25442 Mdot
.85916 .38636 Mdot
.86012 .09555 Mdot
.86107 .29136 Mdot
.86202 .33875 Mdot
.86297 .23917 Mdot
.86392 .39834 Mdot
.86487 .05252 Mdot
.86582 .18193 Mdot
.86678 .40334 Mdot
.86773 .03373 Mdot
.86868 .12294 Mdot
.86963 .34244 Mdot
.87058 .2296 Mdot
.87153 .40357 Mdot
.87248 .03286 Mdot
.87344 .12004 Mdot
.87439 .33772 Mdot
.87534 .24179 Mdot
.87629 .3966 Mdot
.87724 .05894 Mdot
.87819 .20052 Mdot
.87914 .40864 Mdot
.8801 .01331 Mdot
.88105 .05114 Mdot
.882 .17782 Mdot
.88295 .40128 Mdot
.8839 .04155 Mdot
.88485 .14833 Mdot
.8858 .37688 Mdot
.88676 .12763 Mdot
.88771 .34974 Mdot
.88866 .20989 Mdot
.88961 .40879 Mdot
.89056 .01274 Mdot
.89151 .04903 Mdot
.89246 .17148 Mdot
.89342 .39744 Mdot
.89437 .05584 Mdot
.89532 .19164 Mdot
.89627 .40694 Mdot
.89722 .01992 Mdot
.89817 .07526 Mdot
.89912 .2442 Mdot
.90008 .39488 Mdot
.90103 .06522 Mdot
.90198 .21795 Mdot
.90293 .40756 Mdot
.90388 .01753 Mdot
.90483 .06663 Mdot
.90578 .22174 Mdot
.90674 .40655 Mdot
.90769 .02145 Mdot
.90864 .08071 Mdot
.90959 .25766 Mdot
.91054 .38323 Mdot
.91149 .10634 Mdot
.91244 .3132 Mdot
.9134 .29822 Mdot
.91435 .327 Mdot
.9153 .26788 Mdot
.91625 .37205 Mdot
.9172 .14329 Mdot
.91815 .37103 Mdot
.9191 .14655 Mdot
.92006 .37486 Mdot
.92101 .13423 Mdot
.92196 .35928 Mdot
.92291 .18257 Mdot
.92386 .40364 Mdot
.92481 .0326 Mdot
.92576 .1192 Mdot
.92672 .33631 Mdot
.92767 .24534 Mdot
.92862 .39403 Mdot
.92957 .06832 Mdot
.93052 .22626 Mdot
.93147 .40498 Mdot
.93242 .02747 Mdot
.93338 .10178 Mdot
.93433 .30426 Mdot
.93528 .31592 Mdot
.93623 .29254 Mdot
.93718 .3368 Mdot
.93813 .24412 Mdot
.93908 .39494 Mdot
.94004 .06502 Mdot
.94099 .21738 Mdot
.94194 .40769 Mdot
.94289 .01703 Mdot
.94384 .06483 Mdot
.94479 .21688 Mdot
.94574 .4078 Mdot
.9467 .01661 Mdot
.94765 .06329 Mdot
.9486 .21266 Mdot
.94955 .40851 Mdot
.9505 .01384 Mdot
.95145 .0531 Mdot
.9524 .18363 Mdot
.95336 .40411 Mdot
.95431 .03082 Mdot
.95526 .1132 Mdot
.95621 .32593 Mdot
.95716 .27037 Mdot
.95811 .36903 Mdot
.95906 .15288 Mdot
.96002 .38174 Mdot
.96097 .1114 Mdot
.96192 .32268 Mdot
.96287 .27779 Mdot
.96382 .35929 Mdot
.96477 .18255 Mdot
.96572 .40363 Mdot
.96668 .03264 Mdot
.96763 .11931 Mdot
.96858 .3365 Mdot
.96953 .24487 Mdot
.97048 .39438 Mdot
.97143 .06703 Mdot
.97238 .22283 Mdot
.97334 .40621 Mdot
.97429 .02276 Mdot
.97524 .08537 Mdot
.97619 .26869 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00A03oool4000000<0oooo0P0000040?ooo`8000009@3oool300000080
oooo0P0000040?ooo`8000008P3oool3000000@0oooo0P0000040?ooo`800000903oool2000000@0
oooo0P0000040?ooo`800000803oool500000080oooo0P0000040?ooo`800000103oool2000000<0
oooo00140?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`00000U0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool00`000000oooo0?ooo`0O0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000R0?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`00000Q0?ooo`050000003oool0oooo0?ooo`00
00000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo0@000001
0?ooo`40oooo00150?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`00000R0?ooo`D0000000D0oooo0000003oool0oooo000000020?ooo`040000
003oool0oooo00000240oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000280oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000240oooo00D000000?ooo`3oool0oooo00000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool100000040oooo
0@3oool004H0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080
oooo00<000000?ooo`3oool0803oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000008@3oool3000000<0oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`00000S0?ooo`8000000`3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000240oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000P3oool100000040oooo0@3oool004@0oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
000002<0oooo00<000000?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo00000280oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000280oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo00000240oooo00D000000?ooo`3oool0oooo000000020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool100000040oooo0@3oool0
04D0oooo0P0000040?ooo`800000103oool2000002D0oooo0P0000030?ooo`800000103oool20000
02<0oooo0`0000030?ooo`800000103oool2000002@0oooo0P0000040?ooo`800000103oool20000
0240oooo0P0000040?ooo`800000103oool2000000@0oooo0P0000030?ooo`00o`3ooolQ0?ooo`00
o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00
5@3ooooo000000H000001P3oool001/0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00X0oooo000K0?ooo`030000003oool0oooo01T0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00X0oooo00<00000
0?ooo`3oool01`3oool2000000d0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0D
0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0K@3oool001/0oooo00<000000?oo
o`3oool01`3oool00`000000oooo0?ooo`090?ooo`040000003oool0oooo0?ooo`<0000000@0oooo
0000003oool0oooo0P00000;0?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0oooo
000000040?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`02000000`0oooo0P0000080?ooo`050000003oool0oooo0?ooo`0000005@3oool2000000H0
oooo1@0000000`3oool000000?ooo`080?ooo`040000003oool0oooo000001D0oooo00<000000?oo
o`3oool02`3oool010000000oooo0000003oool300000140oooo00@000000?ooo`3oool000003`3o
ool00`000000oooo0?ooo`0A0?ooo`006`3oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo00P0oooo0P0000020?ooo`<0000000<0oooo0000000000000P3oool00`000000oooo0?ooo`0:
0?ooo`040000003oool0oooo000000<0oooo0P0000020?ooo`030000003oool0oooo01H0oooo00<0
00000?ooo`3oool03P3oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool01`3oool2000000030?ooo`000000oooo00H0oooo1@0000090?ooo`030000
003oool000000080oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`000000100000030?ooo`80000000@0oooo000000000000
0000203oool01@000000oooo0?ooo`000000oooo008000002P3oool3000001<0oooo000K0?ooo`80
000000<0oooo0000003oool0403oool01@000000oooo0000003oool0000000<0oooo00<000000?oo
o`0000004@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool09`3oool010000000oooo0?ooo`00000;0?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`02000001L0oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0103oool2
000000040?ooo`0000000000000000d0oooo0`0000090?ooo`8000001P3oool00`000000oooo0?oo
o`0;0?ooo`006`3oool010000000oooo0?ooo`00000C0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00l0oooo00<0
00000?ooo`3oool04@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`0C0?ooo`050000003oool0oooo0?ooo`000000
203oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00/0oooo000K0?ooo`030000003o
ool0oooo02D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0L0?ooo`030000003o
ool000000140oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`050?ooo`050000003o
ool0oooo0?ooo`0000005`3oool01@000000oooo0?ooo`3oool0000000l0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`0<0?ooo`050000003oool0oooo0?ooo`0000001P3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0403oool001/0
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo0000
01`0oooo00@000000?ooo`3oool000001`3oool01@000000oooo0?ooo`3oool0000001@0oooo00<0
00000?ooo`3oool02@3oool010000000oooo0?ooo`0000070?ooo`030000003oool0oooo00`0oooo
00D000000?ooo`3oool0oooo000000040?ooo`050000003oool0oooo0?ooo`0000001P3oool00`00
0000oooo0?ooo`0:0?ooo`8000003@3oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo
000000l0oooo000K0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool06@3oool20000
00D0oooo0P0000070?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool01000
0000oooo0?ooo`0000030?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0603oool0
0`000000oooo000000070?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool0
0`000000oooo0?ooo`090?ooo`040000003oool0oooo000001H0oooo00H000000?ooo`3oool0oooo
0000003oool2000001T0oooo0P00000=0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool03@3oool001/0oooo0P0000060?ooo`040000003oool0oooo000001T0oooo00<000000?ooo`3o
ool00`3oool2000000D0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000060?oo
o`070000003oool000000?ooo`000000oooo0000000@0?ooo`030000003oool0oooo01<0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo0280oooo00D0
00000?ooo`3oool0oooo000000090?ooo`040000003oool0oooo0?ooo`8000007@3oool00`000000
oooo0?ooo`0S0?ooo`006`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo
00L000000?ooo`3oool0oooo0000003oool000000200oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`070?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`09
0?ooo`80000000<0oooo0000000000002`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0
oooo01d0oooo00<000000?ooo`3oool00`3oool01@000000oooo0?ooo`3oool0000000T0oooo00<0
00000?ooo`3oool05`3oool00`000000oooo000000060?ooo`030000003oool0oooo02<0oooo000K
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01@3oool4000000X0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo00X0oooo0P000008
0?ooo`030000003oool000000080oooo0P0000090?ooo`030000003oool0000000T0oooo00<00000
0?ooo`3oool0503oool00`000000oooo0?ooo`0;0?ooo`040000003oool0oooo000000D0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`0=0?ooo`040000003oool0oooo00000140oooo
00<000000?ooo`3oool01P3oool00`000000oooo000000080?ooo`030000003oool0oooo0240oooo
000K0?ooo`030000003oool0oooo00P0oooo00H000000?ooo`3oool000000?ooo`0000050?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo00P0oooo00D000000?ooo`3oool0oooo000000050?ooo`030000003oool0oooo
00D0oooo0P0000050?ooo`030000003oool0000000/0oooo00D000000?ooo`3oool0oooo00000007
0?ooo`050000003oool000000?ooo`0000001@3oool00`000000oooo0?ooo`0I0?ooo`040000003o
ool0oooo00000080oooo0P0000040?ooo`80000000<0oooo0000003oool03`3oool00`000000oooo
0?ooo`020?ooo`80000000<0oooo0000003oool01@3oool01@000000oooo0?ooo`3oool0000000H0
oooo00<000000?ooo`3oool02P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`0A0?ooo`006`3oool00`000000oooo0?ooo`080?ooo`03
0000003oool0oooo00P0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool00000
00l0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`020?ooo`8000003@3oool00`00
0000oooo0?ooo`090?ooo`030000003oool0000000L0oooo00<000000?ooo`0000002@3oool01000
0000oooo0?ooo`0000080?ooo`D000001P3oool00`000000oooo0?ooo`030?ooo`030000003oool0
00000100oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`050000003oool0
oooo0?ooo`0000000P3oool01@000000oooo0000003oool0000000`0oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool04@3oool001/0oooo
00<000000?ooo`3oool05`3oool2000000040?ooo`000000oooo00000080oooo00<000000?ooo`3o
ool0403oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool01@3oool01@000000oooo0?ooo`3oool0000000d0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`0:0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool00P0000070?oo
o`@000002`3oool00`000000oooo0?ooo`0X0?ooo`040000003oool0000000000100oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`0P0?ooo`006`3oool2000000P0oooo00<000000?oo
o`3oool0203oool00`000000oooo0?ooo`02000000050?ooo`000000oooo0?ooo`0000000`3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00D000000?ooo`3oool0oooo0000
000<0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02`3oool2000000H0oooo00<0
00000?ooo`3oool05@3oool010000000oooo0?ooo`00000F0?ooo`030000003oool0oooo02@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo000000030?ooo`030000003oool0000000800000
203oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00L0oooo0`00000D0?ooo`006`3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00P00
00040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0203oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00D0oooo00D000000?ooo`3oool0oooo000000050?ooo`030000
003oool0oooo00l0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`0000000P00000?0?ooo`8000001@3oool00`000000oooo
0?ooo`03000000D0oooo00<000000?ooo`3oool0303oool001/0oooo00<000000?ooo`3oool02P3o
ool00`000000oooo0000000C0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool02P3o
ool00`000000oooo0?ooo`080?ooo`050000003oool0oooo0?ooo`0000002P3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00D0oooo00D000000?ooo`3oool0oooo000000060?ooo`05
0000003oool0oooo0?ooo`000000303oool010000000oooo0?ooo`00000C0?ooo`030000003oool0
oooo02D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0303oool000L0oooo100000030?ooo`800000103oool20000
00D0oooo00<000000?ooo`3oool02P3oool00`000000oooo0000000J0?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo
00P0oooo00D000000?ooo`3oool0oooo0000000:0?ooo`040000003oool0oooo000001/0oooo00@0
00000?ooo`3oool0oooo0P00000>0?ooo`050000003oool0oooo0?ooo`0000003`3oool00`000000
oooo0?ooo`0Q0?ooo`050000003oool0oooo0?ooo`0000003@3oool00`000000oooo0?ooo`0O0?oo
o`001`3oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool00000103oool010000000oooo0?ooo`00000>0?ooo`030000003oool0oooo01D0oooo00<0
00000?ooo`3oool0<@3oool00`000000oooo0?ooo`080?ooo`8000005P3oool00`000000oooo0?oo
o`060?ooo`80000000<0oooo0000003oool03P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo02X0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`080?ooo`040000003o
ool0oooo000001h0oooo00080?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000040?ooo`80000000<0oooo0000003oool00P3oool00`000000
oooo0?ooo`080?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool09@3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0503oool00`000000
oooo0?ooo`070?ooo`030000003oool0000001H0oooo00<000000?ooo`3oool0<@3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool02`3oool000T0oooo
00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool0:P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01P0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo01@0oooo00<000000?oo
o`3oool07P3oool00`000000oooo0?ooo`0;0?ooo`001`3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?oo
o`0D0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool08`3oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0503oool00`000000oooo0000
000H0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`0D0?ooo`030000003oool0oooo02`0oooo00080?ooo`800000103oool2000000@0oooo0P000005
0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`0Y
0?ooo`006`3oool01@000000oooo0?ooo`3oool0000002<0oooo00<000000?ooo`3oool0<@3oool0
0`000000oooo0?ooo`0G0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04P3oool0
0`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0:@3oool0
01/0oooo00D000000?ooo`3oool0oooo0000000=0?ooo`030000003oool0oooo03T0oooo00<00000
0?ooo`3oool02`3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo00/0oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo01H0oooo000K0?oo
o`800000403oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo01X0oooo00<000000?oo
o`3oool0;@3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00`0oooo00<000000?oo
o`3oool0;`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01H0oooo000K0?ooo`80
00009@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3o
ool0603oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool09P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool02@3oool01@000000oooo0?ooo`3oool0000000H0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0:0?ooo`030000003oool0oooo00l0oooo000K0?ooo`8000009@3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0303oool00`000000
oooo0?ooo`0A0?ooo`030000003oool0oooo00D0oooo0P0000020?ooo`030000003oool0oooo02T0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`050000003oool0oooo0?oo
o`0000001P3oool00`000000oooo0?ooo`0Q0?ooo`8000004@3oool001/0oooo00<000000?ooo`3o
ool0G03oool00`000000oooo0?ooo`0I0?ooo`050000003oool0oooo0?ooo`000000?P3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool01@3oool01000
0000oooo0?ooo`00000?0?ooo`006`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
01X0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo
04l0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`02000001`0oooo0P00000=0?oo
o`030000003oool0oooo00P0oooo00<000000?ooo`3oool03@3oool001/0oooo0P0000050?ooo`03
0000003oool0oooo01H0oooo00D000000?ooo`3oool0oooo0000000?0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool00000
00h0oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`00000M0?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool08P3oool001/0oooo00<000000?ooo`3oool07@3oool00`00
0000oooo0?ooo`0A0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool06@3oool00`00
0000oooo0?ooo`0Q0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`000000?03oool00`00
0000oooo0?ooo`0R0?ooo`006`3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`050000003oool0oooo0?oo
o`0000003@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool04@3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo02H0oooo00<000000?oo
o`3oool06@3oool001/0oooo00<000000?ooo`3oool00P3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool0703oool00`000000oooo000000050?ooo`030000003oool0oooo
0080oooo00@000000?ooo`3oool000001P3oool200000080oooo00@000000?ooo`3oool000003`3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo03@0oooo0P00000W0?ooo`030000003o
ool0oooo01T0oooo000K0?ooo`030000003oool0oooo0080oooo00D000000?ooo`3oool0oooo0000
00020?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo00P0oooo00L000000?ooo`3oool0oooo0000003oool0000000l0
oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00l0
oooo00<000000?ooo`3oool0@@3oool001/0oooo0P00000:0?ooo`030000003oool0oooo01L0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00L0oooo
00L000000?ooo`3oool0oooo0000003oool000000100oooo00<000000?ooo`3oool0B`3oool00`00
0000oooo0?ooo`050?ooo`800000>03oool00`000000oooo0?ooo`0J0?ooo`006`3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`070?ooo`050000003oool0oooo0?ooo`0000004P3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo04/0oooo0P0000020?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool0803oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo01X0oooo000K0?ooo`03
0000003oool0oooo02<0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`1?0?ooo`05
0000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo
0140oooo00<000000?ooo`3oool03`3oool001/0oooo00<000000?ooo`3oool08`3oool00`000000
oooo0?ooo`0c0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0<03oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool03`3oool000T0oooo
0`0000020?ooo`800000103oool2000000D0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`0o0?ooo`030000003oool0oooo0140oooo0P0000090?ooo`030000003oool0oooo00`0oooo
00<000000?ooo`3oool0;P3oool00`000000oooo000000060?ooo`030000003oool0oooo02<0oooo
00<000000?ooo`3oool0;03oool000X0oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`040?ooo`050000003oool000000?ooo`0000004@3oool00`000000oooo0?ooo`0H0?oo
o`030000003oool0oooo00L0oooo00@000000?ooo`3oool000002`3oool010000000oooo0?ooo`00
00020?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool07P3oool00`000000oooo0000
00020?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`0S0?ooo`030000003oool0000002`0oooo00070?ooo`D0000000D0oooo0000003oool0oooo0000
00020?ooo`040000003oool0oooo000000@0oooo0P0000070?ooo`090000003oool0oooo0?ooo`00
0000oooo0000003oool0000000H0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00P3oool2000000X0oooo00<00000
0?ooo`0000002@3oool00`000000oooo000000020?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool02P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`0000000P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo02/0oooo00<00000
0?ooo`3oool04@3oool00`000000oooo0?ooo`0Z0?ooo`001`3oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo00`0oooo00D000000?ooo`3oool0oooo0000000@0?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo00<0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000003oool0oooo
00d0oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000060?ooo`050000003oool0
oooo0?ooo`000000603oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0
5`3oool00`000000oooo0?ooo`060?ooo`030000003oool0000000P0oooo00<000000?ooo`3oool0
4@3oool00`000000oooo0?ooo`0Q0?ooo`00203oool00`000000oooo000000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`0000002`3oool00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0C0?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0000000H0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`0000008`3oool000T0oooo0P0000030?ooo`800000
103oool2000000D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`060000
003oool0oooo0000003oool000006`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool01@3oool01@000000oooo0000003oool0000000`0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`0B0?ooo`800000203oool00`000000oooo0?ooo`0I
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`0000001@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool00P3oool2000001D0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0S0?ooo`006`3oool00`000000oooo0?ooo`080?oo
o`030000003oool0oooo01h0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo00D0oooo00D000000?ooo`000000oooo0000000<0?ooo`030000003o
ool0oooo01P0oooo0P0000080?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo000000070?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0103o
ool2000000050?ooo`000000oooo0?ooo`0000001`3oool00`000000oooo0?ooo`0:0?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`00000@0?ooo`00
6`3oool2000001@0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00T0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0A0?ooo`030000
003oool0oooo03H0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000070?ooo`03
0000003oool0oooo00X0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`050?ooo`04
0000003oool0oooo00000100oooo000K0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3o
ool04@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3o
ool05`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3o
ool0803oool001/0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`030?ooo`060000
003oool0oooo0000003oool000004@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
01P0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo
00<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo03@0oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0
oooo0200oooo000K0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool00`3oool01000
0000oooo0?ooo`00000c0?ooo`8000006P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0
oooo00H0oooo00@000000?ooo`3oool000002@3oool4000003@0oooo0P0000000`3oool000000?oo
o`020?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0903oool001/0oooo00<00000
0?ooo`3oool0603oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01P0oooo00<00000
0?ooo`3oool04P3oool00`000000oooo0000000H0?ooo`050000003oool0oooo0?ooo`0000005@3o
ool00`000000oooo0?ooo`060?ooo`80000000@0oooo0000003oool000008P3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0903oool001/0oooo0P00
000I0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`0000003@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?oo
o`0P0?ooo`030000003oool0oooo04X0oooo000K0?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool0;03oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool02`3oool00`000000oooo0?ooo`0g0?ooo`040000003oool0oooo000002X0oooo00<0
00000?ooo`3oool04@3oool00`000000oooo0?ooo`0R0?ooo`006`3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00P0oooo00D000000?ooo`3oool0oooo000000040?ooo`040000003o
ool0oooo000000`0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool0000005D0
oooo00<000000?ooo`3oool0303oool010000000oooo0?ooo`00000S0?ooo`030000003oool0oooo
0080oooo00<000000?ooo`0000004`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo
0180oooo000K0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool00P0000040?ooo`04
0000003oool0oooo000000`0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0[0?oo
o`040000003oool0oooo000001d0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0J
0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`05
0?ooo`<000003`3oool00`000000oooo0?ooo`070?ooo`<00000503oool001/0oooo00<000000?oo
o`0000005@3oool00`000000oooo0?ooo`180?ooo`040000003oool0oooo000000d0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool01P3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool00000008000003`3oool2
000000P0oooo0P0000060?ooo`030000003oool0oooo00`0oooo000K0?ooo`030000003oool00000
06l0oooo00<000000?ooo`0000008P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0<0?ooo`006`3oool200000280
oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo0200
oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`00000H0?ooo`030000003oool0oooo
02<0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo
01L0oooo000K0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool06@3oool2000000D0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00D0
oooo0P00000>0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000007`3oool01000
0000oooo0?ooo`00000:0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`0L0?ooo`030000003oool0oooo02H0oooo000K0?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00000D0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`040000003oool0
oooo000000/0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0?0?ooo`030000003o
ool0oooo00d0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0;0?ooo`030000003o
ool0oooo01L0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0X0?ooo`001`3oool3
000000@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`0:0?ooo`040000003oool0
oooo000003/0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003o
ool0000001<0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo01L0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00000W0?ooo`001`3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool00000103oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo03@0oooo00<000000?oo
o`3oool0203oool00`000000oooo0?ooo`0D0?ooo`030000003oool000000180oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo01/0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`000000203oool00`000000oooo0?ooo`0<0?ooo`001`3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool2000002L0oooo0P00
000o0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool03`3oool00`000000oooo0?oo
o`050?ooo`030000003oool0000000P0oooo00<000000?ooo`3oool0303oool000L0oooo0`000003
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo
0?ooo`0V0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0503oool00`000000oooo
0?ooo`070?ooo`030000003oool000000300oooo00<000000?ooo`3oool0603oool00`000000oooo
0?ooo`0Y0?ooo`00203oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool00000103oool2000000030?ooo`000000oooo00d0oooo00<000000?ooo`3o
ool0E@3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`00
00005P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0L0?ooo`00203oool3000000<0oooo0P0000040?ooo`800000
1@3oool2000000030?ooo`000000oooo0080oooo00<000000?ooo`3oool0203oool00`000000oooo
0?ooo`190?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool03`3oool00`000000oooo
0?ooo`0U0?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool0703oool001/0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0
>`3oool00`000000oooo0?ooo`0K0?ooo`040000003oool0oooo000008D0oooo000K0?ooo`800000
0P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0
503oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0
?P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00/0oooo000K0?ooo`030000003o
ool0oooo04D0oooo00<000000?ooo`3oool04P3oool00`000000oooo0000000E0?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0G0?ooo`030000003o
ool0oooo00d0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`080?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool02`3oool001/0oooo00<000000?ooo`3oool0503oool0
0`000000oooo0?ooo`0R0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool05@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0603oool0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0603oool0
0`000000oooo0?ooo`0@0?ooo`006`3oool00`000000oooo0?ooo`0A0?ooo`040000003oool0oooo
000000l0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo0180oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0l0?ooo`040000003oool0
oooo000000H0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`020?ooo`040000003o
ool0oooo000000L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo00h0oooo000K0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0403o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0503o
ool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool03@3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool03P3o
ool001/0oooo00<000000?ooo`000000C03oool00`000000oooo0?ooo`0@0?ooo`030000003oool0
oooo00l0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`1;0?ooo`006`3oool30000
04`0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`0000002`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00/0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo
0140oooo00<000000?ooo`3oool05@3oool001/0oooo00<000000?ooo`3oool09P3oool00`000000
oooo0?ooo`0o0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`0E0?ooo`006`3oool01@000000oooo0?ooo`3oool0000002@0oooo00<000000?ooo`3o
ool0<03oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo00X0oooo00D000000?ooo`3o
ool0oooo0000000;0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool06`3oool001/0
oooo00D000000?ooo`3oool0oooo0000000>0?ooo`030000003oool0oooo03P0oooo00<000000?oo
o`3oool02`3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo00L0oooo00D000000?oo
o`3oool0oooo0000000;0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`0F0?ooo`006`3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo
03P0oooo00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo
03@0oooo00<000000?ooo`3oool05P3oool001/0oooo0P00000A0?ooo`030000003oool0oooo09l0
oooo00<000000?ooo`3oool0C@3oool001/0oooo00<000000?ooo`3oool0403oool00`000000oooo
0?ooo`2?0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0;`3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo01D0oooo000K0?ooo`800000C@3oool00`000000oooo0?oo
o`0I0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`0_0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool05@3oool001/0oooo0P00000A
0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0L
0?ooo`8000006P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo02H0oooo00<00000
0?ooo`3oool02`3oool2000000/0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool03P3oool000P0oooo0P0000040?oo
o`800000103oool2000000D0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0A0?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0000001d0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00P0oooo00<000000?ooo`000000303oool010000000oooo0?ooo`000007
0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0203oool00`000000oooo0000000@
0?ooo`001`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool00000103oool01@000000oooo0?ooo`3oool0000005P0oooo00<000000?ooo`00
0000703oool2000000030?ooo`000000oooo02@0oooo00<000000?ooo`3oool03@3oool00`000000
oooo0?ooo`0<0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`0@0?ooo`001`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool00000103oool200000080oooo00<000000?ooo`3oool08P3oool0
0`000000oooo0?ooo`1@0?ooo`040000003oool0oooo000003h0oooo00<000000?ooo`3oool0A03o
ool000P0oooo0P0000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
103oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0
2@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0
4`3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0
oooo0000000K0?ooo`040000003oool0oooo000000`0oooo00@000000?ooo`3oool000001`3oool0
0`000000oooo0?ooo`0=0?ooo`001`3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo01X0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0M0?ooo`030000
003oool0oooo00T0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000
003oool0oooo01<0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`040?ooo`040000
003oool0oooo000001`0oooo00@000000?ooo`0000000000303oool010000000oooo0?ooo`000007
0?ooo`030000003oool0oooo00d0oooo00080?ooo`800000103oool2000000@0oooo0P0000050?oo
o`030000003oool0000000D0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0H0?oo
o`030000003oool0oooo00`0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0U0?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo01`0oooo00<000000?ooo`3oool09P3oool001/0oooo00<000000?ooo`00
00007P3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3o
ool04@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`020?ooo`030000003oool0000000P0oooo00<000000?ooo`3o
ool0<@3oool00`000000oooo0?ooo`0R0?ooo`006`3oool2000001l0oooo00<000000?ooo`3oool0
403oool00`000000oooo0?ooo`0J0?ooo`040000003oool0oooo000000h0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0R0?ooo`006`3oool00`000000oooo0?ooo`0A0?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`080?ooo`030000
003oool0oooo01<0oooo00@000000?ooo`3oool000004`3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo00d0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0O0?ooo`03
0000003oool0oooo00h0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0c0?ooo`00
6`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0
403oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0oooo0000000B0?oo
o`030000003oool0oooo00`0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0U0?oo
o`030000003oool0000000H0oooo00<000000?ooo`3oool02`3oool2000000h0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool03P3oool001/0oooo00<000000?ooo`3oool00P3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0B0?ooo`8000001@3oool00`00
0000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`0000001@3oool200000080oooo00@00000
0?ooo`3oool000003`3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo00P0oooo00D0
00000?ooo`3oool0oooo0000000<0?ooo`030000003oool0000001/0oooo00<000000?ooo`000000
1P3oool00`000000oooo0?ooo`0;0?ooo`80000000@0oooo0000003oool000004P3oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool03P3oool001/0oooo
00<000000?ooo`3oool01P3oool010000000oooo0?ooo`00000:0?ooo`030000003oool0oooo00`0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`080?ooo`050000003oool0oooo0?oo
o`0000001P3oool01`000000oooo0?ooo`3oool000000?ooo`0000004`3oool00`000000oooo0000
000>0?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`0000006@3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0000000^0?ooo`030000
003oool0oooo00l0oooo000K0?ooo`8000002P3oool00`000000oooo0?ooo`0G0?ooo`030000003o
ool0oooo01`0oooo00<000000?ooo`0000005@3oool00`000000oooo0000000E0?ooo`030000003o
ool0oooo02h0oooo00<000000?ooo`3oool01@3oool3000000D0oooo00<000000?ooo`3oool0;`3o
ool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00l0oooo000K0?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0A0?ooo`030000003oool0
oooo0100oooo00D000000?ooo`3oool0oooo000000090?ooo`040000003oool0oooo0?ooo`800000
0P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0
8`3oool00`000000oooo0?ooo`050?ooo`800000<03oool00`000000oooo0?ooo`050?ooo`800000
6`3oool001/0oooo00<000000?ooo`3oool00P3oool00`000000oooo0000000H0?ooo`030000003o
ool0oooo0100oooo00D000000?ooo`3oool0oooo000000090?ooo`030000003oool0oooo0080oooo
00@000000?ooo`3oool000003`3oool00`000000oooo0?ooo`020?ooo`030000003oool0000001l0
oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0I0?ooo`006`3oool2000000D0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo03D0oooo
00<000000?ooo`0000002P3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo02H0oooo
00D000000?ooo`3oool0oooo000000080?ooo`050000003oool0oooo0?ooo`0000001@3oool00`00
0000oooo0?ooo`0W0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool03`3oool001/0
oooo0P0000000`3oool000000?ooo`0=0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3o
ool0<`3oool00`000000oooo0?ooo`090?ooo`040000003oool0oooo000000X0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`0000005P3oool01@000000oooo0000003oool0000000H0oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo01@0oooo00@000000?ooo`3oool00000303o
ool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00l0oooo000K0?ooo`040000003oool0
oooo00000080oooo00<000000?ooo`3oool0103oool01@000000oooo0000003oool0000001L0oooo
00<000000?ooo`3oool0703oool010000000oooo0?ooo`00000@0?ooo`030000003oool0000000T0
oooo00<000000?ooo`0000002`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00D0
oooo1@0000090?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`0<0?ooo`030000003oool0oooo01@0oooo00@000000?ooo`0000000000:`3oool001/0
oooo0P0000040?ooo`040000003oool0oooo000000<0oooo00D000000?ooo`000000oooo00000006
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00`3oool200000080oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`020?ooo`030000003oool0000000P0oooo00@00000
0?ooo`00000000002@3oool00`000000oooo000000020?ooo`050000003oool0oooo0?ooo`000000
1P3oool00`000000oooo0?ooo`020?ooo`030000003oool0000000D0oooo00<000000?ooo`3oool0
2@3oool00`000000oooo0?ooo`070?ooo`060000003oool000000000003oool00000203oool00`00
0000oooo000000050?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool02P3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`050?ooo`040000003oool0oooo000000L0oooo00<000000?ooo`3oool0303oool0
01/0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`0000040?ooo`040000003oool0
0000000000H0oooo00D000000?ooo`3oool0oooo000000060?ooo`030000003oool0oooo00@0oooo
00@000000?ooo`3oool000002P3oool00`000000oooo0?ooo`020?ooo`030000003oool0000000@0
oooo00<000000?ooo`3oool00`3oool010000000oooo0000000000070?ooo`030000003oool00000
0080oooo00<000000?ooo`3oool0103oool01`000000oooo0?ooo`3oool000000?ooo`000000103o
ool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`000000
103oool00`000000oooo0?ooo`020?ooo`060000003oool0oooo0000003oool000003@3oool00`00
0000oooo0?ooo`02000000<0oooo0P00000C0?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`0000001P3oool010000000oooo0?ooo`0000070?ooo`030000003oool0oooo0080oooo00H00000
0?ooo`3oool000000?ooo`0000020?ooo`040000003oool0oooo000000@0oooo0P0000070?ooo`04
0000003oool0oooo000000L0oooo00<000000?ooo`3oool0303oool001/0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo000000020?ooo`050000003oool0oooo0000003oool00P00000:0?oo
o`030000003oool0oooo00D0oooo0P0000050?ooo`8000000P3oool01P000000oooo0?ooo`000000
oooo00000080oooo00@000000?ooo`3oool00000103oool01P000000oooo000000000000oooo0000
0080oooo00<000000?ooo`3oool00P3oool200000080oooo00@000000?ooo`3oool00000103oool0
10000000oooo0000000000050?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103o
ool3000000H0oooo0`0000001@3oool000000?ooo`3oool0000000@0oooo00@000000?ooo`3oool0
00000P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0080oooo0P0000040?ooo`80
000000<0oooo0000003oool0103oool01P000000oooo0?ooo`000000oooo000000<0oooo00<00000
0?ooo`0000001@3oool500000080oooo100000020?ooo`030000003oool0oooo00@0oooo0P000006
0?ooo`030000003oool000000080oooo0`0000020?ooo`040000003oool0oooo000000L0oooo00<0
00000?ooo`3oool0103oool01@000000oooo0?ooo`3oool0000000l0oooo00000`3oool000000000
000300000080oooo0P0000040?ooo`800000103oool2000000D0oooo00<000000?ooo`0000001@3o
ool010000000oooo0?ooo`0000080?ooo`030000003oool000000080oooo0`0000001P3oool00000
0?ooo`000000oooo00000080oooo0P0000020?ooo`030000003oool0oooo008000000P3oool01`00
0000oooo000000000000oooo0000003oool00P0000020?ooo`8000000`3oool01P000000oooo0000
00000000oooo00000080oooo00<000000?ooo`3oool0103oool01P000000oooo000000000000oooo
000000@0oooo00@000000?ooo`3oool000001P3oool200000080oooo00@000000?ooo`3oool00000
103oool00`000000oooo000000020?ooo`8000000`3oool010000000oooo0000000000020?ooo`04
0000003oool0oooo00000080oooo0`0000020?ooo`030000003oool0oooo00<0oooo100000001@3o
ool000000?ooo`3oool0000000<0oooo00<000000?ooo`0000000P3oool01@000000oooo0000003o
ool0000000<0oooo00<000000?ooo`3oool00`0000030?ooo`040000003oool0oooo000000D0oooo
00@000000?ooo`00000000000P3oool2000000060?ooo`000000oooo0?ooo`000000oooo10000002
0?ooo`030000003oool0000000@000001P3oool200000080oooo00D000000?ooo`3oool000000?oo
o`02000000@0oooo00@000000?ooo`000000oooo0P0000000`3oool000000?ooo`020?ooo`030000
003oool0000000d0oooo00030?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00P3oool00`00
0000oooo000000070?ooo`030000003oool0oooo00L0oooo0`0000020?ooo`<0000000D0oooo0000
0000000000000?ooo`02000000D0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`00
00030?ooo`8000000P3oool00`000000oooo000000020?ooo`030000003oool0oooo00T0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`80000000@0oooo0000003oool000002`3oool300000005
0?ooo`000000oooo0?ooo`0000000`3oool01P000000oooo0?ooo`3oool000000?ooo`8000001@3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@000001`3oool5000000040?ooo`00
0000oooo000000<0oooo00@000000?ooo`00000000000P3oool010000000oooo0?ooo`0000070?oo
o`030000003oool0oooo00D0oooo00D000000?ooo`3oool0oooo0000000<0?ooo`030000003oool0
oooo00D000000`3oool5000000T0oooo00<000000?ooo`3oool00P0000000`3oool0000000000006
0?ooo`030000003oool00000008000001P3oool00`000000oooo0?ooo`0;0?ooo`000`3oool01@00
0000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo0080oooo0P0000080?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool00`3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`050?ooo`050000003oool000000?ooo`0000003@3oool0
0`000000oooo0?ooo`060?ooo`050000003oool0oooo0?ooo`0000005@3oool00`000000oooo0?oo
o`090?ooo`030000003oool0000000P0oooo00@000000?ooo`3oool000005P3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool03`3oool010000000oooo
0?ooo`00000>0?ooo`030000003oool0oooo0180oooo00030?ooo`050000003oool0oooo0?ooo`00
00000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`3o0?ooo`<0oooo00030?ooo`050000003oool0oooo
0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`3o0?ooo`<0oooo00020?ooo`800000103o
ool2000000@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K
0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo0P00003o0?ooo`@0oooo000K0?ooo`03
0000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3o
ool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool0
01/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool200000?l0oooo103oool001/0oooo
00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K
0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?oo
o`006`3oool200000?l0oooo103oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3o
ool00`000000oooo0?ooo`3o0?ooo`<0oooo00000`3oool0000000000003000000030?ooo`000000
0000008000000`3oool2000000@0oooo0P0000050?ooo`030000003oool0oooo0?l0oooo0`3oool0
00<0oooo00D000000?ooo`3oool0oooo000000050?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool00000103oool00`000000oooo0?ooo`3o0?ooo`<0oooo00030?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000000@0oooo0P00003o0?ooo`@0oooo00030?ooo`030000003oool0oooo00<0oooo
00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`3o0?ooo`<0oooo00030?ooo`050000003oool0oooo0?oo
o`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`3o0?ooo`<0oooo00020?ooo`800000103oool2
000000@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?oo
o`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`00
6`3oool200000?l0oooo103oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool0
0`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0
oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool200000?l0oooo103oool001/0oooo00<0
00000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?oo
o`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`00
6`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`800000o`3oool40?ooo`006`3oool0
0`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool00003
0?ooo`000000000000<000000`3oool300000080oooo0P0000040?ooo`8000001@3oool00`000000
oooo0?ooo`3o0?ooo`<0oooo00030?ooo`030000003oool0oooo00@0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool0o`3oool30?ooo`000`3oool010000000oooo0?ooo`3oool5000000050?ooo`000000oooo
0?ooo`0000000P3oool010000000oooo0?ooo`0000040?ooo`800000o`3oool40?ooo`000`3oool0
1@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0o`3oool30?ooo`00
0`3oool00`000000oooo0?ooo`020?ooo`030000003oool000000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0?l0oooo0`3oool00080
oooo0P0000050?ooo`8000000`3oool2000000@0oooo0P0000050?ooo`030000003oool0oooo0?l0
oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool200000?l0oooo103o
ool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?oo
o`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0
o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0
oooo0?l0oooo0`3oool00?l0oooo8@3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-110.017, -131.721, 4.03645, \
9.32083}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[TextData[StyleBox["Extra Sections", "Subtitle"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[StyleBox["13: Building recursive lists with NestList", \
"Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "The ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " NestList method provides another way to model recursiveness. The NestList \
second arg is the inital value of the recursive variable, and the third arg \
is the number of recursive iterations. Notice how NestList can be used with \
multivariate functions, provided the variable to be treated recursively is \
listed last."
}], "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[{
    \(\(Clear[g1];\)\), "\[IndentingNewLine]", 
    \(\(g1[z_]\  := \ N[z^2];\)\), "\[IndentingNewLine]", 
    \(NestList[g1, \ 3, \ 4]\), "\[IndentingNewLine]", 
    \(\(Clear[g2];\)\), "\[IndentingNewLine]", 
    \(\(\(\(g2[x_]\)[y_]\)[z_]\  := \ x*y*z;\)\), "\[IndentingNewLine]", 
    \(NestList[\(g2[b]\)[c], \ a, \ \ 5]\)}], "Input"],

Cell[TextData[StyleBox["14: Sensitivity analysis with list differences", \
"Subsection"]], "Text",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "The code in the cell below offers a technique on how to compare two \
alternative histories. ",
  StyleBox["Apply this technique to the Logistic map. Suggested steps: 1) \
Define a non-recursive version of the pop[] function above, with all of the \
appropriate parameters.  2) Use NestList to populate two lists, that are each \
seeded with nearly identical starting populations. 3) Plot the history \
difference.  Compare results of the history differences in the chaotic and \
non-chaotic regimes.",
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 1]]
}], "Text",
  TextAlignment->Left,
  TextJustification->0],

Cell[BoxData[{
    \(\(Clear[browny];\)\), "\[IndentingNewLine]", 
    \(\(browny[x_]\  := \ 
        x\  + \ Random[Real, \ {0, 1}]\  - 
          0.5\ ;\)\), "\[IndentingNewLine]", 
    \(\(hist1\  = \ NestList[browny, \ 0, \ 10];\)\), "\[IndentingNewLine]", 
    \(\(hist2\  = \ NestList[browny, \ 0, \ 10];\)\), "\[IndentingNewLine]", 
    \(ListPlot[hist2 - hist1, \ PlotJoined\  \[Rule] True]\)}], "Input"],

Cell[TextData[StyleBox["The function fg below is the stripped down logistic \
map, where the carrying capacity is normalized to 1. Here, if we start with \
initial conditions far enough apart, in this case 0.5 and 0.75 each history \
will be at a different step in the period 4 limit cycle. If you choose values \
that are close enough together, the graph will become very boring, since each \
trajectory will move thru the same limit cycle in paralel.",
  FontColor->RGBColor[1, 0.501961, 1]]], "Input",
  Evaluatable->False,
  FormatType->TextForm],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\(Clear[fg];\)\[IndentingNewLine]
    r\  = \ 3.51\[IndentingNewLine]
    \(fg[x_]\  := \ r\ x \((1 - x)\);\)\[IndentingNewLine]
    \(h1\  = \ NestList[fg, \ 0.5, \ 1000];\)\[IndentingNewLine]
    \(h2\  = \ NestList[fg, \ 0.75, \ 1000];\)\[IndentingNewLine]
    \(ListPlot[h2 - h1, \ PlotJoined\  \[Rule] False];\)\)\)\)], "Input"],

Cell[BoxData[
    \(3.51`\)], "Output"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00095143 0.292837 0.621262 [
[.2141 .28034 -9 -9 ]
[.2141 .28034 9 0 ]
[.40438 .28034 -9 -9 ]
[.40438 .28034 9 0 ]
[.59467 .28034 -9 -9 ]
[.59467 .28034 9 0 ]
[.78495 .28034 -9 -9 ]
[.78495 .28034 9 0 ]
[.97524 .28034 -12 -9 ]
[.97524 .28034 12 0 ]
[.01131 .04433 -24 -4.5 ]
[.01131 .04433 0 4.5 ]
[.01131 .16858 -24 -4.5 ]
[.01131 .16858 0 4.5 ]
[.01131 .41709 -18 -4.5 ]
[.01131 .41709 0 4.5 ]
[.01131 .54134 -18 -4.5 ]
[.01131 .54134 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2141 .29284 m
.2141 .29909 L
s
[(200)] .2141 .28034 0 1 Mshowa
.40438 .29284 m
.40438 .29909 L
s
[(400)] .40438 .28034 0 1 Mshowa
.59467 .29284 m
.59467 .29909 L
s
[(600)] .59467 .28034 0 1 Mshowa
.78495 .29284 m
.78495 .29909 L
s
[(800)] .78495 .28034 0 1 Mshowa
.97524 .29284 m
.97524 .29909 L
s
[(1000)] .97524 .28034 0 1 Mshowa
.125 Mabswid
.07138 .29284 m
.07138 .29659 L
s
.11895 .29284 m
.11895 .29659 L
s
.16652 .29284 m
.16652 .29659 L
s
.26167 .29284 m
.26167 .29659 L
s
.30924 .29284 m
.30924 .29659 L
s
.35681 .29284 m
.35681 .29659 L
s
.45195 .29284 m
.45195 .29659 L
s
.49952 .29284 m
.49952 .29659 L
s
.5471 .29284 m
.5471 .29659 L
s
.64224 .29284 m
.64224 .29659 L
s
.68981 .29284 m
.68981 .29659 L
s
.73738 .29284 m
.73738 .29659 L
s
.83252 .29284 m
.83252 .29659 L
s
.8801 .29284 m
.8801 .29659 L
s
.92767 .29284 m
.92767 .29659 L
s
.25 Mabswid
0 .29284 m
1 .29284 L
s
.02381 .04433 m
.03006 .04433 L
s
[(-0.4)] .01131 .04433 1 0 Mshowa
.02381 .16858 m
.03006 .16858 L
s
[(-0.2)] .01131 .16858 1 0 Mshowa
.02381 .41709 m
.03006 .41709 L
s
[(0.2)] .01131 .41709 1 0 Mshowa
.02381 .54134 m
.03006 .54134 L
s
[(0.4)] .01131 .54134 1 0 Mshowa
.125 Mabswid
.02381 .0754 m
.02756 .0754 L
s
.02381 .10646 m
.02756 .10646 L
s
.02381 .13752 m
.02756 .13752 L
s
.02381 .19965 m
.02756 .19965 L
s
.02381 .23071 m
.02756 .23071 L
s
.02381 .26177 m
.02756 .26177 L
s
.02381 .3239 m
.02756 .3239 L
s
.02381 .35496 m
.02756 .35496 L
s
.02381 .38603 m
.02756 .38603 L
s
.02381 .44815 m
.02756 .44815 L
s
.02381 .47922 m
.02756 .47922 L
s
.02381 .51028 m
.02756 .51028 L
s
.02381 .01327 m
.02756 .01327 L
s
.02381 .5724 m
.02756 .5724 L
s
.02381 .60347 m
.02756 .60347 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02476 .44815 Mdot
.02571 .15655 Mdot
.02666 .54907 Mdot
.02762 .14261 Mdot
.02857 .50772 Mdot
.02952 .0206 Mdot
.03047 .59518 Mdot
.03142 .03569 Mdot
.03237 .50613 Mdot
.03332 .02607 Mdot
.03428 .59744 Mdot
.03523 .03016 Mdot
.03618 .50229 Mdot
.03713 .03502 Mdot
.03808 .60023 Mdot
.03903 .02282 Mdot
.03998 .49701 Mdot
.04094 .04772 Mdot
.04189 .60268 Mdot
.04284 .0164 Mdot
.04379 .49182 Mdot
.04474 .05976 Mdot
.04569 .60332 Mdot
.04664 .01472 Mdot
.0476 .49039 Mdot
.04855 .06304 Mdot
.0495 .60321 Mdot
.05045 .01501 Mdot
.0514 .49064 Mdot
.05235 .06246 Mdot
.0533 .60324 Mdot
.05426 .01493 Mdot
.05521 .49058 Mdot
.05616 .06261 Mdot
.05711 .60323 Mdot
.05806 .01495 Mdot
.05901 .49059 Mdot
.05996 .06257 Mdot
.06092 .60323 Mdot
.06187 .01495 Mdot
.06282 .49059 Mdot
.06377 .06258 Mdot
.06472 .60323 Mdot
.06567 .01495 Mdot
.06662 .49059 Mdot
.06758 .06258 Mdot
.06853 .60323 Mdot
.06948 .01495 Mdot
.07043 .49059 Mdot
.07138 .06258 Mdot
.07233 .60323 Mdot
.07328 .01495 Mdot
.07424 .49059 Mdot
.07519 .06258 Mdot
.07614 .60323 Mdot
.07709 .01495 Mdot
.07804 .49059 Mdot
.07899 .06258 Mdot
.07994 .60323 Mdot
.0809 .01495 Mdot
.08185 .49059 Mdot
.0828 .06258 Mdot
.08375 .60323 Mdot
.0847 .01495 Mdot
.08565 .49059 Mdot
.0866 .06258 Mdot
.08756 .60323 Mdot
.08851 .01495 Mdot
.08946 .49059 Mdot
.09041 .06258 Mdot
.09136 .60323 Mdot
.09231 .01495 Mdot
.09326 .49059 Mdot
.09422 .06258 Mdot
.09517 .60323 Mdot
.09612 .01495 Mdot
.09707 .49059 Mdot
.09802 .06258 Mdot
.09897 .60323 Mdot
.09992 .01495 Mdot
.10088 .49059 Mdot
.10183 .06258 Mdot
.10278 .60323 Mdot
.10373 .01495 Mdot
.10468 .49059 Mdot
.10563 .06258 Mdot
.10658 .60323 Mdot
.10754 .01495 Mdot
.10849 .49059 Mdot
.10944 .06258 Mdot
.11039 .60323 Mdot
.11134 .01495 Mdot
.11229 .49059 Mdot
.11324 .06258 Mdot
.1142 .60323 Mdot
.11515 .01495 Mdot
.1161 .49059 Mdot
.11705 .06258 Mdot
.118 .60323 Mdot
.11895 .01495 Mdot
.1199 .49059 Mdot
.12086 .06258 Mdot
.12181 .60323 Mdot
.12276 .01495 Mdot
.12371 .49059 Mdot
.12466 .06258 Mdot
.12561 .60323 Mdot
.12656 .01495 Mdot
.12752 .49059 Mdot
.12847 .06258 Mdot
.12942 .60323 Mdot
.13037 .01495 Mdot
.13132 .49059 Mdot
.13227 .06258 Mdot
.13322 .60323 Mdot
.13418 .01495 Mdot
.13513 .49059 Mdot
.13608 .06258 Mdot
.13703 .60323 Mdot
.13798 .01495 Mdot
.13893 .49059 Mdot
.13988 .06258 Mdot
.14084 .60323 Mdot
.14179 .01495 Mdot
.14274 .49059 Mdot
.14369 .06258 Mdot
.14464 .60323 Mdot
.14559 .01495 Mdot
.14654 .49059 Mdot
.1475 .06258 Mdot
.14845 .60323 Mdot
.1494 .01495 Mdot
.15035 .49059 Mdot
.1513 .06258 Mdot
.15225 .60323 Mdot
.1532 .01495 Mdot
.15416 .49059 Mdot
.15511 .06258 Mdot
.15606 .60323 Mdot
.15701 .01495 Mdot
.15796 .49059 Mdot
.15891 .06258 Mdot
.15986 .60323 Mdot
.16082 .01495 Mdot
.16177 .49059 Mdot
.16272 .06258 Mdot
.16367 .60323 Mdot
.16462 .01495 Mdot
.16557 .49059 Mdot
.16652 .06258 Mdot
.16748 .60323 Mdot
.16843 .01495 Mdot
.16938 .49059 Mdot
.17033 .06258 Mdot
.17128 .60323 Mdot
.17223 .01495 Mdot
.17318 .49059 Mdot
.17414 .06258 Mdot
.17509 .60323 Mdot
.17604 .01495 Mdot
.17699 .49059 Mdot
.17794 .06258 Mdot
.17889 .60323 Mdot
.17984 .01495 Mdot
.1808 .49059 Mdot
.18175 .06258 Mdot
.1827 .60323 Mdot
.18365 .01495 Mdot
.1846 .49059 Mdot
.18555 .06258 Mdot
.1865 .60323 Mdot
.18746 .01495 Mdot
.18841 .49059 Mdot
.18936 .06258 Mdot
.19031 .60323 Mdot
.19126 .01495 Mdot
.19221 .49059 Mdot
.19316 .06258 Mdot
.19412 .60323 Mdot
.19507 .01495 Mdot
.19602 .49059 Mdot
.19697 .06258 Mdot
.19792 .60323 Mdot
.19887 .01495 Mdot
.19982 .49059 Mdot
.20078 .06258 Mdot
.20173 .60323 Mdot
.20268 .01495 Mdot
.20363 .49059 Mdot
.20458 .06258 Mdot
.20553 .60323 Mdot
.20648 .01495 Mdot
.20744 .49059 Mdot
.20839 .06258 Mdot
.20934 .60323 Mdot
.21029 .01495 Mdot
.21124 .49059 Mdot
.21219 .06258 Mdot
.21314 .60323 Mdot
.2141 .01495 Mdot
.21505 .49059 Mdot
.216 .06258 Mdot
.21695 .60323 Mdot
.2179 .01495 Mdot
.21885 .49059 Mdot
.2198 .06258 Mdot
.22076 .60323 Mdot
.22171 .01495 Mdot
.22266 .49059 Mdot
.22361 .06258 Mdot
.22456 .60323 Mdot
.22551 .01495 Mdot
.22646 .49059 Mdot
.22742 .06258 Mdot
.22837 .60323 Mdot
.22932 .01495 Mdot
.23027 .49059 Mdot
.23122 .06258 Mdot
.23217 .60323 Mdot
.23312 .01495 Mdot
.23408 .49059 Mdot
.23503 .06258 Mdot
.23598 .60323 Mdot
.23693 .01495 Mdot
.23788 .49059 Mdot
.23883 .06258 Mdot
.23978 .60323 Mdot
.24074 .01495 Mdot
.24169 .49059 Mdot
.24264 .06258 Mdot
.24359 .60323 Mdot
.24454 .01495 Mdot
.24549 .49059 Mdot
.24644 .06258 Mdot
.2474 .60323 Mdot
.24835 .01495 Mdot
.2493 .49059 Mdot
.25025 .06258 Mdot
.2512 .60323 Mdot
.25215 .01495 Mdot
.2531 .49059 Mdot
.25406 .06258 Mdot
.25501 .60323 Mdot
.25596 .01495 Mdot
.25691 .49059 Mdot
.25786 .06258 Mdot
.25881 .60323 Mdot
.25976 .01495 Mdot
.26072 .49059 Mdot
.26167 .06258 Mdot
.26262 .60323 Mdot
.26357 .01495 Mdot
.26452 .49059 Mdot
.26547 .06258 Mdot
.26642 .60323 Mdot
.26738 .01495 Mdot
.26833 .49059 Mdot
.26928 .06258 Mdot
.27023 .60323 Mdot
.27118 .01495 Mdot
.27213 .49059 Mdot
.27308 .06258 Mdot
.27404 .60323 Mdot
.27499 .01495 Mdot
.27594 .49059 Mdot
.27689 .06258 Mdot
.27784 .60323 Mdot
.27879 .01495 Mdot
.27974 .49059 Mdot
.2807 .06258 Mdot
.28165 .60323 Mdot
.2826 .01495 Mdot
.28355 .49059 Mdot
.2845 .06258 Mdot
.28545 .60323 Mdot
.2864 .01495 Mdot
.28736 .49059 Mdot
.28831 .06258 Mdot
.28926 .60323 Mdot
.29021 .01495 Mdot
.29116 .49059 Mdot
.29211 .06258 Mdot
.29306 .60323 Mdot
.29402 .01495 Mdot
.29497 .49059 Mdot
.29592 .06258 Mdot
.29687 .60323 Mdot
.29782 .01495 Mdot
.29877 .49059 Mdot
.29972 .06258 Mdot
.30068 .60323 Mdot
.30163 .01495 Mdot
.30258 .49059 Mdot
.30353 .06258 Mdot
.30448 .60323 Mdot
.30543 .01495 Mdot
.30638 .49059 Mdot
.30734 .06258 Mdot
.30829 .60323 Mdot
.30924 .01495 Mdot
.31019 .49059 Mdot
.31114 .06258 Mdot
.31209 .60323 Mdot
.31304 .01495 Mdot
.314 .49059 Mdot
.31495 .06258 Mdot
.3159 .60323 Mdot
.31685 .01495 Mdot
.3178 .49059 Mdot
.31875 .06258 Mdot
.3197 .60323 Mdot
.32066 .01495 Mdot
.32161 .49059 Mdot
.32256 .06258 Mdot
.32351 .60323 Mdot
.32446 .01495 Mdot
.32541 .49059 Mdot
.32636 .06258 Mdot
.32732 .60323 Mdot
.32827 .01495 Mdot
.32922 .49059 Mdot
.33017 .06258 Mdot
.33112 .60323 Mdot
.33207 .01495 Mdot
.33302 .49059 Mdot
.33398 .06258 Mdot
.33493 .60323 Mdot
.33588 .01495 Mdot
.33683 .49059 Mdot
.33778 .06258 Mdot
.33873 .60323 Mdot
.33968 .01495 Mdot
.34064 .49059 Mdot
.34159 .06258 Mdot
.34254 .60323 Mdot
.34349 .01495 Mdot
.34444 .49059 Mdot
.34539 .06258 Mdot
.34634 .60323 Mdot
.3473 .01495 Mdot
.34825 .49059 Mdot
.3492 .06258 Mdot
.35015 .60323 Mdot
.3511 .01495 Mdot
.35205 .49059 Mdot
.353 .06258 Mdot
.35396 .60323 Mdot
.35491 .01495 Mdot
.35586 .49059 Mdot
.35681 .06258 Mdot
.35776 .60323 Mdot
.35871 .01495 Mdot
.35966 .49059 Mdot
.36062 .06258 Mdot
.36157 .60323 Mdot
.36252 .01495 Mdot
.36347 .49059 Mdot
.36442 .06258 Mdot
.36537 .60323 Mdot
.36632 .01495 Mdot
.36728 .49059 Mdot
.36823 .06258 Mdot
.36918 .60323 Mdot
.37013 .01495 Mdot
.37108 .49059 Mdot
.37203 .06258 Mdot
.37298 .60323 Mdot
.37394 .01495 Mdot
.37489 .49059 Mdot
.37584 .06258 Mdot
.37679 .60323 Mdot
.37774 .01495 Mdot
.37869 .49059 Mdot
.37964 .06258 Mdot
.3806 .60323 Mdot
.38155 .01495 Mdot
.3825 .49059 Mdot
.38345 .06258 Mdot
.3844 .60323 Mdot
.38535 .01495 Mdot
.3863 .49059 Mdot
.38726 .06258 Mdot
.38821 .60323 Mdot
.38916 .01495 Mdot
.39011 .49059 Mdot
.39106 .06258 Mdot
.39201 .60323 Mdot
.39296 .01495 Mdot
.39392 .49059 Mdot
.39487 .06258 Mdot
.39582 .60323 Mdot
.39677 .01495 Mdot
.39772 .49059 Mdot
.39867 .06258 Mdot
.39962 .60323 Mdot
.40058 .01495 Mdot
.40153 .49059 Mdot
.40248 .06258 Mdot
.40343 .60323 Mdot
.40438 .01495 Mdot
.40533 .49059 Mdot
.40628 .06258 Mdot
.40724 .60323 Mdot
.40819 .01495 Mdot
.40914 .49059 Mdot
.41009 .06258 Mdot
.41104 .60323 Mdot
.41199 .01495 Mdot
.41294 .49059 Mdot
.4139 .06258 Mdot
.41485 .60323 Mdot
.4158 .01495 Mdot
.41675 .49059 Mdot
.4177 .06258 Mdot
.41865 .60323 Mdot
.4196 .01495 Mdot
.42056 .49059 Mdot
.42151 .06258 Mdot
.42246 .60323 Mdot
.42341 .01495 Mdot
.42436 .49059 Mdot
.42531 .06258 Mdot
.42626 .60323 Mdot
.42722 .01495 Mdot
.42817 .49059 Mdot
.42912 .06258 Mdot
.43007 .60323 Mdot
.43102 .01495 Mdot
.43197 .49059 Mdot
.43292 .06258 Mdot
.43388 .60323 Mdot
.43483 .01495 Mdot
.43578 .49059 Mdot
.43673 .06258 Mdot
.43768 .60323 Mdot
.43863 .01495 Mdot
.43958 .49059 Mdot
.44054 .06258 Mdot
.44149 .60323 Mdot
.44244 .01495 Mdot
.44339 .49059 Mdot
.44434 .06258 Mdot
.44529 .60323 Mdot
.44624 .01495 Mdot
.4472 .49059 Mdot
.44815 .06258 Mdot
.4491 .60323 Mdot
.45005 .01495 Mdot
.451 .49059 Mdot
.45195 .06258 Mdot
.4529 .60323 Mdot
.45386 .01495 Mdot
.45481 .49059 Mdot
.45576 .06258 Mdot
.45671 .60323 Mdot
.45766 .01495 Mdot
.45861 .49059 Mdot
.45956 .06258 Mdot
.46052 .60323 Mdot
.46147 .01495 Mdot
.46242 .49059 Mdot
.46337 .06258 Mdot
.46432 .60323 Mdot
.46527 .01495 Mdot
.46622 .49059 Mdot
.46718 .06258 Mdot
.46813 .60323 Mdot
.46908 .01495 Mdot
.47003 .49059 Mdot
.47098 .06258 Mdot
.47193 .60323 Mdot
.47288 .01495 Mdot
.47384 .49059 Mdot
.47479 .06258 Mdot
.47574 .60323 Mdot
.47669 .01495 Mdot
.47764 .49059 Mdot
.47859 .06258 Mdot
.47954 .60323 Mdot
.4805 .01495 Mdot
.48145 .49059 Mdot
.4824 .06258 Mdot
.48335 .60323 Mdot
.4843 .01495 Mdot
.48525 .49059 Mdot
.4862 .06258 Mdot
.48716 .60323 Mdot
.48811 .01495 Mdot
.48906 .49059 Mdot
.49001 .06258 Mdot
.49096 .60323 Mdot
.49191 .01495 Mdot
.49286 .49059 Mdot
.49382 .06258 Mdot
.49477 .60323 Mdot
.49572 .01495 Mdot
.49667 .49059 Mdot
.49762 .06258 Mdot
.49857 .60323 Mdot
.49952 .01495 Mdot
.50048 .49059 Mdot
.50143 .06258 Mdot
.50238 .60323 Mdot
.50333 .01495 Mdot
.50428 .49059 Mdot
.50523 .06258 Mdot
.50618 .60323 Mdot
.50714 .01495 Mdot
.50809 .49059 Mdot
.50904 .06258 Mdot
.50999 .60323 Mdot
.51094 .01495 Mdot
.51189 .49059 Mdot
.51284 .06258 Mdot
.5138 .60323 Mdot
.51475 .01495 Mdot
.5157 .49059 Mdot
.51665 .06258 Mdot
.5176 .60323 Mdot
.51855 .01495 Mdot
.5195 .49059 Mdot
.52046 .06258 Mdot
.52141 .60323 Mdot
.52236 .01495 Mdot
.52331 .49059 Mdot
.52426 .06258 Mdot
.52521 .60323 Mdot
.52616 .01495 Mdot
.52712 .49059 Mdot
.52807 .06258 Mdot
.52902 .60323 Mdot
.52997 .01495 Mdot
.53092 .49059 Mdot
.53187 .06258 Mdot
.53282 .60323 Mdot
.53378 .01495 Mdot
.53473 .49059 Mdot
.53568 .06258 Mdot
.53663 .60323 Mdot
.53758 .01495 Mdot
.53853 .49059 Mdot
.53948 .06258 Mdot
.54044 .60323 Mdot
.54139 .01495 Mdot
.54234 .49059 Mdot
.54329 .06258 Mdot
.54424 .60323 Mdot
.54519 .01495 Mdot
.54614 .49059 Mdot
.5471 .06258 Mdot
.54805 .60323 Mdot
.549 .01495 Mdot
.54995 .49059 Mdot
.5509 .06258 Mdot
.55185 .60323 Mdot
.5528 .01495 Mdot
.55376 .49059 Mdot
.55471 .06258 Mdot
.55566 .60323 Mdot
.55661 .01495 Mdot
.55756 .49059 Mdot
.55851 .06258 Mdot
.55946 .60323 Mdot
.56042 .01495 Mdot
.56137 .49059 Mdot
.56232 .06258 Mdot
.56327 .60323 Mdot
.56422 .01495 Mdot
.56517 .49059 Mdot
.56612 .06258 Mdot
.56708 .60323 Mdot
.56803 .01495 Mdot
.56898 .49059 Mdot
.56993 .06258 Mdot
.57088 .60323 Mdot
.57183 .01495 Mdot
.57278 .49059 Mdot
.57374 .06258 Mdot
.57469 .60323 Mdot
.57564 .01495 Mdot
.57659 .49059 Mdot
.57754 .06258 Mdot
.57849 .60323 Mdot
.57944 .01495 Mdot
.5804 .49059 Mdot
.58135 .06258 Mdot
.5823 .60323 Mdot
.58325 .01495 Mdot
.5842 .49059 Mdot
.58515 .06258 Mdot
.5861 .60323 Mdot
.58706 .01495 Mdot
.58801 .49059 Mdot
.58896 .06258 Mdot
.58991 .60323 Mdot
.59086 .01495 Mdot
.59181 .49059 Mdot
.59276 .06258 Mdot
.59372 .60323 Mdot
.59467 .01495 Mdot
.59562 .49059 Mdot
.59657 .06258 Mdot
.59752 .60323 Mdot
.59847 .01495 Mdot
.59942 .49059 Mdot
.60038 .06258 Mdot
.60133 .60323 Mdot
.60228 .01495 Mdot
.60323 .49059 Mdot
.60418 .06258 Mdot
.60513 .60323 Mdot
.60608 .01495 Mdot
.60704 .49059 Mdot
.60799 .06258 Mdot
.60894 .60323 Mdot
.60989 .01495 Mdot
.61084 .49059 Mdot
.61179 .06258 Mdot
.61274 .60323 Mdot
.6137 .01495 Mdot
.61465 .49059 Mdot
.6156 .06258 Mdot
.61655 .60323 Mdot
.6175 .01495 Mdot
.61845 .49059 Mdot
.6194 .06258 Mdot
.62036 .60323 Mdot
.62131 .01495 Mdot
.62226 .49059 Mdot
.62321 .06258 Mdot
.62416 .60323 Mdot
.62511 .01495 Mdot
.62606 .49059 Mdot
.62702 .06258 Mdot
.62797 .60323 Mdot
.62892 .01495 Mdot
.62987 .49059 Mdot
.63082 .06258 Mdot
.63177 .60323 Mdot
.63272 .01495 Mdot
.63368 .49059 Mdot
.63463 .06258 Mdot
.63558 .60323 Mdot
.63653 .01495 Mdot
.63748 .49059 Mdot
.63843 .06258 Mdot
.63938 .60323 Mdot
.64034 .01495 Mdot
.64129 .49059 Mdot
.64224 .06258 Mdot
.64319 .60323 Mdot
.64414 .01495 Mdot
.64509 .49059 Mdot
.64604 .06258 Mdot
.647 .60323 Mdot
.64795 .01495 Mdot
.6489 .49059 Mdot
.64985 .06258 Mdot
.6508 .60323 Mdot
.65175 .01495 Mdot
.6527 .49059 Mdot
.65366 .06258 Mdot
.65461 .60323 Mdot
.65556 .01495 Mdot
.65651 .49059 Mdot
.65746 .06258 Mdot
.65841 .60323 Mdot
.65936 .01495 Mdot
.66032 .49059 Mdot
.66127 .06258 Mdot
.66222 .60323 Mdot
.66317 .01495 Mdot
.66412 .49059 Mdot
.66507 .06258 Mdot
.66602 .60323 Mdot
.66698 .01495 Mdot
.66793 .49059 Mdot
.66888 .06258 Mdot
.66983 .60323 Mdot
.67078 .01495 Mdot
.67173 .49059 Mdot
.67268 .06258 Mdot
.67364 .60323 Mdot
.67459 .01495 Mdot
.67554 .49059 Mdot
.67649 .06258 Mdot
.67744 .60323 Mdot
.67839 .01495 Mdot
.67934 .49059 Mdot
.6803 .06258 Mdot
.68125 .60323 Mdot
.6822 .01495 Mdot
.68315 .49059 Mdot
.6841 .06258 Mdot
.68505 .60323 Mdot
.686 .01495 Mdot
.68696 .49059 Mdot
.68791 .06258 Mdot
.68886 .60323 Mdot
.68981 .01495 Mdot
.69076 .49059 Mdot
.69171 .06258 Mdot
.69266 .60323 Mdot
.69362 .01495 Mdot
.69457 .49059 Mdot
.69552 .06258 Mdot
.69647 .60323 Mdot
.69742 .01495 Mdot
.69837 .49059 Mdot
.69932 .06258 Mdot
.70028 .60323 Mdot
.70123 .01495 Mdot
.70218 .49059 Mdot
.70313 .06258 Mdot
.70408 .60323 Mdot
.70503 .01495 Mdot
.70598 .49059 Mdot
.70694 .06258 Mdot
.70789 .60323 Mdot
.70884 .01495 Mdot
.70979 .49059 Mdot
.71074 .06258 Mdot
.71169 .60323 Mdot
.71264 .01495 Mdot
.7136 .49059 Mdot
.71455 .06258 Mdot
.7155 .60323 Mdot
.71645 .01495 Mdot
.7174 .49059 Mdot
.71835 .06258 Mdot
.7193 .60323 Mdot
.72026 .01495 Mdot
.72121 .49059 Mdot
.72216 .06258 Mdot
.72311 .60323 Mdot
.72406 .01495 Mdot
.72501 .49059 Mdot
.72596 .06258 Mdot
.72692 .60323 Mdot
.72787 .01495 Mdot
.72882 .49059 Mdot
.72977 .06258 Mdot
.73072 .60323 Mdot
.73167 .01495 Mdot
.73262 .49059 Mdot
.73358 .06258 Mdot
.73453 .60323 Mdot
.73548 .01495 Mdot
.73643 .49059 Mdot
.73738 .06258 Mdot
.73833 .60323 Mdot
.73928 .01495 Mdot
.74024 .49059 Mdot
.74119 .06258 Mdot
.74214 .60323 Mdot
.74309 .01495 Mdot
.74404 .49059 Mdot
.74499 .06258 Mdot
.74594 .60323 Mdot
.7469 .01495 Mdot
.74785 .49059 Mdot
.7488 .06258 Mdot
.74975 .60323 Mdot
.7507 .01495 Mdot
.75165 .49059 Mdot
.7526 .06258 Mdot
.75356 .60323 Mdot
.75451 .01495 Mdot
.75546 .49059 Mdot
.75641 .06258 Mdot
.75736 .60323 Mdot
.75831 .01495 Mdot
.75926 .49059 Mdot
.76022 .06258 Mdot
.76117 .60323 Mdot
.76212 .01495 Mdot
.76307 .49059 Mdot
.76402 .06258 Mdot
.76497 .60323 Mdot
.76592 .01495 Mdot
.76688 .49059 Mdot
.76783 .06258 Mdot
.76878 .60323 Mdot
.76973 .01495 Mdot
.77068 .49059 Mdot
.77163 .06258 Mdot
.77258 .60323 Mdot
.77354 .01495 Mdot
.77449 .49059 Mdot
.77544 .06258 Mdot
.77639 .60323 Mdot
.77734 .01495 Mdot
.77829 .49059 Mdot
.77924 .06258 Mdot
.7802 .60323 Mdot
.78115 .01495 Mdot
.7821 .49059 Mdot
.78305 .06258 Mdot
.784 .60323 Mdot
.78495 .01495 Mdot
.7859 .49059 Mdot
.78686 .06258 Mdot
.78781 .60323 Mdot
.78876 .01495 Mdot
.78971 .49059 Mdot
.79066 .06258 Mdot
.79161 .60323 Mdot
.79256 .01495 Mdot
.79352 .49059 Mdot
.79447 .06258 Mdot
.79542 .60323 Mdot
.79637 .01495 Mdot
.79732 .49059 Mdot
.79827 .06258 Mdot
.79922 .60323 Mdot
.80018 .01495 Mdot
.80113 .49059 Mdot
.80208 .06258 Mdot
.80303 .60323 Mdot
.80398 .01495 Mdot
.80493 .49059 Mdot
.80588 .06258 Mdot
.80684 .60323 Mdot
.80779 .01495 Mdot
.80874 .49059 Mdot
.80969 .06258 Mdot
.81064 .60323 Mdot
.81159 .01495 Mdot
.81254 .49059 Mdot
.8135 .06258 Mdot
.81445 .60323 Mdot
.8154 .01495 Mdot
.81635 .49059 Mdot
.8173 .06258 Mdot
.81825 .60323 Mdot
.8192 .01495 Mdot
.82016 .49059 Mdot
.82111 .06258 Mdot
.82206 .60323 Mdot
.82301 .01495 Mdot
.82396 .49059 Mdot
.82491 .06258 Mdot
.82586 .60323 Mdot
.82682 .01495 Mdot
.82777 .49059 Mdot
.82872 .06258 Mdot
.82967 .60323 Mdot
.83062 .01495 Mdot
.83157 .49059 Mdot
.83252 .06258 Mdot
.83348 .60323 Mdot
.83443 .01495 Mdot
.83538 .49059 Mdot
.83633 .06258 Mdot
.83728 .60323 Mdot
.83823 .01495 Mdot
.83918 .49059 Mdot
.84014 .06258 Mdot
.84109 .60323 Mdot
.84204 .01495 Mdot
.84299 .49059 Mdot
.84394 .06258 Mdot
.84489 .60323 Mdot
.84584 .01495 Mdot
.8468 .49059 Mdot
.84775 .06258 Mdot
.8487 .60323 Mdot
.84965 .01495 Mdot
.8506 .49059 Mdot
.85155 .06258 Mdot
.8525 .60323 Mdot
.85346 .01495 Mdot
.85441 .49059 Mdot
.85536 .06258 Mdot
.85631 .60323 Mdot
.85726 .01495 Mdot
.85821 .49059 Mdot
.85916 .06258 Mdot
.86012 .60323 Mdot
.86107 .01495 Mdot
.86202 .49059 Mdot
.86297 .06258 Mdot
.86392 .60323 Mdot
.86487 .01495 Mdot
.86582 .49059 Mdot
.86678 .06258 Mdot
.86773 .60323 Mdot
.86868 .01495 Mdot
.86963 .49059 Mdot
.87058 .06258 Mdot
.87153 .60323 Mdot
.87248 .01495 Mdot
.87344 .49059 Mdot
.87439 .06258 Mdot
.87534 .60323 Mdot
.87629 .01495 Mdot
.87724 .49059 Mdot
.87819 .06258 Mdot
.87914 .60323 Mdot
.8801 .01495 Mdot
.88105 .49059 Mdot
.882 .06258 Mdot
.88295 .60323 Mdot
.8839 .01495 Mdot
.88485 .49059 Mdot
.8858 .06258 Mdot
.88676 .60323 Mdot
.88771 .01495 Mdot
.88866 .49059 Mdot
.88961 .06258 Mdot
.89056 .60323 Mdot
.89151 .01495 Mdot
.89246 .49059 Mdot
.89342 .06258 Mdot
.89437 .60323 Mdot
.89532 .01495 Mdot
.89627 .49059 Mdot
.89722 .06258 Mdot
.89817 .60323 Mdot
.89912 .01495 Mdot
.90008 .49059 Mdot
.90103 .06258 Mdot
.90198 .60323 Mdot
.90293 .01495 Mdot
.90388 .49059 Mdot
.90483 .06258 Mdot
.90578 .60323 Mdot
.90674 .01495 Mdot
.90769 .49059 Mdot
.90864 .06258 Mdot
.90959 .60323 Mdot
.91054 .01495 Mdot
.91149 .49059 Mdot
.91244 .06258 Mdot
.9134 .60323 Mdot
.91435 .01495 Mdot
.9153 .49059 Mdot
.91625 .06258 Mdot
.9172 .60323 Mdot
.91815 .01495 Mdot
.9191 .49059 Mdot
.92006 .06258 Mdot
.92101 .60323 Mdot
.92196 .01495 Mdot
.92291 .49059 Mdot
.92386 .06258 Mdot
.92481 .60323 Mdot
.92576 .01495 Mdot
.92672 .49059 Mdot
.92767 .06258 Mdot
.92862 .60323 Mdot
.92957 .01495 Mdot
.93052 .49059 Mdot
.93147 .06258 Mdot
.93242 .60323 Mdot
.93338 .01495 Mdot
.93433 .49059 Mdot
.93528 .06258 Mdot
.93623 .60323 Mdot
.93718 .01495 Mdot
.93813 .49059 Mdot
.93908 .06258 Mdot
.94004 .60323 Mdot
.94099 .01495 Mdot
.94194 .49059 Mdot
.94289 .06258 Mdot
.94384 .60323 Mdot
.94479 .01495 Mdot
.94574 .49059 Mdot
.9467 .06258 Mdot
.94765 .60323 Mdot
.9486 .01495 Mdot
.94955 .49059 Mdot
.9505 .06258 Mdot
.95145 .60323 Mdot
.9524 .01495 Mdot
.95336 .49059 Mdot
.95431 .06258 Mdot
.95526 .60323 Mdot
.95621 .01495 Mdot
.95716 .49059 Mdot
.95811 .06258 Mdot
.95906 .60323 Mdot
.96002 .01495 Mdot
.96097 .49059 Mdot
.96192 .06258 Mdot
.96287 .60323 Mdot
.96382 .01495 Mdot
.96477 .49059 Mdot
.96572 .06258 Mdot
.96668 .60323 Mdot
.96763 .01495 Mdot
.96858 .49059 Mdot
.96953 .06258 Mdot
.97048 .60323 Mdot
.97143 .01495 Mdot
.97238 .49059 Mdot
.97334 .06258 Mdot
.97429 .60323 Mdot
.97524 .01495 Mdot
.97619 .49059 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo
000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool3
0?ooo`006`3oool200000080oooom000000=0?ooo`006`3oool200000080oooom000000=0?ooo`00
6`3oool2000000030?ooo`000000oooo0?l0oooo0@3oool001/0oooo00@000000?ooo`0000000000
o`3oool20?ooo`006`3oool00`000000oooo0000003o0?ooo`<0oooo000K0?ooo`@00000o`3oool2
0?ooo`00203oool2000000@0oooo0P0000050?ooo`<000000`3oool2000000030?ooo`000000oooo
0?l0oooo0@3oool000L0oooo00@000000?ooo`3oool000002`3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo0?l0oooo0`3oool000L0oooo00@000000?ooo`3oool00000203oool50000
00<0oooo0P0000020?ooo`030000003oool0oooo0?h0oooo00000`3oool000000000000200000080
oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000040?ooo`050000003oool0
oooo0?ooo`000000o`3oool10?ooo`001`3oool010000000oooo0?ooo`0000090?ooo`030000003o
ool0000000@0oooo00<000000?ooo`3oool0o`3oool30?ooo`00203oool2000000/0oooo0P000004
0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool00P3ooooc0000
00d0oooo000K0?ooo`030000003oool0oooo0080ooool`00000=0?ooo`006`3oool00`000000oooo
0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo0P00003o
0?ooo`@0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3o
ool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003o
ool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`00
0000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo
0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<00000
0?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`03
0000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3o
ool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool0
01/0oooo0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo
00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K
0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?oo
o`00203oool2000000@0oooo0P0000030?ooo`@00000103oool00`000000oooo0?ooo`3o0?ooo`<0
oooo00070?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`3o0?ooo`<0oooo00070?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3o
ool0103oool200000?l0oooo103oool000030?ooo`0000000000008000000P3oool010000000oooo
0?ooo`00000:0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0o`3oool30?ooo`00
1`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000000@0oooo00<000000?oo
o`3oool0o`3oool30?ooo`00203oool2000000X0oooo0P0000050?ooo`030000003oool0oooo0?l0
oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?oo
o`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?oo
o`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`800000
o`3oool40?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0
oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000
oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<0
00000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?oo
o`800000o`3oool40?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000
003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool0
0`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo02H0oooo100000030?oo
o`800000103oool2000002D0oooo0`0000020?ooo`800000103oool200000280oooo0`0000040?oo
o`800000103oool2000002@0oooo0P0000040?ooo`800000103oool200000200oooo1@0000020?oo
o`800000103oool2000000@0oooo0P0000030?ooo`006`3oool00`000000oooo0?ooo`0V0?ooo`03
0000003oool0oooo00<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000U
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo
0?ooo`0O0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`00000R0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`00000Q0?ooo`050000003oool0oooo0?ooo`0000000P3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo0@0000010?ooo`40oooo000K
0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo00000280oooo1@0000001@3oool000000?ooo`3oool000000080
oooo00@000000?ooo`3oool000008@3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000008P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000008@3oool01@000000oooo0?ooo`3o
ool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`40
00000@3oool10?ooo`006`3oool2000002T0oooo00D000000?ooo`3oool0oooo000000020?ooo`04
0000003oool0oooo00000080oooo00<000000?ooo`3oool0803oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000008@3oool3000000<0oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000S0?ooo`8000000`3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000240oooo00D000000?ooo`3oool0oooo
000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool10000
0040oooo0@3oool001/0oooo00<000000?ooo`3oool09P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000008`3oool00`000000oooo0000
00020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000008P3oool00`000000
oooo0?ooo`020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000008P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00008@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`0000020?ooo`4000000@3oool10?ooo`006`3oool00`000000oooo0?ooo`0W
0?ooo`800000103oool2000000@0oooo0P00000U0?ooo`8000000`3oool2000000@0oooo0P00000S
0?ooo`<000000`3oool2000000@0oooo0P00000T0?ooo`800000103oool2000000@0oooo0P00000Q
0?ooo`800000103oool2000000@0oooo0P0000040?ooo`8000000`3oool001/0oooo00<000000?oo
o`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000
003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool0
0`000000oooo0?ooo`3o0?ooo`<0oooo000E0?ooool000001P0000060?ooo`006`3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool001/0oooo
00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K
0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?oo
o`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo
0`3oool001/0oooo0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool0
01/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0
oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3o
ool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo
0?l0oooo0`3oool001/0oooo0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0oooo0?l0oooo
0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o
0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3o
ool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003o
ool0oooo0?l0oooo0`3oool001/0oooo0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0oooo
0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo
0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<00000
0?ooo`3oool0o`3oool30?ooo`00203oool2000000@0oooo0P0000030?ooo`@00000103oool00`00
0000oooo0?ooo`3o0?ooo`<0oooo00070?ooo`040000003oool0oooo000000P0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`3o0?ooo`<0oooo00070?ooo`040000003oool0oooo0000
00T0oooo00<000000?ooo`3oool0103oool200000?l0oooo103oool000L0oooo00@000000?ooo`3o
ool000002P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0?l0oooo0`3oool000L0
oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000040?ooo`030000003oool0
oooo0?l0oooo0`3oool000P0oooo0P00000:0?ooo`8000001@3oool00`000000oooo0?ooo`3o0?oo
o`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0
o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0
oooo0?l0oooo0`3oool001/0oooo0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0oooo0?l0
oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?oo
o`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?oo
o`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000
003oool0oooo0?l0oooo0`3oool001/0oooo0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0
oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool010000000
oooo0?ooo`3ooood000000d0oooo000K0?ooo`030000003oool0oooo0?D000003@3oool001/0oooo
00@000000?ooo`3oool00000o`3oool20?ooo`006`3oool00`000000oooo0000003o0?ooo`<0oooo
000K0?ooo`<00000o`3oool30?ooo`006`3oool200000?l0oooo103oool001/0oooo00<000000?oo
o`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000
003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool0
0`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool000P0
oooo0P0000040?ooo`8000001@3oool3000000<0oooo00<000000?ooo`3oool0o`3oool30?ooo`00
1`3oool010000000oooo0?ooo`00000;0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0o`3oool30?ooo`001`3oool010000000oooo0?ooo`0000080?ooo`D000000`3oool200000?l0
oooo103oool000L0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000040?oo
o`030000003oool0oooo0?l0oooo0`3oool000L0oooo00@000000?ooo`3oool000002@3oool00`00
0000oooo000000040?ooo`030000003oool0oooo0?l0oooo0`3oool000P0oooo0P00000;0?ooo`80
0000103oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo
0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o
0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo0P00003o0?ooo`@0
oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3o
ool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo
0?l0oooo0`3oool001/0oooo0P00003o0?ooo`@0oooo000K0?ooo`@00000o`3oool20?ooo`006`3o
ool00`000000oooo0000003e000000d0oooo000K0?ooo`8000000P3ooood000000d0oooo000K0?oo
o`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`00
6`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo003o0?ooob40oooo003o0?ooob40oooo003o0?oo
ob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?oo
ob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-110.017, -0.520838, \
4.03645, 0.00618161}}]
}, Open  ]],

Cell[TextData[StyleBox["When we are in the 8 cycle regime, we need to start \
with nearly the same initial condition to make the histories coincide. Try \
starting with 0.55, and 0.56 for h1 and h2.  In this case the convergence is \
slow enough to generate an interesting plot.",
  FontColor->RGBColor[1, 0.501961, 1]]], "Input",
  Evaluatable->False,
  FormatType->TextForm],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\(Clear[fg];\)\[IndentingNewLine]
    r\  = \ 3.562\[IndentingNewLine]
    \(fg[x_]\  := \ r\ x \((1 - x)\);\)\[IndentingNewLine]
    \(h1\  = \ NestList[fg, \ 0.50, \ 1000];\)\[IndentingNewLine]
    \(h2\  = \ NestList[fg, \ 0.55, \ 1000];\)\[IndentingNewLine]
    \(ListPlot[h2 - h1, \ PlotJoined\  \[Rule] False];\)\)\)\)], "Input"],

Cell[BoxData[
    \(3.562`\)], "Output"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00095143 0.303086 4.71091 [
[.2141 .29059 -9 -9 ]
[.2141 .29059 9 0 ]
[.40438 .29059 -9 -9 ]
[.40438 .29059 9 0 ]
[.59467 .29059 -9 -9 ]
[.59467 .29059 9 0 ]
[.78495 .29059 -9 -9 ]
[.78495 .29059 9 0 ]
[.97524 .29059 -12 -9 ]
[.97524 .29059 12 0 ]
[.01131 .02043 -30 -4.5 ]
[.01131 .02043 0 4.5 ]
[.01131 .11465 -30 -4.5 ]
[.01131 .11465 0 4.5 ]
[.01131 .20887 -30 -4.5 ]
[.01131 .20887 0 4.5 ]
[.01131 .3973 -24 -4.5 ]
[.01131 .3973 0 4.5 ]
[.01131 .49152 -24 -4.5 ]
[.01131 .49152 0 4.5 ]
[.01131 .58574 -24 -4.5 ]
[.01131 .58574 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2141 .30309 m
.2141 .30934 L
s
[(200)] .2141 .29059 0 1 Mshowa
.40438 .30309 m
.40438 .30934 L
s
[(400)] .40438 .29059 0 1 Mshowa
.59467 .30309 m
.59467 .30934 L
s
[(600)] .59467 .29059 0 1 Mshowa
.78495 .30309 m
.78495 .30934 L
s
[(800)] .78495 .29059 0 1 Mshowa
.97524 .30309 m
.97524 .30934 L
s
[(1000)] .97524 .29059 0 1 Mshowa
.125 Mabswid
.07138 .30309 m
.07138 .30684 L
s
.11895 .30309 m
.11895 .30684 L
s
.16652 .30309 m
.16652 .30684 L
s
.26167 .30309 m
.26167 .30684 L
s
.30924 .30309 m
.30924 .30684 L
s
.35681 .30309 m
.35681 .30684 L
s
.45195 .30309 m
.45195 .30684 L
s
.49952 .30309 m
.49952 .30684 L
s
.5471 .30309 m
.5471 .30684 L
s
.64224 .30309 m
.64224 .30684 L
s
.68981 .30309 m
.68981 .30684 L
s
.73738 .30309 m
.73738 .30684 L
s
.83252 .30309 m
.83252 .30684 L
s
.8801 .30309 m
.8801 .30684 L
s
.92767 .30309 m
.92767 .30684 L
s
.25 Mabswid
0 .30309 m
1 .30309 L
s
.02381 .02043 m
.03006 .02043 L
s
[(-0.06)] .01131 .02043 1 0 Mshowa
.02381 .11465 m
.03006 .11465 L
s
[(-0.04)] .01131 .11465 1 0 Mshowa
.02381 .20887 m
.03006 .20887 L
s
[(-0.02)] .01131 .20887 1 0 Mshowa
.02381 .3973 m
.03006 .3973 L
s
[(0.02)] .01131 .3973 1 0 Mshowa
.02381 .49152 m
.03006 .49152 L
s
[(0.04)] .01131 .49152 1 0 Mshowa
.02381 .58574 m
.03006 .58574 L
s
[(0.06)] .01131 .58574 1 0 Mshowa
.125 Mabswid
.02381 .04399 m
.02756 .04399 L
s
.02381 .06754 m
.02756 .06754 L
s
.02381 .0911 m
.02756 .0911 L
s
.02381 .1382 m
.02756 .1382 L
s
.02381 .16176 m
.02756 .16176 L
s
.02381 .18531 m
.02756 .18531 L
s
.02381 .23242 m
.02756 .23242 L
s
.02381 .25598 m
.02756 .25598 L
s
.02381 .27953 m
.02756 .27953 L
s
.02381 .32664 m
.02756 .32664 L
s
.02381 .3502 m
.02756 .3502 L
s
.02381 .37375 m
.02756 .37375 L
s
.02381 .42086 m
.02756 .42086 L
s
.02381 .44441 m
.02756 .44441 L
s
.02381 .46797 m
.02756 .46797 L
s
.02381 .51508 m
.02756 .51508 L
s
.02381 .53863 m
.02756 .53863 L
s
.02381 .56219 m
.02756 .56219 L
s
.02381 .60929 m
.02756 .60929 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02476 .53863 Mdot
.02571 .26114 Mdot
.02666 .41846 Mdot
.02762 .4185 Mdot
.02857 .0402 Mdot
.02952 .35148 Mdot
.03047 .17023 Mdot
.03142 .17198 Mdot
.03237 .60332 Mdot
.03332 .25651 Mdot
.03428 .4309 Mdot
.03523 .42883 Mdot
.03618 .01472 Mdot
.03713 .34569 Mdot
.03808 .18604 Mdot
.03903 .18695 Mdot
.03998 .56854 Mdot
.04094 .25907 Mdot
.04189 .42403 Mdot
.04284 .42337 Mdot
.04379 .02846 Mdot
.04474 .3501 Mdot
.04569 .17401 Mdot
.04664 .17554 Mdot
.0476 .59504 Mdot
.04855 .25704 Mdot
.0495 .42948 Mdot
.05045 .42778 Mdot
.0514 .01745 Mdot
.05235 .347 Mdot
.0533 .18246 Mdot
.05426 .18354 Mdot
.05521 .57644 Mdot
.05616 .25843 Mdot
.05711 .42577 Mdot
.05806 .42481 Mdot
.05901 .02489 Mdot
.05996 .34935 Mdot
.06092 .17605 Mdot
.06187 .17746 Mdot
.06282 .59057 Mdot
.06377 .25736 Mdot
.06472 .42864 Mdot
.06567 .42713 Mdot
.06662 .01909 Mdot
.06758 .34764 Mdot
.06853 .18071 Mdot
.06948 .18188 Mdot
.07043 .58029 Mdot
.07138 .25813 Mdot
.07233 .42658 Mdot
.07328 .42549 Mdot
.07424 .02323 Mdot
.07519 .34893 Mdot
.07614 .17719 Mdot
.07709 .17854 Mdot
.07804 .58805 Mdot
.07899 .25754 Mdot
.07994 .42816 Mdot
.0809 .42675 Mdot
.08185 .02006 Mdot
.0828 .34798 Mdot
.08375 .17979 Mdot
.0847 .181 Mdot
.08565 .58233 Mdot
.0866 .25797 Mdot
.08756 .42701 Mdot
.08851 .42583 Mdot
.08946 .02237 Mdot
.09041 .3487 Mdot
.09136 .17783 Mdot
.09231 .17915 Mdot
.09326 .58663 Mdot
.09422 .25764 Mdot
.09517 .42788 Mdot
.09612 .42653 Mdot
.09707 .02062 Mdot
.09802 .34816 Mdot
.09897 .17928 Mdot
.09992 .18053 Mdot
.10088 .58344 Mdot
.10183 .25788 Mdot
.10278 .42723 Mdot
.10373 .42601 Mdot
.10468 .02191 Mdot
.10563 .34856 Mdot
.10658 .1782 Mdot
.10754 .1795 Mdot
.10849 .58584 Mdot
.10944 .2577 Mdot
.11039 .42772 Mdot
.11134 .4264 Mdot
.11229 .02094 Mdot
.11324 .34827 Mdot
.1142 .17901 Mdot
.11515 .18026 Mdot
.1161 .58406 Mdot
.11705 .25784 Mdot
.118 .42736 Mdot
.11895 .42611 Mdot
.1199 .02166 Mdot
.12086 .34849 Mdot
.12181 .1784 Mdot
.12276 .17969 Mdot
.12371 .58539 Mdot
.12466 .25774 Mdot
.12561 .42763 Mdot
.12656 .42633 Mdot
.12752 .02112 Mdot
.12847 .34832 Mdot
.12942 .17885 Mdot
.13037 .18012 Mdot
.13132 .5844 Mdot
.13227 .25781 Mdot
.13322 .42743 Mdot
.13418 .42617 Mdot
.13513 .02152 Mdot
.13608 .34845 Mdot
.13703 .17851 Mdot
.13798 .1798 Mdot
.13893 .58514 Mdot
.13988 .25775 Mdot
.14084 .42758 Mdot
.14179 .42629 Mdot
.14274 .02122 Mdot
.14369 .34835 Mdot
.14464 .17877 Mdot
.14559 .18004 Mdot
.14654 .58458 Mdot
.1475 .2578 Mdot
.14845 .42747 Mdot
.1494 .4262 Mdot
.15035 .02145 Mdot
.1513 .34842 Mdot
.15225 .17858 Mdot
.1532 .17986 Mdot
.15416 .585 Mdot
.15511 .25777 Mdot
.15606 .42755 Mdot
.15701 .42627 Mdot
.15796 .02128 Mdot
.15891 .34837 Mdot
.15986 .17872 Mdot
.16082 .17999 Mdot
.16177 .58469 Mdot
.16272 .25779 Mdot
.16367 .42749 Mdot
.16462 .42622 Mdot
.16557 .0214 Mdot
.16652 .34841 Mdot
.16748 .17861 Mdot
.16843 .17989 Mdot
.16938 .58492 Mdot
.17033 .25777 Mdot
.17128 .42753 Mdot
.17223 .42625 Mdot
.17318 .02131 Mdot
.17414 .34838 Mdot
.17509 .17869 Mdot
.17604 .17996 Mdot
.17699 .58475 Mdot
.17794 .25778 Mdot
.17889 .4275 Mdot
.17984 .42623 Mdot
.1808 .02138 Mdot
.18175 .3484 Mdot
.1827 .17863 Mdot
.18365 .17991 Mdot
.1846 .58488 Mdot
.18555 .25777 Mdot
.1865 .42753 Mdot
.18746 .42625 Mdot
.18841 .02133 Mdot
.18936 .34839 Mdot
.19031 .17868 Mdot
.19126 .17995 Mdot
.19221 .58478 Mdot
.19316 .25778 Mdot
.19412 .42751 Mdot
.19507 .42623 Mdot
.19602 .02137 Mdot
.19697 .3484 Mdot
.19792 .17864 Mdot
.19887 .17992 Mdot
.19982 .58485 Mdot
.20078 .25778 Mdot
.20173 .42752 Mdot
.20268 .42624 Mdot
.20363 .02134 Mdot
.20458 .34839 Mdot
.20553 .17867 Mdot
.20648 .17994 Mdot
.20744 .5848 Mdot
.20839 .25778 Mdot
.20934 .42751 Mdot
.21029 .42623 Mdot
.21124 .02136 Mdot
.21219 .3484 Mdot
.21314 .17865 Mdot
.2141 .17993 Mdot
.21505 .58484 Mdot
.216 .25778 Mdot
.21695 .42752 Mdot
.2179 .42624 Mdot
.21885 .02134 Mdot
.2198 .34839 Mdot
.22076 .17866 Mdot
.22171 .17994 Mdot
.22266 .58481 Mdot
.22361 .25778 Mdot
.22456 .42751 Mdot
.22551 .42624 Mdot
.22646 .02136 Mdot
.22742 .3484 Mdot
.22837 .17865 Mdot
.22932 .17993 Mdot
.23027 .58483 Mdot
.23122 .25778 Mdot
.23217 .42752 Mdot
.23312 .42624 Mdot
.23408 .02135 Mdot
.23503 .34839 Mdot
.23598 .17866 Mdot
.23693 .17994 Mdot
.23788 .58481 Mdot
.23883 .25778 Mdot
.23978 .42751 Mdot
.24074 .42624 Mdot
.24169 .02135 Mdot
.24264 .34839 Mdot
.24359 .17866 Mdot
.24454 .17993 Mdot
.24549 .58483 Mdot
.24644 .25778 Mdot
.2474 .42752 Mdot
.24835 .42624 Mdot
.2493 .02135 Mdot
.25025 .34839 Mdot
.2512 .17866 Mdot
.25215 .17994 Mdot
.2531 .58482 Mdot
.25406 .25778 Mdot
.25501 .42751 Mdot
.25596 .42624 Mdot
.25691 .02135 Mdot
.25786 .34839 Mdot
.25881 .17866 Mdot
.25976 .17993 Mdot
.26072 .58482 Mdot
.26167 .25778 Mdot
.26262 .42751 Mdot
.26357 .42624 Mdot
.26452 .02135 Mdot
.26547 .34839 Mdot
.26642 .17866 Mdot
.26738 .17993 Mdot
.26833 .58482 Mdot
.26928 .25778 Mdot
.27023 .42751 Mdot
.27118 .42624 Mdot
.27213 .02135 Mdot
.27308 .34839 Mdot
.27404 .17866 Mdot
.27499 .17993 Mdot
.27594 .58482 Mdot
.27689 .25778 Mdot
.27784 .42751 Mdot
.27879 .42624 Mdot
.27974 .02135 Mdot
.2807 .34839 Mdot
.28165 .17866 Mdot
.2826 .17993 Mdot
.28355 .58482 Mdot
.2845 .25778 Mdot
.28545 .42751 Mdot
.2864 .42624 Mdot
.28736 .02135 Mdot
.28831 .34839 Mdot
.28926 .17866 Mdot
.29021 .17993 Mdot
.29116 .58482 Mdot
.29211 .25778 Mdot
.29306 .42751 Mdot
.29402 .42624 Mdot
.29497 .02135 Mdot
.29592 .34839 Mdot
.29687 .17866 Mdot
.29782 .17993 Mdot
.29877 .58482 Mdot
.29972 .25778 Mdot
.30068 .42751 Mdot
.30163 .42624 Mdot
.30258 .02135 Mdot
.30353 .34839 Mdot
.30448 .17866 Mdot
.30543 .17993 Mdot
.30638 .58482 Mdot
.30734 .25778 Mdot
.30829 .42751 Mdot
.30924 .42624 Mdot
.31019 .02135 Mdot
.31114 .34839 Mdot
.31209 .17866 Mdot
.31304 .17993 Mdot
.314 .58482 Mdot
.31495 .25778 Mdot
.3159 .42751 Mdot
.31685 .42624 Mdot
.3178 .02135 Mdot
.31875 .34839 Mdot
.3197 .17866 Mdot
.32066 .17993 Mdot
.32161 .58482 Mdot
.32256 .25778 Mdot
.32351 .42751 Mdot
.32446 .42624 Mdot
.32541 .02135 Mdot
.32636 .34839 Mdot
.32732 .17866 Mdot
.32827 .17993 Mdot
.32922 .58482 Mdot
.33017 .25778 Mdot
.33112 .42751 Mdot
.33207 .42624 Mdot
.33302 .02135 Mdot
.33398 .34839 Mdot
.33493 .17866 Mdot
.33588 .17993 Mdot
.33683 .58482 Mdot
.33778 .25778 Mdot
.33873 .42751 Mdot
.33968 .42624 Mdot
.34064 .02135 Mdot
.34159 .34839 Mdot
.34254 .17866 Mdot
.34349 .17993 Mdot
.34444 .58482 Mdot
.34539 .25778 Mdot
.34634 .42751 Mdot
.3473 .42624 Mdot
.34825 .02135 Mdot
.3492 .34839 Mdot
.35015 .17866 Mdot
.3511 .17993 Mdot
.35205 .58482 Mdot
.353 .25778 Mdot
.35396 .42751 Mdot
.35491 .42624 Mdot
.35586 .02135 Mdot
.35681 .34839 Mdot
.35776 .17866 Mdot
.35871 .17993 Mdot
.35966 .58482 Mdot
.36062 .25778 Mdot
.36157 .42751 Mdot
.36252 .42624 Mdot
.36347 .02135 Mdot
.36442 .34839 Mdot
.36537 .17866 Mdot
.36632 .17993 Mdot
.36728 .58482 Mdot
.36823 .25778 Mdot
.36918 .42751 Mdot
.37013 .42624 Mdot
.37108 .02135 Mdot
.37203 .34839 Mdot
.37298 .17866 Mdot
.37394 .17993 Mdot
.37489 .58482 Mdot
.37584 .25778 Mdot
.37679 .42751 Mdot
.37774 .42624 Mdot
.37869 .02135 Mdot
.37964 .34839 Mdot
.3806 .17866 Mdot
.38155 .17993 Mdot
.3825 .58482 Mdot
.38345 .25778 Mdot
.3844 .42751 Mdot
.38535 .42624 Mdot
.3863 .02135 Mdot
.38726 .34839 Mdot
.38821 .17866 Mdot
.38916 .17993 Mdot
.39011 .58482 Mdot
.39106 .25778 Mdot
.39201 .42751 Mdot
.39296 .42624 Mdot
.39392 .02135 Mdot
.39487 .34839 Mdot
.39582 .17866 Mdot
.39677 .17993 Mdot
.39772 .58482 Mdot
.39867 .25778 Mdot
.39962 .42751 Mdot
.40058 .42624 Mdot
.40153 .02135 Mdot
.40248 .34839 Mdot
.40343 .17866 Mdot
.40438 .17993 Mdot
.40533 .58482 Mdot
.40628 .25778 Mdot
.40724 .42751 Mdot
.40819 .42624 Mdot
.40914 .02135 Mdot
.41009 .34839 Mdot
.41104 .17866 Mdot
.41199 .17993 Mdot
.41294 .58482 Mdot
.4139 .25778 Mdot
.41485 .42751 Mdot
.4158 .42624 Mdot
.41675 .02135 Mdot
.4177 .34839 Mdot
.41865 .17866 Mdot
.4196 .17993 Mdot
.42056 .58482 Mdot
.42151 .25778 Mdot
.42246 .42751 Mdot
.42341 .42624 Mdot
.42436 .02135 Mdot
.42531 .34839 Mdot
.42626 .17866 Mdot
.42722 .17993 Mdot
.42817 .58482 Mdot
.42912 .25778 Mdot
.43007 .42751 Mdot
.43102 .42624 Mdot
.43197 .02135 Mdot
.43292 .34839 Mdot
.43388 .17866 Mdot
.43483 .17993 Mdot
.43578 .58482 Mdot
.43673 .25778 Mdot
.43768 .42751 Mdot
.43863 .42624 Mdot
.43958 .02135 Mdot
.44054 .34839 Mdot
.44149 .17866 Mdot
.44244 .17993 Mdot
.44339 .58482 Mdot
.44434 .25778 Mdot
.44529 .42751 Mdot
.44624 .42624 Mdot
.4472 .02135 Mdot
.44815 .34839 Mdot
.4491 .17866 Mdot
.45005 .17993 Mdot
.451 .58482 Mdot
.45195 .25778 Mdot
.4529 .42751 Mdot
.45386 .42624 Mdot
.45481 .02135 Mdot
.45576 .34839 Mdot
.45671 .17866 Mdot
.45766 .17993 Mdot
.45861 .58482 Mdot
.45956 .25778 Mdot
.46052 .42751 Mdot
.46147 .42624 Mdot
.46242 .02135 Mdot
.46337 .34839 Mdot
.46432 .17866 Mdot
.46527 .17993 Mdot
.46622 .58482 Mdot
.46718 .25778 Mdot
.46813 .42751 Mdot
.46908 .42624 Mdot
.47003 .02135 Mdot
.47098 .34839 Mdot
.47193 .17866 Mdot
.47288 .17993 Mdot
.47384 .58482 Mdot
.47479 .25778 Mdot
.47574 .42751 Mdot
.47669 .42624 Mdot
.47764 .02135 Mdot
.47859 .34839 Mdot
.47954 .17866 Mdot
.4805 .17993 Mdot
.48145 .58482 Mdot
.4824 .25778 Mdot
.48335 .42751 Mdot
.4843 .42624 Mdot
.48525 .02135 Mdot
.4862 .34839 Mdot
.48716 .17866 Mdot
.48811 .17993 Mdot
.48906 .58482 Mdot
.49001 .25778 Mdot
.49096 .42751 Mdot
.49191 .42624 Mdot
.49286 .02135 Mdot
.49382 .34839 Mdot
.49477 .17866 Mdot
.49572 .17993 Mdot
.49667 .58482 Mdot
.49762 .25778 Mdot
.49857 .42751 Mdot
.49952 .42624 Mdot
.50048 .02135 Mdot
.50143 .34839 Mdot
.50238 .17866 Mdot
.50333 .17993 Mdot
.50428 .58482 Mdot
.50523 .25778 Mdot
.50618 .42751 Mdot
.50714 .42624 Mdot
.50809 .02135 Mdot
.50904 .34839 Mdot
.50999 .17866 Mdot
.51094 .17993 Mdot
.51189 .58482 Mdot
.51284 .25778 Mdot
.5138 .42751 Mdot
.51475 .42624 Mdot
.5157 .02135 Mdot
.51665 .34839 Mdot
.5176 .17866 Mdot
.51855 .17993 Mdot
.5195 .58482 Mdot
.52046 .25778 Mdot
.52141 .42751 Mdot
.52236 .42624 Mdot
.52331 .02135 Mdot
.52426 .34839 Mdot
.52521 .17866 Mdot
.52616 .17993 Mdot
.52712 .58482 Mdot
.52807 .25778 Mdot
.52902 .42751 Mdot
.52997 .42624 Mdot
.53092 .02135 Mdot
.53187 .34839 Mdot
.53282 .17866 Mdot
.53378 .17993 Mdot
.53473 .58482 Mdot
.53568 .25778 Mdot
.53663 .42751 Mdot
.53758 .42624 Mdot
.53853 .02135 Mdot
.53948 .34839 Mdot
.54044 .17866 Mdot
.54139 .17993 Mdot
.54234 .58482 Mdot
.54329 .25778 Mdot
.54424 .42751 Mdot
.54519 .42624 Mdot
.54614 .02135 Mdot
.5471 .34839 Mdot
.54805 .17866 Mdot
.549 .17993 Mdot
.54995 .58482 Mdot
.5509 .25778 Mdot
.55185 .42751 Mdot
.5528 .42624 Mdot
.55376 .02135 Mdot
.55471 .34839 Mdot
.55566 .17866 Mdot
.55661 .17993 Mdot
.55756 .58482 Mdot
.55851 .25778 Mdot
.55946 .42751 Mdot
.56042 .42624 Mdot
.56137 .02135 Mdot
.56232 .34839 Mdot
.56327 .17866 Mdot
.56422 .17993 Mdot
.56517 .58482 Mdot
.56612 .25778 Mdot
.56708 .42751 Mdot
.56803 .42624 Mdot
.56898 .02135 Mdot
.56993 .34839 Mdot
.57088 .17866 Mdot
.57183 .17993 Mdot
.57278 .58482 Mdot
.57374 .25778 Mdot
.57469 .42751 Mdot
.57564 .42624 Mdot
.57659 .02135 Mdot
.57754 .34839 Mdot
.57849 .17866 Mdot
.57944 .17993 Mdot
.5804 .58482 Mdot
.58135 .25778 Mdot
.5823 .42751 Mdot
.58325 .42624 Mdot
.5842 .02135 Mdot
.58515 .34839 Mdot
.5861 .17866 Mdot
.58706 .17993 Mdot
.58801 .58482 Mdot
.58896 .25778 Mdot
.58991 .42751 Mdot
.59086 .42624 Mdot
.59181 .02135 Mdot
.59276 .34839 Mdot
.59372 .17866 Mdot
.59467 .17993 Mdot
.59562 .58482 Mdot
.59657 .25778 Mdot
.59752 .42751 Mdot
.59847 .42624 Mdot
.59942 .02135 Mdot
.60038 .34839 Mdot
.60133 .17866 Mdot
.60228 .17993 Mdot
.60323 .58482 Mdot
.60418 .25778 Mdot
.60513 .42751 Mdot
.60608 .42624 Mdot
.60704 .02135 Mdot
.60799 .34839 Mdot
.60894 .17866 Mdot
.60989 .17993 Mdot
.61084 .58482 Mdot
.61179 .25778 Mdot
.61274 .42751 Mdot
.6137 .42624 Mdot
.61465 .02135 Mdot
.6156 .34839 Mdot
.61655 .17866 Mdot
.6175 .17993 Mdot
.61845 .58482 Mdot
.6194 .25778 Mdot
.62036 .42751 Mdot
.62131 .42624 Mdot
.62226 .02135 Mdot
.62321 .34839 Mdot
.62416 .17866 Mdot
.62511 .17993 Mdot
.62606 .58482 Mdot
.62702 .25778 Mdot
.62797 .42751 Mdot
.62892 .42624 Mdot
.62987 .02135 Mdot
.63082 .34839 Mdot
.63177 .17866 Mdot
.63272 .17993 Mdot
.63368 .58482 Mdot
.63463 .25778 Mdot
.63558 .42751 Mdot
.63653 .42624 Mdot
.63748 .02135 Mdot
.63843 .34839 Mdot
.63938 .17866 Mdot
.64034 .17993 Mdot
.64129 .58482 Mdot
.64224 .25778 Mdot
.64319 .42751 Mdot
.64414 .42624 Mdot
.64509 .02135 Mdot
.64604 .34839 Mdot
.647 .17866 Mdot
.64795 .17993 Mdot
.6489 .58482 Mdot
.64985 .25778 Mdot
.6508 .42751 Mdot
.65175 .42624 Mdot
.6527 .02135 Mdot
.65366 .34839 Mdot
.65461 .17866 Mdot
.65556 .17993 Mdot
.65651 .58482 Mdot
.65746 .25778 Mdot
.65841 .42751 Mdot
.65936 .42624 Mdot
.66032 .02135 Mdot
.66127 .34839 Mdot
.66222 .17866 Mdot
.66317 .17993 Mdot
.66412 .58482 Mdot
.66507 .25778 Mdot
.66602 .42751 Mdot
.66698 .42624 Mdot
.66793 .02135 Mdot
.66888 .34839 Mdot
.66983 .17866 Mdot
.67078 .17993 Mdot
.67173 .58482 Mdot
.67268 .25778 Mdot
.67364 .42751 Mdot
.67459 .42624 Mdot
.67554 .02135 Mdot
.67649 .34839 Mdot
.67744 .17866 Mdot
.67839 .17993 Mdot
.67934 .58482 Mdot
.6803 .25778 Mdot
.68125 .42751 Mdot
.6822 .42624 Mdot
.68315 .02135 Mdot
.6841 .34839 Mdot
.68505 .17866 Mdot
.686 .17993 Mdot
.68696 .58482 Mdot
.68791 .25778 Mdot
.68886 .42751 Mdot
.68981 .42624 Mdot
.69076 .02135 Mdot
.69171 .34839 Mdot
.69266 .17866 Mdot
.69362 .17993 Mdot
.69457 .58482 Mdot
.69552 .25778 Mdot
.69647 .42751 Mdot
.69742 .42624 Mdot
.69837 .02135 Mdot
.69932 .34839 Mdot
.70028 .17866 Mdot
.70123 .17993 Mdot
.70218 .58482 Mdot
.70313 .25778 Mdot
.70408 .42751 Mdot
.70503 .42624 Mdot
.70598 .02135 Mdot
.70694 .34839 Mdot
.70789 .17866 Mdot
.70884 .17993 Mdot
.70979 .58482 Mdot
.71074 .25778 Mdot
.71169 .42751 Mdot
.71264 .42624 Mdot
.7136 .02135 Mdot
.71455 .34839 Mdot
.7155 .17866 Mdot
.71645 .17993 Mdot
.7174 .58482 Mdot
.71835 .25778 Mdot
.7193 .42751 Mdot
.72026 .42624 Mdot
.72121 .02135 Mdot
.72216 .34839 Mdot
.72311 .17866 Mdot
.72406 .17993 Mdot
.72501 .58482 Mdot
.72596 .25778 Mdot
.72692 .42751 Mdot
.72787 .42624 Mdot
.72882 .02135 Mdot
.72977 .34839 Mdot
.73072 .17866 Mdot
.73167 .17993 Mdot
.73262 .58482 Mdot
.73358 .25778 Mdot
.73453 .42751 Mdot
.73548 .42624 Mdot
.73643 .02135 Mdot
.73738 .34839 Mdot
.73833 .17866 Mdot
.73928 .17993 Mdot
.74024 .58482 Mdot
.74119 .25778 Mdot
.74214 .42751 Mdot
.74309 .42624 Mdot
.74404 .02135 Mdot
.74499 .34839 Mdot
.74594 .17866 Mdot
.7469 .17993 Mdot
.74785 .58482 Mdot
.7488 .25778 Mdot
.74975 .42751 Mdot
.7507 .42624 Mdot
.75165 .02135 Mdot
.7526 .34839 Mdot
.75356 .17866 Mdot
.75451 .17993 Mdot
.75546 .58482 Mdot
.75641 .25778 Mdot
.75736 .42751 Mdot
.75831 .42624 Mdot
.75926 .02135 Mdot
.76022 .34839 Mdot
.76117 .17866 Mdot
.76212 .17993 Mdot
.76307 .58482 Mdot
.76402 .25778 Mdot
.76497 .42751 Mdot
.76592 .42624 Mdot
.76688 .02135 Mdot
.76783 .34839 Mdot
.76878 .17866 Mdot
.76973 .17993 Mdot
.77068 .58482 Mdot
.77163 .25778 Mdot
.77258 .42751 Mdot
.77354 .42624 Mdot
.77449 .02135 Mdot
.77544 .34839 Mdot
.77639 .17866 Mdot
.77734 .17993 Mdot
.77829 .58482 Mdot
.77924 .25778 Mdot
.7802 .42751 Mdot
.78115 .42624 Mdot
.7821 .02135 Mdot
.78305 .34839 Mdot
.784 .17866 Mdot
.78495 .17993 Mdot
.7859 .58482 Mdot
.78686 .25778 Mdot
.78781 .42751 Mdot
.78876 .42624 Mdot
.78971 .02135 Mdot
.79066 .34839 Mdot
.79161 .17866 Mdot
.79256 .17993 Mdot
.79352 .58482 Mdot
.79447 .25778 Mdot
.79542 .42751 Mdot
.79637 .42624 Mdot
.79732 .02135 Mdot
.79827 .34839 Mdot
.79922 .17866 Mdot
.80018 .17993 Mdot
.80113 .58482 Mdot
.80208 .25778 Mdot
.80303 .42751 Mdot
.80398 .42624 Mdot
.80493 .02135 Mdot
.80588 .34839 Mdot
.80684 .17866 Mdot
.80779 .17993 Mdot
.80874 .58482 Mdot
.80969 .25778 Mdot
.81064 .42751 Mdot
.81159 .42624 Mdot
.81254 .02135 Mdot
.8135 .34839 Mdot
.81445 .17866 Mdot
.8154 .17993 Mdot
.81635 .58482 Mdot
.8173 .25778 Mdot
.81825 .42751 Mdot
.8192 .42624 Mdot
.82016 .02135 Mdot
.82111 .34839 Mdot
.82206 .17866 Mdot
.82301 .17993 Mdot
.82396 .58482 Mdot
.82491 .25778 Mdot
.82586 .42751 Mdot
.82682 .42624 Mdot
.82777 .02135 Mdot
.82872 .34839 Mdot
.82967 .17866 Mdot
.83062 .17993 Mdot
.83157 .58482 Mdot
.83252 .25778 Mdot
.83348 .42751 Mdot
.83443 .42624 Mdot
.83538 .02135 Mdot
.83633 .34839 Mdot
.83728 .17866 Mdot
.83823 .17993 Mdot
.83918 .58482 Mdot
.84014 .25778 Mdot
.84109 .42751 Mdot
.84204 .42624 Mdot
.84299 .02135 Mdot
.84394 .34839 Mdot
.84489 .17866 Mdot
.84584 .17993 Mdot
.8468 .58482 Mdot
.84775 .25778 Mdot
.8487 .42751 Mdot
.84965 .42624 Mdot
.8506 .02135 Mdot
.85155 .34839 Mdot
.8525 .17866 Mdot
.85346 .17993 Mdot
.85441 .58482 Mdot
.85536 .25778 Mdot
.85631 .42751 Mdot
.85726 .42624 Mdot
.85821 .02135 Mdot
.85916 .34839 Mdot
.86012 .17866 Mdot
.86107 .17993 Mdot
.86202 .58482 Mdot
.86297 .25778 Mdot
.86392 .42751 Mdot
.86487 .42624 Mdot
.86582 .02135 Mdot
.86678 .34839 Mdot
.86773 .17866 Mdot
.86868 .17993 Mdot
.86963 .58482 Mdot
.87058 .25778 Mdot
.87153 .42751 Mdot
.87248 .42624 Mdot
.87344 .02135 Mdot
.87439 .34839 Mdot
.87534 .17866 Mdot
.87629 .17993 Mdot
.87724 .58482 Mdot
.87819 .25778 Mdot
.87914 .42751 Mdot
.8801 .42624 Mdot
.88105 .02135 Mdot
.882 .34839 Mdot
.88295 .17866 Mdot
.8839 .17993 Mdot
.88485 .58482 Mdot
.8858 .25778 Mdot
.88676 .42751 Mdot
.88771 .42624 Mdot
.88866 .02135 Mdot
.88961 .34839 Mdot
.89056 .17866 Mdot
.89151 .17993 Mdot
.89246 .58482 Mdot
.89342 .25778 Mdot
.89437 .42751 Mdot
.89532 .42624 Mdot
.89627 .02135 Mdot
.89722 .34839 Mdot
.89817 .17866 Mdot
.89912 .17993 Mdot
.90008 .58482 Mdot
.90103 .25778 Mdot
.90198 .42751 Mdot
.90293 .42624 Mdot
.90388 .02135 Mdot
.90483 .34839 Mdot
.90578 .17866 Mdot
.90674 .17993 Mdot
.90769 .58482 Mdot
.90864 .25778 Mdot
.90959 .42751 Mdot
.91054 .42624 Mdot
.91149 .02135 Mdot
.91244 .34839 Mdot
.9134 .17866 Mdot
.91435 .17993 Mdot
.9153 .58482 Mdot
.91625 .25778 Mdot
.9172 .42751 Mdot
.91815 .42624 Mdot
.9191 .02135 Mdot
.92006 .34839 Mdot
.92101 .17866 Mdot
.92196 .17993 Mdot
.92291 .58482 Mdot
.92386 .25778 Mdot
.92481 .42751 Mdot
.92576 .42624 Mdot
.92672 .02135 Mdot
.92767 .34839 Mdot
.92862 .17866 Mdot
.92957 .17993 Mdot
.93052 .58482 Mdot
.93147 .25778 Mdot
.93242 .42751 Mdot
.93338 .42624 Mdot
.93433 .02135 Mdot
.93528 .34839 Mdot
.93623 .17866 Mdot
.93718 .17993 Mdot
.93813 .58482 Mdot
.93908 .25778 Mdot
.94004 .42751 Mdot
.94099 .42624 Mdot
.94194 .02135 Mdot
.94289 .34839 Mdot
.94384 .17866 Mdot
.94479 .17993 Mdot
.94574 .58482 Mdot
.9467 .25778 Mdot
.94765 .42751 Mdot
.9486 .42624 Mdot
.94955 .02135 Mdot
.9505 .34839 Mdot
.95145 .17866 Mdot
.9524 .17993 Mdot
.95336 .58482 Mdot
.95431 .25778 Mdot
.95526 .42751 Mdot
.95621 .42624 Mdot
.95716 .02135 Mdot
.95811 .34839 Mdot
.95906 .17866 Mdot
.96002 .17993 Mdot
.96097 .58482 Mdot
.96192 .25778 Mdot
.96287 .42751 Mdot
.96382 .42624 Mdot
.96477 .02135 Mdot
.96572 .34839 Mdot
.96668 .17866 Mdot
.96763 .17993 Mdot
.96858 .58482 Mdot
.96953 .25778 Mdot
.97048 .42751 Mdot
.97143 .42624 Mdot
.97238 .02135 Mdot
.97334 .34839 Mdot
.97429 .17866 Mdot
.97524 .17993 Mdot
.97619 .58482 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`008@3oool00`000000oooo0?oo
o`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?oo
o`008@3oool00`000000oooo0?ooo`3l0?ooo`00203oool2000000@0oooo0P0000040?ooo`800000
0`3oool3000000D0oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`3f0?ooo`001`3o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool00000103oool00`000000oooo000000030?ooo`050000003oool0oooo0?ooo`0000000`3oool0
1@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`000000oooo0P0000006`3oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000M0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000006`3oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001d0oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool00P0000001P3oool000000?ooo`000000oooo
000000h0oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000040?ooo`8000001P3oool04P000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`80000001/0oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000007@3oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000006`3oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000M0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000006`3oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000000H0oooo0000003oool00000
0?ooo`00000>0?ooo`0000<0oooo0000000000000P0000020?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool000000P3oool3000000D0oooo00D000000?ooo`3oool0oooo00000003
0?ooo`050000003oool0oooo0?ooo`0000000`3oool01@000000oooo0?ooo`3oool000000>X0oooo
00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000`3oool00`000000
oooo0?ooo`040?ooo`050000003oool0oooo0?ooo`000000nP3oool000P0oooo0P00000:0?ooo`80
0000103oool3000000@0oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0
o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?ooo`008@3oool00`00
0000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo
0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l
0?ooo`008@3oool200000?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000
003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0
oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`800000o@3oool00240oooo
00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<00000
0?ooo`3oool0o03oool000P0oooo0P0000040?ooo`800000103oool2000000D0oooo0`0000030?oo
o`030000003oool0oooo0?`0oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?oo
o`3oool000001@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0?`0oooo00070?oo
o`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool5000000<0oooo0P00
003m0?ooo`0000<0oooo0000000000000P0000020?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0?`0
oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000`3oool00`00
0000oooo000000040?ooo`030000003oool0oooo0?`0oooo00080?ooo`8000002P3oool2000000D0
oooo0P0000040?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo
000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`800000o@3oool00240oooo00<000000?oo
o`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0
o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool0
0240oooo0P00003m0?ooo`008@3oool200000?d0oooo000Q0?ooo`8000000`3oool00`000000oooo
0?ooo`3g0?ooo`008@3oool2000000<0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000
0P3oool060000000oooo0?ooo`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`80000001d0oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000007@3oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000006`3oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`020000000F0?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo000000d0oooo000Q0?ooo`030000003oool0oooo0080oooo00H000000?ooo`000000oooo
0000003oool:0000000C0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`0:0000000E0?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo00P0000001D0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool02P0000004`3oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
2P0000005@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`080000000E0?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo00X0000001<0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo00X0000000h0oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo000000d0oooo000Q0?ooo`040000003oool0oooo0000
00<0oooo00D000000?ooo`3oool0oooo000000020?ooo`80000000<0oooo0000000000000P000000
6`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001d0oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000007@3oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000003P3oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000003@3oool00240oooo0P00
00000`3oool000000?ooo`020?ooo`030000003oool0oooo0?D0oooo000Q0?ooo`040000003oool0
oooo00000?/0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo
0?`0oooo00080?ooo`800000103oool2000000@0oooo0P0000030?ooo`@00000103oool00`000000
oooo0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000
oooo0?ooo`0000080?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool0103oool2
00000?d0oooo00000`3oool000000000000200000080oooo00@000000?ooo`3oool00000203oool0
10000000oooo0?ooo`0000040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0o03o
ool000L0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000000@0oooo00<000000?ooo`3oool0o03oool000P0oooo0P00000:0?ooo`800000
103oool2000000D0oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03o
ool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?ooo`008@3oool00`000000
oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?oo
o`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo000000020?oo
o`050000003oool0oooo0?ooo`0000000`3oool01@000000oooo0?ooo`3oool0000000<0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0=l0oooo000Q0?ooo`<0000001h0
oooo000000000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool2
000000050?ooo`000000oooo0000003oool01@0000001`3oool00000000000000000oooo0000003o
ool00`0000002@3oool000000?ooo`000000oooo0000003oool000000?ooo`020000000G0?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool0200000000`3oool000000?ooo`030000000C0?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`020000000=0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`03000000030?ooo`000000oooo00<0000000<0oooo0000003oool0100000007@3o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo00800000
00L0oooo00000000000000000?ooo`000000oooo00<0000000<0oooo0000003oool00`0000002`3o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo008000000140oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`07
000000040?ooo`0000000000000000<0oooo0P0000040?ooo`8000000`3oool00240oooo00D00000
0?ooo`3oool0oooo000000020?ooo`050000003oool0oooo0?ooo`0000000`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0oooo000000030?ooo`0A0000003oool00000
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00`00
00000`3oool000000?ooo`03000000070?ooo`000000oooo0000003oool000000?ooo`020000000K
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000000L0oooo
00000000000000000?ooo`000000oooo00<000000140oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000?0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo00<0000000<0oooo
0000003oool00`0000000`3oool000000?ooo`020000000M0?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool00P0000000`3oool000000?ooo`0300000003
0?ooo`000000oooo00<0000000<0oooo0000003oool00`0000002@3oool000000?ooo`000000oooo
0000003oool000000?ooo`020000000C0?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`03000000060?ooo`0000000000
0000003oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080
oooo000Q0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool00P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000200oooo1@0000001@3oool000000?ooo`3oool0
00000080oooo00@000000?ooo`3oool000008@3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000803oool01@000000oooo
0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000002
0?ooo`4000000@3oool10?ooo`008@3oool00`000000oooo0?ooo`0W0?ooo`050000003oool0oooo
0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo01h0oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
0240oooo0`0000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000008@3o
ool2000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000P0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo0@0000010?ooo`40oooo000Q0?ooo`030000003oool0oooo02D0oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000240
oooo00<000000?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000280oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo00000200oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000200oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000P3oool100000040oooo0@3oool00240oooo
00<000000?ooo`3oool09P3oool2000000@0oooo0P0000040?ooo`8000008`3oool2000000<0oooo
0P0000040?ooo`8000008`3oool3000000<0oooo0P0000040?ooo`8000008P3oool2000000@0oooo
0P0000040?ooo`800000803oool2000000@0oooo0P0000040?ooo`800000103oool2000000<0oooo
000Q0?ooo`800000o@3oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?oo
o`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0
o03oool00240oooo00<000000?ooo`3oool0o03oool001/0ooooo`0000060?ooo`008@3oool00`00
0000oooo0?ooo`0]0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0;P3oool00`00
0000oooo0?ooo`0]0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool02P3oool00240
oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<0
00000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?oo
o`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3o
ool00`000000oooo0?ooo`3l0?ooo`008@3oool010000000oooo0?ooo`0000020?ooo`050000003o
ool0oooo0?ooo`0000000`3oool01@000000oooo0?ooo`3oool000000>`0oooo000Q0?ooo`800000
0200oooo000000000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`80000001/0oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`020000000M0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080
000001/0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P000000
7P3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
00d0oooo000Q0?ooo`8000000P3oool01@000000oooo0?ooo`3oool0000000<0oooo00D000000?oo
o`3oool0oooo000000030?ooo`0>0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool20000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool00P0000007@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0080000001h0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`00000=0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?oo
o`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?oo
o`008@3oool200000?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003o
ool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo00080?ooo`800000103oool20000
00@0oooo0P0000030?ooo`@00000103oool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000
oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0
oooo000000<0oooo00<000000?ooo`3oool0103oool200000?d0oooo00070?ooo`040000003oool0
oooo000000P0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo0?`0oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0?`0oooo00080?ooo`80
00002P3oool2000000@0oooo0P0000050?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000
003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`800000o@3oool0
0240oooo00D000000?ooo`3oool0oooo000000030?ooo`0:0000003oool0oooo0?ooo`000000oooo
0000003oool000000?ooo`80000001d0oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool00P0000007@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0080000000h0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo000000h0oooo000Q0?ooo`0<0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo200000005@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`0:0000000C0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`0:0000000E0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo00P0000001D0oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool02P0000004`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool02P0000004`3oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool02P00
00005@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`080000000>0?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`00000>0?ooo`008@3oool00`000000oooo00000003
0?ooo`050000003oool0oooo0?ooo`0000000P3oool070000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool20000000K0?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0080000001d0oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`020000000K0?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`020000000M0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool00P000000503oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000003P3oool00240oooo00<0
00000?ooo`000000o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?oo
o`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3o
ool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`00
0000oooo0?ooo`3l0?ooo`008@3oool200000?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo
000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo00080?oo
o`800000103oool2000000@0oooo0P0000050?ooo`<000000`3oool00`000000oooo0?ooo`3l0?oo
o`001`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000000D0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo00000080oooo1@0000030?ooo`800000o@3oool000L0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0
oooo00<000000?ooo`3oool0o03oool000L0oooo00@000000?ooo`3oool00000203oool010000000
oooo0?ooo`0000030?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool0o03oool000P0
oooo0P00000:0?ooo`8000001@3oool2000000@0oooo00<000000?ooo`3oool0o03oool00240oooo
00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m
0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`00
8@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool0
0`000000oooo0?ooo`3l0?ooo`00803oool300000?d0oooo000P0?ooo`800000oP3oool00240oooo
00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<00000
0?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?ooo`00
8@3oool010000000oooo0?ooo`00003k0?ooo`008@3oool010000000oooo0?ooo`00003k0?ooo`00
8@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0?D0oooo00080?ooo`800000103o
ool2000000@0oooo0P0000030?ooo`<000001@3oool00`000000oooo0?ooo`040?ooo`050000003o
ool0oooo0?ooo`000000l`3oool000L0oooo00@000000?ooo`3oool00000203oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0203oool01@00
0000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0oooo0000003W0?ooo`001`3oool0
10000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
0000103oool2000000/0oooo00h000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`80000001/0oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0080000001d0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
0P0000007@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0080000000H0oooo0000003oool000000?ooo`00000=0?ooo`001`3oool010000000oooo0?oo
o`0000080?ooo`040000003oool0oooo00000080oooo0`0000050?ooo`030000003oool0oooo00H0
oooo00D000000?ooo`3oool0oooo000000030?ooo`050000003oool0oooo0?ooo`0000000`3oool0
7`000000oooo000000000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080
000001d0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080
000001/0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P000000
7@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080
000000H0oooo0000003oool000000?ooo`00000=0?ooo`001`3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`020?ooo`050000003oool0oooo0?ooo`000000m@3oool000P0oooo0P00000:0?ooo`800000103o
ool3000000@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`3g0?ooo`008@3oool2
00000?d0oooo000Q0?ooo`800000o@3oool00240oooo0P00003m0?ooo`008@3oool00`000000oooo
0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-137.202, -0.0726286, \
4.1353, 0.000835178}}]
}, Open  ]],

Cell[TextData[StyleBox["When we are in the 8 cycle regime, we need to start \
with nearly the same initial condition to make the histories coincide. Try \
starting with 0.55, and 0.56 for h1 and h2.  In this case the convergence is \
slow enough to generate an interesting plot.",
  FontColor->RGBColor[1, 0.501961, 1]]], "Input",
  Evaluatable->False,
  FormatType->TextForm],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\(Clear[fg];\)\[IndentingNewLine]
    r\  = \ 3.562\[IndentingNewLine]
    \(fg[x_]\  := \ r\ x \((1 - x)\);\)\[IndentingNewLine]
    \(h1\  = \ NestList[fg, \ 0.50, \ 1000];\)\[IndentingNewLine]
    \(h2\  = \ NestList[fg, \ 0.55, \ 1000];\)\[IndentingNewLine]
    \(ListPlot[h2 - h1, \ PlotJoined\  \[Rule] False];\)\)\)\)], "Input"],

Cell[BoxData[
    \(3.562`\)], "Output"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00095143 0.303086 4.71091 [
[.2141 .29059 -9 -9 ]
[.2141 .29059 9 0 ]
[.40438 .29059 -9 -9 ]
[.40438 .29059 9 0 ]
[.59467 .29059 -9 -9 ]
[.59467 .29059 9 0 ]
[.78495 .29059 -9 -9 ]
[.78495 .29059 9 0 ]
[.97524 .29059 -12 -9 ]
[.97524 .29059 12 0 ]
[.01131 .02043 -30 -4.5 ]
[.01131 .02043 0 4.5 ]
[.01131 .11465 -30 -4.5 ]
[.01131 .11465 0 4.5 ]
[.01131 .20887 -30 -4.5 ]
[.01131 .20887 0 4.5 ]
[.01131 .3973 -24 -4.5 ]
[.01131 .3973 0 4.5 ]
[.01131 .49152 -24 -4.5 ]
[.01131 .49152 0 4.5 ]
[.01131 .58574 -24 -4.5 ]
[.01131 .58574 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2141 .30309 m
.2141 .30934 L
s
[(200)] .2141 .29059 0 1 Mshowa
.40438 .30309 m
.40438 .30934 L
s
[(400)] .40438 .29059 0 1 Mshowa
.59467 .30309 m
.59467 .30934 L
s
[(600)] .59467 .29059 0 1 Mshowa
.78495 .30309 m
.78495 .30934 L
s
[(800)] .78495 .29059 0 1 Mshowa
.97524 .30309 m
.97524 .30934 L
s
[(1000)] .97524 .29059 0 1 Mshowa
.125 Mabswid
.07138 .30309 m
.07138 .30684 L
s
.11895 .30309 m
.11895 .30684 L
s
.16652 .30309 m
.16652 .30684 L
s
.26167 .30309 m
.26167 .30684 L
s
.30924 .30309 m
.30924 .30684 L
s
.35681 .30309 m
.35681 .30684 L
s
.45195 .30309 m
.45195 .30684 L
s
.49952 .30309 m
.49952 .30684 L
s
.5471 .30309 m
.5471 .30684 L
s
.64224 .30309 m
.64224 .30684 L
s
.68981 .30309 m
.68981 .30684 L
s
.73738 .30309 m
.73738 .30684 L
s
.83252 .30309 m
.83252 .30684 L
s
.8801 .30309 m
.8801 .30684 L
s
.92767 .30309 m
.92767 .30684 L
s
.25 Mabswid
0 .30309 m
1 .30309 L
s
.02381 .02043 m
.03006 .02043 L
s
[(-0.06)] .01131 .02043 1 0 Mshowa
.02381 .11465 m
.03006 .11465 L
s
[(-0.04)] .01131 .11465 1 0 Mshowa
.02381 .20887 m
.03006 .20887 L
s
[(-0.02)] .01131 .20887 1 0 Mshowa
.02381 .3973 m
.03006 .3973 L
s
[(0.02)] .01131 .3973 1 0 Mshowa
.02381 .49152 m
.03006 .49152 L
s
[(0.04)] .01131 .49152 1 0 Mshowa
.02381 .58574 m
.03006 .58574 L
s
[(0.06)] .01131 .58574 1 0 Mshowa
.125 Mabswid
.02381 .04399 m
.02756 .04399 L
s
.02381 .06754 m
.02756 .06754 L
s
.02381 .0911 m
.02756 .0911 L
s
.02381 .1382 m
.02756 .1382 L
s
.02381 .16176 m
.02756 .16176 L
s
.02381 .18531 m
.02756 .18531 L
s
.02381 .23242 m
.02756 .23242 L
s
.02381 .25598 m
.02756 .25598 L
s
.02381 .27953 m
.02756 .27953 L
s
.02381 .32664 m
.02756 .32664 L
s
.02381 .3502 m
.02756 .3502 L
s
.02381 .37375 m
.02756 .37375 L
s
.02381 .42086 m
.02756 .42086 L
s
.02381 .44441 m
.02756 .44441 L
s
.02381 .46797 m
.02756 .46797 L
s
.02381 .51508 m
.02756 .51508 L
s
.02381 .53863 m
.02756 .53863 L
s
.02381 .56219 m
.02756 .56219 L
s
.02381 .60929 m
.02756 .60929 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02476 .53863 Mdot
.02571 .26114 Mdot
.02666 .41846 Mdot
.02762 .4185 Mdot
.02857 .0402 Mdot
.02952 .35148 Mdot
.03047 .17023 Mdot
.03142 .17198 Mdot
.03237 .60332 Mdot
.03332 .25651 Mdot
.03428 .4309 Mdot
.03523 .42883 Mdot
.03618 .01472 Mdot
.03713 .34569 Mdot
.03808 .18604 Mdot
.03903 .18695 Mdot
.03998 .56854 Mdot
.04094 .25907 Mdot
.04189 .42403 Mdot
.04284 .42337 Mdot
.04379 .02846 Mdot
.04474 .3501 Mdot
.04569 .17401 Mdot
.04664 .17554 Mdot
.0476 .59504 Mdot
.04855 .25704 Mdot
.0495 .42948 Mdot
.05045 .42778 Mdot
.0514 .01745 Mdot
.05235 .347 Mdot
.0533 .18246 Mdot
.05426 .18354 Mdot
.05521 .57644 Mdot
.05616 .25843 Mdot
.05711 .42577 Mdot
.05806 .42481 Mdot
.05901 .02489 Mdot
.05996 .34935 Mdot
.06092 .17605 Mdot
.06187 .17746 Mdot
.06282 .59057 Mdot
.06377 .25736 Mdot
.06472 .42864 Mdot
.06567 .42713 Mdot
.06662 .01909 Mdot
.06758 .34764 Mdot
.06853 .18071 Mdot
.06948 .18188 Mdot
.07043 .58029 Mdot
.07138 .25813 Mdot
.07233 .42658 Mdot
.07328 .42549 Mdot
.07424 .02323 Mdot
.07519 .34893 Mdot
.07614 .17719 Mdot
.07709 .17854 Mdot
.07804 .58805 Mdot
.07899 .25754 Mdot
.07994 .42816 Mdot
.0809 .42675 Mdot
.08185 .02006 Mdot
.0828 .34798 Mdot
.08375 .17979 Mdot
.0847 .181 Mdot
.08565 .58233 Mdot
.0866 .25797 Mdot
.08756 .42701 Mdot
.08851 .42583 Mdot
.08946 .02237 Mdot
.09041 .3487 Mdot
.09136 .17783 Mdot
.09231 .17915 Mdot
.09326 .58663 Mdot
.09422 .25764 Mdot
.09517 .42788 Mdot
.09612 .42653 Mdot
.09707 .02062 Mdot
.09802 .34816 Mdot
.09897 .17928 Mdot
.09992 .18053 Mdot
.10088 .58344 Mdot
.10183 .25788 Mdot
.10278 .42723 Mdot
.10373 .42601 Mdot
.10468 .02191 Mdot
.10563 .34856 Mdot
.10658 .1782 Mdot
.10754 .1795 Mdot
.10849 .58584 Mdot
.10944 .2577 Mdot
.11039 .42772 Mdot
.11134 .4264 Mdot
.11229 .02094 Mdot
.11324 .34827 Mdot
.1142 .17901 Mdot
.11515 .18026 Mdot
.1161 .58406 Mdot
.11705 .25784 Mdot
.118 .42736 Mdot
.11895 .42611 Mdot
.1199 .02166 Mdot
.12086 .34849 Mdot
.12181 .1784 Mdot
.12276 .17969 Mdot
.12371 .58539 Mdot
.12466 .25774 Mdot
.12561 .42763 Mdot
.12656 .42633 Mdot
.12752 .02112 Mdot
.12847 .34832 Mdot
.12942 .17885 Mdot
.13037 .18012 Mdot
.13132 .5844 Mdot
.13227 .25781 Mdot
.13322 .42743 Mdot
.13418 .42617 Mdot
.13513 .02152 Mdot
.13608 .34845 Mdot
.13703 .17851 Mdot
.13798 .1798 Mdot
.13893 .58514 Mdot
.13988 .25775 Mdot
.14084 .42758 Mdot
.14179 .42629 Mdot
.14274 .02122 Mdot
.14369 .34835 Mdot
.14464 .17877 Mdot
.14559 .18004 Mdot
.14654 .58458 Mdot
.1475 .2578 Mdot
.14845 .42747 Mdot
.1494 .4262 Mdot
.15035 .02145 Mdot
.1513 .34842 Mdot
.15225 .17858 Mdot
.1532 .17986 Mdot
.15416 .585 Mdot
.15511 .25777 Mdot
.15606 .42755 Mdot
.15701 .42627 Mdot
.15796 .02128 Mdot
.15891 .34837 Mdot
.15986 .17872 Mdot
.16082 .17999 Mdot
.16177 .58469 Mdot
.16272 .25779 Mdot
.16367 .42749 Mdot
.16462 .42622 Mdot
.16557 .0214 Mdot
.16652 .34841 Mdot
.16748 .17861 Mdot
.16843 .17989 Mdot
.16938 .58492 Mdot
.17033 .25777 Mdot
.17128 .42753 Mdot
.17223 .42625 Mdot
.17318 .02131 Mdot
.17414 .34838 Mdot
.17509 .17869 Mdot
.17604 .17996 Mdot
.17699 .58475 Mdot
.17794 .25778 Mdot
.17889 .4275 Mdot
.17984 .42623 Mdot
.1808 .02138 Mdot
.18175 .3484 Mdot
.1827 .17863 Mdot
.18365 .17991 Mdot
.1846 .58488 Mdot
.18555 .25777 Mdot
.1865 .42753 Mdot
.18746 .42625 Mdot
.18841 .02133 Mdot
.18936 .34839 Mdot
.19031 .17868 Mdot
.19126 .17995 Mdot
.19221 .58478 Mdot
.19316 .25778 Mdot
.19412 .42751 Mdot
.19507 .42623 Mdot
.19602 .02137 Mdot
.19697 .3484 Mdot
.19792 .17864 Mdot
.19887 .17992 Mdot
.19982 .58485 Mdot
.20078 .25778 Mdot
.20173 .42752 Mdot
.20268 .42624 Mdot
.20363 .02134 Mdot
.20458 .34839 Mdot
.20553 .17867 Mdot
.20648 .17994 Mdot
.20744 .5848 Mdot
.20839 .25778 Mdot
.20934 .42751 Mdot
.21029 .42623 Mdot
.21124 .02136 Mdot
.21219 .3484 Mdot
.21314 .17865 Mdot
.2141 .17993 Mdot
.21505 .58484 Mdot
.216 .25778 Mdot
.21695 .42752 Mdot
.2179 .42624 Mdot
.21885 .02134 Mdot
.2198 .34839 Mdot
.22076 .17866 Mdot
.22171 .17994 Mdot
.22266 .58481 Mdot
.22361 .25778 Mdot
.22456 .42751 Mdot
.22551 .42624 Mdot
.22646 .02136 Mdot
.22742 .3484 Mdot
.22837 .17865 Mdot
.22932 .17993 Mdot
.23027 .58483 Mdot
.23122 .25778 Mdot
.23217 .42752 Mdot
.23312 .42624 Mdot
.23408 .02135 Mdot
.23503 .34839 Mdot
.23598 .17866 Mdot
.23693 .17994 Mdot
.23788 .58481 Mdot
.23883 .25778 Mdot
.23978 .42751 Mdot
.24074 .42624 Mdot
.24169 .02135 Mdot
.24264 .34839 Mdot
.24359 .17866 Mdot
.24454 .17993 Mdot
.24549 .58483 Mdot
.24644 .25778 Mdot
.2474 .42752 Mdot
.24835 .42624 Mdot
.2493 .02135 Mdot
.25025 .34839 Mdot
.2512 .17866 Mdot
.25215 .17994 Mdot
.2531 .58482 Mdot
.25406 .25778 Mdot
.25501 .42751 Mdot
.25596 .42624 Mdot
.25691 .02135 Mdot
.25786 .34839 Mdot
.25881 .17866 Mdot
.25976 .17993 Mdot
.26072 .58482 Mdot
.26167 .25778 Mdot
.26262 .42751 Mdot
.26357 .42624 Mdot
.26452 .02135 Mdot
.26547 .34839 Mdot
.26642 .17866 Mdot
.26738 .17993 Mdot
.26833 .58482 Mdot
.26928 .25778 Mdot
.27023 .42751 Mdot
.27118 .42624 Mdot
.27213 .02135 Mdot
.27308 .34839 Mdot
.27404 .17866 Mdot
.27499 .17993 Mdot
.27594 .58482 Mdot
.27689 .25778 Mdot
.27784 .42751 Mdot
.27879 .42624 Mdot
.27974 .02135 Mdot
.2807 .34839 Mdot
.28165 .17866 Mdot
.2826 .17993 Mdot
.28355 .58482 Mdot
.2845 .25778 Mdot
.28545 .42751 Mdot
.2864 .42624 Mdot
.28736 .02135 Mdot
.28831 .34839 Mdot
.28926 .17866 Mdot
.29021 .17993 Mdot
.29116 .58482 Mdot
.29211 .25778 Mdot
.29306 .42751 Mdot
.29402 .42624 Mdot
.29497 .02135 Mdot
.29592 .34839 Mdot
.29687 .17866 Mdot
.29782 .17993 Mdot
.29877 .58482 Mdot
.29972 .25778 Mdot
.30068 .42751 Mdot
.30163 .42624 Mdot
.30258 .02135 Mdot
.30353 .34839 Mdot
.30448 .17866 Mdot
.30543 .17993 Mdot
.30638 .58482 Mdot
.30734 .25778 Mdot
.30829 .42751 Mdot
.30924 .42624 Mdot
.31019 .02135 Mdot
.31114 .34839 Mdot
.31209 .17866 Mdot
.31304 .17993 Mdot
.314 .58482 Mdot
.31495 .25778 Mdot
.3159 .42751 Mdot
.31685 .42624 Mdot
.3178 .02135 Mdot
.31875 .34839 Mdot
.3197 .17866 Mdot
.32066 .17993 Mdot
.32161 .58482 Mdot
.32256 .25778 Mdot
.32351 .42751 Mdot
.32446 .42624 Mdot
.32541 .02135 Mdot
.32636 .34839 Mdot
.32732 .17866 Mdot
.32827 .17993 Mdot
.32922 .58482 Mdot
.33017 .25778 Mdot
.33112 .42751 Mdot
.33207 .42624 Mdot
.33302 .02135 Mdot
.33398 .34839 Mdot
.33493 .17866 Mdot
.33588 .17993 Mdot
.33683 .58482 Mdot
.33778 .25778 Mdot
.33873 .42751 Mdot
.33968 .42624 Mdot
.34064 .02135 Mdot
.34159 .34839 Mdot
.34254 .17866 Mdot
.34349 .17993 Mdot
.34444 .58482 Mdot
.34539 .25778 Mdot
.34634 .42751 Mdot
.3473 .42624 Mdot
.34825 .02135 Mdot
.3492 .34839 Mdot
.35015 .17866 Mdot
.3511 .17993 Mdot
.35205 .58482 Mdot
.353 .25778 Mdot
.35396 .42751 Mdot
.35491 .42624 Mdot
.35586 .02135 Mdot
.35681 .34839 Mdot
.35776 .17866 Mdot
.35871 .17993 Mdot
.35966 .58482 Mdot
.36062 .25778 Mdot
.36157 .42751 Mdot
.36252 .42624 Mdot
.36347 .02135 Mdot
.36442 .34839 Mdot
.36537 .17866 Mdot
.36632 .17993 Mdot
.36728 .58482 Mdot
.36823 .25778 Mdot
.36918 .42751 Mdot
.37013 .42624 Mdot
.37108 .02135 Mdot
.37203 .34839 Mdot
.37298 .17866 Mdot
.37394 .17993 Mdot
.37489 .58482 Mdot
.37584 .25778 Mdot
.37679 .42751 Mdot
.37774 .42624 Mdot
.37869 .02135 Mdot
.37964 .34839 Mdot
.3806 .17866 Mdot
.38155 .17993 Mdot
.3825 .58482 Mdot
.38345 .25778 Mdot
.3844 .42751 Mdot
.38535 .42624 Mdot
.3863 .02135 Mdot
.38726 .34839 Mdot
.38821 .17866 Mdot
.38916 .17993 Mdot
.39011 .58482 Mdot
.39106 .25778 Mdot
.39201 .42751 Mdot
.39296 .42624 Mdot
.39392 .02135 Mdot
.39487 .34839 Mdot
.39582 .17866 Mdot
.39677 .17993 Mdot
.39772 .58482 Mdot
.39867 .25778 Mdot
.39962 .42751 Mdot
.40058 .42624 Mdot
.40153 .02135 Mdot
.40248 .34839 Mdot
.40343 .17866 Mdot
.40438 .17993 Mdot
.40533 .58482 Mdot
.40628 .25778 Mdot
.40724 .42751 Mdot
.40819 .42624 Mdot
.40914 .02135 Mdot
.41009 .34839 Mdot
.41104 .17866 Mdot
.41199 .17993 Mdot
.41294 .58482 Mdot
.4139 .25778 Mdot
.41485 .42751 Mdot
.4158 .42624 Mdot
.41675 .02135 Mdot
.4177 .34839 Mdot
.41865 .17866 Mdot
.4196 .17993 Mdot
.42056 .58482 Mdot
.42151 .25778 Mdot
.42246 .42751 Mdot
.42341 .42624 Mdot
.42436 .02135 Mdot
.42531 .34839 Mdot
.42626 .17866 Mdot
.42722 .17993 Mdot
.42817 .58482 Mdot
.42912 .25778 Mdot
.43007 .42751 Mdot
.43102 .42624 Mdot
.43197 .02135 Mdot
.43292 .34839 Mdot
.43388 .17866 Mdot
.43483 .17993 Mdot
.43578 .58482 Mdot
.43673 .25778 Mdot
.43768 .42751 Mdot
.43863 .42624 Mdot
.43958 .02135 Mdot
.44054 .34839 Mdot
.44149 .17866 Mdot
.44244 .17993 Mdot
.44339 .58482 Mdot
.44434 .25778 Mdot
.44529 .42751 Mdot
.44624 .42624 Mdot
.4472 .02135 Mdot
.44815 .34839 Mdot
.4491 .17866 Mdot
.45005 .17993 Mdot
.451 .58482 Mdot
.45195 .25778 Mdot
.4529 .42751 Mdot
.45386 .42624 Mdot
.45481 .02135 Mdot
.45576 .34839 Mdot
.45671 .17866 Mdot
.45766 .17993 Mdot
.45861 .58482 Mdot
.45956 .25778 Mdot
.46052 .42751 Mdot
.46147 .42624 Mdot
.46242 .02135 Mdot
.46337 .34839 Mdot
.46432 .17866 Mdot
.46527 .17993 Mdot
.46622 .58482 Mdot
.46718 .25778 Mdot
.46813 .42751 Mdot
.46908 .42624 Mdot
.47003 .02135 Mdot
.47098 .34839 Mdot
.47193 .17866 Mdot
.47288 .17993 Mdot
.47384 .58482 Mdot
.47479 .25778 Mdot
.47574 .42751 Mdot
.47669 .42624 Mdot
.47764 .02135 Mdot
.47859 .34839 Mdot
.47954 .17866 Mdot
.4805 .17993 Mdot
.48145 .58482 Mdot
.4824 .25778 Mdot
.48335 .42751 Mdot
.4843 .42624 Mdot
.48525 .02135 Mdot
.4862 .34839 Mdot
.48716 .17866 Mdot
.48811 .17993 Mdot
.48906 .58482 Mdot
.49001 .25778 Mdot
.49096 .42751 Mdot
.49191 .42624 Mdot
.49286 .02135 Mdot
.49382 .34839 Mdot
.49477 .17866 Mdot
.49572 .17993 Mdot
.49667 .58482 Mdot
.49762 .25778 Mdot
.49857 .42751 Mdot
.49952 .42624 Mdot
.50048 .02135 Mdot
.50143 .34839 Mdot
.50238 .17866 Mdot
.50333 .17993 Mdot
.50428 .58482 Mdot
.50523 .25778 Mdot
.50618 .42751 Mdot
.50714 .42624 Mdot
.50809 .02135 Mdot
.50904 .34839 Mdot
.50999 .17866 Mdot
.51094 .17993 Mdot
.51189 .58482 Mdot
.51284 .25778 Mdot
.5138 .42751 Mdot
.51475 .42624 Mdot
.5157 .02135 Mdot
.51665 .34839 Mdot
.5176 .17866 Mdot
.51855 .17993 Mdot
.5195 .58482 Mdot
.52046 .25778 Mdot
.52141 .42751 Mdot
.52236 .42624 Mdot
.52331 .02135 Mdot
.52426 .34839 Mdot
.52521 .17866 Mdot
.52616 .17993 Mdot
.52712 .58482 Mdot
.52807 .25778 Mdot
.52902 .42751 Mdot
.52997 .42624 Mdot
.53092 .02135 Mdot
.53187 .34839 Mdot
.53282 .17866 Mdot
.53378 .17993 Mdot
.53473 .58482 Mdot
.53568 .25778 Mdot
.53663 .42751 Mdot
.53758 .42624 Mdot
.53853 .02135 Mdot
.53948 .34839 Mdot
.54044 .17866 Mdot
.54139 .17993 Mdot
.54234 .58482 Mdot
.54329 .25778 Mdot
.54424 .42751 Mdot
.54519 .42624 Mdot
.54614 .02135 Mdot
.5471 .34839 Mdot
.54805 .17866 Mdot
.549 .17993 Mdot
.54995 .58482 Mdot
.5509 .25778 Mdot
.55185 .42751 Mdot
.5528 .42624 Mdot
.55376 .02135 Mdot
.55471 .34839 Mdot
.55566 .17866 Mdot
.55661 .17993 Mdot
.55756 .58482 Mdot
.55851 .25778 Mdot
.55946 .42751 Mdot
.56042 .42624 Mdot
.56137 .02135 Mdot
.56232 .34839 Mdot
.56327 .17866 Mdot
.56422 .17993 Mdot
.56517 .58482 Mdot
.56612 .25778 Mdot
.56708 .42751 Mdot
.56803 .42624 Mdot
.56898 .02135 Mdot
.56993 .34839 Mdot
.57088 .17866 Mdot
.57183 .17993 Mdot
.57278 .58482 Mdot
.57374 .25778 Mdot
.57469 .42751 Mdot
.57564 .42624 Mdot
.57659 .02135 Mdot
.57754 .34839 Mdot
.57849 .17866 Mdot
.57944 .17993 Mdot
.5804 .58482 Mdot
.58135 .25778 Mdot
.5823 .42751 Mdot
.58325 .42624 Mdot
.5842 .02135 Mdot
.58515 .34839 Mdot
.5861 .17866 Mdot
.58706 .17993 Mdot
.58801 .58482 Mdot
.58896 .25778 Mdot
.58991 .42751 Mdot
.59086 .42624 Mdot
.59181 .02135 Mdot
.59276 .34839 Mdot
.59372 .17866 Mdot
.59467 .17993 Mdot
.59562 .58482 Mdot
.59657 .25778 Mdot
.59752 .42751 Mdot
.59847 .42624 Mdot
.59942 .02135 Mdot
.60038 .34839 Mdot
.60133 .17866 Mdot
.60228 .17993 Mdot
.60323 .58482 Mdot
.60418 .25778 Mdot
.60513 .42751 Mdot
.60608 .42624 Mdot
.60704 .02135 Mdot
.60799 .34839 Mdot
.60894 .17866 Mdot
.60989 .17993 Mdot
.61084 .58482 Mdot
.61179 .25778 Mdot
.61274 .42751 Mdot
.6137 .42624 Mdot
.61465 .02135 Mdot
.6156 .34839 Mdot
.61655 .17866 Mdot
.6175 .17993 Mdot
.61845 .58482 Mdot
.6194 .25778 Mdot
.62036 .42751 Mdot
.62131 .42624 Mdot
.62226 .02135 Mdot
.62321 .34839 Mdot
.62416 .17866 Mdot
.62511 .17993 Mdot
.62606 .58482 Mdot
.62702 .25778 Mdot
.62797 .42751 Mdot
.62892 .42624 Mdot
.62987 .02135 Mdot
.63082 .34839 Mdot
.63177 .17866 Mdot
.63272 .17993 Mdot
.63368 .58482 Mdot
.63463 .25778 Mdot
.63558 .42751 Mdot
.63653 .42624 Mdot
.63748 .02135 Mdot
.63843 .34839 Mdot
.63938 .17866 Mdot
.64034 .17993 Mdot
.64129 .58482 Mdot
.64224 .25778 Mdot
.64319 .42751 Mdot
.64414 .42624 Mdot
.64509 .02135 Mdot
.64604 .34839 Mdot
.647 .17866 Mdot
.64795 .17993 Mdot
.6489 .58482 Mdot
.64985 .25778 Mdot
.6508 .42751 Mdot
.65175 .42624 Mdot
.6527 .02135 Mdot
.65366 .34839 Mdot
.65461 .17866 Mdot
.65556 .17993 Mdot
.65651 .58482 Mdot
.65746 .25778 Mdot
.65841 .42751 Mdot
.65936 .42624 Mdot
.66032 .02135 Mdot
.66127 .34839 Mdot
.66222 .17866 Mdot
.66317 .17993 Mdot
.66412 .58482 Mdot
.66507 .25778 Mdot
.66602 .42751 Mdot
.66698 .42624 Mdot
.66793 .02135 Mdot
.66888 .34839 Mdot
.66983 .17866 Mdot
.67078 .17993 Mdot
.67173 .58482 Mdot
.67268 .25778 Mdot
.67364 .42751 Mdot
.67459 .42624 Mdot
.67554 .02135 Mdot
.67649 .34839 Mdot
.67744 .17866 Mdot
.67839 .17993 Mdot
.67934 .58482 Mdot
.6803 .25778 Mdot
.68125 .42751 Mdot
.6822 .42624 Mdot
.68315 .02135 Mdot
.6841 .34839 Mdot
.68505 .17866 Mdot
.686 .17993 Mdot
.68696 .58482 Mdot
.68791 .25778 Mdot
.68886 .42751 Mdot
.68981 .42624 Mdot
.69076 .02135 Mdot
.69171 .34839 Mdot
.69266 .17866 Mdot
.69362 .17993 Mdot
.69457 .58482 Mdot
.69552 .25778 Mdot
.69647 .42751 Mdot
.69742 .42624 Mdot
.69837 .02135 Mdot
.69932 .34839 Mdot
.70028 .17866 Mdot
.70123 .17993 Mdot
.70218 .58482 Mdot
.70313 .25778 Mdot
.70408 .42751 Mdot
.70503 .42624 Mdot
.70598 .02135 Mdot
.70694 .34839 Mdot
.70789 .17866 Mdot
.70884 .17993 Mdot
.70979 .58482 Mdot
.71074 .25778 Mdot
.71169 .42751 Mdot
.71264 .42624 Mdot
.7136 .02135 Mdot
.71455 .34839 Mdot
.7155 .17866 Mdot
.71645 .17993 Mdot
.7174 .58482 Mdot
.71835 .25778 Mdot
.7193 .42751 Mdot
.72026 .42624 Mdot
.72121 .02135 Mdot
.72216 .34839 Mdot
.72311 .17866 Mdot
.72406 .17993 Mdot
.72501 .58482 Mdot
.72596 .25778 Mdot
.72692 .42751 Mdot
.72787 .42624 Mdot
.72882 .02135 Mdot
.72977 .34839 Mdot
.73072 .17866 Mdot
.73167 .17993 Mdot
.73262 .58482 Mdot
.73358 .25778 Mdot
.73453 .42751 Mdot
.73548 .42624 Mdot
.73643 .02135 Mdot
.73738 .34839 Mdot
.73833 .17866 Mdot
.73928 .17993 Mdot
.74024 .58482 Mdot
.74119 .25778 Mdot
.74214 .42751 Mdot
.74309 .42624 Mdot
.74404 .02135 Mdot
.74499 .34839 Mdot
.74594 .17866 Mdot
.7469 .17993 Mdot
.74785 .58482 Mdot
.7488 .25778 Mdot
.74975 .42751 Mdot
.7507 .42624 Mdot
.75165 .02135 Mdot
.7526 .34839 Mdot
.75356 .17866 Mdot
.75451 .17993 Mdot
.75546 .58482 Mdot
.75641 .25778 Mdot
.75736 .42751 Mdot
.75831 .42624 Mdot
.75926 .02135 Mdot
.76022 .34839 Mdot
.76117 .17866 Mdot
.76212 .17993 Mdot
.76307 .58482 Mdot
.76402 .25778 Mdot
.76497 .42751 Mdot
.76592 .42624 Mdot
.76688 .02135 Mdot
.76783 .34839 Mdot
.76878 .17866 Mdot
.76973 .17993 Mdot
.77068 .58482 Mdot
.77163 .25778 Mdot
.77258 .42751 Mdot
.77354 .42624 Mdot
.77449 .02135 Mdot
.77544 .34839 Mdot
.77639 .17866 Mdot
.77734 .17993 Mdot
.77829 .58482 Mdot
.77924 .25778 Mdot
.7802 .42751 Mdot
.78115 .42624 Mdot
.7821 .02135 Mdot
.78305 .34839 Mdot
.784 .17866 Mdot
.78495 .17993 Mdot
.7859 .58482 Mdot
.78686 .25778 Mdot
.78781 .42751 Mdot
.78876 .42624 Mdot
.78971 .02135 Mdot
.79066 .34839 Mdot
.79161 .17866 Mdot
.79256 .17993 Mdot
.79352 .58482 Mdot
.79447 .25778 Mdot
.79542 .42751 Mdot
.79637 .42624 Mdot
.79732 .02135 Mdot
.79827 .34839 Mdot
.79922 .17866 Mdot
.80018 .17993 Mdot
.80113 .58482 Mdot
.80208 .25778 Mdot
.80303 .42751 Mdot
.80398 .42624 Mdot
.80493 .02135 Mdot
.80588 .34839 Mdot
.80684 .17866 Mdot
.80779 .17993 Mdot
.80874 .58482 Mdot
.80969 .25778 Mdot
.81064 .42751 Mdot
.81159 .42624 Mdot
.81254 .02135 Mdot
.8135 .34839 Mdot
.81445 .17866 Mdot
.8154 .17993 Mdot
.81635 .58482 Mdot
.8173 .25778 Mdot
.81825 .42751 Mdot
.8192 .42624 Mdot
.82016 .02135 Mdot
.82111 .34839 Mdot
.82206 .17866 Mdot
.82301 .17993 Mdot
.82396 .58482 Mdot
.82491 .25778 Mdot
.82586 .42751 Mdot
.82682 .42624 Mdot
.82777 .02135 Mdot
.82872 .34839 Mdot
.82967 .17866 Mdot
.83062 .17993 Mdot
.83157 .58482 Mdot
.83252 .25778 Mdot
.83348 .42751 Mdot
.83443 .42624 Mdot
.83538 .02135 Mdot
.83633 .34839 Mdot
.83728 .17866 Mdot
.83823 .17993 Mdot
.83918 .58482 Mdot
.84014 .25778 Mdot
.84109 .42751 Mdot
.84204 .42624 Mdot
.84299 .02135 Mdot
.84394 .34839 Mdot
.84489 .17866 Mdot
.84584 .17993 Mdot
.8468 .58482 Mdot
.84775 .25778 Mdot
.8487 .42751 Mdot
.84965 .42624 Mdot
.8506 .02135 Mdot
.85155 .34839 Mdot
.8525 .17866 Mdot
.85346 .17993 Mdot
.85441 .58482 Mdot
.85536 .25778 Mdot
.85631 .42751 Mdot
.85726 .42624 Mdot
.85821 .02135 Mdot
.85916 .34839 Mdot
.86012 .17866 Mdot
.86107 .17993 Mdot
.86202 .58482 Mdot
.86297 .25778 Mdot
.86392 .42751 Mdot
.86487 .42624 Mdot
.86582 .02135 Mdot
.86678 .34839 Mdot
.86773 .17866 Mdot
.86868 .17993 Mdot
.86963 .58482 Mdot
.87058 .25778 Mdot
.87153 .42751 Mdot
.87248 .42624 Mdot
.87344 .02135 Mdot
.87439 .34839 Mdot
.87534 .17866 Mdot
.87629 .17993 Mdot
.87724 .58482 Mdot
.87819 .25778 Mdot
.87914 .42751 Mdot
.8801 .42624 Mdot
.88105 .02135 Mdot
.882 .34839 Mdot
.88295 .17866 Mdot
.8839 .17993 Mdot
.88485 .58482 Mdot
.8858 .25778 Mdot
.88676 .42751 Mdot
.88771 .42624 Mdot
.88866 .02135 Mdot
.88961 .34839 Mdot
.89056 .17866 Mdot
.89151 .17993 Mdot
.89246 .58482 Mdot
.89342 .25778 Mdot
.89437 .42751 Mdot
.89532 .42624 Mdot
.89627 .02135 Mdot
.89722 .34839 Mdot
.89817 .17866 Mdot
.89912 .17993 Mdot
.90008 .58482 Mdot
.90103 .25778 Mdot
.90198 .42751 Mdot
.90293 .42624 Mdot
.90388 .02135 Mdot
.90483 .34839 Mdot
.90578 .17866 Mdot
.90674 .17993 Mdot
.90769 .58482 Mdot
.90864 .25778 Mdot
.90959 .42751 Mdot
.91054 .42624 Mdot
.91149 .02135 Mdot
.91244 .34839 Mdot
.9134 .17866 Mdot
.91435 .17993 Mdot
.9153 .58482 Mdot
.91625 .25778 Mdot
.9172 .42751 Mdot
.91815 .42624 Mdot
.9191 .02135 Mdot
.92006 .34839 Mdot
.92101 .17866 Mdot
.92196 .17993 Mdot
.92291 .58482 Mdot
.92386 .25778 Mdot
.92481 .42751 Mdot
.92576 .42624 Mdot
.92672 .02135 Mdot
.92767 .34839 Mdot
.92862 .17866 Mdot
.92957 .17993 Mdot
.93052 .58482 Mdot
.93147 .25778 Mdot
.93242 .42751 Mdot
.93338 .42624 Mdot
.93433 .02135 Mdot
.93528 .34839 Mdot
.93623 .17866 Mdot
.93718 .17993 Mdot
.93813 .58482 Mdot
.93908 .25778 Mdot
.94004 .42751 Mdot
.94099 .42624 Mdot
.94194 .02135 Mdot
.94289 .34839 Mdot
.94384 .17866 Mdot
.94479 .17993 Mdot
.94574 .58482 Mdot
.9467 .25778 Mdot
.94765 .42751 Mdot
.9486 .42624 Mdot
.94955 .02135 Mdot
.9505 .34839 Mdot
.95145 .17866 Mdot
.9524 .17993 Mdot
.95336 .58482 Mdot
.95431 .25778 Mdot
.95526 .42751 Mdot
.95621 .42624 Mdot
.95716 .02135 Mdot
.95811 .34839 Mdot
.95906 .17866 Mdot
.96002 .17993 Mdot
.96097 .58482 Mdot
.96192 .25778 Mdot
.96287 .42751 Mdot
.96382 .42624 Mdot
.96477 .02135 Mdot
.96572 .34839 Mdot
.96668 .17866 Mdot
.96763 .17993 Mdot
.96858 .58482 Mdot
.96953 .25778 Mdot
.97048 .42751 Mdot
.97143 .42624 Mdot
.97238 .02135 Mdot
.97334 .34839 Mdot
.97429 .17866 Mdot
.97524 .17993 Mdot
.97619 .58482 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`008@3oool00`000000oooo0?oo
o`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?oo
o`008@3oool00`000000oooo0?ooo`3l0?ooo`00203oool2000000@0oooo0P0000040?ooo`800000
0`3oool3000000D0oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`3f0?ooo`001`3o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool00000103oool00`000000oooo000000030?ooo`050000003oool0oooo0?ooo`0000000`3oool0
1@000000oooo0?ooo`3oool0000000<0oooo00@000000?ooo`000000oooo0P0000006`3oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000M0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000006`3oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001d0oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool00P0000001P3oool000000?ooo`000000oooo
000000h0oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000040?ooo`8000001P3oool04P000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`80000001/0oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000007@3oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000006`3oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000M0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000006`3oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000000H0oooo0000003oool00000
0?ooo`00000>0?ooo`0000<0oooo0000000000000P0000020?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool000000P3oool3000000D0oooo00D000000?ooo`3oool0oooo00000003
0?ooo`050000003oool0oooo0?ooo`0000000`3oool01@000000oooo0?ooo`3oool000000>X0oooo
00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000`3oool00`000000
oooo0?ooo`040?ooo`050000003oool0oooo0?ooo`000000nP3oool000P0oooo0P00000:0?ooo`80
0000103oool3000000@0oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0
o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?ooo`008@3oool00`00
0000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo
0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l
0?ooo`008@3oool200000?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000
003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0
oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`800000o@3oool00240oooo
00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<00000
0?ooo`3oool0o03oool000P0oooo0P0000040?ooo`800000103oool2000000D0oooo0`0000030?oo
o`030000003oool0oooo0?`0oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?oo
o`3oool000001@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0?`0oooo00070?oo
o`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool5000000<0oooo0P00
003m0?ooo`0000<0oooo0000000000000P0000020?ooo`040000003oool0oooo000000P0oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0?`0
oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000`3oool00`00
0000oooo000000040?ooo`030000003oool0oooo0?`0oooo00080?ooo`8000002P3oool2000000D0
oooo0P0000040?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo
000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`800000o@3oool00240oooo00<000000?oo
o`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0
o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool0
0240oooo0P00003m0?ooo`008@3oool200000?d0oooo000Q0?ooo`8000000`3oool00`000000oooo
0?ooo`3g0?ooo`008@3oool2000000<0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000
0P3oool060000000oooo0?ooo`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`80000001d0oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000007@3oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000006`3oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`020000000F0?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo000000d0oooo000Q0?ooo`030000003oool0oooo0080oooo00H000000?ooo`000000oooo
0000003oool:0000000C0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`0:0000000E0?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo00P0000001D0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool02P0000004`3oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
2P0000005@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`080000000E0?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo00X0000001<0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo00X0000000h0oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo000000d0oooo000Q0?ooo`040000003oool0oooo0000
00<0oooo00D000000?ooo`3oool0oooo000000020?ooo`80000000<0oooo0000000000000P000000
6`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001d0oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000K0?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000007@3oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000001/0oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P0000003P3oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000003@3oool00240oooo0P00
00000`3oool000000?ooo`020?ooo`030000003oool0oooo0?D0oooo000Q0?ooo`040000003oool0
oooo00000?/0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo
0?`0oooo00080?ooo`800000103oool2000000@0oooo0P0000030?ooo`@00000103oool00`000000
oooo0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000
oooo0?ooo`0000080?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool0103oool2
00000?d0oooo00000`3oool000000000000200000080oooo00@000000?ooo`3oool00000203oool0
10000000oooo0?ooo`0000040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0o03o
ool000L0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000000@0oooo00<000000?ooo`3oool0o03oool000P0oooo0P00000:0?ooo`800000
103oool2000000D0oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03o
ool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?ooo`008@3oool00`000000
oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?oo
o`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo000000020?oo
o`050000003oool0oooo0?ooo`0000000`3oool01@000000oooo0?ooo`3oool0000000<0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0=l0oooo000Q0?ooo`<0000001h0
oooo000000000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool2
000000050?ooo`000000oooo0000003oool01@0000001`3oool00000000000000000oooo0000003o
ool00`0000002@3oool000000?ooo`000000oooo0000003oool000000?ooo`020000000G0?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool0200000000`3oool000000?ooo`030000000C0?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`020000000=0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`03000000030?ooo`000000oooo00<0000000<0oooo0000003oool0100000007@3o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo00800000
00L0oooo00000000000000000?ooo`000000oooo00<0000000<0oooo0000003oool00`0000002`3o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo008000000140oooo0000003o
ool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`07
000000040?ooo`0000000000000000<0oooo0P0000040?ooo`8000000`3oool00240oooo00D00000
0?ooo`3oool0oooo000000020?ooo`050000003oool0oooo0?ooo`0000000`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0oooo000000030?ooo`0A0000003oool00000
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00`00
00000`3oool000000?ooo`03000000070?ooo`000000oooo0000003oool000000?ooo`020000000K
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080000000L0oooo
00000000000000000?ooo`000000oooo00<000000140oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`020000000?0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo00<0000000<0oooo
0000003oool00`0000000`3oool000000?ooo`020000000M0?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool00P0000000`3oool000000?ooo`0300000003
0?ooo`000000oooo00<0000000<0oooo0000003oool00`0000002@3oool000000?ooo`000000oooo
0000003oool000000?ooo`020000000C0?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`03000000060?ooo`0000000000
0000003oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080
oooo000Q0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool00P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000200oooo1@0000001@3oool000000?ooo`3oool0
00000080oooo00@000000?ooo`3oool000008@3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool00000803oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000803oool01@000000oooo
0?ooo`3oool000000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000002
0?ooo`4000000@3oool10?ooo`008@3oool00`000000oooo0?ooo`0W0?ooo`050000003oool0oooo
0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo01h0oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
0240oooo0`0000030?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000008@3o
ool2000000<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000P0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo0@0000010?ooo`40oooo000Q0?ooo`030000003oool0oooo02D0oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000240
oooo00<000000?ooo`0000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000280oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo00000200oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000200oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000P3oool100000040oooo0@3oool00240oooo
00<000000?ooo`3oool09P3oool2000000@0oooo0P0000040?ooo`8000008`3oool2000000<0oooo
0P0000040?ooo`8000008`3oool3000000<0oooo0P0000040?ooo`8000008P3oool2000000@0oooo
0P0000040?ooo`800000803oool2000000@0oooo0P0000040?ooo`800000103oool2000000<0oooo
000Q0?ooo`800000o@3oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?oo
o`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0
o03oool00240oooo00<000000?ooo`3oool0o03oool001/0ooooo`0000060?ooo`008@3oool00`00
0000oooo0?ooo`0]0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0;P3oool00`00
0000oooo0?ooo`0]0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool02P3oool00240
oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<0
00000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?oo
o`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3o
ool00`000000oooo0?ooo`3l0?ooo`008@3oool010000000oooo0?ooo`0000020?ooo`050000003o
ool0oooo0?ooo`0000000`3oool01@000000oooo0?ooo`3oool000000>`0oooo000Q0?ooo`800000
0200oooo000000000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`80000001/0oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`020000000M0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080
000001/0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P000000
7P3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
00d0oooo000Q0?ooo`8000000P3oool01@000000oooo0?ooo`3oool0000000<0oooo00D000000?oo
o`3oool0oooo000000030?ooo`0>0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool20000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool00P0000007@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0080000001h0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`00000=0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?oo
o`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?oo
o`008@3oool200000?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003o
ool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo00080?ooo`800000103oool20000
00@0oooo0P0000030?ooo`@00000103oool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000
oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0
oooo000000<0oooo00<000000?ooo`3oool0103oool200000?d0oooo00070?ooo`040000003oool0
oooo000000P0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo0?`0oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0?`0oooo00080?ooo`80
00002P3oool2000000@0oooo0P0000050?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000
003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`800000o@3oool0
0240oooo00D000000?ooo`3oool0oooo000000030?ooo`0:0000003oool0oooo0?ooo`000000oooo
0000003oool000000?ooo`80000001d0oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool00P0000007@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0080000000h0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo000000h0oooo000Q0?ooo`0<0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo200000005@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`0:0000000C0?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`0:0000000E0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo00P0000001D0oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool02P0000004`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool02P0000004`3oool000000?ooo`000000oooo
0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool02P00
00005@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`080000000>0?ooo`000000oooo0000003oool00000
0?ooo`000000oooo0000003oool000000?ooo`00000>0?ooo`008@3oool00`000000oooo00000003
0?ooo`050000003oool0oooo0?ooo`0000000P3oool070000000oooo0000003oool000000?ooo`00
0000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003o
ool000000?ooo`000000oooo0000003oool20000000K0?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0080000001d0oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`020000000K0?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`020000000M0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool00P000000503oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000003P3oool00240oooo00<0
00000?ooo`000000o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?oo
o`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3o
ool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`00
0000oooo0?ooo`3l0?ooo`008@3oool200000?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo
000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo00080?oo
o`800000103oool2000000@0oooo0P0000050?ooo`<000000`3oool00`000000oooo0?ooo`3l0?oo
o`001`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000000D0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo00000080oooo1@0000030?ooo`800000o@3oool000L0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0
oooo00<000000?ooo`3oool0o03oool000L0oooo00@000000?ooo`3oool00000203oool010000000
oooo0?ooo`0000030?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool0o03oool000P0
oooo0P00000:0?ooo`8000001@3oool2000000@0oooo00<000000?ooo`3oool0o03oool00240oooo
00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m
0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`00
8@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool0
0`000000oooo0?ooo`3l0?ooo`00803oool300000?d0oooo000P0?ooo`800000oP3oool00240oooo
00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<00000
0?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?ooo`00
8@3oool010000000oooo0?ooo`00003k0?ooo`008@3oool010000000oooo0?ooo`00003k0?ooo`00
8@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0?D0oooo00080?ooo`800000103o
ool2000000@0oooo0P0000030?ooo`<000001@3oool00`000000oooo0?ooo`040?ooo`050000003o
ool0oooo0?ooo`000000l`3oool000L0oooo00@000000?ooo`3oool00000203oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0203oool01@00
0000oooo0?ooo`3oool0000000<0oooo00D000000?ooo`3oool0oooo0000003W0?ooo`001`3oool0
10000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
0000103oool2000000/0oooo00h000000?ooo`000000oooo0000003oool000000?ooo`000000oooo
0000003oool000000?ooo`80000001/0oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0080000001d0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0080000001/0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
0P0000007@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool0
00000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000
oooo0080000000H0oooo0000003oool000000?ooo`00000=0?ooo`001`3oool010000000oooo0?oo
o`0000080?ooo`040000003oool0oooo00000080oooo0`0000050?ooo`030000003oool0oooo00H0
oooo00D000000?ooo`3oool0oooo000000030?ooo`050000003oool0oooo0?ooo`0000000`3oool0
7`000000oooo000000000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool00P0000006`3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080
000001d0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`020000000K0?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080
000001/0oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000
003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool00P000000
7@3oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?oo
o`000000oooo0000003oool000000?ooo`000000oooo0000003oool000000?ooo`000000oooo0080
000000H0oooo0000003oool000000?ooo`00000=0?ooo`001`3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`020?ooo`050000003oool0oooo0?ooo`000000m@3oool000P0oooo0P00000:0?ooo`800000103o
ool3000000@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`3g0?ooo`008@3oool2
00000?d0oooo000Q0?ooo`800000o@3oool00240oooo0P00003m0?ooo`008@3oool00`000000oooo
0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-137.202, -0.0726286, \
4.1353, 0.000835178}}]
}, Open  ]],

Cell[TextData[StyleBox["In the chaotic regime of the logistic function, any \
two points eventualy have divergent histories. You may not always see it \
though, due to calculation precision limits. One way to get Mathematica to \
use, say 400 digits of precision is to put `400 in front of the numbers. If \
you increase precision from 400 digits to say, 800, the graph will remain \
chaotic longer.",
  FontColor->RGBColor[1, 0.501961, 1]]], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(Clear[fg];\)\), "\[IndentingNewLine]", 
    \(\(r\  = \ 3.989`400;\)\), "\[IndentingNewLine]", 
    \(\(fg[x_]\  := \ r\ x \((1 - x)\);\)\), "\[IndentingNewLine]", 
    \(\(h1\  = \ 
        NestList[fg, \ 0.700000000000000000000`400, \ 
          1000];\)\), "\[IndentingNewLine]", 
    \(\(h2\  = \ 
        NestList[fg, \ 0.700000000000000010000`400, \ 
          1000];\)\), "\[IndentingNewLine]", 
    \(\(ListPlot[h2 - h1, \ PlotJoined\  \[Rule] False];\)\)}], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.00095143 0.304037 0.300122 [
[.2141 .29154 -9 -9 ]
[.2141 .29154 9 0 ]
[.40438 .29154 -9 -9 ]
[.40438 .29154 9 0 ]
[.59467 .29154 -9 -9 ]
[.59467 .29154 9 0 ]
[.78495 .29154 -9 -9 ]
[.78495 .29154 9 0 ]
[.97524 .29154 -12 -9 ]
[.97524 .29154 12 0 ]
[.01131 .00391 -12 -4.5 ]
[.01131 .00391 0 4.5 ]
[.01131 .15398 -24 -4.5 ]
[.01131 .15398 0 4.5 ]
[.01131 .4541 -18 -4.5 ]
[.01131 .4541 0 4.5 ]
[.01131 .60416 -6 -4.5 ]
[.01131 .60416 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2141 .30404 m
.2141 .31029 L
s
[(200)] .2141 .29154 0 1 Mshowa
.40438 .30404 m
.40438 .31029 L
s
[(400)] .40438 .29154 0 1 Mshowa
.59467 .30404 m
.59467 .31029 L
s
[(600)] .59467 .29154 0 1 Mshowa
.78495 .30404 m
.78495 .31029 L
s
[(800)] .78495 .29154 0 1 Mshowa
.97524 .30404 m
.97524 .31029 L
s
[(1000)] .97524 .29154 0 1 Mshowa
.125 Mabswid
.07138 .30404 m
.07138 .30779 L
s
.11895 .30404 m
.11895 .30779 L
s
.16652 .30404 m
.16652 .30779 L
s
.26167 .30404 m
.26167 .30779 L
s
.30924 .30404 m
.30924 .30779 L
s
.35681 .30404 m
.35681 .30779 L
s
.45195 .30404 m
.45195 .30779 L
s
.49952 .30404 m
.49952 .30779 L
s
.5471 .30404 m
.5471 .30779 L
s
.64224 .30404 m
.64224 .30779 L
s
.68981 .30404 m
.68981 .30779 L
s
.73738 .30404 m
.73738 .30779 L
s
.83252 .30404 m
.83252 .30779 L
s
.8801 .30404 m
.8801 .30779 L
s
.92767 .30404 m
.92767 .30779 L
s
.25 Mabswid
0 .30404 m
1 .30404 L
s
.02381 .00391 m
.03006 .00391 L
s
[(-1)] .01131 .00391 1 0 Mshowa
.02381 .15398 m
.03006 .15398 L
s
[(-0.5)] .01131 .15398 1 0 Mshowa
.02381 .4541 m
.03006 .4541 L
s
[(0.5)] .01131 .4541 1 0 Mshowa
.02381 .60416 m
.03006 .60416 L
s
[(1)] .01131 .60416 1 0 Mshowa
.125 Mabswid
.02381 .03393 m
.02756 .03393 L
s
.02381 .06394 m
.02756 .06394 L
s
.02381 .09395 m
.02756 .09395 L
s
.02381 .12396 m
.02756 .12396 L
s
.02381 .18399 m
.02756 .18399 L
s
.02381 .214 m
.02756 .214 L
s
.02381 .24401 m
.02756 .24401 L
s
.02381 .27402 m
.02756 .27402 L
s
.02381 .33405 m
.02756 .33405 L
s
.02381 .36406 m
.02756 .36406 L
s
.02381 .39407 m
.02756 .39407 L
s
.02381 .42409 m
.02756 .42409 L
s
.02381 .48411 m
.02756 .48411 L
s
.02381 .51412 m
.02756 .51412 L
s
.02381 .54413 m
.02756 .54413 L
s
.02381 .57415 m
.02756 .57415 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02476 .30404 Mdot
.02571 .30404 Mdot
.02666 .30404 Mdot
.02762 .30404 Mdot
.02857 .30404 Mdot
.02952 .30404 Mdot
.03047 .30404 Mdot
.03142 .30404 Mdot
.03237 .30404 Mdot
.03332 .30404 Mdot
.03428 .30404 Mdot
.03523 .30404 Mdot
.03618 .30404 Mdot
.03713 .30404 Mdot
.03808 .30404 Mdot
.03903 .30404 Mdot
.03998 .30404 Mdot
.04094 .30404 Mdot
.04189 .30404 Mdot
.04284 .30404 Mdot
.04379 .30404 Mdot
.04474 .30404 Mdot
.04569 .30404 Mdot
.04664 .30404 Mdot
.0476 .30404 Mdot
.04855 .30404 Mdot
.0495 .30404 Mdot
.05045 .30404 Mdot
.0514 .30404 Mdot
.05235 .30404 Mdot
.0533 .30404 Mdot
.05426 .30404 Mdot
.05521 .30404 Mdot
.05616 .30404 Mdot
.05711 .30404 Mdot
.05806 .30404 Mdot
.05901 .30404 Mdot
.05996 .30404 Mdot
.06092 .30404 Mdot
.06187 .30404 Mdot
.06282 .30404 Mdot
.06377 .30404 Mdot
.06472 .30404 Mdot
.06567 .30404 Mdot
.06662 .30403 Mdot
.06758 .30403 Mdot
.06853 .30404 Mdot
.06948 .30404 Mdot
.07043 .30404 Mdot
.07138 .30406 Mdot
.07233 .3041 Mdot
.07328 .30399 Mdot
.07424 .30422 Mdot
.07519 .30455 Mdot
.07614 .30396 Mdot
.07709 .30433 Mdot
.07804 .30518 Mdot
.07899 .30801 Mdot
.07994 .31232 Mdot
.0809 .28921 Mdot
.08185 .33902 Mdot
.0828 .26337 Mdot
.08375 .43349 Mdot
.0847 .46534 Mdot
.08565 .02812 Mdot
.0866 .36083 Mdot
.08756 .46186 Mdot
.08851 .3322 Mdot
.08946 .25471 Mdot
.09041 .42062 Mdot
.09136 .19228 Mdot
.09231 .56187 Mdot
.09326 .25181 Mdot
.09422 .20347 Mdot
.09517 .49235 Mdot
.09612 .05536 Mdot
.09707 .29482 Mdot
.09802 .29026 Mdot
.09897 .34319 Mdot
.09992 .30736 Mdot
.10088 .2913 Mdot
.10183 .26123 Mdot
.10278 .23146 Mdot
.10373 .47591 Mdot
.10468 .18413 Mdot
.10563 .43765 Mdot
.10658 .02661 Mdot
.10754 .36913 Mdot
.10849 .49012 Mdot
.10944 .39575 Mdot
.11039 .23185 Mdot
.11134 .51441 Mdot
.11229 .4597 Mdot
.11324 .33762 Mdot
.1142 .24347 Mdot
.11515 .43977 Mdot
.1161 .15041 Mdot
.11705 .56508 Mdot
.118 .18952 Mdot
.11895 .05801 Mdot
.1199 .42729 Mdot
.12086 .48953 Mdot
.12181 .02714 Mdot
.12276 .25246 Mdot
.12371 .15845 Mdot
.12466 .26739 Mdot
.12561 .37965 Mdot
.12656 .17399 Mdot
.12752 .56192 Mdot
.12847 .17328 Mdot
.12942 .03785 Mdot
.13037 .40645 Mdot
.13132 .5463 Mdot
.13227 .24526 Mdot
.13322 .23076 Mdot
.13418 .51543 Mdot
.13513 .44531 Mdot
.13608 .33277 Mdot
.13703 .24129 Mdot
.13798 .39881 Mdot
.13893 .06913 Mdot
.13988 .32798 Mdot
.14084 .32587 Mdot
.14179 .22759 Mdot
.14274 .13573 Mdot
.14369 .4769 Mdot
.14464 .14198 Mdot
.14559 .44797 Mdot
.14654 .1237 Mdot
.1475 .54789 Mdot
.14845 .26006 Mdot
.1494 .2468 Mdot
.15035 .47284 Mdot
.1513 .41724 Mdot
.15225 .16533 Mdot
.1532 .59317 Mdot
.15416 .27652 Mdot
.15511 .20991 Mdot
.15606 .12024 Mdot
.15701 .53895 Mdot
.15796 .26496 Mdot
.15891 .26804 Mdot
.15986 .4267 Mdot
.16082 .54375 Mdot
.16177 .12939 Mdot
.16272 .06409 Mdot
.16367 .38302 Mdot
.16462 .39665 Mdot
.16557 .05133 Mdot
.16652 .17438 Mdot
.16748 .06997 Mdot
.16843 .50362 Mdot
.16938 .55066 Mdot
.17033 .38169 Mdot
.17128 .417 Mdot
.17223 .0356 Mdot
.17318 .30848 Mdot
.17414 .31469 Mdot
.17509 .29242 Mdot
.17604 .34308 Mdot
.17699 .37034 Mdot
.17794 .14553 Mdot
.17889 .41839 Mdot
.17984 .13393 Mdot
.1808 .59417 Mdot
.18175 .31663 Mdot
.1827 .34771 Mdot
.18365 .39421 Mdot
.1846 .15372 Mdot
.18555 .58354 Mdot
.1865 .23626 Mdot
.18746 .10323 Mdot
.18841 .13777 Mdot
.18936 .31442 Mdot
.19031 .28822 Mdot
.19126 .34829 Mdot
.19221 .30262 Mdot
.19316 .30941 Mdot
.19412 .3214 Mdot
.19507 .3257 Mdot
.19602 .23553 Mdot
.19697 .23043 Mdot
.19792 .52304 Mdot
.19887 .50939 Mdot
.19982 .44962 Mdot
.20078 .30535 Mdot
.20173 .30127 Mdot
.20268 .30893 Mdot
.20363 .29231 Mdot
.20458 .31688 Mdot
.20553 .26095 Mdot
.20648 .23176 Mdot
.20744 .47723 Mdot
.20839 .19411 Mdot
.20934 .42673 Mdot
.21029 .02469 Mdot
.21124 .31672 Mdot
.21219 .34115 Mdot
.21314 .3163 Mdot
.2141 .25756 Mdot
.21505 .15385 Mdot
.216 .08708 Mdot
.21695 .50609 Mdot
.2179 .43017 Mdot
.21885 .28308 Mdot
.2198 .35743 Mdot
.22076 .26763 Mdot
.22171 .43084 Mdot
.22266 .58489 Mdot
.22361 .27761 Mdot
.22456 .22464 Mdot
.22551 .25577 Mdot
.22646 .45971 Mdot
.22742 .52828 Mdot
.22837 .12713 Mdot
.22932 .165 Mdot
.23027 .42831 Mdot
.23122 .07287 Mdot
.23217 .50581 Mdot
.23312 .53286 Mdot
.23408 .36629 Mdot
.23503 .3473 Mdot
.23598 .15767 Mdot
.23693 .02278 Mdot
.23788 .36831 Mdot
.23883 .49983 Mdot
.23978 .50727 Mdot
.24074 .29544 Mdot
.24169 .30677 Mdot
.24264 .29335 Mdot
.24359 .26474 Mdot
.24454 .19379 Mdot
.24549 .29257 Mdot
.24644 .33714 Mdot
.2474 .31115 Mdot
.24835 .27665 Mdot
.2493 .2099 Mdot
.25025 .11503 Mdot
.2512 .52492 Mdot
.25215 .27563 Mdot
.2531 .29407 Mdot
.25406 .34226 Mdot
.25501 .4337 Mdot
.25596 .55244 Mdot
.25691 .14333 Mdot
.25786 .03205 Mdot
.25881 .37303 Mdot
.25976 .48337 Mdot
.26072 .27382 Mdot
.26167 .33764 Mdot
.26262 .19423 Mdot
.26357 .14232 Mdot
.26452 .59797 Mdot
.26547 .30248 Mdot
.26642 .29832 Mdot
.26738 .28834 Mdot
.26833 .30709 Mdot
.26928 .29204 Mdot
.27023 .25913 Mdot
.27118 .16724 Mdot
.27213 .18761 Mdot
.27308 .5313 Mdot
.27404 .10756 Mdot
.27499 .11367 Mdot
.27594 .32077 Mdot
.27689 .29128 Mdot
.27784 .35063 Mdot
.27879 .43052 Mdot
.27974 .29265 Mdot
.2807 .33308 Mdot
.28165 .28357 Mdot
.2826 .37861 Mdot
.28355 .50616 Mdot
.2845 .34384 Mdot
.28545 .29054 Mdot
.2864 .35493 Mdot
.28736 .46455 Mdot
.28831 .50234 Mdot
.28926 .11999 Mdot
.29021 .3156 Mdot
.29116 .29279 Mdot
.29211 .3432 Mdot
.29306 .3865 Mdot
.29402 .17083 Mdot
.29497 .57867 Mdot
.29592 .22868 Mdot
.29687 .09812 Mdot
.29782 .24877 Mdot
.29877 .3143 Mdot
.29972 .26626 Mdot
.30068 .19776 Mdot
.30163 .29166 Mdot
.30258 .34072 Mdot
.30353 .32 Mdot
.30448 .2441 Mdot
.30543 .11825 Mdot
.30638 .08959 Mdot
.30734 .35811 Mdot
.30829 .31089 Mdot
.30924 .27866 Mdot
.31019 .23082 Mdot
.31114 .28568 Mdot
.31209 .3676 Mdot
.31304 .4347 Mdot
.314 .10842 Mdot
.31495 .56585 Mdot
.3159 .3848 Mdot
.31685 .47646 Mdot
.3178 .11231 Mdot
.31875 .44261 Mdot
.3197 .24043 Mdot
.32066 .44177 Mdot
.32161 .12979 Mdot
.32256 .56386 Mdot
.32351 .25894 Mdot
.32446 .21335 Mdot
.32541 .46412 Mdot
.32636 .03467 Mdot
.32732 .38156 Mdot
.32827 .49655 Mdot
.32922 .23607 Mdot
.33017 .34693 Mdot
.33112 .15992 Mdot
.33207 .03889 Mdot
.33302 .42073 Mdot
.33398 .57702 Mdot
.33493 .29642 Mdot
.33588 .28411 Mdot
.33683 .31481 Mdot
.33778 .26324 Mdot
.33873 .17312 Mdot
.33968 .13004 Mdot
.34064 .57721 Mdot
.34159 .28751 Mdot
.34254 .26064 Mdot
.34349 .32549 Mdot
.34444 .22511 Mdot
.34539 .07995 Mdot
.34634 .16648 Mdot
.3473 .21369 Mdot
.34825 .49196 Mdot
.3492 .10054 Mdot
.35015 .35723 Mdot
.3511 .2894 Mdot
.35205 .35788 Mdot
.353 .4559 Mdot
.35396 .34447 Mdot
.35491 .22743 Mdot
.35586 .4594 Mdot
.35681 .08774 Mdot
.35776 .49131 Mdot
.35871 .40522 Mdot
.35966 .23086 Mdot
.36062 .50902 Mdot
.36157 .39205 Mdot
.36252 .28965 Mdot
.36347 .35108 Mdot
.36442 .36972 Mdot
.36537 .12032 Mdot
.36632 .2442 Mdot
.36728 .35986 Mdot
.36823 .12454 Mdot
.36918 .03866 Mdot
.37013 .31154 Mdot
.37108 .32095 Mdot
.37203 .27998 Mdot
.37298 .37454 Mdot
.37394 .3306 Mdot
.37489 .21221 Mdot
.37584 .11388 Mdot
.37679 .50903 Mdot
.37774 .26467 Mdot
.37869 .31336 Mdot
.37964 .26857 Mdot
.3806 .18812 Mdot
.38155 .13175 Mdot
.3825 .59273 Mdot
.38345 .32097 Mdot
.3844 .36156 Mdot
.38535 .40912 Mdot
.3863 .09319 Mdot
.38726 .51038 Mdot
.38821 .39454 Mdot
.38916 .29408 Mdot
.39011 .33627 Mdot
.39106 .34537 Mdot
.39201 .17785 Mdot
.39296 .19755 Mdot
.39392 .53878 Mdot
.39487 .17832 Mdot
.39582 .17281 Mdot
.39677 .56994 Mdot
.39772 .19951 Mdot
.39867 .05782 Mdot
.39962 .36013 Mdot
.40058 .38333 Mdot
.40153 .09072 Mdot
.40248 .25998 Mdot
.40343 .3008 Mdot
.40438 .31631 Mdot
.40533 .34364 Mdot
.40628 .35367 Mdot
.40724 .153 Mdot
.40819 .17104 Mdot
.40914 .5121 Mdot
.41009 .05832 Mdot
.41104 .16791 Mdot
.41199 .0972 Mdot
.41294 .54726 Mdot
.4139 .42644 Mdot
.41485 .47354 Mdot
.4158 .01845 Mdot
.41675 .30684 Mdot
.4177 .31311 Mdot
.41865 .31559 Mdot
.4196 .26766 Mdot
.42056 .26756 Mdot
.42151 .42615 Mdot
.42246 .51809 Mdot
.42341 .06566 Mdot
.42436 .13717 Mdot
.42531 .08762 Mdot
.42626 .44831 Mdot
.42722 .36059 Mdot
.42817 .188 Mdot
.42912 .48736 Mdot
.43007 .0236 Mdot
.43102 .25594 Mdot
.43197 .16002 Mdot
.43292 .20026 Mdot
.43388 .49867 Mdot
.43483 .05937 Mdot
.43578 .26264 Mdot
.43673 .24879 Mdot
.43768 .46564 Mdot
.43863 .39781 Mdot
.43958 .16415 Mdot
.44054 .59467 Mdot
.44149 .28069 Mdot
.44244 .22239 Mdot
.44339 .12473 Mdot
.44434 .47735 Mdot
.44529 .18965 Mdot
.44624 .42942 Mdot
.4472 .02687 Mdot
.44815 .34151 Mdot
.4491 .40999 Mdot
.45005 .32038 Mdot
.451 .25559 Mdot
.45195 .28232 Mdot
.4529 .38349 Mdot
.45386 .52411 Mdot
.45481 .39791 Mdot
.45576 .34177 Mdot
.45671 .18676 Mdot
.45766 .18812 Mdot
.45861 .56644 Mdot
.45956 .24687 Mdot
.46052 .18177 Mdot
.46147 .47413 Mdot
.46242 .01846 Mdot
.46337 .30463 Mdot
.46432 .30595 Mdot
.46527 .30647 Mdot
.46622 .29636 Mdot
.46718 .29618 Mdot
.46813 .33105 Mdot
.46908 .35673 Mdot
.47003 .19866 Mdot
.47098 .48551 Mdot
.47193 .03121 Mdot
.47288 .28441 Mdot
.47384 .2528 Mdot
.47479 .33102 Mdot
.47574 .20701 Mdot
.47669 .05516 Mdot
.47764 .26574 Mdot
.47859 .246 Mdot
.47954 .4601 Mdot
.4805 .29554 Mdot
.48145 .31946 Mdot
.4824 .26833 Mdot
.48335 .34927 Mdot
.4843 .166 Mdot
.48525 .18379 Mdot
.4862 .53305 Mdot
.48716 .10337 Mdot
.48811 .09343 Mdot
.48906 .27443 Mdot
.49001 .3052 Mdot
.49096 .29953 Mdot
.49191 .28783 Mdot
.49286 .26358 Mdot
.49382 .33757 Mdot
.49477 .18736 Mdot
.49572 .04926 Mdot
.49667 .40097 Mdot
.49762 .48228 Mdot
.49857 .04622 Mdot
.49952 .33359 Mdot
.50048 .36052 Mdot
.50143 .18745 Mdot
.50238 .48528 Mdot
.50333 .02165 Mdot
.50428 .26214 Mdot
.50523 .17469 Mdot
.50618 .18053 Mdot
.50714 .55517 Mdot
.50809 .1653 Mdot
.50904 .06039 Mdot
.50999 .48064 Mdot
.51094 .57586 Mdot
.51189 .29652 Mdot
.51284 .28478 Mdot
.5138 .31724 Mdot
.51475 .25521 Mdot
.5157 .16288 Mdot
.51665 .24449 Mdot
.5176 .43016 Mdot
.51855 .12613 Mdot
.5195 .58284 Mdot
.52046 .31981 Mdot
.52141 .34978 Mdot
.52236 .31597 Mdot
.52331 .25932 Mdot
.52426 .16676 Mdot
.52521 .1774 Mdot
.52616 .54174 Mdot
.52712 .11652 Mdot
.52807 .05372 Mdot
.52902 .29656 Mdot
.52997 .29231 Mdot
.53092 .33609 Mdot
.53187 .29697 Mdot
.53282 .33125 Mdot
.53378 .39809 Mdot
.53473 .4989 Mdot
.53568 .10145 Mdot
.53663 .31876 Mdot
.53758 .29904 Mdot
.53853 .32349 Mdot
.53948 .3741 Mdot
.54044 .48302 Mdot
.54139 .25564 Mdot
.54234 .35731 Mdot
.54329 .136 Mdot
.54424 .0926 Mdot
.54519 .44809 Mdot
.54614 .33483 Mdot
.5471 .23902 Mdot
.54805 .41163 Mdot
.549 .0647 Mdot
.54995 .41663 Mdot
.5509 .4395 Mdot
.55185 .01638 Mdot
.5528 .33037 Mdot
.55376 .39214 Mdot
.55471 .45314 Mdot
.55566 .02828 Mdot
.55661 .38489 Mdot
.55756 .52981 Mdot
.55851 .41899 Mdot
.55946 .38047 Mdot
.56042 .10693 Mdot
.56137 .32888 Mdot
.56232 .29093 Mdot
.56327 .35348 Mdot
.56422 .46066 Mdot
.56517 .50219 Mdot
.56612 .10589 Mdot
.56708 .30381 Mdot
.56803 .30415 Mdot
.56898 .30361 Mdot
.56993 .30258 Mdot
.57088 .30131 Mdot
.57183 .3101 Mdot
.57278 .29502 Mdot
.57374 .32983 Mdot
.57469 .30731 Mdot
.57564 .29128 Mdot
.57659 .25759 Mdot
.57754 .17994 Mdot
.57849 .32973 Mdot
.57944 .2376 Mdot
.5804 .34167 Mdot
.58135 .17546 Mdot
.5823 .0475 Mdot
.58325 .43652 Mdot
.5842 .56625 Mdot
.58515 .18393 Mdot
.5861 .03848 Mdot
.58706 .37003 Mdot
.58801 .45535 Mdot
.58896 .15969 Mdot
.58991 .51907 Mdot
.59086 .08534 Mdot
.59181 .16531 Mdot
.59276 .2404 Mdot
.59372 .44161 Mdot
.59467 .12899 Mdot
.59562 .56413 Mdot
.59657 .26327 Mdot
.59752 .22168 Mdot
.59847 .45058 Mdot
.59942 .04247 Mdot
.60038 .42886 Mdot
.60133 .57742 Mdot
.60228 .25141 Mdot
.60323 .16443 Mdot
.60418 .33248 Mdot
.60513 .24076 Mdot
.60608 .39396 Mdot
.60704 .06991 Mdot
.60799 .27201 Mdot
.60894 .27572 Mdot
.60989 .40273 Mdot
.61084 .51904 Mdot
.61179 .14631 Mdot
.61274 .24328 Mdot
.6137 .40705 Mdot
.61465 .07702 Mdot
.6156 .44062 Mdot
.61655 .40865 Mdot
.6175 .09209 Mdot
.61845 .505 Mdot
.6194 .39452 Mdot
.62036 .27703 Mdot
.62131 .39043 Mdot
.62226 .40905 Mdot
.62321 .03425 Mdot
.62416 .22121 Mdot
.62511 .09624 Mdot
.62606 .3485 Mdot
.62702 .29826 Mdot
.62797 .32591 Mdot
.62892 .37392 Mdot
.62987 .38651 Mdot
.63082 .06987 Mdot
.63177 .14837 Mdot
.63272 .13323 Mdot
.63368 .5132 Mdot
.63463 .1701 Mdot
.63558 .29032 Mdot
.63653 .33665 Mdot
.63748 .26735 Mdot
.63843 .42292 Mdot
.63938 .47074 Mdot
.64034 .01472 Mdot
.64129 .30589 Mdot
.64224 .31037 Mdot
.64319 .3161 Mdot
.64414 .27809 Mdot
.64509 .34665 Mdot
.64604 .195 Mdot
.647 .36215 Mdot
.64795 .14277 Mdot
.6489 .27481 Mdot
.64985 .35237 Mdot
.6508 .18202 Mdot
.65175 .37406 Mdot
.6527 .12987 Mdot
.65366 .38079 Mdot
.65461 .21265 Mdot
.65556 .55969 Mdot
.65651 .45513 Mdot
.65746 .60332 Mdot
.65841 .30404 Mdot
.65936 .30404 Mdot
.66032 .30404 Mdot
.66127 .30404 Mdot
.66222 .30404 Mdot
.66317 .30404 Mdot
.66412 .30404 Mdot
.66507 .30404 Mdot
.66602 .30404 Mdot
.66698 .30404 Mdot
.66793 .30404 Mdot
.66888 .30404 Mdot
.66983 .30404 Mdot
.67078 .30404 Mdot
.67173 .30404 Mdot
.67268 .30404 Mdot
.67364 .30404 Mdot
.67459 .30404 Mdot
.67554 .30404 Mdot
.67649 .30404 Mdot
.67744 .30404 Mdot
.67839 .30404 Mdot
.67934 .30404 Mdot
.6803 .30404 Mdot
.68125 .30404 Mdot
.6822 .30404 Mdot
.68315 .30404 Mdot
.6841 .30404 Mdot
.68505 .30404 Mdot
.686 .30404 Mdot
.68696 .30404 Mdot
.68791 .30404 Mdot
.68886 .30404 Mdot
.68981 .30404 Mdot
.69076 .30404 Mdot
.69171 .30404 Mdot
.69266 .30404 Mdot
.69362 .30404 Mdot
.69457 .30404 Mdot
.69552 .30404 Mdot
.69647 .30404 Mdot
.69742 .30404 Mdot
.69837 .30404 Mdot
.69932 .30404 Mdot
.70028 .30404 Mdot
.70123 .30404 Mdot
.70218 .30404 Mdot
.70313 .30404 Mdot
.70408 .30404 Mdot
.70503 .30404 Mdot
.70598 .30404 Mdot
.70694 .30404 Mdot
.70789 .30404 Mdot
.70884 .30404 Mdot
.70979 .30404 Mdot
.71074 .30404 Mdot
.71169 .30404 Mdot
.71264 .30404 Mdot
.7136 .30404 Mdot
.71455 .30404 Mdot
.7155 .30404 Mdot
.71645 .30404 Mdot
.7174 .30404 Mdot
.71835 .30404 Mdot
.7193 .30404 Mdot
.72026 .30404 Mdot
.72121 .30404 Mdot
.72216 .30404 Mdot
.72311 .30404 Mdot
.72406 .30404 Mdot
.72501 .30404 Mdot
.72596 .30404 Mdot
.72692 .30404 Mdot
.72787 .30404 Mdot
.72882 .30404 Mdot
.72977 .30404 Mdot
.73072 .30404 Mdot
.73167 .30404 Mdot
.73262 .30404 Mdot
.73358 .30404 Mdot
.73453 .30404 Mdot
.73548 .30404 Mdot
.73643 .30404 Mdot
.73738 .30404 Mdot
.73833 .30404 Mdot
.73928 .30404 Mdot
.74024 .30404 Mdot
.74119 .30404 Mdot
.74214 .30404 Mdot
.74309 .30404 Mdot
.74404 .30404 Mdot
.74499 .30404 Mdot
.74594 .30404 Mdot
.7469 .30404 Mdot
.74785 .30404 Mdot
.7488 .30404 Mdot
.74975 .30404 Mdot
.7507 .30404 Mdot
.75165 .30404 Mdot
.7526 .30404 Mdot
.75356 .30404 Mdot
.75451 .30404 Mdot
.75546 .30404 Mdot
.75641 .30404 Mdot
.75736 .30404 Mdot
.75831 .30404 Mdot
.75926 .30404 Mdot
.76022 .30404 Mdot
.76117 .30404 Mdot
.76212 .30404 Mdot
.76307 .30404 Mdot
.76402 .30404 Mdot
.76497 .30404 Mdot
.76592 .30404 Mdot
.76688 .30404 Mdot
.76783 .30404 Mdot
.76878 .30404 Mdot
.76973 .30404 Mdot
.77068 .30404 Mdot
.77163 .30404 Mdot
.77258 .30404 Mdot
.77354 .30404 Mdot
.77449 .30404 Mdot
.77544 .30404 Mdot
.77639 .30404 Mdot
.77734 .30404 Mdot
.77829 .30404 Mdot
.77924 .30404 Mdot
.7802 .30404 Mdot
.78115 .30404 Mdot
.7821 .30404 Mdot
.78305 .30404 Mdot
.784 .30404 Mdot
.78495 .30404 Mdot
.7859 .30404 Mdot
.78686 .30404 Mdot
.78781 .30404 Mdot
.78876 .30404 Mdot
.78971 .30404 Mdot
.79066 .30404 Mdot
.79161 .30404 Mdot
.79256 .30404 Mdot
.79352 .30404 Mdot
.79447 .30404 Mdot
.79542 .30404 Mdot
.79637 .30404 Mdot
.79732 .30404 Mdot
.79827 .30404 Mdot
.79922 .30404 Mdot
.80018 .30404 Mdot
.80113 .30404 Mdot
.80208 .30404 Mdot
.80303 .30404 Mdot
.80398 .30404 Mdot
.80493 .30404 Mdot
.80588 .30404 Mdot
.80684 .30404 Mdot
.80779 .30404 Mdot
.80874 .30404 Mdot
.80969 .30404 Mdot
.81064 .30404 Mdot
.81159 .30404 Mdot
.81254 .30404 Mdot
.8135 .30404 Mdot
.81445 .30404 Mdot
.8154 .30404 Mdot
.81635 .30404 Mdot
.8173 .30404 Mdot
.81825 .30404 Mdot
.8192 .30404 Mdot
.82016 .30404 Mdot
.82111 .30404 Mdot
.82206 .30404 Mdot
.82301 .30404 Mdot
.82396 .30404 Mdot
.82491 .30404 Mdot
.82586 .30404 Mdot
.82682 .30404 Mdot
.82777 .30404 Mdot
.82872 .30404 Mdot
.82967 .30404 Mdot
.83062 .30404 Mdot
.83157 .30404 Mdot
.83252 .30404 Mdot
.83348 .30404 Mdot
.83443 .30404 Mdot
.83538 .30404 Mdot
.83633 .30404 Mdot
.83728 .30404 Mdot
.83823 .30404 Mdot
.83918 .30404 Mdot
.84014 .30404 Mdot
.84109 .30404 Mdot
.84204 .30404 Mdot
.84299 .30404 Mdot
.84394 .30404 Mdot
.84489 .30404 Mdot
.84584 .30404 Mdot
.8468 .30404 Mdot
.84775 .30404 Mdot
.8487 .30404 Mdot
.84965 .30404 Mdot
.8506 .30404 Mdot
.85155 .30404 Mdot
.8525 .30404 Mdot
.85346 .30404 Mdot
.85441 .30404 Mdot
.85536 .30404 Mdot
.85631 .30404 Mdot
.85726 .30404 Mdot
.85821 .30404 Mdot
.85916 .30404 Mdot
.86012 .30404 Mdot
.86107 .30404 Mdot
.86202 .30404 Mdot
.86297 .30404 Mdot
.86392 .30404 Mdot
.86487 .30404 Mdot
.86582 .30404 Mdot
.86678 .30404 Mdot
.86773 .30404 Mdot
.86868 .30404 Mdot
.86963 .30404 Mdot
.87058 .30404 Mdot
.87153 .30404 Mdot
.87248 .30404 Mdot
.87344 .30404 Mdot
.87439 .30404 Mdot
.87534 .30404 Mdot
.87629 .30404 Mdot
.87724 .30404 Mdot
.87819 .30404 Mdot
.87914 .30404 Mdot
.8801 .30404 Mdot
.88105 .30404 Mdot
.882 .30404 Mdot
.88295 .30404 Mdot
.8839 .30404 Mdot
.88485 .30404 Mdot
.8858 .30404 Mdot
.88676 .30404 Mdot
.88771 .30404 Mdot
.88866 .30404 Mdot
.88961 .30404 Mdot
.89056 .30404 Mdot
.89151 .30404 Mdot
.89246 .30404 Mdot
.89342 .30404 Mdot
.89437 .30404 Mdot
.89532 .30404 Mdot
.89627 .30404 Mdot
.89722 .30404 Mdot
.89817 .30404 Mdot
.89912 .30404 Mdot
.90008 .30404 Mdot
.90103 .30404 Mdot
.90198 .30404 Mdot
.90293 .30404 Mdot
.90388 .30404 Mdot
.90483 .30404 Mdot
.90578 .30404 Mdot
.90674 .30404 Mdot
.90769 .30404 Mdot
.90864 .30404 Mdot
.90959 .30404 Mdot
.91054 .30404 Mdot
.91149 .30404 Mdot
.91244 .30404 Mdot
.9134 .30404 Mdot
.91435 .30404 Mdot
.9153 .30404 Mdot
.91625 .30404 Mdot
.9172 .30404 Mdot
.91815 .30404 Mdot
.9191 .30404 Mdot
.92006 .30404 Mdot
.92101 .30404 Mdot
.92196 .30404 Mdot
.92291 .30404 Mdot
.92386 .30404 Mdot
.92481 .30404 Mdot
.92576 .30404 Mdot
.92672 .30404 Mdot
.92767 .30404 Mdot
.92862 .30404 Mdot
.92957 .30404 Mdot
.93052 .30404 Mdot
.93147 .30404 Mdot
.93242 .30404 Mdot
.93338 .30404 Mdot
.93433 .30404 Mdot
.93528 .30404 Mdot
.93623 .30404 Mdot
.93718 .30404 Mdot
.93813 .30404 Mdot
.93908 .30404 Mdot
.94004 .30404 Mdot
.94099 .30404 Mdot
.94194 .30404 Mdot
.94289 .30404 Mdot
.94384 .30404 Mdot
.94479 .30404 Mdot
.94574 .30404 Mdot
.9467 .30404 Mdot
.94765 .30404 Mdot
.9486 .30404 Mdot
.94955 .30404 Mdot
.9505 .30404 Mdot
.95145 .30404 Mdot
.9524 .30404 Mdot
.95336 .30404 Mdot
.95431 .30404 Mdot
.95526 .30404 Mdot
.95621 .30404 Mdot
.95716 .30404 Mdot
.95811 .30404 Mdot
.95906 .30404 Mdot
.96002 .30404 Mdot
.96097 .30404 Mdot
.96192 .30404 Mdot
.96287 .30404 Mdot
.96382 .30404 Mdot
.96477 .30404 Mdot
.96572 .30404 Mdot
.96668 .30404 Mdot
.96763 .30404 Mdot
.96858 .30404 Mdot
.96953 .30404 Mdot
.97048 .30404 Mdot
.97143 .30404 Mdot
.97238 .30404 Mdot
.97334 .30404 Mdot
.97429 .30404 Mdot
.97524 .30404 Mdot
.97619 .30404 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`004`3oool500000?l0oooo2@3oool001D0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000E0?ooo`030000003oool0
oooo00<0oooo0P00003o0?ooo`@0oooo000=0?ooo`@00000103oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo0?l0oooo0`3oool001D0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`2M0?ooo`030000003oool0oooo0680oooo000D0?ooo`8000001@3oool00`000000oooo
0?ooo`1R0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool05@3oool00`000000oooo
0?ooo`0D0?ooo`030000003oool0oooo0680oooo000K0?ooo`030000003oool0oooo03@0oooo00<0
00000?ooo`3oool0:`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool02P3oool00`000000oooo0?ooo`1i0?ooo`006`3oool00`000000oooo0?ooo`0B
0?ooo`050000003oool0oooo0?ooo`0000005P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo02l0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0;0?ooo`030000003o
ool0oooo08H0oooo000K0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool00`3oool0
1@000000oooo0?ooo`3oool0000001H0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?oo
o`1h0?ooo`006`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo02X0oooo00<00000
0?ooo`3oool03`3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo01<0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`1W0?ooo`006`3oool2000001T0oooo00<000000?oo
o`3oool0203oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo00l0oooo00<000000?oo
o`000000203oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0I`3oool001/0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`080?ooo`03
0000003oool0oooo02L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0f0?ooo`04
0000003oool0oooo000006l0oooo000K0?ooo`030000003oool0oooo07P0oooo00<000000?ooo`3o
ool05`3oool00`000000oooo0?ooo`1]0?ooo`006`3oool00`000000oooo0?ooo`1g0?ooo`800000
5@3oool00`000000oooo0?ooo`1a0?ooo`006`3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo05<0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0;0?ooo`030000003o
ool0oooo0740oooo000K0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool04@3oool0
0`000000oooo0?ooo`0;0?ooo`030000003oool0oooo07l0oooo000K0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`160?ooo`040000003oool0oooo
000000D0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo08@0oooo000K0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0?P3oool01000
0000oooo0?ooo`0000020?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool01`3oool0
0`000000oooo0?ooo`1j0?ooo`006`3oool2000001/0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`110?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0NP3oool001/0
oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0
oooo00<000000?ooo`3oool0G`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo06D0
oooo000K0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool03@3oool00`000000oooo
0?ooo`1O0?ooo`030000003oool0000000<0oooo00<000000?ooo`3oool0I@3oool001/0oooo00<0
00000?ooo`3oool0D03oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo06T0oooo000K
0?ooo`030000003oool0oooo0500oooo00<000000?ooo`3oool0[`3oool001/0oooo00<000000?oo
o`3oool0;P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo00l0oooo00<000000?oo
o`3oool0:03oool00`000000oooo0?ooo`1_0?ooo`006`3oool00`000000oooo0?ooo`0^0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0J03oool001/0oooo0P0000170?ooo`030000
003oool0oooo0180oooo00D000000?ooo`3oool0oooo0000000E0?ooo`030000003oool0oooo00`0
oooo00<000000?ooo`3oool0403oool00`000000oooo0000001X0?ooo`006`3oool00`000000oooo
0?ooo`130?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`0A0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0IP3oool001/0oooo00<0
00000?ooo`3oool09`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00/0oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00X0oooo00<0
00000?ooo`3oool0O@3oool001/0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0C
0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0:
0?ooo`030000003oool0oooo00<0oooo0P00001h0?ooo`006`3oool00`000000oooo0?ooo`0m0?oo
o`030000003oool0oooo00P0oooo00<000000?ooo`3oool0?@3oool2000007P0oooo000K0?ooo`03
0000003oool0oooo03L0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`070?ooo`80
00003P3oool00`000000oooo0?ooo`2W0?ooo`006`3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`00000>0?ooo`03
0000003oool0oooo02@0oooo00<000000?ooo`3oool0P03oool001/0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0
303oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo0800oooo000K0?ooo`8000007@3o
ool010000000oooo0?ooo`00000B0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0
4@3oool2000001<0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`220?ooo`006`3o
ool00`000000oooo0?ooo`0L0?ooo`050000003oool0oooo0?ooo`0000004@3oool00`000000oooo
0?ooo`0E0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`0A0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`0<0?ooo`030000003oool0oooo05l0oooo000K0?ooo`030000003oool0oooo0200oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo00L0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`1O0?ooo`006`3oool00`000000oooo0?ooo`0K
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`000000<@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`1T
0?ooo`006`3oool00`000000oooo0?ooo`0K0?ooo`8000002P3oool00`000000oooo0?ooo`0A0?oo
o`030000003oool0oooo02L0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`1k0?oo
o`006`3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool04P3oool00`000000oooo0000001I0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool0H03oool000P0oooo0P0000040?ooo`800000103oool2000000D0oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo05T0oooo00<000000?ooo`3oool0
0`3oool01@000000oooo0?ooo`3oool000000680oooo00070?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo
03P0oooo00<000000?ooo`3oool0I03oool000L0oooo00@000000?ooo`3oool000002`3oool00`00
0000oooo0?ooo`020?ooo`8000005@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo
09l0oooo00000`3oool000000000000200000080oooo00@000000?ooo`3oool000002@3oool20000
00D0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01D0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo
0700oooo00070?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`0F0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`0G0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`000000403oool00`00
0000oooo0000000B0?ooo`8000000P3oool00`000000oooo0?ooo`1/0?ooo`00203oool2000000X0
oooo0`0000040?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`080?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool03P3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00`3oool00`000000
oooo000000020?ooo`030000003oool0oooo00h0oooo00@000000?ooo`3oool00000KP3oool001/0
oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool0203oool00`000000oooo0000000<0?ooo`030000003oool0oooo0080
00004P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3o
ool0I03oool001/0oooo00<000000?ooo`3oool05`3oool2000000P0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00`0oooo00@000000?ooo`3oool0
00006@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3o
ool0I03oool001/0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo03P0oooo0P00000L0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0
2P3oool2000007@0oooo000K0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0B03o
ool200000100oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool02P3oool00`000000oooo0000000A0?ooo`030000003o
ool0oooo05l0oooo000K0?ooo`8000004P3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0
oooo01T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`040?ooo`8000001@3oool0
1P000000oooo0?ooo`000000oooo000001@0oooo00<000000?ooo`3oool03`3oool00`000000oooo
0?ooo`1O0?ooo`006`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool09@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00X0oooo00D0
00000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo00L0oooo00<000000?ooo`000000
R03oool001/0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo01@0oooo00<000000?ooo`3oool01`3oool01@000000oooo0?ooo`3oool0000002l0oooo
00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`1Q0?ooo`006`3oool00`000000oooo0?oo
o`0/0?ooo`030000003oool0oooo00L0oooo00D000000?ooo`3oool0oooo000000090?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`0000004@3oool00`000000oooo0?ooo`0[0?ooo`030000
003oool0oooo0640oooo000K0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0<P3o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0000000P0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`2?0?ooo`006`3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0
oooo05D0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`2=0?ooo`006`3oool00`00
0000oooo0?ooo`0N0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0>03oool00`00
0000oooo0?ooo`2=0?ooo`006`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo01H0
oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`1N0?ooo`006`3oool2000004`0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo04H0oooo
00<000000?ooo`3oool0GP3oool001/0oooo00<000000?ooo`3oool0J@3oool00`000000oooo0?oo
o`0V0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0IP3oool001/0oooo00<00000
0?ooo`3oool0<@3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo01H0oooo00<00000
0?ooo`3oool09P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo06H0oooo000K0?oo
o`030000003oool0oooo01T0oooo00<000000?ooo`0000003@3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00l0oooo00D000000?ooo`3oool0oooo000000080?ooo`050000003oool0
00000?ooo`000000[@3oool001/0oooo00<000000?ooo`3oool04@3oool00`000000oooo00000005
0?ooo`030000003oool0000000d0oooo00@000000?ooo`3oool000005P3oool01@000000oooo0?oo
o`3oool0000000X0oooo00<000000?ooo`000000[@3oool001/0oooo00<000000?ooo`3oool04@3o
ool00`000000oooo0000000C0?ooo`030000003oool000000080oooo00<000000?ooo`3oool07@3o
ool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0780oooo000K0?ooo`030000003oool0
oooo01X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0000000O0?ooo`040000003oool0
oooo000003P0oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000030?ooo`030000
003oool0oooo06/0oooo000K0?ooo`8000005@3oool01`000000oooo0?ooo`3oool000000?ooo`00
0000:P3oool01@000000oooo0?ooo`3oool0000000/0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0203oool01`00
0000oooo0?ooo`3oool000000?ooo`000000J`3oool001/0oooo00<000000?ooo`3oool0503oool0
1@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0903oool2000000l0oooo00<0
00000?ooo`3oool0403oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo06T0oooo000K
0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`03
0?ooo`040000003oool0oooo00000240oooo00<000000?ooo`3oool0K03oool001/0oooo00<00000
0?ooo`3oool03@3oool2000000L0oooo00<000000?ooo`3oool05@3oool010000000oooo0?ooo`00
000d0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo06`0oooo000K0?ooo`030000003oool0oooo00d0oooo00D00000
0?ooo`3oool0oooo0000000;0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`0000000P3o
ool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`1c0?ooo`006`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool02@3oool00`000000oooo000000060?ooo`@000000P3oool3
000000@0oooo0`0000060?ooo`030000003oool0oooo00/0oooo00@000000?ooo`3oool0oooo0P00
00080?ooo`030000003oool00000008000000P3oool2000000@0oooo0P0000000`3oool000000?oo
o`0<0?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0203oool3000000@0oooo
0P0000040?ooo`800000903oool2000000@0oooo0P0000040?ooo`800000803oool500000080oooo
0P0000040?ooo`800000103oool2000000<0oooo000K0?ooo`030000003oool0oooo00`0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`02000000050?ooo`000000oooo0?ooo`000000
3P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo0P0000001@3oool00000
0?ooo`3oool000000080oooo00@000000?ooo`00000000000P3oool2000000T0oooo00D000000?oo
o`000000oooo000000020?ooo`030000003oool0oooo00d0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0000000000020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3o
ool0703oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000008@3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000020?ooo`4000000@3oool10?ooo`006`3oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo0080000000D0oooo0000003oool0oooo0000000>0?oo
o`030000003oool0oooo0140oooo1@0000001P3oool000000?ooo`3oool000000?ooo`8000000P3o
ool00`000000oooo0?ooo`080?ooo`030000003oool0000001@0oooo00@000000?ooo`3oool00000
0P3oool01@000000oooo0?ooo`000000oooo008000000P3oool01@000000oooo0?ooo`3oool00000
01h0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo00000240oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000000P3oool100000040oooo0@3oool001/0oooo0P00000O0?oo
o`030000003oool0oooo00L0oooo00D000000?ooo`3oool0oooo000000020?ooo`040000003oool0
oooo00000080oooo00H000000?ooo`00000000000?ooo`00000M0?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00000=0?ooo`030000003o
ool0oooo0140oooo0`0000030?ooo`050000003oool0oooo0000003oool00P0000020?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool06P3oool2000000<0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`00000Q0?ooo`050000003oool0oooo0?ooo`0000000P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo0@0000010?ooo`40oooo
000K0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool01@3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo0080000000H0oooo0000003oool0oooo0000003oool20000
00030?ooo`000000oooo00/0oooo00<000000?ooo`3oool03@3oool01@000000oooo0000003oool0
00000080oooo00@000000?ooo`3oool000000P3oool01P000000oooo0?ooo`000000oooo000000/0
oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000001@3oool2000001/0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000240oooo00D000000?ooo`3o
ool0oooo000000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool100000040oooo0@3oool001/0oooo00<000000?ooo`3oool09`3oool2000000@0oooo10000002
0?ooo`8000002P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool01P3oool00`000000oooo0?ooo`02000000<0oooo0P0000040?ooo`8000000P3oool0
10000000oooo0?ooo`0000040?ooo`030000003oool0oooo01H0oooo0`0000030?ooo`800000103o
ool2000000H0oooo00<000000?ooo`3oool06`3oool2000000@0oooo0P0000040?ooo`8000008@3o
ool2000000@0oooo0P0000040?ooo`800000103oool2000000<0oooo000K0?ooo`030000003oool0
oooo02P0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0:0?ooo`040000003oool0
oooo000000L0oooo00<000000?ooo`3oool0103oool2000001`0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0P`3o
ool001/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo01D0oooo00@000000?ooo`3oool00000403oool01@000000oooo0000003oool0000000@0oooo
00<000000?ooo`0000001`3oool00`000000oooo000000020?ooo`030000003oool0oooo01l0oooo
00<000000?ooo`3oool00`3oool01@000000oooo0?ooo`3oool0000000L0oooo00D000000?ooo`3o
ool0oooo0000000?0?ooo`030000003oool0oooo06<0oooo000K0?ooo`030000003oool0oooo00/0
oooo00@000000?ooo`3oool0oooo0P00000C0?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool01`3oool2000000030?ooo`000000oooo0080oooo00<000000?ooo`0000000P0000001@3o
ool000000?ooo`3oool0000000/0oooo00@000000?ooo`3oool000001P3oool00`000000oooo0?oo
o`0B0?ooo`040000003oool0oooo000000`0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`02000000l0oooo00<000000?ooo`3oool0H`3oool001/0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo00h0oooo0P0000001@3oool000000?oo
o`3oool0000000<0oooo00@000000?ooo`3oool000002P3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo0140oooo0P0000020?ooo`040000003oool0oooo000000@0oooo00<000000?oo
o`3oool00P3oool3000000P0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`1V0?oo
o`006`3oool00`000000oooo0?ooo`0X0?ooo`040000003oool0oooo000000l0oooo00<000000?oo
o`3oool03`3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo0`0000070?oo
o`8000003@3oool00`000000oooo0?ooo`1V0?ooo`005@3ooooo000000H000001P3oool001/0oooo
3`0000040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool2000000@0oooo
00@000000?ooo`00000000000P3oool00`000000oooo0?ooo`040?ooo`800000103oool2000000T0
oooo0P00000;0?ooo`040000003oool0oooo000000T0oooo00@000000?ooo`3oool00000203oool0
10000000oooo0?ooo`0000060?ooo`040000003oool0oooo000000/0oooo00<000000?ooo`3oool0
0P3oool3000000@0oooo00<000000?ooo`3oool02@3oool2000000<0ooooE000000<0?ooo`006`3o
ool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo01D0oooo00@000000?ooo`3oool0oooo
0P0000020?ooo`040000003oool0oooo000000L0oooo00<000000?ooo`3oool02`3oool00`000000
oooo000000070?ooo`030000003oool0oooo00D0oooo00@000000?ooo`3oool000001P3oool01000
0000oooo0?ooo`00000W0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool0
0`000000oooo0?ooo`0S0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool02P3oool0
01/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0E0?ooo`050000003oool00000
0?ooo`0000000`3oool010000000oooo00000000000C0?ooo`030000003oool0000000T0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`030?ooo`050000003oool0oooo0?ooo`000000
603oool00`000000oooo000000030?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0
H@3oool001/0oooo00<000000?ooo`3oool09@3oool020000000oooo0?ooo`3oool000000?ooo`00
0000oooo0P00000?0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0?
0?ooo`040000003oool0oooo000000@0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo000000030?ooo`030000
003oool0oooo01T0oooo00<000000?ooo`3oool0H@3oool001/0oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00D0oooo00@000000?ooo`3oool00000
403oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00P0oooo00D000000?ooo`3oool0
oooo0000000G0?ooo`030000003oool0oooo06D0oooo000K0?ooo`030000003oool0oooo01X0oooo
0P00000=0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`0X0?ooo`070000003oool0oooo0?ooo`000000oooo000000020?ooo`030000003oool00000
00`0oooo00<000000?ooo`3oool0I@3oool001/0oooo00<000000?ooo`3oool03@3oool00`000000
oooo0?ooo`090?ooo`800000903oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01H0
oooo00<000000?ooo`0000001@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0080
oooo00<000000?ooo`0000000P3oool00`000000oooo000000050?ooo`030000003oool0oooo06`0
oooo000K0?ooo`8000003P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool06P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0000000@0oooo0P0000070?ooo`80
00000P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool0H`3oool001/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo01H0oooo00<000000?ooo`3oool01P3oool01@000000oooo0000003oool0000000X0
oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0<0?ooo`030000003oool0000000T0
oooo00<000000?ooo`3oool01P3oool01@000000oooo0?ooo`3oool0000000P0oooo00<000000?oo
o`3oool0303oool00`000000oooo0?ooo`1S0?ooo`006`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool01@3oool00`000000oooo000000020?ooo`03
0000003oool0oooo00X0oooo00<000000?ooo`3oool01`3oool01@000000oooo0?ooo`3oool00000
00X0oooo00<000000?ooo`0000007`3oool00`000000oooo0?ooo`1b0?ooo`006`3oool00`000000
oooo0?ooo`0@0?ooo`030000003oool0oooo0140oooo00D000000?ooo`000000oooo0000000:0?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`0000002@3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo00L0oooo00D000000?ooo`3oool0oooo0000000C0?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo0640oooo000K0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`0000002P3oool00`00
0000oooo0?ooo`080?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`080?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool01`3oool00`00
0000oooo0?ooo`080?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool00P3oool20000
0680oooo000K0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0303oool010000000
oooo0?ooo`00000?0?ooo`050000003oool0oooo0?ooo`0000002P3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0C
0?ooo`030000003oool0oooo0600oooo000K0?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool07`3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool0203oool2000000<0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`080?oo
o`030000003oool0oooo07`0oooo000K0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool0=P3oool00`000000oooo0?ooo`090?ooo`050000003oool0oooo0?ooo`0000000`3oool01@00
0000oooo0?ooo`3oool0000000H0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0T
0?ooo`030000003oool0oooo0600oooo000K0?ooo`8000004`3oool00`000000oooo0?ooo`0N0?oo
o`8000004P3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0480oooo00<000000?oo
o`3oool0H03oool001/0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0?0?ooo`03
0000003oool0oooo00`0oooo0P0000040?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo0700oooo000K0?ooo`030000
003oool0oooo02@0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0I0?ooo`030000
003oool0000002/0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0G`3oool001/0oooo00<000000?ooo`3oool05`3o
ool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0:@3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`1O0?ooo`006`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0
oooo00L0oooo0P00000M0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`0;0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool05@3oool0
0`000000oooo0?ooo`1O0?ooo`006`3oool00`000000oooo0?ooo`0Q0?ooo`8000007`3oool00`00
0000oooo0?ooo`030?ooo`040000003oool0oooo00000180oooo00<000000?ooo`3oool02`3oool0
0`000000oooo0?ooo`0H0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`1O0?ooo`006`3oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0_0?ooo`800000403oool00`00
0000oooo0000001W0?ooo`006`3oool2000001@0oooo00<000000?ooo`3oool0403oool00`000000
oooo0?ooo`0[0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0:03oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo00800000J@3oool001/0oooo00<000000?ooo`3oool0
4`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo00X0oooo00D000000?ooo`3oool0
oooo0000000D0?ooo`030000003oool0oooo0100oooo00@000000?ooo`3oool00000JP3oool001/0
oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo04@0
oooo00D000000?ooo`3oool0oooo0000000:0?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool04@3oool00`000000oooo0?ooo`1Z0?ooo`006`3oool00`000000oooo0?ooo`0H0?ooo`03
0000003oool0oooo03P0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0K0?ooo`80
0000J`3oool001/0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0h0?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0X0?ooo`<00000
J@3oool001/0oooo00<000000?ooo`3oool0FP3oool00`000000oooo0?ooo`0>0?ooo`030000003o
ool0oooo01L0oooo00<000000?ooo`3oool03`3oool2000006T0oooo000K0?ooo`030000003oool0
oooo01d0oooo00<000000?ooo`3oool00`3oool00`000000oooo0000001O0?ooo`030000003oool0
000007X0oooo000K0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0303oool00`00
0000oooo0?ooo`030?ooo`030000003oool0000002L0oooo00<000000?ooo`3oool0=@3oool00`00
0000oooo0000000D0?ooo`030000003oool0oooo06<0oooo000K0?ooo`8000003`3oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool07@3oool00`000000
oooo0?ooo`0B0?ooo`030000003oool0000003L0oooo00<000000?ooo`3oool0H`3oool001/0oooo
00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`0000000P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0200oooo
00<000000?ooo`0000001@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool0K@3oool001/0oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo01L0oooo0P0000000`3oool000000?ooo`040?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0@0?ooo`030000003o
ool0oooo0180oooo00<000000?ooo`3oool0K@3oool001/0oooo00<000000?ooo`3oool0303oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0L@3oool0
01/0oooo00<000000?ooo`3oool04P3oool00`000000oooo0000000c0?ooo`030000003oool00000
03/0oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000040?ooo`030000003oool0
oooo06T0oooo000K0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`0]0?ooo`800000>`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0J@3oool000P0oooo0P0000040?ooo`800000103oool2000000D0
oooo00<000000?ooo`3oool06@3oool010000000oooo0?ooo`00000=0?ooo`030000003oool0oooo
01`0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo
07/0oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000103oool0
0`000000oooo0?ooo`0L0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0>03oool0
0`000000oooo0?ooo`0L0?ooo`030000003oool0000000/0oooo00<000000?ooo`3oool0K@3oool0
00L0oooo00@000000?ooo`3oool000002`3oool00`000000oooo0?ooo`020?ooo`800000D`3oool0
0`000000oooo0?ooo`0a0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool000003P3o
ool00`000000oooo0?ooo`1N0?ooo`001`3oool010000000oooo0?ooo`0000090?ooo`8000001@3o
ool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool07P3o
ool2000001l0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool0GP3oool000L0oooo00@000000?ooo`3oool000002@3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool04`3o
ool00`000000oooo0?ooo`1f0?ooo`00203oool2000000X0oooo0`0000040?ooo`030000003oool0
oooo00`0oooo0P00000c0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool06P3oool0
0`000000oooo0?ooo`2G0?ooo`006`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo
0680oooo000K0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`0Y0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`0/0?ooo`030000003oool0oooo0680oooo000K0?ooo`030000003oool0oooo0140oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo01X0oooo
00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`050?ooo`050000003oool0oooo0?ooo`00
0000T`3oool001/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0>0?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0;0?ooo`040000
003oool0oooo000000L0oooo00<000000?ooo`3oool0O03oool001/0oooo0P00000k0?ooo`030000
003oool0oooo02T0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`040?ooo`800000
00<0oooo0000003oool01P3oool00`000000oooo0?ooo`1l0?ooo`006`3oool00`000000oooo0?oo
o`0B0?ooo`050000003oool0oooo0?ooo`000000>P3oool00`000000oooo0000000B0?ooo`030000
003oool0oooo00P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`260?ooo`006`3o
ool00`000000oooo0?ooo`0?0?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool0
>03oool00`000000oooo0000002^0?ooo`006`3oool00`000000oooo0?ooo`0?0?ooo`030000003o
ool0oooo03X0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0G0?ooo`030000003o
ool0oooo07h0oooo000K0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool03`3oool0
0`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0603oool0
0`000000oooo0?ooo`0G0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0MP3oool0
01/0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0:0?ooo`040000003oool0oooo
0?ooo`8000002`3oool2000004L0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`1X
0?ooo`006`3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo0080oooo00@000000?oo
o`3oool0oooo0P00000;0?ooo`030000003oool0oooo0140oooo00D000000?ooo`3oool0oooo0000
00020?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0J03oool001/0oooo00<00000
0?ooo`3oool04`3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo02L0oooo00D00000
0?ooo`3oool0oooo000000020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0=`3o
ool00`000000oooo0?ooo`1T0?ooo`006`3oool2000001@0oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`150?ooo`040000003oool0oooo000003H0oooo00<000000?ooo`3oool0I03o
ool001/0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`180?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`1Z0?ooo`006`3oool00`00
0000oooo0?ooo`0Z0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0<P3oool00`00
0000oooo0?ooo`0Q0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0JP3oool001/0
oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo07P0
oooo000K0?ooo`030000003oool0oooo0340oooo00<000000?ooo`0000002@3oool00`000000oooo
0?ooo`0e0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0N03oool001/0oooo00<0
00000?ooo`3oool0<`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo03D0oooo00<0
00000?ooo`3oool0RP3oool001/0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0k
0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0P03oool001/0oooo00<000000?oo
o`3oool07`3oool2000003`0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`200?oo
o`006`3oool2000001T0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo
03l0oooo00<000000?ooo`3oool0W@3oool001/0oooo00<000000?ooo`3oool0603oool01@000000
oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0V0?oo
o`030000003oool0oooo09d0oooo000K0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3o
ool0503oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo08D0oooo000K0?ooo`030000
003oool0oooo07X0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`1N0?ooo`006`3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0<03o
ool00`000000oooo0?ooo`140?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0GP3o
ool001/0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`040?ooo`030000003oool0
00000300oooo00<000000?ooo`0000008P3oool00`000000oooo0?ooo`0N0?ooo`040000003oool0
oooo00000700oooo000K0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0<03oool0
0`000000oooo0?ooo`0B0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool07P3oool0
0`000000oooo0?ooo`1a0?ooo`006`3oool2000005h0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`240?ooo`006`3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`000000:`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo06`0
oooo000K0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool06P3oool00`000000oooo
0?ooo`070?ooo`030000003oool0000002d0oooo00<000000?ooo`3oool04`3oool00`000000oooo
0?ooo`1/0?ooo`006`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo00L0oooo00<0
00000?ooo`3oool0BP3oool00`000000oooo0?ooo`220?ooo`006`3oool00`000000oooo0?ooo`0`
0?ooo`030000003oool0oooo0<l0oooo000K0?ooo`030000003oool0oooo01h0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo00`0oooo00<000000?oo
o`3oool0UP3oool001<0oooo1@0000030?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`2F0?ooo`005@3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo03/0oooo00<000000?ooo`3oool0H`3oool00`000000oooo0?ooo`1N0?ooo`005@3o
ool00`000000oooo0?ooo`030?ooo`800000XP3oool00`000000oooo0?ooo`1N0?ooo`005@3oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo0?l0oooo0`3oool001D0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000D0?ooo`8000001@3oool00`000000
oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool00?l0oooo8@3o
ool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3o
ool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-110.017, -1.13206, 4.03645, \
0.0127961}}]
}, Open  ]]
},
FrontEndVersion->"4.2 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 941}},
WindowToolbars->"EditBar",
CellGrouping->Manual,
WindowSize->{602, 855},
WindowMargins->{{Automatic, 19}, {Automatic, 0}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 152, 3, 52, "Text"],
Cell[1909, 56, 85, 2, 64, "Subtitle"],
Cell[1997, 60, 252, 7, 87, "Subtitle",
  Evaluatable->False],
Cell[2252, 69, 640, 17, 90, "Text"],

Cell[CellGroupData[{
Cell[2917, 90, 119, 2, 35, "Text"],
Cell[3039, 94, 399, 6, 90, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3475, 105, 233, 7, 36, "Text"],
Cell[3711, 114, 842, 13, 147, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4590, 132, 215, 7, 36, "Text"],
Cell[4808, 141, 809, 21, 109, "Text"],

Cell[CellGroupData[{
Cell[5642, 166, 126, 3, 33, "Text",
  Evaluatable->True],
Cell[5771, 171, 35, 1, 29, "Output"]
}, Open  ]],
Cell[5821, 175, 387, 8, 71, "Text"],

Cell[CellGroupData[{
Cell[6233, 187, 242, 7, 84, "Input"],
Cell[6478, 196, 183, 3, 42, "Message"],
Cell[6664, 201, 181, 3, 42, "Message"],
Cell[6848, 206, 181, 3, 42, "Message"],
Cell[7032, 211, 167, 3, 42, "Message"],
Cell[7202, 216, 189, 3, 42, "Message"],
Cell[7394, 221, 228, 6, 88, "Message"]
}, Open  ]],
Cell[7637, 230, 317, 6, 47, "Input"]
}, Open  ]],
Cell[7969, 239, 115, 2, 35, "Text"],
Cell[8087, 243, 422, 7, 90, "Text"],

Cell[CellGroupData[{
Cell[8534, 254, 113, 2, 35, "Text"],
Cell[8650, 258, 479, 12, 71, "Text"],

Cell[CellGroupData[{
Cell[9154, 274, 229, 4, 70, "Input"],
Cell[9386, 280, 53, 1, 29, "Output"],
Cell[9442, 283, 59, 1, 29, "Output"],
Cell[9504, 286, 39, 1, 29, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[9592, 293, 143, 3, 35, "Text"],
Cell[9738, 298, 232, 8, 33, "Text"],

Cell[CellGroupData[{
Cell[9995, 310, 128, 3, 70, "Input"],
Cell[10126, 315, 35, 1, 29, "Output"],
Cell[10164, 318, 35, 1, 29, "Output"],
Cell[10202, 321, 46, 1, 29, "Output"]
}, Open  ]],
Cell[10263, 325, 90, 2, 33, "Text"],

Cell[CellGroupData[{
Cell[10378, 331, 166, 3, 70, "Input"],
Cell[10547, 336, 36, 1, 29, "Output"],
Cell[10586, 339, 70, 1, 29, "Output"],
Cell[10659, 342, 51, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10747, 348, 111, 2, 50, "Input"],
Cell[10861, 352, 481, 7, 67, "Output"]
}, Open  ]],
Cell[11357, 362, 441, 11, 71, "Text"],
Cell[11801, 375, 117, 4, 33, "Text"],
Cell[11921, 381, 220, 4, 90, "Input"],
Cell[12144, 387, 224, 5, 33, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12405, 397, 69, 1, 30, "Input"],
Cell[12477, 400, 65, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12579, 406, 158, 3, 35, "Text"],
Cell[12740, 411, 530, 14, 71, "Text"],

Cell[CellGroupData[{
Cell[13295, 429, 422, 9, 110, "Input"],
Cell[13720, 440, 117, 2, 29, "Output"],
Cell[13840, 444, 117, 2, 29, "Output"],
Cell[13960, 448, 15856, 406, 186, 3608, 250, "GraphicsData", "PostScript", \
"Graphics"],
Cell[29819, 856, 19163, 448, 186, 3554, 251, "GraphicsData", "PostScript", \
"Graphics"],
Cell[48985, 1306, 130, 3, 29, "Output"]
}, Open  ]],
Cell[49130, 1312, 1718, 37, 223, "Text"]
}, Open  ]],
Cell[50863, 1352, 144, 3, 35, "Text"],

Cell[CellGroupData[{
Cell[51032, 1359, 338, 10, 52, "Text"],

Cell[CellGroupData[{
Cell[51395, 1373, 191, 4, 90, "Input"],
Cell[51589, 1379, 53, 1, 29, "Output"]
}, Open  ]],
Cell[51657, 1383, 420, 11, 52, "Text"]
}, Open  ]],
Cell[52092, 1397, 308, 8, 84, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[52425, 1409, 516, 10, 130, "Input"],
Cell[52944, 1421, 18287, 489, 186, 4165, 310, "GraphicsData", "PostScript", \
"Graphics"],
Cell[71234, 1912, 130, 3, 29, "Output"],
Cell[71367, 1917, 54, 1, 29, "Output"],
Cell[71424, 1920, 18241, 491, 186, 4465, 316, "GraphicsData", "PostScript", \
"Graphics"],
Cell[89668, 2413, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[89835, 2421, 118, 2, 35, "Text"],
Cell[89956, 2425, 572, 18, 71, "Text"],

Cell[CellGroupData[{
Cell[90553, 2447, 156, 3, 50, "Input"],
Cell[90712, 2452, 174, 3, 48, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[90935, 2461, 173, 4, 70, "Input"],
Cell[91111, 2467, 247, 4, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[91395, 2476, 122, 2, 35, "Text"],
Cell[91520, 2480, 1015, 25, 166, "Text"],

Cell[CellGroupData[{
Cell[92560, 2509, 170, 3, 70, "Input"],
Cell[92733, 2514, 36, 1, 29, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[92818, 2521, 127, 3, 90, "Input"],
Cell[92948, 2526, 37, 1, 29, "Output"],
Cell[92988, 2529, 37, 1, 29, "Output"],
Cell[93028, 2532, 37, 1, 29, "Output"]
}, Open  ]],
Cell[93080, 2536, 164, 6, 48, "Input"],

Cell[CellGroupData[{
Cell[93269, 2546, 131, 3, 35, "Text"],
Cell[93403, 2551, 734, 17, 109, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[94174, 2573, 660, 20, 50, "Input"],
Cell[94837, 2595, 19074, 458, 186, 3640, 263, "GraphicsData", "PostScript", \
"Graphics"],
Cell[113914, 3055, 325, 8, 84, "Input"],
Cell[114242, 3065, 130, 3, 29, "Output"]
}, Open  ]],
Cell[114387, 3071, 123, 2, 35, "Text"],
Cell[114513, 3075, 1613, 27, 337, "Text"],
Cell[116129, 3104, 622, 14, 192, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[116776, 3122, 422, 11, 210, "Input"],
Cell[117201, 3135, 19340, 497, 186, 4137, 305, "GraphicsData", "PostScript", \
"Graphics"],
Cell[136544, 3634, 130, 3, 29, "Output"]
}, Open  ]],
Cell[136689, 3640, 413, 7, 84, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[137127, 3651, 427, 11, 210, "Input"],
Cell[137557, 3664, 35633, 1422, 186, 22408, 1254, "GraphicsData", \
"PostScript", "Graphics"],
Cell[173193, 5088, 130, 3, 29, "Output"]
}, Open  ]],
Cell[173338, 5094, 342, 8, 84, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[173705, 5106, 430, 11, 210, "Input"],
Cell[174138, 5119, 71802, 1853, 186, 22033, 1234, "GraphicsData", \
"PostScript", "Graphics"],
Cell[245943, 6974, 130, 3, 29, "Output"]
}, Open  ]],
Cell[246088, 6980, 111, 2, 45, "Text"],
Cell[246202, 6984, 143, 3, 35, "Text"],
Cell[246348, 6989, 463, 11, 71, "Text"],
Cell[246814, 7002, 354, 6, 130, "Input"],
Cell[247171, 7010, 147, 3, 35, "Text"],
Cell[247321, 7015, 638, 13, 109, "Text"],
Cell[247962, 7030, 412, 7, 110, "Input"],
Cell[248377, 7039, 550, 8, 120, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[248952, 7051, 380, 6, 150, "Input"],
Cell[249335, 7059, 39, 1, 29, "Output"],
Cell[249377, 7062, 33014, 1340, 186, 21663, 1195, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[282406, 8405, 376, 6, 84, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[282807, 8415, 382, 6, 150, "Input"],
Cell[283192, 8423, 40, 1, 29, "Output"],
Cell[283235, 8426, 50267, 1572, 186, 22007, 1219, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[333517, 10001, 376, 6, 84, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[333918, 10011, 382, 6, 150, "Input"],
Cell[334303, 10019, 40, 1, 29, "Output"],
Cell[334346, 10022, 50267, 1572, 186, 22007, 1219, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[384628, 11597, 473, 7, 120, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[385126, 11608, 498, 10, 130, "Input"],
Cell[385627, 11620, 56210, 1630, 186, 21618, 1198, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

